<?php
/**
 * mobile-hook
 * Created by PhpStorm.
 * User: sunbing
 * Date: 2017/11/9
 * Time: 15:13
 */

if (!defined('IN_DISCUZ')) {
    exit('Access Denied');
}

define('IN_QIANFAN', strpos(strtolower($_SERVER['HTTP_USER_AGENT']), 'qianfan') !== false); // qianfan


class mobileplugin_qianfan
{

    public function __construct()
    {
        include_once DISCUZ_ROOT . DIRECTORY_SEPARATOR . 'data' . DIRECTORY_SEPARATOR . 'sysdata' . DIRECTORY_SEPARATOR .
            'cache_qianfan_config.php';

        $this->cloudhost = isset($qianfan_config['cloud_host']) ? $qianfan_config['cloud_host'] : '';
        $this->cloudsecretkey = isset($qianfan_config['cloud_secretkey']) ? $qianfan_config['cloud_secretkey'] : '';
        $this->allowpush = isset($qianfan_config['cloud_allow_notice']) ? $qianfan_config['cloud_allow_notice'] : 0;
        $this->replynotice = isset($qianfan_config['cloud_reply_notice']) ? $qianfan_config['cloud_reply_notice'] : 0;
        $this->replypush = isset($qianfan_config['cloud_thread_replypush']) && is_array($qianfan_config['cloud_thread_replypush']) ?
            $qianfan_config['cloud_thread_replypush'] : array();
        $this->fidpush = isset($qianfan_config['cloud_fids_push']) && is_array($qianfan_config['cloud_fids_push']
        ) ? $qianfan_config['cloud_fids_push'] : array();
        $this->app_pic =isset($qianfan_config['app_pic']) ? $qianfan_config['app_pic'] : '';
    }

    public function discuzcode($param)
    {
        global $_G;
        if ($param['caller'] == 'discuzcode') {
            // iframe
//            $_G['discuzcodemessage'] = preg_replace('/\[iframe\](.+?)\[\/iframe\]/', '<iframe height=428 width=640 frameborder="0" scrolling="no" src="\\1" frameborder=0 allowfullscreen></iframe>', $_G['discuzcodemessage']);

            // 千帆富文本
            if (strpos($_G['discuzcodemessage'], "[qianfan_html]") !== false) {

                // 富文本有投票、打赏可见等高级功能的
                if(strpos($_G['discuzcodemessage'], "<!-- qf-special-start") !== false && strpos($_G['discuzcodemessage'], "qf-special-end -->") !== false){
                    $_G['discuzcodemessage'] = str_replace('<!-- qf-special-start', '', $_G['discuzcodemessage']);
                    $_G['discuzcodemessage'] = str_replace('qf-special-end -->', '', $_G['discuzcodemessage']);
                }

                $_G['discuzcodemessage'] =htmlspecialchars_decode($_G['discuzcodemessage']);
                if(!empty($this->app_pic)){
                    // img
                    if(strpos($_G['discuzcodemessage'], "<img") !== false){
                        if (preg_match_all('/\<img.*?src="(.*?)".*?>/is',$_G['discuzcodemessage'], $matches)) {
                            foreach ($matches[0] as $k=>$v) {
                                if(strpos($v, "data-qf-origin=") !== false){
                                    if (preg_match_all('/\<img.*?src="(.*?)".*?data-qf-origin="(.*?)".*?>/is', $v, $new_imgs)) {
                                        $_G['discuzcodemessage'] = str_replace($new_imgs[1][0], $this->app_pic .'/'. $new_imgs[2][0], $_G['discuzcodemessage']);
                                    }
                                }
                                // 其他图片 表情
                                if(strpos($v, "data-smilie-id=") !== false){
                                    $pic = explode("/", $matches[1][$k]);
                                    $_G['discuzcodemessage'] = str_replace($matches[1][$k], $this->app_pic . substr($matches[1][$k], strlen($pic[0].'//'.$pic[2])), $_G['discuzcodemessage']);
                                }
                            }
                        }
                    }

                    // video
                    if(strpos($_G['discuzcodemessage'], "<video") !== false && strpos($_G['discuzcodemessage'], "</video>") !== false){
                        if (preg_match_all('/\<video.*?src="(.*?)".*?><\/video>/is',$_G['discuzcodemessage'], $matches)) {
                            foreach ($matches[0] as $v) {
                                if(strpos($v, "data-qf-origin=") !== false){
                                    if (preg_match_all('/\<video.*?src="(.*?)".*?data-qf-origin="(.*?)".*?><\/video>/is', $v, $new_videos)) {
                                        $_G['discuzcodemessage'] = str_replace($new_videos[1][0], $this->app_pic .'/'. $new_videos[2][0], $_G['discuzcodemessage']);
                                    }
                                    // video 水印
                                    if (preg_match_all('/\<video.*?poster="(.*?)".*?data-qf-poster-origin="(.*?)".*?><\/video>/is', $v, $watermark)) {
                                        $_G['discuzcodemessage'] = str_replace($watermark[1][0], $this->app_pic .'/'. $watermark[2][0], $_G['discuzcodemessage']);
                                    }

                                    // 禁止下载视频
                                    if(defined('CURSCRIPT') && CURSCRIPT == 'forum' && defined('CURMODULE') && CURMODULE == 'viewthread') {
                                        $videoStyle = '<video class="qf_video" controlslist="nodownload" style="background-color: black;"';
                                        $_G['discuzcodemessage'] = preg_replace('/\<video class="qf_video" style="(.+?)"/', $videoStyle, $_G['discuzcodemessage']);
                                    }
                                }
                            }
                        }
                    }

                    //link 替换url
                    if (preg_match_all('/\<link.*?href="(.*?)".*?data-qf-origin="(.*?)".*?>/is', $_G['discuzcodemessage'], $matches)) {
                        foreach ($matches[1] as $k=>$v) {
                            $_G['discuzcodemessage'] = str_replace($v, $this->app_pic . $matches[2][$k], $_G['discuzcodemessage']);
                        }
                    }
                }
                // xss <script> 去除标签
                if (preg_match_all('/\<script.*?<\/script>/is',$_G['discuzcodemessage'],$matches)) {
                    foreach($matches as $v){
                        $_G['discuzcodemessage'] = str_replace($v, '' , $_G['discuzcodemessage']);
                    }
                }
            }

            // @  [qf_at=1234]sunbing1[/qf_at]
            if(strpos($_G['discuzcodemessage'], "[qf_at") !== false && strpos($_G['discuzcodemessage'], "[/qf_at]") !== false) {
                if (defined('CURSCRIPT') && CURSCRIPT == 'plugin' && defined('CURMODULE') && CURMODULE == 'qianfan') {
                    $_G['discuzcodemessage'] = preg_replace('/\[qf_at=(.+?)\](.+?)\[\/qf_at\]/', '<span class="qianfan_at" data-uid="\\1">@\\2&nbsp;</span>', $_G['discuzcodemessage']);
                } else {
                    $_G['discuzcodemessage'] = preg_replace('/\[qf_at=(.+?)\](.+?)\[\/qf_at\]/', '<a href="' . $_G['siteurl'] .'home.php?mod=space&amp;uid=\\1" target=\"_blank\">@\\2</a>', $_G['discuzcodemessage']);
                    /* 匿名函数 php>=5.3
                    $_G['discuzcodemessage'] = preg_replace_callback(
                        '/\[qf_at=(.+?)\](.+?)\[\/qf_at\]/',
                        function ($matches) {
                            global $_G;
                            if ($matches[1] > 0 && !empty($matches[2])) {
                                $url = $_G['siteurl'] . 'home.php?mod=space&amp;uid=' . $matches[1];
                                $re = '<a href="' . $url . '" target=\"_blank\">@' . $matches[2] . '</a>';
                                return $re;
                            }
                            return '';
                        },
                        $_G['discuzcodemessage']
                    );
                    */
                }
            }

            // video
            $rand = rand(1, 99);
            if (strpos($_G['discuzcodemessage'], "[qf_video") !== false && strpos($_G['discuzcodemessage'], "[/qf_video]") !== false) {
                if (defined('CURSCRIPT') && CURSCRIPT == 'plugin' && defined('CURMODULE') && CURMODULE == 'qianfan') {
                    $videoHtml = '<p><video class="qf-video" style="background-color: black; margin:m.*, mc.* 0.16rem 0;" controls poster="\\3" preload="none" controlslist="nodownload" width="95%" src="\\4?'.$rand.'"></video></p>';
                }else{
                    $videoHtml = '<video class="qf-video" style="background-color: black" controls poster="\\3" preload="none" controlslist="nodownload" width="95%" src="\\4?'.$rand.'"></video><br>';
                }

                $_G['discuzcodemessage'] = preg_replace('/\[qf_video w=(.+?) h=(.+?) poster=(.+?)\](.+?)\[\/qf_video\]/', $videoHtml, $_G['discuzcodemessage']);
            }
            // 自定义标签处理成class
            if(strpos($_G['discuzcodemessage'], "[qf_") !== false && strpos($_G['discuzcodemessage'], "[/qf_") !== false) {
                if(preg_match('/\[qf_(.+?)]/', $_G['discuzcodemessage'], $matches)) {
                    $_G['discuzcodemessage'] = str_replace('[qf_'.$matches[1].']', '<div class="qf_'.$matches[1].'">', $_G['discuzcodemessage']);
                    $_G['discuzcodemessage'] = str_replace('[/qf_'.$matches[1].']',  '</div>', $_G['discuzcodemessage']);
                }

            }
            // 大图表情
            if (strpos($_G['discuzcodemessage'], "[bigface]") !== false && strpos($_G['discuzcodemessage'], "[/bigface]") !== false) {
                if (defined('CURSCRIPT') && CURSCRIPT == 'plugin' && defined('CURMODULE') && CURMODULE == 'qianfan') {
                    $bigfaceHtml = '<img class="bigface" src="\\1" width="200">';
                } else {
                    $bigfaceHtml = '<img class="bigface" src="\\1" width="200">';
                }
                $_G['discuzcodemessage'] = preg_replace('/\[bigface\](.+?)\[\/bigface\]/', $bigfaceHtml, $_G['discuzcodemessage']);
            }
        }
        if ($param['caller'] == 'messagecutstr') {
            $_G['discuzcodemessage'] = preg_replace('/\[tthread=(.+?)\](.*?)\[\/tthread\]/', '', $_G['discuzcodemessage']);
        }
    }

}

class mobileplugin_qianfan_forum extends mobileplugin_qianfan
{
    public function post_bottom_mobile_output($value)
    {
        global $_G;
        // edit thread
        $postMessage = array('post_edit_succeed', 'edit_newthread_mod_succeed');
        if(IN_QIANFAN && isset($value['message']) && (in_array($value['message'], $postMessage))) {
            $tid = !empty($value['values']['tid']) ? $value['values']['tid'] : 0;
            showmessage('qianfan:'.$value['message'], '', array('tid' => $tid));
        }
    }

    public function viewthread_posttop_mobile_output()
    {
        global $_G, $postlist;
        foreach ($postlist as $k => $post) {
            if (isset($post['invisible']) && $post['invisible'] == -3 && empty($_GET['modthreadkey']) && $post['first'] == 0) {
                unset($postlist[$k]);
            }
        }
        return array();
    }

    // 发帖回帖成功后
    public function post_qianfan_message($params)
    {
        global $_G;

        if (isset($params['param'][0]) &&  $params['param'][0] == 'post_reply_succeed') {

            $configPath = rtrim(DISCUZ_ROOT, '/') . DIRECTORY_SEPARATOR . 'data' . DIRECTORY_SEPARATOR . 'sysdata' . DIRECTORY_SEPARATOR .
                'cache_qianfan_config.php';
            $cloud_host = $cloud_secretkey = $reply_notice = '';
            if (file_exists($configPath)) {
                require($configPath);
                $cloud_host = isset($qianfan_config['cloud_host']) ? $qianfan_config['cloud_host'] : '';
                $cloud_secretkey = isset($qianfan_config['cloud_secretkey']) ? $qianfan_config['cloud_secretkey'] : '';
                $reply_notice = isset($qianfan_config['cloud_reply_notice']) ? $qianfan_config['cloud_reply_notice'] : 0;
            }
            // 评论通知
            if (isset($params['param'][2]['pid'])) {
                if ($reply_notice) {
                    $pid = (int)$params['param'][2]['pid'];
                    $quote_uid = 0;
                    if (isset($_GET['reppid']) && $_GET['reppid'] > 0) {
                        $quote_reply = DB::fetch_first( "select authorid from %t where pid=%d",array('forum_post', $_GET['reppid']));
                        $quote_uid = isset($quote_reply['authorid']) && ($quote_reply['authorid'] != $_G['forum_thread']['authorid']) ? $quote_reply['authorid'] : 0;
                    }

                    $postParams = array(
                        'from' => $_G['uid'],
                        'from_username' => strtoupper($_G['charset']) == 'UTF-8' ? $_G['member']['username'] : diconv($_G['member']['username'], $_G['charset'], 'UTF-8'),
                        'to' => $_G['forum_thread']['authorid'],
                        'tid' => $_G['forum_thread']['tid'],
                        'pid' => $pid,
                        'title' => strtoupper($_G['charset']) == 'UTF-8' ? $_G['forum_thread']['subject'] : diconv($_G['forum_thread']['subject'], $_G['charset'], 'UTF-8'),
                        'content' => strtoupper($_G['charset']) == 'UTF-8' ? $_GET['message'] : diconv($_GET['message'], $_G['charset'], 'UTF-8'),
                        'quote_uid' => $quote_uid,
                        'anonymous' => isset($_POST['isanonymous']) ? (int)$_GET['isanonymous'] : 0
                    );

                    $param = array();
                    $param['reply'] = json_encode(array($postParams));
                    $apiUrl = rtrim($cloud_host, '/') . '/api1_2/thread/reply';
                    $this->qfRequest($cloud_secretkey, $apiUrl, array(), $param);
                }
            }
        }
    }
    protected function qfRequest($secret_key, $url, $get_params, $post_data = array())
    {
        $timeout = 5;
        $nonce = rand(10000, 99999);
        $timestamp = time();
        $array = array($nonce, $timestamp, $secret_key);
        sort($array, SORT_STRING);
        $token = md5(implode($array));
        $params['nonce'] = $nonce;
        $params['timestamp'] = $timestamp;
        $params['token'] = $token;
        $params = array_merge($params, $get_params);
        $url .= '?';
        foreach ($params as $k => $v) {
            $url .= $k . '=' . $v . '&';
        }
        $url = rtrim($url, '&');
        $curlHandle = curl_init();
        curl_setopt($curlHandle, CURLOPT_URL, $url);
        curl_setopt($curlHandle, CURLOPT_HEADER, 0);
        curl_setopt($curlHandle, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curlHandle, CURLOPT_USERAGENT, 'bbs, qianfan');

        curl_setopt($curlHandle, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($curlHandle, CURLOPT_SSL_VERIFYHOST, FALSE);
        curl_setopt($curlHandle, CURLOPT_POST, count($post_data));
        curl_setopt($curlHandle, CURLOPT_POSTFIELDS, $post_data);
        curl_setopt($curlHandle, CURLOPT_CONNECTTIMEOUT, $timeout);
        curl_setopt($curlHandle, CURLOPT_TIMEOUT, $timeout);

        $data = curl_exec($curlHandle);
        $status = curl_getinfo($curlHandle, CURLINFO_HTTP_CODE);
        if ($status != 200) {
            return false;
        }
        curl_close($curlHandle);
        return $data;
    }

}