<?php
/**
 * Created by PhpStorm.
 * User: zhaofei
 * Date: 15/11/11
 * Time: 下午2:41
 */

if (!defined('IN_DISCUZ')) {
    exit('Access Denied');
}

class ForumThread
{

    const DISPLAY_ORDER_GLOBAL = 3;  // 全局置顶
    const DISPLAY_ORDER_GROUP = 2;   // 分类置顶
    const DISPLAY_ORDER_FORUM = 1;   // 本版置顶
    const DISPLAY_ORDER_NORMAL = 0;
    const DISPLAY_ORDER_CHECK = -2;  // 审核中

    /**
     * @param $post
     * @return mixed
     */
    public static function parsePostMessage(&$post, $type = 0)
    {
        global $_G;
        //兼容MP3 ios播放 获取真实地址
        if (preg_match_all("/\s*\[audio\](.+?)\[\/audio\]\s*/is", $post['message'], $matches)) {
            $setting = C::t('common_setting')->fetch_all('ftp');
            $setting['ftp'] = dunserialize($setting['ftp']);
            foreach ($matches[1] as $key => $val) {
                $aid = '';
                $url = $matches[1][$key];
                str_replace('&amp;', '&', $url);
                if (is_int(strpos($url, 'mod=attachment&aid='))) {
                    $query = parse_url($url, PHP_URL_QUERY);
                    parse_str($query);
                    if ($aid) {
                        @list($aid, $k, $t, $uid, $table_id) = daddslashes(explode('|', base64_decode($aid)));
                        $aid = intval($aid);
                    }
                } elseif (is_int(strpos($url, 'attach://'))) {
                    if (preg_match('/attach:\/\/(\d+).*/', $url, $m)) {
                        $aid = intval($m[1]);
                    }
                }
                if (is_int($aid)) {
                    $table_id = 'aid:' . $aid;
                    if ($attach = C::t('forum_attachment_n')->fetch($table_id, $aid)) {
                        if ($attach['remote']) {
                            $file_prefix = trim($setting['ftp']['attachurl'], '/') . '/forum/';
                        } else {
                            $file_prefix = trim($_G['siteurl'], '/') . '/data/attachment/forum/';
                        }
                        $file = isset($attach['attachment']) ? $attach['attachment'] : null;
                        if ($file && substr($file, -4) == '.mp3') {
                            $mp3_file = $file_prefix . $file;
                            $post['message'] = str_replace($matches[0][$key], '[audio]' . $mp3_file . '[/audio]', $post['message']);
                        }
                    }
                }
            }
        }
        if ($post['bbcodeoff'] != 1) {
            // 转换视音频，为了不走 discuz 原先的流程
            $post['message'] = preg_replace_callback(
                '/\[(audio|media|flash).*?\](.*?)\[\/\1\]/s',
                function ($matches) {
                    $string = "";
                    switch ($matches[1]) {
                        case "audio":
                            $string = "[qianfan_audio={$matches[2]}]";
                            break;
                        case "media":
                        case "flash":
                            $string = "[qianfan_media]{$matches[2]}[/qianfan_media]";
                            break;
                        default:
                            break;
                    }
                    return $string . "\r\n";
                }, $post['message']
            );

            //兼容html <embed>标签
            if (preg_match_all('/<embed src="(.+?)".*?>(<\/embed>)?/', $post['message'], $matches)) {
                foreach ($matches[1] as $key => $val) {
                    $post['message'] = str_replace($matches[0][$key], '[qianfan_media]' . $matches[1][$key] . '[/qianfan_media]', $post['message']);
                }
            }

            //qq交谈
            if (preg_match_all('/\[qq\](.+?)\[\/qq\]/', $post['message'], $matches)) {
                foreach ($matches[1] as $key => $val) {
                    $post['message'] = str_replace($matches[0][$key], '[qianfan_qq]' . $matches[1][$key] . '[/qianfan_qq]', $post['message']);

                }
            }
            //code兼容
            if (preg_match_all("/\s*\[code\](.+?)\[\/code\]\s*/is", $post['message'], $matches)) {
                foreach ($matches[1] as $key => $val) {
                    $post['message'] = str_replace($matches[0][$key], '[qianfan_code]' . $matches[1][$key] . '[/qianfan_code]', $post['message']);

                }
            }
        }

        /*
        // 转换超链接
        $post['message'] = preg_replace_callback('/\[url=?(.*?)\](.*?)\[\\/url\]/', create_function('$matches', '
                $matches[1] || $matches[1] = $matches[2];
                $matches[1] = WebUtils::getHttpFileName($matches[1]);
                return "[mobcent_br]\r\n[mobcent_url={$matches[1]}(title={$matches[2]})]\r\n";
            '),
            $post['message']
        );
        */

        $post = ForumThread::parsePostMessage2Html($post, $type);

        $content = ForumThread::handlePostContent($post['message']);

        return $content;
    }


    /**
     * 处理主题帖内容，将内容转换成HTML
     * @param $content
     * @return mixed
     */
    public static function parsePostMessage2Html(&$post, $type = 0)
    {
        global $_G;

        require_once(Yii::getPathOfAlias('application.components.func') . DIRECTORY_SEPARATOR . 'forum_viewthread.php');

        loadcache('usergroups');
        $userInfo = getuserbyuid($post['authorid'], 1);
        $post = array_merge($userInfo, $post);

        //处理主题价格
        $_G['forum_threadpay'] = false;
        if ($post['first']) {
            if ($_G['forum_thread']['price'] > 0 && $_G['forum_thread']['special'] == 0) {
                if ($_G['setting']['maxchargespan'] && TIMESTAMP - $_G['forum_thread']['dateline'] >= $_G['setting']['maxchargespan'] * 3600) {
                    C::t('forum_thread')->update($_G['tid'], array('price' => 0), false, false, $archiveid);
                    $_G['forum_thread']['price'] = 0;
                } else {
                    $exemptvalue = $_G['forum']['ismoderator'] ? 128 : 16;
                    if (!($_G['group']['exempt'] & $exemptvalue) && $_G['forum_thread']['authorid'] != $_G['uid']) {
                        if (!(C::t('common_credit_log')->count_by_uid_operation_relatedid($_G['uid'], 'BTC', $_G['tid']))) {
                            require_once libfile('thread/pay', 'include');
                            $_G['forum_threadpay'] = true;
                        }
                    }
                }
            }
        }

        $lastvisit = $_G['member']['lastvisit'];
        $ordertype = $maxposition = 0;

        // 处理附件
        $_G['forum_attachpids'] = $_G['forum_attachtags'] = array();
        $_G['tid'] = $post['tid'];

        // 去掉干扰码
        $_G['forum']['jammer'] = 0;
        // 用户组默认允许访问图片
        $_G['group']['allowgetimage'] = 1;

        $postlist = array();
        //处理帖子内容
        $post = viewthread_procpost($post, $lastvisit, $ordertype, $maxposition);

        $postlist[$post['pid']] = $post;
        //处理帖子附件
        if ($_G['forum_attachpids'] && !defined('IN_ARCHIVER')) {
            require_once libfile('function/attachment');
            if (is_array($threadsortshow) && !empty($threadsortshow['sortaids'])) {
                $skipaids = $threadsortshow['sortaids'];
            }
            parseattach($_G['forum_attachpids'], $_G['forum_attachtags'], $postlist, $skipaids);
        }

        //如果找不到内容
        if (empty($postlist)) {

        } elseif (!defined('IN_MOBILE_API')) {
            foreach ($postlist as $pid => $post) {
                // 取出没有插入的附件
                if (!empty($post['imagelist'])) {
                    $postlist[$pid]['message'] .= showattach($post, 1);
                }

                if ($post['attachlist']) {
                    $postlist[$pid]['message'] .= showattach($post);
                }

                // 将本地附件拼接上论坛域名 For Pethome
                if (isset($post['attachments']) && $post['attachments']) {
                    foreach ($post['attachments'] as $attachment) {
                        if (isset($attachment['remote']) && !$attachment['remote']) {
                            if (strpos($_G['setting']['attachurl'], 'http') === false) {
                                $search = rtrim($attachment['url'], '/') . '/' . ltrim($attachment['attachment'], '/');
                                $replacement = rtrim($_G['setting']['siteurl'], '/') . '/' . trim($attachment['url'], '/') . '/' . ltrim($attachment['attachment'], '/');
                                $postlist[$pid]['message'] = str_replace($search, $replacement, $postlist[$pid]['message']);
                            }
                        }
                    }
                }

                // 将不存在的附件移除
                $postlist[$pid]['message'] = preg_replace("/\[attach\]\d+\[\/attach\]/i", '', $postlist[$pid]['message']);
            }
        }

        //将主题帖内容转换成 需要购买的文案
        if ($post['first'] && $_G['forum_threadpay']) {
            $postlist[$pid]['message'] = $thread['freemessage'];
        }

        // 处理楼层屏蔽
        $shield = 0;
        if (($postlist[$pid]['status'] & 1)) {
            if ($_G['forum']['ismoderator']) {
                $postlist[$pid]['message'] = Tool::getInstance()->lang('shield by manager to admin') . '<p></p>' . $postlist[$pid]['message'];
            } else {
                if ($type == 1) {
                    //是主题的情况
                    $postlist[$pid]['message'] = Tool::getInstance()->lang('shield by manager to user');
                } else {
                    $postlist[$pid]['message'] = Tool::getInstance()->lang('shield by manager');
                }

            }
            $shield = 1;
        }

        // 已经屏蔽过
        if (!$shield) {
            if ($_G['setting']['bannedmessages'] & 1 && (($post['authorid'] && !$post['username']) || ($_G['thread']['digest'] == 0 && ($post['groupid'] == 4 || $post['groupid'] == 5 || $post['memberstatus'] == '-1')))) {
                if ($_G['forum']['ismoderator']) {
                    $postlist[$pid]['message'] = Tool::getInstance()->lang('author shield by manager to admin') . '<p></p>' .
                        $postlist[$pid]['message'];
                } else {
                    if ($type == 1) {
                        //是主题的情况
                        if ($post['groupid'] == 5) {
                            $postlist[$pid]['message'] = Tool::getInstance()->lang('ban author shield by manager to user');
                        } else {
                            $postlist[$pid]['message'] = Tool::getInstance()->lang('author shield by manager to user');
                        }
                    } else {
                        if ($post['groupid'] == 5) {
                            $postlist[$pid]['message'] = Tool::getInstance()->lang('ban author shield by manager');
                        } else {
                            $postlist[$pid]['message'] = Tool::getInstance()->lang('author shield by manager');
                        }
                    }

                }
            }
        }

        return $postlist[$post['pid']];
    }

    /**
     * 处理POST的内容
     * @param $content
     * @return mixed
     */
    public static function handlePostContent($content)
    {
        global $_G;
        //处理\r \n
        $content = str_replace("\r", '', $content);
        $content = str_replace("\n", '', $content);

        //处理引用内容 to do

        // 处理图片缩略图
        $content = preg_replace('/<style>.*?<\/style>/', '', $content);

        // 处理表情
        if (preg_match_all('/<img src="([^>]+?)" smilieid="(\d+)".*?>/', $content, $matches)) {
            foreach ($matches[1] as $key => $val) {
                if (!is_int(strpos($val, 'http://')) && !is_int(strpos($val, 'https://'))) {
                    $content = str_replace($matches[0][$key], '<img src="' . rtrim($_G['setting']['siteurl'], '/') . '/' . ltrim($val, '/') . '" smilieid="' . $matches[2][$key] . '" width="24" height="24" />', $content);
                }
            }
        }

        if (preg_match_all('/<ignore_js_op>[\s\S]+?<\/ignore_js_op>/', $content, $matches)) {
            // 处理下载附件
            $attachPattern = '/<a.*?href=\"(.+?)\".*?>(.+?)<\/a>/';
            // 处理图片附件
            $imgPattern = "/<img.*?aid=\"(\d+)\".*?(zoomfile|makefile)=\"(.+?)\".*?\/>/";
            foreach ($matches[0] as $key => $val) {
                if (preg_match($imgPattern, $val, $match)) {
                    if (!is_int(strpos($match[3], $_G['setting']['siteurl'])) && is_int(strpos($match[3],
                                'forum.php')
                        )) {
                        if (strpos($_G['setting']['attachurl'], 'http') === false) {
                            $match[3] = rtrim($_G['setting']['siteurl'], '/') . '/' . $match[3];
                        }

                    }
                    $content = str_replace($matches[0][$key], '<div style="text-align: center;"><img aid="' . $match[1] . '" src="' . $match[3]
                        . '" /></div>', $content);

                } elseif (preg_match($attachPattern, $val, $match)) {
                    // 附件小图标
                    $img = $size = $aid = '';
                    if (preg_match_all('/\<img.*?src="(.*?)".*?>/is', $val, $typeimg)) {
                        $img = $typeimg[1][0];
                    }

                    // 下载次数及附件大小
                    if (preg_match_all('/<em.*?class=\"xg1\".*?>(.+?)<\/em>/', $val, $size)) {
                        $size = $size[1][0];
                    }

                    if (preg_match_all('/<span.*?id=\"attach_(.+?)\".*?>/', $val, $aid)) {
                        $aid = $aid[1][0];
                    }

                    $url = rtrim($_G['setting']['siteurl'], '/') . '/';

                    $html = '<div class="attach_download"><img class="vm" width="30px" height="30px" src="' . $url . $img . '" /><span id="attach_' . $aid . '" initialized="true"><a style="font-size:14px" href="' . $url . $match[1] . '">' . $match[2] . '</a><span style="color:#989898">' . $size . '</span></span></div>';
                    $content = str_replace($matches[0][$key], $html, $content);
                }


            }
        }

        //qq交谈
        if (preg_match_all('/\[qianfan_qq\](.+?)\[\/qianfan_qq\]/', $content, $matches)) {
            foreach ($matches[1] as $key => $val) {
                $content = str_replace($matches[0][$key], '<a href="mqq://im/chat?chat_type=wpa&uin=' . $matches[1][$key] . '&version=1&src_type=web" target="_blank"><img src="static/image/common/qq_big.gif" border="0"></a><br/>', $content);

            }
        }

        return $content;
    }

    /**
     * 更新帖子阅读量
     * @param $tableid
     */
    public static function updateThreadViews($tableid, $readnum = 1)
    {
        global $_G;
        $reads = intval(Yii::app()->params['cloud_reads']);
        if (!is_numeric($reads)) {
            $reads = 1;
        }
        $reads = $reads * $readnum;//缓存过来的值
        if (!$_G['setting']['preventrefresh'] || $_G['cookie']['viewid'] != 'tid_' . $_G['tid']) {
            if (!$tableid && $_G['setting']['optimizeviews']) {
                if (isset($_G['forum_thread']['addviews'])) {
                    if ($_G['forum_thread']['addviews'] < 100) {
                        //C::t('forum_threadaddviews')->update_by_tid($_G['tid']);
                        DB::query('UPDATE %t SET `addviews`=`addviews`+%d WHERE tid=%d', array('forum_threadaddviews', $reads, $_G['tid']));
                        C::t("forum_threadaddviews")->increase_cache(array($_G['tid']), array('addviews' => $reads));
                    } else {
                        if (!discuz_process::islocked('update_thread_view')) {
                            $row = C::t('forum_threadaddviews')->fetch($_G['tid']);
                            C::t('forum_threadaddviews')->update($_G['tid'], array('addviews' => 0));
                            C::t('forum_thread')->increase($_G['tid'], array('views' => $row['addviews'] + $reads), true);
                            discuz_process::unlock('update_thread_view');
                        }
                    }
                } else {
                    C::t('forum_threadaddviews')->insert(array('tid' => $_G['tid'], 'addviews' => $reads), false, true);
                }
            } else {
                C::t('forum_thread')->increase($_G['tid'], array('views' => $reads), true, $tableid);
            }
        }
    }

    /**
     * 帖子附件地址
     * @param $attach
     * @return string
     */
    public static function getAttachUrl($attach)
    {
        global $_G;

        //合并论坛附件地址变成绝对地址
        if (strpos($attach['attachment'], 'http://') === 0 || strpos($attach['attachment'], 'https://') === 0) {
            return $attach['attachment'];
        }

        if ($attach['remote']) {
            $attachUrlPrefix = $_G['setting']['ftp']['attachurl'];
        } else {
            if (strpos($_G['setting']['attachurl'], 'http') === false) {
                $attachUrlPrefix = rtrim($_G['setting']['siteurl'], '/') . '/' . trim($_G['setting']['attachurl'], '/');
            } else {
                $attachUrlPrefix = rtrim($_G['setting']['attachurl'], '/');
            }

        }

        return $attachUrlPrefix . '/forum/' . ltrim($attach['attachment'], '/');
//        $attachUrlPrefix = $attach['remote'] ? $_G['setting']['ftp']['attachurl'] : $attach['attachurl'];  // $_G['setting']['attachurl'];
//        $attachUrl = $attachUrlPrefix . 'forum/';
//        return $attachUrl . $attach['attachment'];
    }

    /**
     * 获取投票贴信息
     * 使用该方法先加载qianfan/protected/components/func/forum_viewthread.php
     * @param $tid
     * @return array
     */
    public static function getVoteInfo($tid)
    {
        global $_G;
        $_G['tid'] = $tid;
        $_G['forum_thread']['starttime'] = gmdate($_G['forum_thread']['dateline']);
        $_G['forum_thread']['remaintime'] = '';
        $polls = $polloptions = array();
        require_once libfile('function/forumlist');
        require_once libfile('thread/poll', 'include');

        $voters = array_slice($voters, 0, 20);
        if (!empty($voters)) {
            $user = DB::fetch_all('SELECT uid,username FROM %t WHERE uid IN (%n)', array('common_member', $voters));
        }

        if (isset($options) && isset($expiration)) {
            $polls = array
            (
                'allowvotepolled' => intval(!$allowvotepolled), // 是否已经投过票
                'visiblepoll' => $visiblepoll, // 是否可见
                'isimage' => intval($isimagepoll), // 是否是图片投票
                'multiple' => $multiple, // 是否多选，checkbox or radio
                'maxchoices' => $maxchoices, // 最大可选数
                'expiration' => $expiration, // 过期时间
                'overt' => $overt, // 是否公开投票参与人
                'voters' => $voterscount, //  投票人数
                'data' => $polloptions,
                'user' => $user
            );
        }

        return $polls;
    }

    /**
     * 活动贴的重新编辑
     * @param $topic
     * @return array
     */
    public static function getActivityThread($topic, $content)
    {
        global $_G;
        $activity = DB::fetch_first("SELECT * FROM %t WHERE tid = %d LIMIT 1", array('forum_activity', $topic['tid']));
        if (!empty($activity)) {

            //$apply已经参与活动的人的消息
            $apply = DB::fetch_all("SELECT * FROM %t WHERE tid = %d ORDER BY `applyid` DESC LIMIT 10", array('forum_activityapply', $topic['tid']));
            //总参加人数
            $numbs = DB::fetch_first("SELECT count('applyid') as numbs FROM %t WHERE tid = %d ", array('forum_activityapply', $topic['tid']));

            $user = array();
            if (!empty($apply)) {
                foreach ($apply as $val) {
                    $user[] = array(
                        'uid' => intval($val['uid']),
                        'username' => $val['username'],
                        'icon' => discuz_uc_avatar($val['uid'], 'big', true)
                    );
                }
            }
            $img = '';
            if ($activity['aid']) {
                $tmp_img = '<div style="text-align: center;"><img aid="' . $activity['aid'] . '"';
                if ($img = strstr($content, $tmp_img)) {
                    $content = str_replace($img, '', $content);
                }
            }
            $reg_data = array();

            if ($activity['ufield']) {
                $activity['ufield'] = dunserialize($activity['ufield']);
                loadcache('profilesetting');
                if (!empty($activity['ufield']['userfield'])) {
                    foreach ($activity['ufield']['userfield'] as $value) {
                        $choices = '';
                        if ($_G['cache']['profilesetting'][$value]['choices']) {
                            $choices = str_replace(PHP_EOL, ',', $_G['cache']['profilesetting'][$value]['choices']);
                        }
                        $reg_data[] = array(
                            'title' => $_G['cache']['profilesetting'][$value]['title'],
                            'name' => $value,
                            'type' => $_G['cache']['profilesetting'][$value]['formtype'],
                            'choices' => $choices,
                            'is_must' => 1,
                        );


                    }
                }
                if (!empty($activity['ufield']['extfield'])) {
                    foreach ($activity['ufield']['extfield'] as $fieldid) {
                        $reg_data[] = array(
                            'title' => $fieldid,
                            'name' => $fieldid,
                            'type' => 'text',
                            'choices' => '',
                            'is_must' => 0,
                        );
                    }
                }
            }
            if (strtoupper($_G['charset']) != 'UTF-8') {
                $msg = mb_convert_encoding('留言', 'gbk', 'utf-8');
            } else {
                $msg = '留言';
            }
            $reg_data[] = array(
                'title' => $msg,
                'name' => 'message',
                'type' => 'text',
                'choices' => '',
                'is_must' => 0,
            );
            //是否报名
            $is_attend = 0;
            $applyid = DB::fetch_first("SELECT applyid FROM %t WHERE tid = %d AND uid=%d", array('forum_activityapply', $topic['tid'], $_G['uid']));
            if (isset($_G['uid']) && $_G['uid'] > 0 && !empty($applyid))
                $is_attend = 1;
            //数据处理
            $re = array(
                'class' => $activity['class'],                //活动类型
                'start_time' => $activity['starttimefrom'],   //开始时间
                'end_time' => $activity['starttimeto'],       //结束时间
                'place' => $activity['place'],                //地点
                'gender' => $activity['gender'],              //性别 0 不限；1 男；2 女
                'cost' => $activity['cost'],                  //每人花销
                'applynumber' => $numbs['numbs'],         //已报名人数
                'rest' => $activity['number'] - $activity['applynumber'],//剩余名额
                'expiration' => $activity['expiration'],      //报名截止时间
                'user' => $user,                               //参加活动的用户 前10
                'pass_num' => $activity['applynumber'],        // 已通过审核人数
                'img' => $img,                                //活动图片 html
                'is_attend' => $is_attend,                    //是否报名
                'reg_data' => $reg_data,                     //需要提交的数据

            );

            return array(
                're' => $re,
                'con' => $content
            );
        } else {
            Tool::getInstance()->fail_json(Code::ACTIVE_POST_NOT_EXIST, Tool::getInstance()->lang('active_post_not_exist'));
        }
    }

    /**
     * 商品贴的重新编辑
     * @param $topic
     * @return array
     */
    public static function getTradeThread($topic)
    {
        global $_G;
        $trade = DB::fetch_all("SELECT * FROM %t WHERE tid = %d ", array('forum_trade', $topic['tid']));
        if (!empty($trade)) {
            //编码转换
            if (strtoupper($_G['charset']) != 'UTF-8') {
                foreach ($trade as &$val) {
                    foreach ($val as &$v) {
                        if (is_string($v)) {
                            $v = iconv('GBK', 'UTF-8//IGNORE', $v);
                        }
                    }
                }
                unset($v);
                unset($val);
            }
            $content_con = '';
            $extra_pid = array();
            foreach ($trade as $value) {
                //商品这边商品内容的介绍跑到1楼去了
                //设置多余的楼层
                if ($value['pid'] > 0) {
                    $extra_pid[] = $value['pid'];
                }
                //商品类型
                $value['quality'] = $value['quality'] == 1 ? '全新商品' : '二手商品';
                //剩余时间
                $time = $value['expiration'] - time();
                if ($time > 0) {
                    $d = floor($time / (3600 * 24));
                    $h = floor(($time - ($d * 3600 * 24)) / 3600);
                    $t = $d . '天' . $h . '小时';
                } else {
                    $t = '成交结束';
                }
                //物流    3   虚拟物品
                //       1   卖家承担运费
                //       2  平邮 10 元 快递 12 元 EMS 22 元
                //      4   买家收到货物后直接支付给物流公司平邮 10 元 快递 12 元 EMS 22 元
                //      0   线下交易
                $transport = $value['transport'];
                $fee = '';
                if ($value['ordinaryfee'] > 0) $fee .= '平邮&nbsp;' . $value['ordinaryfee'] . '元&nbsp;';
                if ($value['expressfee'] > 0) $fee .= '快递&nbsp;' . $value['expressfee'] . '元&nbsp;';
                if ($value['emsfee'] > 0) $fee .= 'EMS&nbsp;' . $value['emsfee'] . '元';
                switch ($transport) {
                    case 0:
                        $transport = '线下交易';
                        break;
                    case 1:
                        $transport = '卖家承担运费';
                        break;
                    case 2:
                        if ($fee == '') $fee = '无运费';
                        $transport = $fee;
                        break;
                    case 3:
                        $transport = '虚拟物品';
                        break;
                    case 4:
                        $transport = '买家收到货物后直接支付给物流公司' . $fee;
                        break;
                    default:
                        $transport = '';
                }
                if ($transport) $transport = '<dt>运费:&nbsp;' . $transport . '</dt>';
                $address = $value['locus'] ? '<dt>地点:&nbsp;' . $value['locus'] . '</dt>' : '';
                $content_con .= '<special><h4>' . $value['subject'] . '</h4>
                                            <dt>商品类型:&nbsp;' . $value['quality'] . '</dt>
                                            ' . $transport . '
                                            <dt>商品数量:&nbsp;' . $value['amount'] . '</dt>
                                            <dt>累计售出:&nbsp;' . $value['totalitems'] . '</dt>
                                            ' . $address . '
                                            <dt>剩余时间:&nbsp;' . $t . '</dt>
                                            <strong>' . $value['price'] . '</strong>&nbsp;元&nbsp;&nbsp;
                                            <p ><del>' . $value['costprice'] . ' 元</del></p></special>[re]' . $value['pid'] . '[/re]<br>';

            }

            if (strtoupper($_G['charset']) != 'UTF-8') {
                $content_con = mb_convert_encoding($content_con, 'gbk', 'utf-8');
            }
            $content_con = addslashes($content_con);

            return array(
                'con' => $content_con,
                'pid' => $extra_pid
            );

        } else {
            Tool::getInstance()->fail_json(Code::GOODS_POST_NOT_EXIST, Tool::getInstance()->lang('goods_post_not_exist'));
        }
    }

    //获取分类信息相关类容
    public static function getSortInfo($sortid, $tid, $sort, $postdate)
    {
        global $_G;
        $sortMessage = '';
        $optionexpiration = 0;
        //重新优化 和论坛的处理不一样
        //----------------------------
        loadcache(array('threadsort_option_' . $sortid, 'threadsort_template_' . $sortid));
        $sortoptionarray = $_G['cache']['threadsort_option_' . $sortid];
        $optiondata = $_G['forum_option'] = array();
        require_once libfile('function/threadsort');
        if ($sortoptionarray) {
            foreach (C::t('forum_typeoptionvar')->fetch_all_by_tid_optionid($tid) as $option) {
                if ($option['expiration'] && $option['expiration'] <= TIMESTAMP) {
                    //信息已过期
                    $optionexpiration = 1;
                }
                $optiondata[$option['optionid']]['value'] = $option['value'];
                $optiondata[$option['optionid']]['expiration'] = $option['expiration'] && $option['expiration'] <= TIMESTAMP ? 1 : 0;

            }
            foreach ($sortoptionarray as $optionid => $option) {
                $_G['forum_option'][$option['identifier']]['title'] = $option['title'];
                $_G['forum_option'][$option['identifier']]['unit'] = $option['unit'];
                $_G['forum_option'][$option['identifier']]['type'] = $option['type'];
                if (!protectguard($option['protect'])) {
                    if (($option['expiration'] && !$optiondata[$optionid]['expiration']) || empty($option['expiration'])) {
                        if ($option['type'] == 'checkbox') {
                            $_G['forum_option'][$option['identifier']]['value'] = '';
                            foreach (explode("\t", $optiondata[$optionid]['value']) as $choiceid) {
                                $_G['forum_option'][$option['identifier']]['value'] .= $option['choices'][$choiceid] . '&nbsp;';
                            }
                        } elseif ($option['type'] == 'radio') {
                            $_G['forum_option'][$option['identifier']]['value'] = $option['choices'][$optiondata[$optionid]['value']];
                        } elseif ($option['type'] == 'select') {
                            $tmpchoiceid = $tmpidentifiervalue = array();
                            foreach (explode('.', $optiondata[$optionid]['value']) as $choiceid) {
                                $tmpchoiceid[] = $choiceid;
                                $tmpidentifiervalue[] = $option['choices'][implode('.', $tmpchoiceid)];
                            }
                            $_G['forum_option'][$option['identifier']]['value'] = implode(' &raquo; ', $tmpidentifiervalue);
                            unset($tmpchoiceid, $tmpidentifiervalue);
                        } elseif ($option['type'] == 'image') {
                            $imgoptiondata = dunserialize($optiondata[$optionid]['value']);
                            if (!$imgoptiondata['url']) $imgoptiondata['url'] = './static/image/common/nophoto.gif';
                            $_G['forum_option'][$option['identifier']]['value'] = '<img sortid="' . $sortid . '" aid="' . $imgoptiondata['aid'] . '" src="' . $imgoptiondata['url'] . '">';
                        } elseif ($option['type'] == 'url') {
                            $_G['forum_option'][$option['identifier']]['value'] = $optiondata[$optionid]['value'] ? "<a href=\"" . $optiondata[$optionid]['value'] . "\" target=\"_blank\">" . $optiondata[$optionid]['value'] . "</a>" : '';
                        } elseif ($option['type'] == 'number') {
                            $_G['forum_option'][$option['identifier']]['value'] = $optiondata[$optionid]['value'];
                        } else {
                            //把 内容为链接的文本转为超链接 todo
                            if (preg_match('/^http(s?):\/\/(?:[A-za-z0-9-]+\.)+[A-za-z]{2,4}(:\d+)?(?:[\/\?#][\/=\?%\-&~`@[\]\':+!\.#\w]*)?/', $optiondata[$optionid]['value'])) {
                                $optiondata[$optionid]['value'] = '<a href="' . $optiondata[$optionid]['value'] . '" target="_blank">' . $option['title'] . '</a>';
                            }
                            if ($option['type'] == 'textarea') {
                                $_G['forum_option'][$option['identifier']]['value'] = $optiondata[$optionid]['value'] != '' ? nl2br($optiondata[$optionid]['value']) : '';
                            } else {
                                $_G['forum_option'][$option['identifier']]['value'] = $optiondata[$optionid]['value'] != '' ? $optiondata[$optionid]['value'] : $option['defaultvalue'];
                            }
                        }
                    }
                } else {
                    if (empty($option['permprompt'])) {
                        $_G['forum_option'][$option['identifier']]['value'] = lang('forum/misc', 'view_noperm');
                    } else {
                        $_G['forum_option'][$option['identifier']]['value'] = $option['permprompt'];
                    }
                }
            }
        }
        //---------------------------------
        $optionlist = $_G['forum_option'];
        //编码转
        if (strtoupper($_G['charset']) != 'UTF-8') {
            foreach ($optionlist as &$val) {
                foreach ($val as &$vv) {
                    foreach ($vv as &$v) {
                        if (is_string($v)) {
                            $v = iconv('GBK', 'UTF-8//IGNORE', $v);
                        }
                    }
                }
            }
            unset($v);
            unset($val);
        }
        if (!empty($optionlist)) {
            $html = '<div class="typeoption"><table summary="threadsort" cellpadding="0" cellspacing="0" class="cgtl"><tr><th colspan="2" class="sorttitle">' . $sort . '</th></tr>';
            $htmlString = '';
            foreach ($optionlist as $val) {
                if ($val != 'info') {
                    $htmlStr = '<tr><th>' . $val['title'] . '</th><td>' . $val['value'] . $val['unit'] . '</td></tr>';
                    $htmlString .= $htmlStr;
                }
            }
            $htmlString .= '</table></div>';
            $html .= $htmlString;
            $sortMessage = $html;
            if (strtoupper($_G['charset']) != 'UTF-8') {
                $sortMessage = mb_convert_encoding($sortMessage, 'utf-8', 'gbk');
            }

        }
        // 分类信息期限
        if ($optionexpiration) {
            $sortMessage .= '<i>该信息已超过有效期，内容可能已失效</i><br>' . PHP_EOL;
        }
        if (strtoupper($_G['charset']) != 'UTF-8') {
            $sortMessage = mb_convert_encoding($sortMessage, 'gbk', 'utf-8');
        }
        $sortImg = array();
        if (preg_match_all('/<td><img.*?src=\"(.*?)\".*?><\/td>/i', $sortMessage, $matches)) {
            $sortImg = $matches[1];
        }

        return array($sortMessage, $sortImg);
    }


    /**
     * 处理内容中img标签图片，下载到本地
     *
     * @param $img
     * @param int $time
     * @param int $type
     * @return array|bool
     */
    public static function uploadImg($img, $time = 5, $type = 0)
    {
        global $_G;

        $save_dir = Yii::app()->getRuntimePath() . DIRECTORY_SEPARATOR;
        if (trim($save_dir) == '') {
            return false;
        }
        // 兼容非jpg/png/gif/等后缀的图片格式
        if ($type == 1) {
            $filename = $_G['uid'] . '_' . time() . rand(100000, 999999) . '.' . 'jpg';
        } else {
            $filename = '';
            if (preg_match('/^http.*?:\/\/.*?(\/(.+?)\.(png|jpg|jpeg|gif|bmp)).*?/i', $img, $matchs)) {
                $imgName = $matchs[1];
                if (preg_match('/([^\/])+$/', $imgName, $matchs)) {
                    $filename = $matchs[0];
                }
            }
        }

        //创建保存目录
        if (!is_dir($save_dir) && !mkdir($save_dir, 0777, true) && empty($filename)) {
            return false;
        }
        $path = $save_dir . $filename;
        if (file_exists($save_dir . $filename)) {
            return array('tmp_name' => $path, 'name' => $filename, 'type' => 'image/jpeg');
        }

        //获取远程文件
        //$content = @dfsockopen($img, 0, '', '', FALSE, '', $time);
        $content = self::DownAttach($img, 0, '', $time);
        if (!$content) {
            return false;
        }
        $fp2 = @fopen($save_dir . $filename, 'wb');
        fwrite($fp2, $content);
        fclose($fp2);

        // 验证是否是真实的图片
        $image_path = $save_dir . $filename;
        if (!@getimagesize($image_path) || abs(filesize($image_path)) < 1) {
            unlink($image_path);
            return false;
        }
        unset($content, $smiles_url);
        return array('tmp_name' => $path, 'name' => $filename, 'type' => 'image/jpeg');
    }

    /**
     * 把下载下来的图片，移动到data/attachment/对应文件夹，并且生成aid，插入对应表
     *
     * @param $file
     * @param $uid
     * @param string $type
     * @param int $extid
     * @param string $forcename
     * @return bool
     */
    public static function qianfanUpload($file, $uid, $type = 'forum', $extid = 0, $forcename = '')
    {
        global $_G;

        $attach = $file;
        $attach['name'] = trim($file['name']);
        $attach['size'] = filesize($file['tmp_name']);
        $attach['thumb'] = '';
        $upload = new discuz_upload();
        $attach['ext'] = $upload->fileext($file['name']);
        $type = $upload->check_dir_type($type);

        $attach['name'] = dhtmlspecialchars($file['name'], ENT_QUOTES);
        if (strlen($attach['name']) > 90) {
            $attach['name'] = cutstr($file['name'], 80, '') . '.' . $file['ext'];
        }
        $attach['isimage'] = $upload->is_image_ext($attach['ext']);
        $attach['extension'] = $upload->get_target_extension($attach['ext']);
        $attach['attachdir'] = $upload->get_target_dir($type, $extid);
        $attach['attachment'] = $attach['attachdir'] . $upload->get_target_filename($type, $extid, $forcename) . '.' . $attach['extension'];
        $attach['target'] = getglobal('setting/attachdir') . './' . $type . '/' . $attach['attachment'];

        // 复制到dz/data/attachment/对应文件夹
        $source = $attach['tmp_name'];
        $target = $attach['target'];
        if (@copy($source, $target)) {
            $succeed = true;
        } elseif (function_exists('move_uploaded_file') && @move_uploaded_file($source, $target)) {
            $succeed = true;
        } elseif (@is_readable($source) && (@$fp_s = fopen($source, 'rb')) && (@$fp_t = fopen($target, 'wb'))) {
            while (!feof($fp_s)) {
                $s = @fread($fp_s, 1280 * 1280);
                @fwrite($fp_t, $s);
            }
            fclose($fp_s);
            fclose($fp_t);
            $succeed = true;
        }
        if ($succeed) {
            @chmod($target, 0644);
            @unlink($source);
        } else {
            @unlink($source);
            return false;
        }

        // 插入数据库
        $aid = getattachnewaid($uid);
        list($width, $height) = @getimagesize($attach['target']);

        if ($width * $height > 2000 * 2000) {
            @unlink($attach['target']);
            return false;
        }

        $insert = array(
            'aid' => $aid,
            'dateline' => $_G['timestamp'],
            'filename' => dhtmlspecialchars($attach['name']),
            'filesize' => $attach['size'],
            'attachment' => $attach['attachment'],
            'isimage' => $attach['isimage'],
            'uid' => $uid,
            'thumb' => 0,
            'remote' => 0,
            'width' => $width,
        );
        C::t('forum_attachment_unused')->insert($insert);
        if ($attach['isimage'] && $_G['setting']['showexif']) {
            require_once libfile('function/attachment');
            $exif = getattachexif(0, $attach['target']);
            C::t('forum_attachment_exif')->insert($aid, $exif);
        }

        return $aid;
    }

    /**
     * 兼容wq_wechatcollection主题内容
     * @param $msg
     * @param $tid
     * @return string
     */
    public static function handleWqwechatcollection($msg, $tid)
    {
        if (file_exists(DISCUZ_ROOT . './source/plugin/wq_wechatcollecting/function/function_sync.php')) {
            $wq = DB::result_first("SHOW TABLES LIKE '%wechatcollecting_article'");
            if ($wq) {
                include_once DISCUZ_ROOT . './source/plugin/wq_wechatcollecting/function/function_sync.php';
                $msg = wq_mobcent_app_get_article_content($msg, $tid);

                if (strtoupper(CHARSET) == 'GBK') {
                    $msg = iconv('GBK', 'UTF-8//ignore', $msg);
                    $msg = iconv('UTF-8', 'GBK', $msg);
                }
            }
        }

        return $msg;
    }


    /**
     * 获取帖子/评论附件
     * @param $post_info
     * @param $threadlist
     * @param int $isRePid 0:返回tid为key的数据  1：返回pid为key的数据
     * @return array
     */
    public static function getAllAttaches($post_info, $threadlist, $isRePid = 0)
    {
        $tid_sortid = Tool::Array_Column($threadlist, 'sortid', 'tid');
        $tid_special = Tool::Array_Column($threadlist, 'special', 'tid');
        $pids = array();

        //兼容商品帖对应pid的问题
        foreach ($post_info as $key => $val) {
            $pid = $val['pid'];
            if ($tid_special[$key] == 2) {
                $pid += 1;
            }
            $pids[] = $pid;
        }

        if ($isRePid) {
            return self::getReplyAttaches($pids, $tid_sortid);
        }

        return self::getAttachesByPids($pids, $tid_sortid);

    }

    //获取指定帖的所有附件
    public static function getAttachesByPids($pids, $tid_sortid)
    {
        global $_G;

        //是否开启远程附件
        $setting = C::t('common_setting')->fetch_all('ftp');
        $setting['ftp'] = dunserialize($setting['ftp']);

        $tid_attachs = array();
        $attachs = C::t('forum_attachment')->fetch_all_by_id('pid', $pids);

        $aid_tableids = Tool::Array_Column($attachs, 'aid', 'tableid', true);
        $all_attachs = array();
        foreach ($aid_tableids as $k => $v) {
            $att = C::t('forum_attachment_n')->fetch_all($k, $v, false);
            $all_attachs = array_merge($att, $all_attachs);
        }
        foreach ($all_attachs as $val) {
            if ($val['isimage'] && isset($val['attachment'])) {
                $attachurl = ForumThread::getAttachUrl($val);
                //分类信息图片统一处理，开启远程附件后不显示data/attachment路径的图片
                if ($tid_sortid[$val['tid']] != '0' && $setting['ftp']['on'] == 1) {
                    if (is_int(strpos(strtolower($attachurl), 'data/attachment'))) {
                        continue;
                    }
                }
                $tid_attachs[$val['tid']][] = $attachurl;
            }

        }
        return $tid_attachs;
    }

    public static function getReplyAttaches($pids, $tid_sortid)
    {
        //是否开启远程附件
        $setting = C::t('common_setting')->fetch_all('ftp');
        $setting['ftp'] = dunserialize($setting['ftp']);

        $tid_attachs = array();
        $attachs = C::t('forum_attachment')->fetch_all_by_id('pid', $pids);

        $aid_tableids = Tool::Array_Column($attachs, 'aid', 'tableid', true);
        $all_attachs = array();
        foreach ($aid_tableids as $k => $v) {
            $att = C::t('forum_attachment_n')->fetch_all($k, $v, false);
            $all_attachs = array_merge($att, $all_attachs);
        }
        foreach ($all_attachs as $val) {
            if ($val['isimage'] && isset($val['attachment'])) {
                $attachurl = ForumThread::getAttachUrl($val);
                //分类信息图片统一处理，开启远程附件后不显示data/attachment路径的图片
                if ($tid_sortid[$val['tid']] != '0' && $setting['ftp']['on'] == 1) {
                    if (is_int(strpos(strtolower($attachurl), 'data/attachment'))) {
                        continue;
                    }
                }
                $tid_attachs[$val['pid']][] = $attachurl;
            }

        }
        return $tid_attachs;
    }

    /**
     * remote attach download
     * @param $url
     * @param $limit
     * @param $ip
     * @param $timeout
     * @return bool|string|void
     */
    private static function DownAttach($url, $limit, $ip, $timeout)
    {
        $matches = parse_url($url);
        $scheme = $matches['scheme'];
        $host = $matches['host'];

        $path = $matches['path'] ? $matches['path'] . ($matches['query'] ? '?' . $matches['query'] : '') : '/';
        $port = !empty($matches['port']) ? $matches['port'] : ($scheme == 'http' ? '80' : '');

        $ch = curl_init();
        $httpheader = array();
        if ($ip) {
            $httpheader[] = "Host: " . $host;
        }
        if ($httpheader) {
            curl_setopt($ch, CURLOPT_HTTPHEADER, $httpheader);
        }
        curl_setopt($ch, CURLOPT_URL, $scheme . '://' . ($ip ? $ip : $host) . ($port ? ':' . $port : '') . $path);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
        curl_setopt($ch, CURLOPT_HEADER, 1);


        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
        curl_setopt($ch, CURLOPT_TIMEOUT, $timeout);
        $data = curl_exec($ch);
        $status = curl_getinfo($ch);
        $errno = curl_errno($ch);
        curl_close($ch);
        if ($errno || $status['http_code'] != 200) {
            return;
        } else {
            $GLOBALS['filesockheader'] = substr($data, 0, $status['header_size']);
            $data = substr($data, $status['header_size']);
            return !$limit ? $data : substr($data, 0, $limit);
        }
    }

    public static function fetchThreadWhere($tid = 0, $fid = 0, $authors = array(), $author = '', $starttime = 0, $endtime = 0, $displayorder = 0, $keywords = '')
    {
        $parameter = array();
        $wherearr = array();

        if ($tid) {
            $tid = dintval($tid, true);
            $parameter[] = $tid;
            $wherearr[] = is_array($tid) ? 'tid IN(%n)' : 'tid=%d';
        }
        if ($fid) {
            $fid = dintval($fid, true);
            $parameter[] = $fid;
            $wherearr[] = is_array($fid) ? 'fid IN(%n)' : 'fid=%d';
        } else {
            $fid = dintval($fid, true);
            $parameter[] = $fid;
            $wherearr[] = 'fid>%d';
        }
        if (is_numeric($displayorder)) {
            $displayorder = intval($displayorder);
            $parameter[] = $displayorder;
            if ($displayorder == 0) {
                $wherearr[] = 'displayorder>=%d';
            } else {
                $wherearr[] = 'displayorder=%d';
            }
        }
        if (!empty($authors)) {
            $parameter[] = $authors;
            $wherearr[] = is_array($authors) && $authors ? 'authorid IN(%n)' : 'authorid=%s';
        }
        if ($author) {
            $parameter[] = $author;
            $wherearr[] = 'author=%s';
        }
        if ($starttime) {
            $parameter[] = $starttime;
            $wherearr[] = 'dateline>=%d';
        }
        if ($endtime) {
            $parameter[] = $endtime;
            $wherearr[] = 'dateline<%d';
        }
        if ($keywords) {
            $keysql = array();
            foreach (explode(',', str_replace(' ', '', $keywords)) as $keyword) {
                $parameter[] = '%' . $keyword . '%';
                $keysql[] = "subject LIKE %s";
            }
            if ($keysql) {
                $wherearr[] = '(' . implode(' OR ', $keysql) . ')';
            }
        }
        $wheresql = !empty($wherearr) && is_array($wherearr) ? ' WHERE ' . implode(' AND ', $wherearr) : '';
        return array($wheresql, $parameter);
    }


    public static function fetchReplyWhere($tid = 0, $fid = 0, $authorid = 0, $author = '', $starttime = 0, $endtime = 0, $filter = 0, $keywords = '')
    {
        if ($filter !== null) {
            $whereSql[] = 'm.' . DB::field('status', $filter);
        }
        if ($tid) {
            $whereSql[] = 'p.' . DB::field('tid', $tid);
        }
        if ($fid) {
            $whereSql[] = 'p.' . DB::field('fid', $fid);
        } else {
            $whereSql[] = 'p.' . DB::field('fid', 0, '>');
        }
        if ($authorid) {
            $whereSql[] = 'p.' . DB::field('authorid', $authorid);
        }
        if ($author) {
            $whereSql[] = 'p.' . DB::field('author', $author);
        }
        if ($starttime) {
            $whereSql[] = 'p.' . DB::field('dateline', $starttime, '>');
        }
        if ($endtime) {
            $whereSql[] = 'p.' . DB::field('dateline', $endtime, '<');
        }
        if ($keywords) {
            $whereSql[] = 'p.' . DB::field('subject', '%' . $keywords . '%', 'like');
        }
        $whereSql[] = 'p.' . DB::field('first', 0);

        $whereSql = !empty($whereSql) && is_array($whereSql) ? implode(' AND ', $whereSql) : '';
        return $whereSql;
    }

    public static function getModerateThread($tidArr)
    {
        $tmpMod = array();
        $parameter = array(
            'forum_thread_moderate',
            $tidArr
        );

        $moderate = DB::fetch_all("SELECT * FROM %t WHERE id IN(%n)", $parameter);
        if ($moderate) {
            foreach ($moderate as $v) {
                $tmpMod[] = $v['id'];
            }
        }

        return $tmpMod;
    }

    public static function getModeratePost($pidArr)
    {
        $tmpMod = array();
        $parameter = array(
            'forum_post_moderate',
            $pidArr
        );

        $moderate = DB::fetch_all("SELECT * FROM %t WHERE id IN(%n)", $parameter);
        if ($moderate) {
            foreach ($moderate as $v) {
                $tmpMod[] = $v['id'];
            }
        }

        return $tmpMod;
    }

    static $smileys;

    /**
     * 回帖/主题表情装换成图片
     * @param $content
     * @return string
     */
    public static function getSmilesImg($content)
    {
        global $_G;
        // 表情包处理
        if (self::$smileys) {
            $smileys = self::$smileys;
        } else {
            $smileys = array(
                'searcharray' => array(),
                'replacearray' => array(),
                'typearray' => array()
            );
            foreach (C::t('common_smiley')->fetch_all_cache() as $smiley) {
                $smileys['searcharray'][$smiley['id']] = '/' . preg_quote(dhtmlspecialchars($smiley['code']), '/') . '/';
                $smileys['replacearray'][$smiley['id']] = $smiley['url'];
                $smileys['typearray'][$smiley['id']] = $smiley['typeid'];
            }
            self::$smileys = $smileys;
        }

        $smileCategory = C::t('forum_imagetype')->fetch_all_by_type('smiley');
        $type = Tool::Array_Column($smileCategory, 'directory', 'typeid');

        $smileRootUrl = rtrim($_G['setting']['siteurl'], '/') . '/static/image/smiley/';

        foreach ($smileys['searcharray'] as $key => $smiley) {
            // 表情地址
            $url = $smileRootUrl . $type[$smileys['typearray'][$key]] . '/' . $smileys['replacearray'][$key];
            $smiley = stripslashes($smiley);

            $str = substr(substr(stripslashes($smiley), 0, strlen(stripslashes($smiley)) - 1), 1);
            $html = '[smiles smilieid=' . $key . ']' . $url . '[/smiles]';

            $content = str_replace($str, $html, $content);
        }
        return $content;
    }

    /**
     * 用户存档表是否存在
     * @param $content
     * @return array
     */
    public static function getUserArchive()
    {
        // 用户表
        $member_arc = DB::result_first("SHOW TABLES LIKE '%common_member_archive'");
        // 用户栏目表
        $profile_arc = DB::result_first("SHOW TABLES LIKE '%common_member_profile_archive'");
        // 用户论坛字段表
        $forum_arc = DB::result_first("SHOW TABLES LIKE '%common_member_field_forum_archive'");
        // 用户家园字段表
        $home_arc = DB::result_first("SHOW TABLES LIKE '%common_member_field_home_archive'");
        // 用户状态表
        $status_arc = DB::result_first("SHOW TABLES LIKE '%common_member_status_archive'");
        // 用户统计表
        $count_arc = DB::result_first("SHOW TABLES LIKE '%common_member_count_archive'");

        $data = array(
            'member_arc' => $member_arc,
            'profile_arc' => $profile_arc,
            'forum_arc' => $forum_arc,
            'home_arc' => $home_arc,
            'status_arc' => $status_arc,
            'count_arc' => $count_arc
        );
        return $data;
    }


    /**
     * 帖子屏蔽状态
     * @param $tid
     * @param $fid
     * @param $authorid
     * @param $dateline
     * @return bool true:正常状态  false:屏蔽状态
     */
    public static function qfThreadBan($tid, $fid, $authorid, $dateline)
    {
        global $_G;

        if (!empty(Yii::app()->params['ban_time'])) {
            if ($dateline <= strtotime(Yii::app()->params['ban_time'])) {
                return false;
            }
        }

        if (!empty($_G['cache']['plugin']['qfthread']['isopen'])) {
            $whiteuids = array();
            if (!empty($_G['cache']['plugin']['qfthread']['whiteuids'])) {
                $whiteuids = explode(',', $_G['cache']['plugin']['qfthread']['whiteuids']);
            }
            $whitetids = array();
            if (!empty($_G['cache']['plugin']['qfthread']['whitetids'])) {
                $whitetids = explode(',', $_G['cache']['plugin']['qfthread']['whitetids']);
            }
            $whitetauthorids = array();
            if (!empty($_G['cache']['plugin']['qfthread']['authorids'])) {
                $whitetauthorids = explode(',', $_G['cache']['plugin']['qfthread']['authorids']);
            }

            if (in_array($_G['uid'], $whiteuids) || in_array($tid, $whitetids) || in_array($authorid, $whitetauthorids)) {
                return true;
            }

            if (!empty($_G['cache']['plugin']['qfthread']['enableauthor']) && $_G['uid'] && $_G['uid'] == $authorid) {
                return true;
            }

            $limitFids = (array)unserialize($_G['cache']['plugin']['qfthread']['forums']);
            $limitFids = array_values(array_filter($limitFids));

            $limitGroups = (array)unserialize($_G['cache']['plugin']['qfthread']['groups']);
            $limitGroups = array_values(array_filter($limitGroups));


            if ((in_array($fid, $limitFids)) && (in_array($_G['groupid'], $limitGroups))) {
                if (!empty($_G['cache']['plugin']['qfthread']['bantime'])) {
                    if ($dateline <= strtotime($_G['cache']['plugin']['qfthread']['bantime'])) {
                        return false;
                    }
                }

                if (!empty($_G['cache']['plugin']['qfthread']['limitdays'])) {
                    $limitTime = time() - 3600 * 24 * (int)$_G['cache']['plugin']['qfthread']['limitdays'];
                    if (!empty($_G['thread'])) {
                        if ($dateline <= $limitTime) {
                            return false;
                        }
                    }
                }
            }
        }
        return true;
    }


    /**
     * 查询所有版块fids
     * @return array
     */
    public static function allForumIds()
    {
        $fids = array();
        $status = array(0, 1);
        $type = array('forum', 'sub');
        $forums = DB::fetch_all("SELECT fid FROM %t WHERE type in (%n) AND status in (%n) limit 1000", array('forum_forum', $type, $status));

        if ($forums) {
            $fids = Tool::Array_Column($forums, 'fid');
        }
        return $fids;
    }

    /**
     * 禁言用户收藏帖子等日志记录，discuzx3.4后基本就不支持了，manyou 和防水墙插件也没了
     * type 操作类型
     * @return true|false
     */
    public static function cloudService($type, $data = array(), $uid = 0, $favid = 0, $ip = '', $my_log_type = 0, $time_stamp = TIMESTAMP)
    {
        global $_G;
        if (!$_G['setting']['cloud_status'] && !class_exists('cloud')) {
            return false;
        }

        // 插件是否存在开启 manyou  防水墙插件
        if (in_array('manyou', $_G['setting']['plugins']['available'])) {
            if (!file_exists(DISCUZ_ROOT . ($modfile = './source/plugin/manyou/admincp.inc.php'))) {
                //指定的插件模块文件({mod})不存在或存在语法错误，请检查是否已将插件完整上传
                Yii::log("指定的插件模块文件(" . $modfile . ")不存在或存在语法错误，请检查是否已将插件完整上传");
                return false;
            }
        } else {
            Yii::log("漫游应用插件（manyou）不存在或者未开启");
            return false;
        }

        if (in_array('security', $_G['setting']['plugins']['available'])) {
            if (!file_exists(DISCUZ_ROOT . ($modfile = './source/plugin/security/unlock.inc.php')) && $type == 'user_status_banlog') {
                Yii::log("指定的插件模块文件(" . $modfile . ")不存在或存在语法错误，请检查是否已将插件完整上传");
                return false;
            }
        } else {
            Yii::log("防水墙插件（security）不存在或者未开启");
            return false;
        }

        if (in_array($type, array('user_favor_post', 'user_favor_forum'))) {
            $favoriteService = Cloud::loadClass('Service_Client_Favorite');
            $favoriteService->add($data['uid'], $favid, $data['id'], $data['idtype'], $data['title'], $data['description'], TIMESTAMP);
        } elseif (in_array($type, array('user_cancel_favor_post', 'user_cancel_favor_forum'))) {
            $favoriteService = Cloud::loadClass('Service_Client_Favorite');
            $favoriteService->remove($uid, $favid, TIMESTAMP);
        } elseif ($type == 'user_status_captcha') {
            if (class_exists('captcha') && method_exists('captcha', 'report')) {
                $ca = new captcha();
                $ca->report($ip);
            }
        } elseif ($type == 'user_status_thread_log') {
            $log_handler = Cloud::loadClass('Cloud_Service_SearchHelper');
            $log_handler->myThreadLog($my_log_type, $data);
        } elseif ($type == 'user_status_banlog') {
            $securityService = Cloud::loadClass('Service_Security');
            if ($data['bannew']) {
                $securityService->logBannedMember($data['username'], $data['reason']);
            } else {
                $securityService->updateMemberRecover($data['username']);
            }
        }
        return true;
    }

}