<?php
/**
 * Created by PhpStorm.
 * User: leeyifiei
 * Date: 2018/9/3
 * Time: 上午10:17
 */

class Mobile
{

    public static function qianfan_encrypt($mobile)
    {
        global $_G;

        if (Yii::app()->params['enable_encrypt_mobile'] == 1) {
            if (is_numeric($mobile) || preg_match('/(\+\d{1,7})\ (\d{3,20}.*?)/', $mobile)) {
                $mobile = openssl_encrypt($mobile, 'AES-128-CBC', Yii::app()->params['cloud_secretkey']);
            }
        }
        return $mobile;
    }

    public static function qianfan_decrypt($mobile)
    {
        global $_G;

        if (Yii::app()->params['enable_encrypt_mobile'] == 1) {
            if (!is_numeric($mobile) && !preg_match('/(\+\d{1,7})\ (\d{3,20}.*?)/', $mobile)) {
                $mobile = openssl_decrypt($mobile, 'AES-128-CBC', Yii::app()->params['cloud_secretkey']);
            }
        }
        return $mobile;
    }

    /**
     * @desc 手机号获取UID
     * @param $mobile
     * @return int
     */
    public static function fetchUidByMobile($mobile)
    {
        $mobile = self::qianfan_encrypt($mobile);

        if (Yii::app()->params['mobile_source'] == 1) {
            $uid = DB::result_first('SELECT uid FROM %t WHERE mobile = %s', array('common_member_profile', $mobile));
        } else {
            $uid = DB::result_first('SELECT uid FROM %t WHERE phone = %s', array('phonebind', $mobile));
        }

        return (int)$uid;
    }

    /**
     * @desc UID获取手机号
     * @param $uid
     * @return string
     */
    public static function fetchMobileByUid($uid)
    {
        if (Yii::app()->params['mobile_source'] == 1) {
            $mobile = DB::result_first('SELECT mobile FROM %t WHERE uid = %d', array('common_member_profile', $uid));
        } else {
            $mobile = DB::result_first('SELECT phone FROM %t WHERE uid = %d', array('phonebind', $uid));
        }

        return self::qianfan_decrypt($mobile);
    }

    /**
     * @desc 获取一组用户的手机号
     * @param $uids
     * @return array
     */
    public static function fetchMobileByUids($uids)
    {
        if (Yii::app()->params['mobile_source'] == 1) {
            $rows = DB::fetch_all('SELECT uid, mobile as phone FROM %t WHERE uid in (%n)', array('common_member_profile', $uids));
        } else {
            $rows = DB::fetch_all('SELECT uid, phone FROM %t WHERE uid in (%n)', array('phonebind', $uids));
        }

        $data = array();
        if ($rows) {
            foreach ($rows as $row) {
                $row['phone'] = self::qianfan_decrypt($row['phone']);
                $data[] = $row;
            }
        }
        return $data;
    }

    /**
     * @desc
     * @param $mobiles
     * @return array
     */
    public static function fetchUidByMobiles($mobiles)
    {
        $phones = array();
        foreach ($mobiles as $v) {
            $phones[] = self::qianfan_encrypt($v);
        }
        $mobiles = $phones;

        if (Yii::app()->params['mobile_source'] == 1) {
            $rows = DB::fetch_all('SELECT uid, mobile as phone FROM %t WHERE mobile in (%n)', array('common_member_profile', $mobiles));
        } else {
            $rows = DB::fetch_all('SELECT uid, phone from %t WHERE phone in (%n)', array('phonebind', $mobiles));
        }

        $data = array();
        if ($rows) {
            foreach ($rows as $row) {
                $row['phone'] = self::qianfan_decrypt($row['phone']);

                $data[] = $row;
            }
        }

        return $data;
    }

    public static function writeMobile($uid, $mobile)
    {
        $mobile = self::qianfan_encrypt($mobile);

        if (Yii::app()->params['mobile_source'] == 1) {
            DB::update('common_member_profile', array('mobile' => $mobile), 'uid=' . $uid);
        } else {
            if (DB::result_first('SELECT uid FROM %t WHERE uid = %d', array('phonebind', $uid))) {
                DB::update('phonebind', array('phone' => $mobile), 'uid=' . $uid);
            } else {
                DB::insert('phonebind', array(
                    'uid' => $uid,
                    'phone' => $mobile,
                    'dateline' => TIMESTAMP
                ));
            }
        }
    }

    public static function deleteByUid($uid)
    {
        if (Yii::app()->params['mobile_source'] == 1) {
            DB::update('common_member_profile', array('mobile' => ''), 'uid=' . $uid);
        } else {
            DB::delete('phonebind', 'uid=' . $uid);
        }
    }
}