<?php
/**
 * Created by PhpStorm.
 * User: leeyifiei
 * Date: 16/2/22
 * Time: 下午12:38
 */

if(!defined('IN_DISCUZ')) {
    exit('Access Denied');
}

class PluginController extends Controller implements TplInterface
{

    public $scriptPath;

    public $staticPath;

    public function init()
    {
        $this->staticPath = rtrim( Yii::app()->getBasePath() , DIRECTORY_SEPARATOR) . DIRECTORY_SEPARATOR . '..' .
            DIRECTORY_SEPARATOR . 'static' . DIRECTORY_SEPARATOR;

        $this->_init_config();
    }

    /**
     * 初始化插件配置
     */
    private function _init_config()
    {
        global $qianfan_config, $_G;

        //项目编码
        Yii::app()->charset = $_G['charset'];

        //项目编码
        Yii::app()->params['site_charset'] = $_G['charset'];

        // 云服务器域名
        Yii::app()->params['cloud_host'] = isset( $qianfan_config['cloud_host'] ) ? $qianfan_config['cloud_host'] : '';
        // 云服务器通信秘钥
        Yii::app()->params['cloud_secretkey'] = isset( $qianfan_config['cloud_secretkey'] ) ? $qianfan_config['cloud_secretkey'] : '';
        //刷新阅读量配置
        Yii::app()->params['cloud_reads'] = isset( $qianfan_config['cloud_reads'] ) ? $qianfan_config['cloud_reads'] : '1';
        //是否允许通知云端
        Yii::app()->params['cloud_allow_notice'] = isset( $qianfan_config['cloud_allow_notice'] ) ? $qianfan_config['cloud_allow_notice'] : 0;
        //回帖是否允许通知云端
        Yii::app()->params['cloud_reply_notice'] = isset( $qianfan_config['cloud_reply_notice'] ) ? $qianfan_config['cloud_reply_notice'] : 0;
        //允许将帖子推送云端的版块
        Yii::app()->params['cloud_fids_push'] = isset( $qianfan_config['cloud_fids_push'] ) && is_array( $qianfan_config['cloud_fids_push'] ) ?
            $qianfan_config['cloud_fids_push'] : array();
        //帖子推送的阀值
        Yii::app()->params['cloud_thread_replypush'] = isset( $qianfan_config['cloud_thread_replypush'] ) && is_array( $qianfan_config['cloud_thread_replypush'] ) ? $qianfan_config['cloud_thread_replypush'] : array();
        //搜索ID
        Yii::app()->params['search_id'] = isset( $qianfan_config['search_id'] ) ? $qianfan_config['search_id'] : '';
        //帖子匹配URL
        Yii::app()->params['thread_match'] = isset( $qianfan_config['thread_match'] ) ? $qianfan_config['thread_match'] : '';
        //用于APP特殊用户组
        Yii::app()->params['qianfan_groupid'] = isset( $qianfan_config['qianfan_groupid'] ) ? trim($qianfan_config['qianfan_groupid']) : '';
        //APP搜索结果排序
        Yii::app()->params['search_sort'] = isset( $qianfan_config['search_sort'] ) ? intval($qianfan_config['search_sort']) : 0;
        //找回密码是否开启图片验证码
        Yii::app()->params['open_image_auth'] = 1;
        //搜索用户匹配方式
        Yii::app()->params['search_user_type'] = isset( $qianfan_config['search_user_type'] ) ? intval($qianfan_config['search_user_type']) : 0;
        // 手机号存储
        Yii::app()->params['mobile_source'] = isset($qianfan_config['mobile_source'] ) ? intval($qianfan_config['mobile_source']) : 2;
        // 限制帖子显示的时间
        Yii::app()->params['ban_time'] = isset($qianfan_config['ban_time']) ? $qianfan_config['ban_time'] : '';
        // 开启ip归属地
        Yii::app()->params['open_ip_locate'] = isset($qianfan_config['open_ip_locate']) ? $qianfan_config['open_ip_locate'] : 0;
        // 内网IP位置
        Yii::app()->params['net_location'] = isset($qianfan_config['net_location']) ? $qianfan_config['net_location'] : '';
        // 开启手机号加密
        Yii::app()->params['enable_encrypt_mobile'] = isset($qianfan_config['enable_encrypt_mobile']) ? $qianfan_config['enable_encrypt_mobile'] : 0;

    }

    /**
     * @param $var
     * @param array $params
     * @param string $tpl
     * @return string
     */
    public function tplLang( $var, $params = array(), $tpl = 'tpl' )
    {
        return Tool::getInstance()->tplLang( $var, $params, $tpl );
    }

    /**
     * 返回JS文件
     * @param $file
     * @return mixed|string
     */
    public function getScriptFile( $file )
    {
        global $_G;

        $file = $this->scriptPath . $file;

        if( strtoupper(Yii::app()->charset) == 'GBK' && is_file( str_replace( '.js', '_gbk.js', $file ) ) )
        {
            return str_replace( '.js', '_gbk.js', $file );
//            if(!isset($_G['config']['output']['forceheader']) || !$_G['config']['output']['forceheader']) {
//                return str_replace( '.js', '_gbk.js', $file );
//            }
        }

        return $file;
    }

    /**
     * 处理AJAX返回
     * @param $data
     */
    public function ajaxResponse($data)
    {
        global $_G;

        Yii::app()->charset = 'UTF-8';
        $response = CJSON::encode($data);
        Yii::app()->charset = $_G['charset'];

        return $response;
    }
}