<?php
/**
 * 楼中楼相关
 *
 * Created by PhpStorm.
 * User: sunbing
 * Date: 2021-11-18
 * Time: 14:28
 */

class ReplyFloor
{

    static $table = 'qianfan_post_floor';

    const STATUS_REVIEW = 0; // 待审核
    const STATUS_APPROVE = 1; // 审核中
    const STATUS_REJECT = 2; // 拒绝
    const STATUS_DELETE = 3; // 删除

    public static function insert($data, $return_insert_id = false, $replace = false, $silent = false)
    {
        return DB::insert(self::$table, $data, $return_insert_id, $replace, $silent);
    }

    public static function fetchById($id)
    {
        return DB::fetch_first('SELECT * FROM %t WHERE id=%d', array(self::$table, $id));
    }

    public static function fetchByIds($ids)
    {
        if (($ids = dintval((array)$ids, true))) {
            return DB::fetch_all('SELECT * FROM %t WHERE id IN(%n)', array(self::$table, $ids), false, true);
        }
        return array();
    }

    public static function fetchAllByWhere($wherearr = array(), $ordersql = '', $offset = 0, $limit = 100)
    {
        $wherearr = implode(' AND ', $wherearr);

        return DB::fetch_all('
                SELECT *
			    FROM %t
			    WHERE %i ' . $ordersql . DB::limit($offset, $limit),
            array(self::$table, $wherearr)
        );
    }

    public static function fetchCountByWhere($wherearr = array())
    {
        $wherearr = implode(' AND ', $wherearr);
        return DB::result_first('
                SELECT COUNT(*)
			    FROM %t
			    WHERE %i ',
            array(self::$table, $wherearr)
        );
    }

    public static function formatSingleRes($list, $parent = false)
    {
        global $_G;
        require_once libfile('function/discuzcode');

        $message = parsesmiles($list['message']);
        if (preg_match_all('/<img src="([^>]+?)" smilieid="(\d+)".*?>/', $message, $matches)) {
            foreach ($matches[1] as $key => $val) {
                if (!is_int(strpos($val, 'http://')) && !is_int(strpos($val, 'https://'))) {
                    $message = str_replace($matches[0][$key], '<img src="' . rtrim($_G['setting']['siteurl'], '/') . '/' . ltrim($val, '/') . '" smilieid="' . $matches[2][$key] . '" width="24" height="24" />', $message);
                }
            }
        }

        $list = array(
            'id' => $list['id'],
            'pid' => $list['pid'],
            'tid' => $list['tid'],
            'anonymous' => $list['anonymous'],
            'userip' => $list['useip'],
            'uid' => $list['authorid'],
            'username' => $list['anonymous'] ? '' : $list['author'],
            'avatar' => discuz_uc_avatar($list['authorid'], 'big', true),
            'icon' => discuz_uc_avatar($list['authorid'], 'big', true),
            'content' => $message,
            'if_check' => $list['status'],
            'created_at' => self::ConvertToCharset(Tool::getInstance()->friendly($list['created_at'])),
            'postdate' => $list['created_at'],
            'authorid' => $list['authorid'],
            'title' => '',
            'ping_num' => isset($list['ping_num']) ? $list['ping_num'] : 0,
        );

        if ($parent) {
            $list['parent'] = null;
        }

        return $list;
    }

    public static function ConvertToCharset($var = '')
    {
        if ($enc = strtoupper(Yii::app()->charset) !== 'UTF-8') {
            $var = iconv('UTF-8', 'GBK//IGNORE', $var);
        }
        return $var;
    }

    // 楼中楼点赞查询
    public static function floorPingsByIds($floor_id = 0, $uids = '')
    {
        $ids = dintval((array)$uids, true);
        if ($uids && !empty($ids)) {
            return DB::fetch_all('SELECT * FROM %t WHERE floor_id=%d AND uid IN(%n)',
                array('qianfan_post_floor_comment',$floor_id, $ids), 'uid');
        }
        return array();
    }

    public static function countImgNumByWhere($wherearr = array(), $ordersql = '', $offset = 0, $limit = 100)
    {
        $wherearr = implode(' AND ', $wherearr);

        return DB::result_first('
                SELECT SUM(attach_num)
			    FROM %t
			    WHERE %i ' . $ordersql . DB::limit($offset, $limit),
            array(self::$table, $wherearr)
        );
    }

    // 获取图片数
    public static function getContentImg($content)
    {
        $img_num = 0;
        if (strpos($content, '<img id="digface"') !== false) {
            if (preg_match_all('/\<img id="digface".*?src="(.*?)".*?>/is', $content, $matches)) {
                if (!empty($matches)) {
                    $img_num = count($matches[0]);
                }
            }
        }
        return $img_num;
    }
}