<?php
/**
 * Created by PhpStorm.
 * User: zhaofei
 * Date: 15/11/24
 * Time: 下午2:38
 */

if (!defined('IN_DISCUZ')) {
    exit('Access Denied');
}

class ForumController extends Controller
{

    /**
     * 板块分类
     */
    public function actionForumcategory()
    {
        $forumGroups = DB::fetch_all("SELECT * FROM %t WHERE type = %s AND status = %d ORDER BY displayorder ASC", array('forum_forum', 'group', 1));

        $http = (int)$_SERVER['SERVER_PORT'] == 80 ? 'http' : 'https';

        $all = array('forums' => array());
        if (!empty($forumGroups)) {
            foreach ($forumGroups as $key => $group) {
                $g = array();
                $forums = DB::fetch_all("SELECT * FROM %t WHERE type = %s AND status = %d AND fup = %d ORDER BY displayorder ASC", array('forum_forum', 'forum', 1, $group['fid']));

                $g['fid'] = $group['fid'];
                $g['name'] = Tool::getInstance()->stripHtmlTags($group['name']);
                $g['child'] = array();

                if (!empty($forums)) {
                    $forumId = Tool::Array_Column($forums, 'fid');
                    $forumId = join(',', $forumId);

                    $forumLogoInfo = DB::fetch_all("SELECT fid, icon FROM %t WHERE fid in ($forumId)", array('forum_forumfield'));
                    $forumLogo = array();
                    foreach ($forumLogoInfo as $value) {
                        if (!empty($value['icon'])) {
                            $forumLogo[$value['fid']] = $value['icon'];
                        }
                    }

                    foreach ($forums as $k => $v) {
                        $g['child'][$k]['fid'] = $v['fid'];
                        $g['child'][$k]['name'] = Tool::getInstance()->stripHtmlTags($v['name']);
                        $g['child'][$k]['isFavored'] = 0;
                        $g['child'][$k]['tpost'] = 0;
                        $g['child'][$k]['lastpost'] = '';
                        $g['child'][$k]['lastposter'] = '';

                        $g['child'][$k]['icon'] = '';

                        //fid => icon
                        if (key_exists($v['fid'], $forumLogo)) {
                            //判断是URL还是本地上传
                            if (strpos($forumLogo[$v['fid']], 'http') !== false) {
                                $g['child'][$k]['icon'] = $forumLogo[$v['fid']];
                            } else {
                                $g['child'][$k]['icon'] = $http . '://' . $_SERVER['HTTP_HOST'] . '/data/attachment/common/' . $forumLogo[$v['fid']];
                            }
                        }

                        $g['child'][$k]['contentmin'] = 0;
                        $g['child'][$k]['child'] = array();
                        $subs = DB::fetch_all("SELECT * FROM %t WHERE type = %s AND status = %d AND fup = %d ORDER BY displayorder ASC", array('forum_forum', 'sub', 1, $v['fid']));
                        if (!empty($subs)) {
                            $subId = Tool::Array_Column($subs, 'fid');
                            $subId = join(',', $subId);

                            $subLogoInfo = DB::fetch_all("SELECT fid, icon FROM %t WHERE fid in ($subId)", array('forum_forumfield'));
                            $subLogo = array();
                            foreach ($subLogoInfo as $value) {
                                if (!empty($value['icon'])) {
                                    $subLogo[$value['fid']] = $value['icon'];
                                }
                            }

                            foreach ($subs as $j => $s) {
                                $g['child'][$k]['child'][$j]['fid'] = $s['fid'];
                                $g['child'][$k]['child'][$j]['name'] = Tool::getInstance()->stripHtmlTags($s['name']);
                                $g['child'][$k]['child'][$j]['isFavored'] = 0;
                                $g['child'][$k]['child'][$j]['tpost'] = 0;
                                $g['child'][$k]['child'][$j]['lastpost'] = '';
                                $g['child'][$k]['child'][$j]['lastposter'] = '';

                                $g['child'][$k]['child'][$j]['icon'] = '';


                                if (key_exists($s['fid'], $subLogo)) {
                                    if (strpos($subLogo[$s['fid']], 'http') !== false) {
                                        $g['child'][$k]['child'][$j]['icon'] = $subLogo[$s['fid']];
                                    } else {
                                        $g['child'][$k]['child'][$j]['icon'] = $http . '://' . $_SERVER['HTTP_HOST'] . '/data/attachment/common/' . $subLogo[$s['fid']];
                                    }
                                }

                                $g['child'][$k]['child'][$j]['contentmin'] = 0;
                            }
                        }
                    }
                }

                $all['forums'][] = $g;
            }
        }

        Tool::getInstance()->success_json($all);
    }

    /**
     * 主题列表
     * 注意点
     * 是否显示置顶帖
     * 是否显示附件
     * 性能调优
     */
    public function actionGetthreads()
    {
        //板块ID
        $fid = Yii::app()->request->getPost('fid', 0);
        //只看精华帖
        $digest = Yii::app()->request->getPost('digest', 0);
        //排序方式  1 发帖日期倒序 0 最后回复时间倒序
        $ordertype = Yii::app()->request->getPost('ordertype', 0);
        //SQL OFFSET
        $offset = dintval(Yii::app()->request->getPost('offset', 0));
        //SQL LIMIT
        $limit = dintval(Yii::app()->request->getPost('limit', 0));
        //上次列表页最后的帖子ID
        $lastid = dintval(Yii::app()->request->getPost('lastid', 0));
        //是否显示图片附件
        $isshowattach = Yii::app()->request->getPost('isshowattach', 0);
        //是否显示置顶帖
        $showtopthread = WebHelper::getPost('showtopthread', 0);

        // 2.0新增参数
        // 分类信息id
        $sortid = WebHelper::getPost('sortid', 0);

        // 主题分类id
        $typeid = WebHelper::getPost('typeid', 0);

        // 分类项目筛选信息，json字符串
        $sortinfo = WebHelper::getPost('sortinfo', '');

        // 2.0.0新版的参数，用来兼容旧版
        $type = WebHelper::getPost('type', 0);

        global $_G;
        if ($fid > 0) {
            if (!function_exists('loadforum')) {
                require_once(libfile('function/forum'));
            }
            require_once(Yii::getPathOfAlias('application.components.func') . DIRECTORY_SEPARATOR . 'forum_viewthread.php');

            loadforum($fid);
            //检查是否该板块不存在
            if (!$_G['forum']['fid']) {
                Tool::getInstance()->fail_json(Code::FORUM_NOT_EXISTS, Tool::getInstance()->lang('forum not exists'));
            }

            //板块阅读权限判断
            if ($_G['forum']['viewperm'] && !forumperm($_G['forum']['viewperm']) && !$_G['forum']['allowview']) {
                $res = qf_showmessagenoperm('viewperm', $_G['fid'], $_G['forum']['formulaperm']);
                Tool::getInstance()->fail_json(Code::FORUM_VIEW_PERM, Tool::getInstance()->stripHtmlTags(lang('message', $res['message'], $res['params'])));
            } //限定只有某些用户能访问板块
            elseif ($_G['forum']['formulaperm']) {
                $msg = qf_formulaperm($_G['forum']['formulaperm']);
                if ($msg['message'] != '') {

                    $lanParamsTmp = $msg['params'];
                    $lanParams = array();
                    foreach ($lanParamsTmp as $k => $v) {
                        $k = str_replace(array('{', '}'), '', $k);
                        $lanParams[$k] = $v;
                    }

                    Tool::getInstance()->fail_json(Code::FORUM_VIEW_PERM, Tool::getInstance()->stripHtmlTags(lang('message', $msg['message'], $lanParams)));
                }
            }

            //需要输入密码才能访问板块，由于客户端目前无法让用户手动输入密码，所以直接抛出错误，管理员可以访问
            if ($_G['forum']['password'] && !$_G['forum']['ismoderator']) {
                Tool::getInstance()->fail_json(Code::FORUM_NEED_PASSWORD, Tool::getInstance()->lang('need password view forum'));
            }

            //板块需要付费才能浏览，版主、管理员默认能访问
            //直接抛出错误，暂未判断其付费记录
            if ($_G['forum']['price'] && !$_G['forum']['ismoderator']) {
                Tool::getInstance()->fail_json(Code::FORUM_NEED_PRICE, Tool::getInstance()->lang('need price view forum'));
            }

            // 置顶帖处理
            $topLists = array();
            if ($showtopthread && !$offset) {
                loadcache('globalstick', 'forumstick');

                $thisgid = $_G['forum']['type'] == 'forum' ? $_G['forum']['fup'] : (!empty($_G['cache']['forums'][$_G['forum']['fup']]['fup']) ? $_G['cache']['forums'][$_G['forum']['fup']]['fup'] : 0);
                $stickytids = '';
                $forumstickytids = array();

                if ($_G['setting']['globalstick'] && $_G['forum']['allowglobalstick']) {
                    $stickytids = explode(',', str_replace("'", '', $_G['cache']['globalstick']['global']['tids']));
                    if (!empty($_G['cache']['globalstick']['categories'][$thisgid]['count'])) {
                        $stickytids = array_merge($stickytids, explode(',', str_replace("'", '', $_G['cache']['globalstick']['categories'][$thisgid]['tids'])));
                    }

                    if ($_G['forum']['status'] != 3) {
                        $stickycount = $_G['cache']['globalstick']['global']['count'];
                        if (!empty($_G['cache']['globalstick']['categories'][$thisgid])) {
                            $stickycount += $_G['cache']['globalstick']['categories'][$thisgid]['count'];
                        }
                    }
                }

                if ($_G['forum']['allowglobalstick']) {
                    $forumstickycount = 0;
                    $forumstickfid = $_G['forum']['status'] != 3 ? $_G['fid'] : $_G['forum']['fup'];
                    if (isset($_G['cache']['forumstick'][$forumstickfid])) {
                        $forumstickycount = count($_G['cache']['forumstick'][$forumstickfid]);
                        $forumstickytids = $_G['cache']['forumstick'][$forumstickfid];
                    }
                    if (!empty($forumstickytids)) {
                        $stickytids = array_merge($stickytids, $forumstickytids);
                    }
                }

                if (is_array($stickytids) && $stickytids[0]) {
                    $filterarr1 = array(
                        'inforum' => '',
                        'intids' => $stickytids,
                        'displayorder' => array(2, 3, 4)
                    );
                    $topLists = C::t('forum_thread')->fetch_all_search($filterarr1, 0, 0, 20, 'displayorder DESC,
                    lastpost DESC', '');
                }
            }

            //开始获取帖子列表
            $filterarr = array(
                'inforum' => $_G['fid'],
                'sticky' => 4,
//                'displayorder' => array(0, 1, 2, 3),
                'displayorder' => 0,
            );
            //关联其他版块
            if ($_G['forum']['relatedgroup']) {
                $relatedgroup = explode(',', $_G['forum']['relatedgroup']);
                $relatedgroup[] = $_G['fid'];
                $filterarr['inforum'] = $relatedgroup;
            } else {
                $filterarr['inforum'] = $_G['fid'];
            }
            //获取精华帖
            if ($digest) {
                $filterarr = array(
                    'digest' => 1,
                    'inforum' => $filterarr['inforum'],
                    'sticky' => 4,
                    'displayorder' => array(0)
                );
            }

            // 主题分类
            if (!empty($typeid)) {
                $filterarr['intype'] = intval($typeid);
            }

            // 分类信息
            if (!empty($sortid)) {
                $filterarr['insort'] = intval($sortid);
                $lastest_id = DB::result_first('select * from %t order by tid desc limit 1', array('forum_thread'));
                $limit_sort_tid = ($lastest_id - 50000) > 0 ? $lastest_id - 50000 : 0;
                if (!empty($sortinfo)) {
                    $sort = CJSON::decode($sortinfo);
                    $sortid = $sort['sortid'] . ' ';
                    //$tidArray = $tidArr = $tidTemp = array();
                    $tidArray = $tidTemp = array();
                    $i = 0;
                    foreach ($sort['select'] as $k => $v) {
                        $tidArr = array();
                        if ($v['optionid'] == 0) continue;
                        $sql['option'] = 'optionid=' . $v['kindid'];
                        $sql['value'] = 'value=' . $v['optionid'];

                        $sql['sql'] = ' AND ' . $sql['option'] . ' AND ' . $sql['value'];
                        $tids = DB::fetch_all("SELECT tid from %t where fid=" . $fid . " and sortid=" . $sortid . " and tid>" . $limit_sort_tid . $sql['sql'] . " order by tid desc limit 1000", array('forum_typeoptionvar'));

                        //$tidArr = array_merge($tids, $tidArr);
                        //$tidTemp = array_intersect_assoc($tids,$tidArr); // 取交集
                        foreach ($tids as $valued) {
                            $tidArr[] = $valued['tid'];
                        }
                        if ($i == 0) {
                            $tidTemp = $tidArr;
                        } else {
                            $tidTemp = array_intersect($tidArr, $tidTemp);
                        }
                        $i++;
                    }

                    foreach ($tidTemp as $kk => $vv) {
                        if ($kk > 1000) break;
                        $tidArray[$kk] = $vv;
                    }

                    if (empty($tidArray) && $i != 0) {
                        $tidArray = array(0 => '0');
                    }
                }
            }

            //主题帖排序
            $order = 'displayorder DESC, ';
            if ($ordertype) {
                $order = 'dateline DESC';
            } else {
                $order = 'lastpost DESC';
            }
//            $threadlist = C::t('forum_thread')->fetch_all_search($filterarr, 0, $offset, $limit, $order, '');

            $threadlist = $this->_searchThread($filterarr, 0, $offset, $limit, $order, '', $tidArray);
            $threadlist = array_merge($topLists, $threadlist);

            //登陆时 自己待审核的帖子
            $pendThreads = array();
            if ($offset == 0 && $_G['uid']) {
                $_limit = 10;//默认最多10条数据
                $pushTime = time() - 3600 * 24 * 7;
                $pendThreads = DB::fetch_all("SELECT * FROM %t WHERE fid=%d AND displayorder=%d AND authorid=%d AND dateline>%d ORDER by dateline DESC limit %d", array('forum_thread', $fid, -2, $_G['uid'], $pushTime, $_limit));
//                $word = '[待审核]';
//                if( strtoupper( $_G['charset'] ) != 'UTF-8' ) $word = mb_convert_encoding($word, 'gbk', 'utf-8');
//                foreach($pendThreads as &$pendVal){
//                    if(isset($pendVal['subject'])) $pendVal['subject'] .= $word;
//                }
//                unset($pendVal);
            }
            $threadlist = array_merge($pendThreads, $threadlist);

            $threads = array();
            if (!empty($threadlist)) {
                //循环前预处理
                $tids = Tool::Array_Column($threadlist, 'tid');
                $post_info = DB::fetch_all("SELECT tid,pid,status,anonymous FROM %t WHERE tid in (%n) AND first = 1", array("forum_post", $tids), 'tid');
                $addviews = DB::fetch_all("SELECT tid,addviews FROM %t WHERE tid in (%n)", array("forum_threadaddviews", $tids), 'tid');
                //附件提取
                $tid_attachs = array();
                if ($isshowattach)
                    $tid_attachs = ForumThread::getAllAttaches($post_info, $threadlist);
                //------------------------------------
                foreach ($threadlist as $key => $val) {
                    $thread = array();
                    $thread['fid'] = $val['fid'];
                    $thread['fname'] = $_G['forum']['name'];
                    $thread['tid'] = intval($val['tid']);
                    $thread['subject'] = $val['subject'];
                    $thread['authorid'] = $val['authorid'];
                    $thread['author'] = $val['author'];
                    $thread['icon'] = discuz_uc_avatar($val['authorid'], 'big', 1);
                    $thread['postdate'] = $val['dateline'];
                    $thread['lastpost'] = $val['lastpost'];
                    $thread['lastposter'] = $val['lastposter'];
                    $thread['favors'] = $val['recommend_add'];
                    $thread['hits'] = $val['views'];
                    $thread['replies'] = $val['replies'];
                    $thread['digest'] = $val['digest'] ? 1 : 0;
                    $thread['special'] = $val['special'];
                    $thread['ifupload'] = $val['attachment'] == 2 ? 1 : 0;
                    $thread['topped'] = $val['displayorder'] > 0 ? 1 : 0;
                    $thread['attach'] = array();
                    $thread['attnum'] = '0';

                    $thread['pid'] = isset($post_info[$thread['tid']]) ? $post_info[$thread['tid']]['pid'] : 0;

                    $thread['anonymous'] = isset($post_info[$thread['tid']]) ? $post_info[$thread['tid']]['anonymous'] : 0;

                    $is_shield = 1;
                    if (!$_G['forum']['ismoderator'] && ($post_info[$thread['tid']]['status'] & 1)) {
                        $is_shield = 0;
                    }
                    //获取帖子附件
                    if ($isshowattach && ($val['attachment'] == 2 || $val['attachment'] == 1) && $is_shield) {
                        if (isset($tid_attachs[$thread['tid']]) && is_array($tid_attachs[$thread['tid']]) && !empty($tid_attachs[$thread['tid']])) {
                            $thread['attach'] = $tid_attachs[$thread['tid']];
                            $thread['attnum'] = '' . count($tid_attachs[$thread['tid']]);
                        }
                    }
                    $add = isset($addviews[$thread['tid']]) ? $addviews[$thread['tid']]['addviews'] : 0;
                    $thread['hits'] += $add;

                    // 主题分类
                    $thread['types'] = array();
                    if ($val['typeid'] > 0 && $_G['forum']['threadtypes']['prefix'] == 1 && !empty($_G['forum']['threadtypes']['types'][$val['typeid']])) {
                        $thread['types'] = array(
                            'id' => $val['typeid'],
                            'name' => $_G['forum']['threadtypes']['types'][$val['typeid']],
                        );
                    }

                    $threads[] = $thread;
                }
            }

            // 2.0.0帖子列表页数据整合分类信息,做好之前版本的兼容
            if (!empty($type)) {
                $data = array(
                    'is_sort' => 0,
                    'thread' => array(),
                    'sort' => array(),
                    'type' => array()
                );

                $data['thread'] = $threads;

                // 主题分类
                $threadType = array();
                if (!empty($_G['forum']['threadtypes'])) {
                    $typeTemp = array();
                    $isAdmin = (!empty($_G['group']['radminid']) && in_array($_G['group']['radminid'], array(1, 2, 3))) ? 1 : 0;
                    $threadType['required'] = $_G['forum']['threadtypes']['required'] ? 1 : 0;
                    $typeArray = $_G['forum']['threadtypes']['types'];
                    foreach ($typeArray as $typeid => $v) {
                        if (!$isAdmin && !empty($_G['forum']['threadtypes']['moderators'][$typeid])) {
                            continue;
                        }
                        $typeTemp[] = array(
                            'typeid' => $typeid,
                            'typename' => strip_tags($v)
                        );
                    }
                    $threadType['types'] = $typeTemp;
                    $data['type'] = $threadType;
                }

                // 分类信息
                if (!empty($_G['forum']['threadsorts']['types'])) {
                    require_once libfile('function/threadsort');
                    $threadSort['required'] = $_G['forum']['threadsorts']['required'] ? 1 : 0;
                    $threadSortArr = $_G['forum']['threadsorts']['types'];
                    $data['is_sort'] = 1;
                    require_once libfile('function/threadsort');
                    foreach ($threadSortArr as $sortid => $vv) {
                        $sortTemp = array(
                            'sortid' => $sortid,
                            'sortname' => $vv,
                            'data' => array()
                        );
                        threadsort_checkoption($sortid);
                        $sortArray = $_G['forum_optionlist'];
                        foreach ($sortArray as $optionid => $option) {
                            $select = array();
                            if ($option['type'] == 'radio') {
                                if (!empty($option['choices'])) {
                                    foreach ($option['choices'] as $kkk => $vvv) {
                                        $selectArr['optionid'] = $kkk;
                                        $selectArr['content'] = $vvv;
                                        $select[] = $selectArr;
                                    }
                                    unset($selectArr);
                                }

                                if (!empty($sortArray)) {
                                    $optionTemp = array(
                                        'kindid' => $optionid,
                                        'name' => $option['title'],
                                        'type' => $option['type'],
                                        'select' => !empty($select) ? $select : array(),
                                    );
                                }

                                $sortTemp['data'][] = $optionTemp;
                            }
                        }
                        if (empty($sortTemp['data'])) continue;
                        $data['sort'][] = $sortTemp;
                    }
                }
                Tool::getInstance()->success_json($data);
            }

            Tool::getInstance()->success_json($threads);
        }
    }

    public function actionAllthreads()
    {
        $fid = WebHelper::getPost('fid', 0);
        $tid = WebHelper::getPost('tid', 0);
        $title = WebHelper::getPost('title', '');
        $authorid = WebHelper::getPost('authorid', 0);
        $author = WebHelper::getPost('author', '');
        $iscount = WebHelper::getPost('iscount', 0);
        $offset = WebHelper::getPost('offset', 0);
        $limit = WebHelper::getPost('limit', 0);

        global $_G;

        $threads = array();
        $data = array();
        if ($fid || $tid || !empty($title) || !empty($author) || $authorid) {
            $threads = $this->_allThreadSearch($fid, $tid, $title, $authorid, $author, 0, $offset, $limit);

            if ($iscount)
                $data['count'] = $this->_allThreadSearch($fid, $tid, $title, $authorid, $author, $iscount, $offset, $limit);
        } else {
            $threads = $this->_allThread(0, $offset, $limit);

            if ($iscount)
                $data['count'] = $this->_allThread($iscount, $offset, $limit);
        }

        if (!empty($threads)) {
            $offset = 0;
            $tids = Tool::Array_Column($threads, 'tid');

            $post_info = DB::fetch_all("SELECT tid,pid,status,anonymous FROM %t WHERE tid in (%n) AND first = 1", array("forum_post", $tids), 'tid');
            //附件提取
            $tid_attachs = ForumThread::getAllAttaches($post_info, $threads);

            foreach ($threads as $key => $val) {

                $data[$offset]['tid'] = $val['tid'];
                $data[$offset]['subject'] = $val['subject'];
                $data[$offset]['authorid'] = $val['authorid'];
                $data[$offset]['author'] = $val['author'];
                $data[$offset]['fid'] = $val['fid'];
                $data[$offset]['forumname'] = DB::result_first("SELECT name FROM %t WHERE fid = %d", array
                ('forum_forum', $val['fid']));
                $data[$offset]['hits'] = $val['views'];
                $data[$offset]['replies'] = $val['replies'];
                $data[$offset]['postdate'] = $val['dateline'];
                $data[$offset]['attachs'] = array();
                $data[$offset]['pid'] = $post_info[$val['tid']]['pid'];
                // 是否匿名
                $data[$offset]['anonymous'] = $post_info[$val['tid']]['anonymous'];

                if ($val['attachment'] == 2 || $val['attachment'] == 1) {
                    //优化附件处理
                    if (isset($tid_attachs[$val['tid']]) && is_array($tid_attachs[$val['tid']]) && !empty($tid_attachs[$val['tid']])) {
                        $data[$offset]['attachs'] = $tid_attachs[$val['tid']];
                    }
                }
//                unset($data[$offset]['pid']);

                $offset++;
            }
        }
        Tool::getInstance()->success_json($data);
    }

    private function _allThreadSearch($fid, $tid, $title, $authorid, $author, $iscount, $offset, $limit)
    {
        $sql = array();
        if ($fid) {
            $sql[] = DB::field('fid', $fid);
        }
        if ($tid) {
            $sql[] = DB::field('tid', $tid);
        }
        if ($title) {
            $sql[] = DB::field('subject', '%' . $title . '%', 'like');
        }
        if ($authorid) {
            $sql[] = DB::field('authorid', $authorid);
        }
        if ($author) {
            $sql[] = DB::field('author', '%' . $author . '%', 'like');
        }
        $sql = implode(' AND ', $sql);
        if (!empty($sql)) {
            $sql = 'WHERE ' . $sql;
        }
        // 数据条数
        if ($iscount) {
            return DB::result_first("SELECT COUNT(*)  FROM %t  %i AND displayorder >= 0", array('forum_thread', $sql));
        }
        return DB::fetch_all("SELECT *  FROM %t  %i AND displayorder >= 0 ORDER by dateline DESC " . DB::limit($offset, $limit), array('forum_thread', $sql));
    }

    private function _allThread($iscount, $offset, $limit)
    {
        // 数据条数
        if ($iscount) {
            return DB::result_first("SELECT COUNT(*) FROM %t WHERE displayorder >= %d", array('forum_thread', 0));
        }
        return DB::fetch_all("SELECT * FROM %t WHERE displayorder >= %d ORDER by dateline DESC " . DB::limit($offset,
                $limit), array('forum_thread', 0));
    }

    // 获取帖子列表
    private function _searchThread($conditions, $tableid = 0, $start = 0, $limit = 0, $order = '', $sort = 'DESC', $tidArray)
    {
        $ordersql = '';
        if (!empty($order)) {
            $ordersql = " ORDER BY $order $sort ";
        }

        if (!empty($tidArray)) {
            $ordersql = ' AND ' . DB::field('tid', $tidArray) . $ordersql;
        }
        $data = array();
        $forumThread = new table_forum_thread();
        if (count($conditions) < 5) {
            foreach (array_keys($conditions) as $key) {
                if (!in_array($key, array('inforum', 'sticky', 'displayorder', 'intids'))) {
                    break;
                }
            }
        }

        $data = DB::fetch_all("SELECT * FROM " . DB::table($forumThread->get_table_name($tableid)) . $forumThread->search_condition($conditions) . " $ordersql " . DB::limit($start, $limit));

        return $data;
    }

    /**
     * 24小时热点帖子列表
     *
     * 只取当前前10000贴
     * 预留后台版块筛选功能
     * 预留后台热度控制
     * 注意性能问题
     */
    public function actionGethotthreads()
    {
        global $_G;
        $order = WebHelper::getPost('order', '');
        $time = WebHelper::getPost('time', '');
        $offset = WebHelper::getPost('offset', 0);
        $limit = WebHelper::getPost('limit', 20);
        $fids = WebHelper::getPost('fids', '');

        $start = !empty($offset) ? intval($offset) : 0;
        $num = $limit ? intval($limit) : 20;
        $fids = $fids ? explode(',', $fids) : 0;
        $heatslimit = $_G['setting']['heatthread']['guidelimit'] ? $_G['setting']['heatthread']['guidelimit'] : 3;

        //热帖的时间范围
        $current = 0;
        if ($order == 'hits') {
            $current = time() - $time;
        }

        //热点帖子，最新发布，最新回复
        switch (!empty($order)) {
            case $order == 'hits';
                $order = 'hot';
                break;
            case $order == 'postdate';
                $order = 'newthread';
                break;
            case $order == 'lastpost';
                $order = 'reply';
                break;
            default:
                $order = 'reply';
        }

        //版块过滤
        if (!$fids) {
            loadcache('forums');
            $fids = array();
            foreach ($_G['cache']['forums'] as $fid => $forum) {
                if ($forum['type'] != 'group' && $forum['status'] > 0 && !$forum['viewperm'] && !$forum['havepassword']) {
                    $fids[] = $fid;
                }
            }
        }

        if (!function_exists('loadforum')) {
            require_once(libfile('function/forum'));
        }

        //只取前50000贴
        $limittid = DB::result_first('
            SELECT tid
            FROM %t
            ORDER BY tid DESC
            LIMIT %d
            ',
            array('forum_thread', 1));
        $limittid = intval($limittid) - 50000;
        $limittid = $limittid > 0 ? $limittid : 0;
        $threadlist = C::t('forum_thread')->fetch_all_for_guide($order, $limittid, null, $heatslimit, $current, $start, $num, $fids);


        $tids = Tool::Array_Column($threadlist, 'tid');
        $post_info = DB::fetch_all("SELECT tid,pid,status,anonymous FROM %t WHERE tid in (%n) AND first = 1", array("forum_post", $tids), 'tid');
        //附件提取
        $tid_attachs = ForumThread::getAllAttaches($post_info, $threadlist);

        $data = array();
        foreach ($threadlist as $k => $v) {
            $temp['tid'] = $v['tid'];
            $temp['subject'] = $v['subject'];
            $temp['authorid'] = $v['authorid'];
            $temp['author'] = $v['author'];
            $temp['authoricon'] = discuz_uc_avatar($temp['authorid'], 'big', 1);
            $temp['fid'] = $v['fid'];
            $foruminfo = C::t('forum_forum')->fetch_info_by_fid($temp['fid']);
            $temp['forumname'] = $foruminfo['name'];

            //修正帖子查看数
            $_GET['tid'] = dintval($v['tid']);
            loadforum();
            if (isset($_G['forum_thread']['views']) && $_G['forum_thread']['tid'] == $v['tid'] && $_G['forum_thread']['views'] > $v['views']) {
                $v['views'] = strval($_G['forum_thread']['views']);
            }
            $temp['hits'] = $v['views'];
            $temp['replies'] = $v['replies'];
            $temp['postdate'] = $v['dateline'];
            $temp['lastpost'] = $v['lastpost'];
            $temp['attnum'] = '0';
            $temp['special'] = $v['special'];
            $temp['pingcount'] = $v['recommend_add'];

            $temp['anonymous'] = isset($post_info[$temp['tid']]) ? $post_info[$temp['tid']]['anonymous'] : 0;

            //获取附件
            $attachs = array();
            if ($v['attachment'] == 2 || $v['attachment'] == 1) {
                if (isset($tid_attachs[$v['tid']]) && is_array($tid_attachs[$v['tid']]) && !empty($tid_attachs[$v['tid']])) {
                    $temp['attnum'] = '' . count($tid_attachs[$v['tid']]);
                    foreach ($tid_attachs[$v['tid']] as $attach) {
                        if ($temp['attnum'] == 2) {
                            if (count($attachs) >= 1) break;
                        } else {
                            if (count($attachs) >= 3) break;
                        }
                        $attachs[] = $attach;
                    }

                }
            }
            $temp['attachs'] = $attachs;
            $temp['special'] = $v['special'];
            $data[] = $temp;
        }
        Tool::getInstance()->success_json($data);
    }

    /*
     * 置顶贴
     *
    */
    public function actionTopthread()
    {
        global $_G;
        $fid = WebHelper::getPost('fid', 0);
        if ($fid > 0) {
            require_once(libfile('function/forum'));
            loadcache(array('forums', 'forumstick', 'globalstick', 'setting'));
            loadforum($fid, null);

            $thisgid = $_G['forum']['type'] == 'forum' ? $_G['forum']['fup'] : (!empty($_G['cache']['forums'][$_G['forum']['fup']]['fup']) ? $_G['cache']['forums'][$_G['forum']['fup']]['fup'] : 0);
            //$stickycount = 0;
            $stickytids = '';
            $forumstickytids = $filterarr = array();

            //$_G['setting']['globalstick'] 不考虑这个论坛设置
            if ($_G['forum']['allowglobalstick'] && $_G['setting']['globalstick']) {
                $stickytids = explode(',', str_replace("'", '', $_G['cache']['globalstick']['global']['tids']));

                if (!empty($_G['cache']['globalstick']['categories'][$thisgid]['count'])) {
                    $stickytids = array_merge($stickytids, explode(',', str_replace("'", '', $_G['cache']['globalstick']['categories'][$thisgid]['tids'])));
                }
//                if ($_G['forum']['status'] != 3) {
//                    $stickycount = $_G['cache']['globalstick']['global']['count'];
//                    if (!empty($_G['cache']['globalstick']['categories'][$thisgid])) {
//                        $stickycount += $_G['cache']['globalstick']['categories'][$thisgid]['count'];
//                    }
//                }
                // $forumstickycount = 0;
                $forumstickfid = $_G['forum']['status'] != 3 ? $_G['fid'] : $_G['forum']['fup'];
                if (isset($_G['cache']['forumstick'][$forumstickfid])) {
                    //$forumstickycount = count($_G['cache']['forumstick'][$forumstickfid]);
                    $forumstickytids = $_G['cache']['forumstick'][$forumstickfid];
                }
                if (!empty($forumstickytids)) {
                    $stickytids = array_merge($stickytids, $forumstickytids);
                }
            }
            //每页显示主题数
            $setting = C::t('common_setting')->fetch_all('topicperpage');
            $limit = $setting['topicperpage'];
            //按照版块设置排序
            $forums = C::t('forum_forum')->fetch_all_info_by_fids($fid);
            $simple = 0;
            if (isset($forums[$fid]['simple'])) $simple = $forums[$fid]['simple'];
            $orderby = bindec((($simple & 128) ? 1 : 0) . (($simple & 64) ? 1 : 0));
            if ($orderby == 0) {
                $order = 'lastpost';
            } elseif ($orderby == 1) {
                $order = 'dateline';
            } elseif ($orderby == 2) {
                $order = 'replies';
            } elseif ($orderby == 3) {
                $order = 'views';
            } else {
                $order = '';
            }
            $filterarr['sticky'] = 4;
            $filterarr['inforum'] = empty($_G['forum']['allowglobalstick']) ? $fid : '';
            $filterarr['intids'] = $stickytids;
            $filterarr['displayorder'] = array(2, 3, 4);
            //本版置顶数据
            if ($order) {
                $lists = DB::fetch_all("SELECT tid,subject,authorid,author,dateline,lastpost,views,replies,displayorder,fid,sortid FROM %t WHERE fid= $fid AND displayorder = 1 ORDER BY $order DESC" . DB::limit(0, 100), array('forum_thread'));
            } else {
                $lists = DB::fetch_all("SELECT tid,subject,authorid,author,dateline,lastpost,views,replies,displayorder,fid,sortid FROM %t WHERE fid= $fid AND displayorder = 1" . DB::limit(0, 100), array('forum_thread'));
            }
            $threadtableids = !empty($_G['cache']['threadtableids']) ? $_G['cache']['threadtableids'] : array();
            $tableid = $_GET['archiveid'] && in_array($_GET['archiveid'], $threadtableids) ? intval($_GET['archiveid']) : 0;

            $order = $order ? 'displayorder DESC,' . $order : 'displayorder';
            $threadlist = C::t('forum_thread')->fetch_all_search($filterarr, $tableid, 0, $limit, $order, 'DESC');
            $threadlist = array_merge($threadlist, $lists);
            //重新组织数据
            $threads = array();

            $tids = Tool::Array_Column($threadlist, 'tid');
            $post_info = DB::fetch_all("SELECT tid,pid,status FROM %t WHERE tid in (%n) AND first = 1", array("forum_post", $tids), 'tid');
            //附件提取
            $tid_attachs = ForumThread::getAllAttaches($post_info, $threadlist);

            foreach ($threadlist as $key => $val) {
                $thread = array();
                $thread['tid'] = $val['tid'];
                $thread['subject'] = $val['subject'];
                $thread['authorid'] = $val['authorid'];
                $thread['author'] = $val['author'];
                $thread['postdate'] = $val['dateline'];
                $thread['lastpost'] = $val['lastpost'];
                $thread['hits'] = $val['views'];
                $thread['replies'] = $val['replies'];
                $thread['special'] = $val['special'];
                $thread['attach'] = array();
                $thread['attnum'] = '0';
                //附件处理
                if (isset($tid_attachs[$thread['tid']]) && is_array($tid_attachs[$thread['tid']]) && !empty($tid_attachs[$thread['tid']])) {
                    $thread['attach'] = $tid_attachs[$thread['tid']];
                    $thread['attnum'] = '' . count($tid_attachs[$thread['tid']]);
                }
                $threads[] = $thread;
            }
            Tool::getInstance()->success_json($threads);
        } else {
            Tool::getInstance()->fail_json(Code::UNDEFINED_ACTION, Tool::getInstance()->lang('undefined action'));
        }
    }

    /**
     * 根据fid获取版主
     */
    public function actionForummaster()
    {
        global $_G;
        $_G['fid'] = WebHelper::getPost('fid', '');

        $forumfield = C::t('forum_forumfield')->fetch_all_by_fid(array($_G['fid']));
        $moderators = explode("\t", $forumfield[$_G['fid']]['moderators']);
        $data = array();
        if (!$moderators || !is_array($moderators) || empty($moderators)) {
            Tool::getInstance()->success_json($data);
        }

        foreach ($moderators as $moderator) {
            $user = C::t('common_member')->fetch_by_username($moderator);

            if ($user['uid'] > 0) {
                $data[] = array(
                    'uid' => $user['uid'] ? $user['uid'] : 0,
                    'username' => $user['username'] ? $user['username'] : '',
                    'icon' => avatar($user['uid'], 'big', true),
                );
            }
        }
        Tool::getInstance()->success_json($data);
    }

    /**
     * 根据fid获取版块主题分类，分类信息的相关内容
     *
     */
    public function actionGetForumInfo()
    {
        global $_G;
        $fid = WebHelper::getPost('fid', '');
        if (!function_exists('loadforum')) {
            require_once(libfile('function/forum'));
        }
        require_once(Yii::getPathOfAlias('application.components.func') . DIRECTORY_SEPARATOR . 'forum_viewthread.php');

        loadforum($fid);
        $data = array(
            'type' => array(),
            'sort' => array()
        );
        $threadType = $threadSort = array();

        // 主题分类
        if (!empty($_G['forum']['threadtypes'])) {
            $threadType['required'] = $_G['forum']['threadtypes']['required'] ? 1 : 0;
//            Yii::log(var_export($_G['forum'], true));
            $typeArray = $_G['forum']['threadtypes']['types'];
            foreach ($typeArray as $typeid => $v) {
                if (!empty($_G['forum']['threadtypes']['moderators'][$typeid]) && $_G['forum'] && !$_G['forum']['ismoderator']) continue;
                $typeTemp[] = array(
                    'typeid' => $typeid,
                    'typename' => strip_tags($v)
                );
            }
            $threadType['types'] = $typeTemp;

        }

        // 分类信息
        if (!empty($_G['forum']['threadsorts'])) {
            $threadSort['required'] = $_G['forum']['threadsorts']['required'] ? 1 : 0;
            $threadSortArr = $_G['forum']['threadsorts']['types'];
            require_once libfile('function/threadsort');
            foreach ($threadSortArr as $sortid => $vv) {
                $expiration = 0;
                if (!empty($_G['forum']['threadsorts']['expiration'])) {
                    $expiration = $_G['forum']['threadsorts']['expiration'][$sortid];
                }
                $sortTemp = array(
                    'sortid' => $sortid,
                    'sortname' => $vv,
                    'expiration' => $expiration, //是否开启有效期
                    'data' => array()
                );
                threadsort_checkoption($sortid);
                $sortArray = $_G['forum_optionlist'];
                $tmpid = 0;
                foreach ($sortArray as $optionid => $option) {
                    $select = array();
                    if ($option['type'] == 'radio' || $option['type'] == 'checkbox') {
                        if (!empty($option['choices'])) {
                            foreach ($option['choices'] as $kkk => $vvv) {
                                $selectArr['content'] = $vvv;
                                $selectArr['optionid'] = $kkk;
                                $select[] = $selectArr;
                            }
                            unset($selectArr);
                        }
                    } elseif ($option['type'] == 'select') {
                        $items = $option['choices'];
                        $topid = 0;

                        // 哇一行代码实现无限级分类
                        foreach ($items as $item) {
                            $items[$item['foptionid']]['children'][] = &$items[$item['optionid']];
                        }
                        $select = isset($items[$topid]['children']) ? $items[$topid]['children'] : array();
                    }
                    // 范围类型规则处理
                    if (in_array($option['type'], array('range', 'number'))) {
                        $option['minnum'] = !empty($option['minnum']) ? $option['minnum'] : 0;
                        $option['maxnum'] = !empty($option['maxnum']) ? $option['maxnum'] : 0;
                        $option['maxlength'] = $option['minnum'] . ',' . $option['maxnum'];
                    }
                    if (!empty($sortArray)) {
                        $optionTemp = array(
                            'kindid' => $optionid,
                            'name' => $option['title'],
                            'type' => $option['type'],
                            'identifier' => $option['identifier'],
                            'desc' => $option['description'],
                            'required' => $option['required'],
                            'maxlength' => !empty($option['maxlength']) ? $option['maxlength'] . '' : '',
                            'select' => $select,
                        );
                    }
                    $sortTemp['data'][] = $optionTemp;
                    $tmpid += $optionid;
                }
                if ($expiration) {
                    if (strtoupper($_G['charset']) != 'UTF-8') {
                        $zero = mb_convert_encoding('3天', 'gbk', 'utf-8');
                        $one = mb_convert_encoding('5天', 'gbk', 'utf-8');
                        $two = mb_convert_encoding('7天', 'gbk', 'utf-8');
                        $three = mb_convert_encoding('1月', 'gbk', 'utf-8');
                        $four = mb_convert_encoding('3月', 'gbk', 'utf-8');
                        $five = mb_convert_encoding('半年', 'gbk', 'utf-8');
                        $six = mb_convert_encoding('1年', 'gbk', 'utf-8');
                        $name = mb_convert_encoding('有效期', 'gbk', 'utf-8');
                        $desc = mb_convert_encoding('信息的有效期', 'gbk', 'utf-8');
                    }

                    $array = array(
                        'kindid' => $tmpid + 1,
                        'name' => isset($name) ? $name : '有效期',
                        'type' => 'radio',
                        'identifier' => 'typeexpiration',
                        'desc' => isset($desc) ? $desc : '信息的有效期',
                        'required' => '1',
                        'maxlength' => '',
                        'select' => array(
                            '0' => array(
                                'content' => isset($zero) ? $zero : '3天',
                                'optionid' => '259200'
                            ),
                            '1' => array(
                                'content' => isset($one) ? $one : '5天',
                                'optionid' => '432000'
                            ),
                            '2' => array(
                                'content' => isset($two) ? $two : '7天',
                                'optionid' => '604800'
                            ),
                            '3' => array(
                                'content' => isset($three) ? $three : '1月',
                                'optionid' => '2592000'
                            ),
                            '4' => array(
                                'content' => isset($four) ? $four : '3月',
                                'optionid' => '7776000'
                            ),
                            '5' => array(
                                'content' => isset($five) ? $five : '半年',
                                'optionid' => '15552000'
                            ),
                            '6' => array(
                                'content' => isset($six) ? $six : '1年',
                                'optionid' => '31104000'
                            )
                        ),
                    );

                    $sortTemp['data'][] = $array;
                }
                $threadSort['types'][] = $sortTemp;
            }
        }

        $data['type'] = $threadType;
        $data['sort'] = $threadSort;
        foreach ($data['type']['types'] as $key => $value) {
            $value['typename'] = strip_tags($value['typename'], chr(32));
            $data['type']['types'][$key]['typename'] = $value['typename'];
        }
        Tool::getInstance()->success_json($data);
    }

    /**
     * 根据fids，获取各个板块主题分类情况
     */
    public function actionGetTypeByFids()
    {
        global $_G;
        $fids = WebHelper::getPost('fids', '');
        $fidArr = explode(',', $fids);

        if (count($fidArr) >= 1200) {
            Tool::getInstance()->fail_json(Code::REQUEST_IS_LARGE, Tool::getInstance()->lang('request_is_large'));
        }

        $forums = C::t('forum_forum')->fetch_all_info_by_fids($fidArr);
        $forumArr = $data = $typeTemp = array();
        if (!empty($forums)) {
            foreach ($forums as $k => $forum) {
                foreach (array('threadtypes', 'threadsorts') as $key) {
                    $forum[$key] = !empty($forum[$key]) ? dunserialize($forum[$key]) : array();
                    if (!is_array($forum[$key])) {
                        $forum[$key] = array();
                    }
                }
                $forumArr['fid'] = $forum['fid'];
                $forumArr['type'] = $forum['threadtypes'];
                $forumArr['is_sort'] = !empty($forum['threadsorts']) ? 1 : 0;  // 是否可以发布分类信息

                if (!empty($forumArr['type'])) {
                    $forumArray = array(
                        'required' => '',
                        'types' => array()
                    );
                    $forumArray['required'] = $forumArr['type']['required'] ? 1 : 0;
                    foreach ($forumArr['type']['types'] as $typeid => $v) {
                        //if(!empty($forumArr['type']['moderators'][$typeid]) && $_G['forum'] && !$_G['forum']['ismoderator']) continue;
//                        $typeTemp[] = array(
//                            'typeid' => $typeid,
//                            'typename' => strip_tags($v)
//                        );

                        $typeTempArr['typeid'] = $typeid;
                        if (strpos($v, "[/color]") !== false) {
                            $v = preg_replace(array('/\[color=.*?\b\]/', '/\[\/color\]/'), '', $v);
                        }
                        if (strpos($v, "[/b]") !== false
                            || strpos($v, "[/u]") !== false
                            || strpos($v, "[/i]") !== false
                            || strpos($v, "[/s]") !== false
                        ) {
                            $v = preg_replace(array('/\[(b|u|i|s)\b\]/', '/\[\/(b|u|i|s)\]/'), '', $v);
                        }
                        $typeTempArr['typename'] = strip_tags($v);


                        $typeTemp[] = $typeTempArr;
                        unset($typeTempArr);
                    }
                    $forumArray['types'] = $typeTemp;
                    $forumArr['type'] = $forumArray;
                    unset($typeTemp);
                }
                //2.0.1 新增 配置
                $fid = $forum['fid'];
                $forums = C::t('forum_forum')->fetch_all_info_by_fids($fid);
                $simple = 0;
                if (isset($forums[$fid]['simple'])) $simple = $forums[$fid]['simple'];
                $orderby = bindec((($simple & 128) ? 1 : 0) . (($simple & 64) ? 1 : 0));

                if ($orderby != 0 && $orderby != 1) $orderby = 0;

                $forumArr['default_order'] = $orderby;

                unset($forum);
                $data[] = $forumArr;
            }
        }

        Tool::getInstance()->success_json($data);
    }

    //获取指定板块的 所有帖子
    public function actionGetThreadsByFids()
    {
        global $_G;
        //板块

        $fids = WebHelper::getPost('fids', '');
        //排序方式  1 发帖日期倒序 0 最后回复时间倒序
        $ordertype = dintval(WebHelper::getPost('ordertype', 0));
        //SQL OFFSET
        $offset = dintval(WebHelper::getPost('offset', 0));
        //SQL LIMIT
        $limit = dintval(WebHelper::getPost('limit', 10));

        $fidArray = $fids ? explode(',', $fids) : 0;
        //版块过滤 todo
        if (!function_exists('loadforum')) {
            require_once(libfile('function/forum'));
        }
        if ($ordertype == 1) {
            $ordertype = 'dateline';
        } else {
            $ordertype = 'lastpost';
        }
        if ($fidArray) {
            $data = array();
            $threadlist = DB::fetch_all("SELECT * FROM %t WHERE " . DB::field('fid', $fidArray) . "AND displayorder>=%d ORDER by $ordertype DESC " . DB::limit($offset, $limit), array("forum_thread", 0));
            $tids = Tool::Array_Column($threadlist, 'tid');
            $post_info = DB::fetch_all("SELECT tid,pid,status FROM %t WHERE tid in (%n) AND first = 1", array("forum_post", $tids), 'tid');
            //附件提取
            $tid_attachs = ForumThread::getAllAttaches($post_info, $threadlist);

            foreach ($threadlist as $k => $v) {
                $temp = array();
                $temp['fid'] = $v['fid'];
                $temp['tid'] = $v['tid'];
                $temp['subject'] = $v['subject'];
                $temp['authorid'] = $v['authorid'];
                $temp['author'] = $v['author'];
                $temp['icon'] = discuz_uc_avatar($temp['authorid'], 'big', 1);
                $temp['postdate'] = $v['dateline'];
                $temp['lastpost'] = $v['lastpost'];
                //修正帖子查看数
                $_GET['tid'] = dintval($v['tid']);
                loadforum();
                if (isset($_G['forum_thread']['views']) && $_G['forum_thread']['tid'] == $v['tid'] && $_G['forum_thread']['views'] > $v['views']) {
                    $v['views'] = strval($_G['forum_thread']['views']);
                }
                $temp['hits'] = $v['views'];
                $temp['replies'] = $v['replies'];

                $foruminfo = C::t('forum_forum')->fetch_info_by_fid($temp['fid']);
                $temp['fname'] = $foruminfo['name'];
                $temp['attnum'] = '0';

                //获取附件
                $attachs = array();
                if ($v['attachment'] == 2 || $v['attachment'] == 1) {
                    if (isset($tid_attachs[$v['tid']]) && is_array($tid_attachs[$v['tid']]) && !empty($tid_attachs[$v['tid']])) {
                        $temp['attnum'] = '' . count($tid_attachs[$v['tid']]);
                        foreach ($tid_attachs[$v['tid']] as $attach) {
                            if ($temp['attnum'] == 2) {
                                if (count($attachs) >= 1) break;
                            } else {
                                if (count($attachs) >= 3) break;
                            }
                            $attachs[] = $attach;
                        }

                    }
                }
                $temp['attachs'] = $attachs;
                $temp['special'] = $v['special'];
                $data[] = $temp;
            }
            Tool::getInstance()->success_json($data);
        } else {
            Tool::getInstance()->fail_json(Code::FORUM_NOT_EXISTS, Tool::getInstance()->lang('forum not exists'));
        }
    }

    //获取主题帖的审核列表
    public function actionVerifyThreadList()
    {
        global $_G;
        //主题帖的审核
        $offset = intval(WebHelper::getPost('page', 0));
        $offset = $offset ? $offset : intval(WebHelper::getPost('offset', 0));
        $limit = intval(WebHelper::getPost('limit', 20));
        $username = WebHelper::getPost('username', ''); //用户名
        $title = WebHelper::getPost('title', '');      //标题包含
        $filter = intval(WebHelper::getPost('filter', 0)); //审核范围 1 已忽略 0 未审核
        $fid = intval(WebHelper::getPost('fid', 0));    //板块 0 所有板块  其他值为板块fid
        $isgroup = intval(WebHelper::getPost('isgroup', 0));    //是否群主 1 是 0 否
        $dateline = intval(WebHelper::getPost('dateline', 0));  //时间 单位 秒 多少秒内的帖子。0为所有

        //-----------------------
        $dateline = $dateline ? (TIMESTAMP - $dateline) : 0;
        if ($isgroup == 0) $isgroup = -1; //论坛是-1
        if (!empty($title)) {            //过滤。。。
            $title = str_replace(array('_', '%'), array('\_', '\%'), $title);
        }
        $modcount = 0;
        $moderates = C::t('common_moderate')->fetch_all_by_idtype('tid', $filter, $dateline);
        if (!empty($moderates)) {
            $modcount = C::t('forum_thread')->count_by_tid_fid(array_keys($moderates), $fid, $isgroup, $username, $title);
        }
        if ($modcount != count($moderates) && !$dateline && !$fid && !$username && !$title) {
            self::moderateswipe('tid', array_keys($moderates));
        }
        $threadList = array();
        if ($modcount) {
            $threadList = C::t('forum_thread')->fetch_all_by_tid_fid(array_keys($moderates), $fid, $isgroup, $username, $title, $offset, $limit);
            $tids = C::t('forum_thread')->get_posttableid();
            if ($tids) {
                foreach ($tids as $posttableid => $tid) {
                    foreach (C::t('forum_post')->fetch_all_by_tid($posttableid, $tid, true, '', 0, 0, 1) as $post) {
                        $fpm = array(
                            'tid' => $post['tid'],
                            'pid' => $post['pid'],
                            'fid' => $post['fid'],
                            'subject' => $post['subject'],
                            'table_id' => $posttableid,
                            'content' => ForumThread::getSmilesImg(self::_contentFilter($post['message'])),
                            'author' => $post['author'],
                            'authorid' => $post['authorid'],
                            'dateline' => $post['dateline'],
                        );
                        $threadList[$post['tid']] = $fpm;
                    }
                }
            }
        }
        Tool::getInstance()->success_json($threadList);
    }

    //获取回帖的审核列表
    public function actionVerifyRepliesList()
    {

        global $_G;

        $offset = intval(WebHelper::getPost('offset', 0));
        $limit = intval(WebHelper::getPost('limit', 20));
        $username = WebHelper::getPost('username', ''); //用户名
        $title = WebHelper::getPost('title', '');      //内容包含
        $filter = intval(WebHelper::getPost('filter', 0)); //审核范围 1 已忽略 0 未审核
        $fid = intval(WebHelper::getPost('fid', 0));    //板块 0 所有板块  其他值为板块fid
        $dateline = intval(WebHelper::getPost('dateline', 0));  //时间 单位 秒 多少秒内的帖子。0为所有

        $dateline = $dateline ? (TIMESTAMP - $dateline) : 0;
        if (!empty($title)) {            //过滤。。。
            $title = str_replace(array('_', '%'), array('\_', '\%'), $title);
        }
        //全部的 post表都查询
        loadcache('posttableids');
        $posttableids = $_G['cache']['posttableids'] ? $_G['cache']['posttableids'] : array('0');
        $data = array();
        foreach ($posttableids as $tableid) {
            $modcount = C::t('common_moderate')->count_by_search_for_post(getposttable($tableid), $filter, 0, $fid, $username, $dateline, $title);
            $postdata = C::t('common_moderate')->fetch_all_by_search_for_post(getposttable($tableid), $filter, 0, $fid, $username, $dateline, $title, $offset, $limit);
            $checklength = C::t('common_moderate')->fetch_all_by_idtype('pid', $filter, null);

            if ($modcount != $checklength && !$dateline && !$fid && !$username && !$title) {
                self::moderateswipe('pid', array_keys($checklength));
            }
            $data[$tableid] = $postdata;
        }
        $List = array();
        foreach ($data as $table_id => $value) {
            foreach ($value as $post) {
                $subject = DB::fetch_first("select subject,authorid from %t where tid = %d", array('forum_thread', $post['tid']));
                $fpm = array(
                    'tid' => $post['tid'],
                    'pid' => $post['pid'],
                    'fid' => $post['fid'],
                    'table_id' => $table_id,
                    'subject' => $subject['subject'],
                    'master_uid' => $subject['authorid'],
                    'content' => ForumThread::getSmilesImg(self::_contentFilter($post['message'])),
                    'author' => $post['author'],
                    'authorid' => $post['authorid'],
                    'dateline' => $post['dateline'],
                );
                $List[] = $fpm;
            }

        }
        Tool::getInstance()->success_json($List);
    }

    // 审核中心-帖子审核列表
    public function actionReviewThreadList()
    {
        global $_G;

        $authorid = WebHelper::getPost('authorid', '');
        $author = WebHelper::getPost('author', ''); // 用户名

        $offset = intval(WebHelper::getPost('offset', 0));
        $limit = intval(WebHelper::getPost('limit', 20));
        $filter = intval(WebHelper::getPost('filter', 0)); // 审核范围 1 已忽略  0 未审核  2 通过
        $fid = intval(WebHelper::getPost('fid', 0));    // 板块 0 所有板块  其他值为板块fid
        $tid = intval(WebHelper::getPost('tid', 0));
        $startTime = WebHelper::getPost('startTime', 0);
        $endTime = WebHelper::getPost('endTime', 0);
        $title = WebHelper::getPost('title', '');  // 标题包含
        $timeOrder = WebHelper::getPost('timeOrder', 1); // 发布时间排序 0:正序  1:倒序
        $count = WebHelper::getPost('count', 0); // 总条数

        $result = array(
            'post' => array(),
            'count' => 0
        );

        if (!empty($title)) {
            $title = str_replace(array('_', '%'), array('\_', '\%'), $title);
        }

        if ($filter == 0) {
            $filter = -2;
        } elseif ($filter == 1) {
            $filter = -3;
        } elseif ($filter == 2) {
            $filter = 0;
        } else {
            $filter = 0;
        }

        $order = ' ORDER BY dateline ASC ';
        $postOrder = 'ASC';
        if ($timeOrder) {
            $order = ' ORDER BY dateline DESC ';
            $postOrder = 'DESC';
        }


        /***************fetch thread*****************/
        if (!$fid) {
            $fidArr = ForumThread::allForumIds();
            $fid = $fidArr;
        }
        $sqlWhere = ForumThread::fetchThreadWhere($tid, $fid, $authorid, $author, $startTime, $endTime, $filter, $title);
        $threadList = DB::fetch_all('SELECT * FROM ' . DB::table('forum_thread') . $sqlWhere[0] .
            $order . DB::limit($offset, $limit), $sqlWhere[1]);

        $tidArr = Tool::Array_Column($threadList, 'tid');
        $fidArr = Tool::Array_Column($threadList, 'fid');
        $forumInfo = DB::fetch_all("SELECT fid,name FROM %t WHERE fid in (%n)", array("forum_forum", $fidArr), 'fid');

        if ($count) {
            $result['count'] = DB::result_first('SELECT COUNT(*) FROM ' . DB::table('forum_thread') . $sqlWhere[0] .
                $order, $sqlWhere[1]);
        }
        /*******************************************/


        if ($threadList) {
            $threadArr = array();
            foreach ($threadList as $thread) {
                $threadArr[$thread['tid']] = $thread;
            }

            loadcache('posttableids');
            $postTableids = $_G['cache']['posttableids'] ? $_G['cache']['posttableids'] : array(0);
            foreach ($postTableids as $posttableid => $tableid) {
                $postList = C::t('forum_post')->fetch_all_by_tid($tableid, $tidArr, true, $postOrder, 0, 0, 1);
                $tidAttach = ForumThread::getAllAttaches($postList, $threadList);
                foreach ($postList as $post) {
                    $fpm = array(
                        'tid' => $post['tid'],
                        'pid' => $post['pid'],
                        'fid' => $post['fid'],
                        'fname' => isset($forumInfo[$post['fid']]) ? $forumInfo[$post['fid']]['name'] : '',
                        'subject' => $post['subject'],
                        'table_id' => $tableid,
                        'content' => ForumThread::getSmilesImg($post['message']),
                        'author' => $post['author'],
                        'authorid' => $post['authorid'],
                        'dateline' => $post['dateline'],
                        'authorip' => $post['useip'],
                        'invisible' => isset($threadArr[$post['tid']]) ? $threadArr[$post['tid']]['displayorder'] : $post['invisible'],
                        'attach' => array(),
                        'views' => isset($threadArr[$post['tid']]) ? $threadArr[$post['tid']]['views'] : 0,
                        'replies' => isset($threadArr[$post['tid']]) ? $threadArr[$post['tid']]['replies'] : 0,
                        'pings' => isset($threadArr[$post['tid']]) ? $threadArr[$post['tid']]['recommend_add'] : 0,
                        'ban' => $post['status'] & 1 ? 1 : 0,
                        'stick' => isset($threadArr[$post['tid']]) ? $threadArr[$post['tid']]['displayorder'] : 0,
                        'anonymous' => $post['anonymous'],
                        'closed' => isset($threadArr[$post['tid']]) ? $threadArr[$post['tid']]['closed'] : 0,
                    );

                    if (isset($tidAttach[$post['tid']])) {
                        $fpm['attach'] = $tidAttach[$post['tid']];
                    }

                    $result['post'][] = $fpm;
                }
                unset($postList);
                unset($tidAttach);
            }

        }

        Tool::getInstance()->success_json($result);
    }

    // 审核中心-评论审核列表
    public function actionReviewReplyList()
    {
        global $_G;

        $authorid = WebHelper::getPost('authorid', '');
        $author = WebHelper::getPost('author', ''); // 用户名
        $offset = intval(WebHelper::getPost('offset', 0));
        $limit = intval(WebHelper::getPost('limit', 20));
        $filter = intval(WebHelper::getPost('filter', 0)); // 审核范围 1 已忽略  0 未审核  2 通过 3 全部
        $fid = intval(WebHelper::getPost('fid', 0));    // 板块 0 所有板块  其他值为板块fid
        $tid = WebHelper::getPost('tid', 0);
        $startTime = WebHelper::getPost('startTime', 0);
        $endTime = WebHelper::getPost('endTime', 0);
        $title = WebHelper::getPost('title', '');  //标题包含
        $timeOrder = WebHelper::getPost('timeOrder', 1); // 发布时间排序 0:正序  1:倒序
        $count = WebHelper::getPost('count', 0); // 总条数
        $tids = !empty($tid) ? explode(',', $tid) : array();
        $author_ids = !empty($authorid) ? explode(',', $authorid) : array();
        $result = array(
            'post' => array(),
            'count' => 0
        );

        if (!empty($title)) {
            $title = str_replace(array('_', '%'), array('\_', '\%'), $title);
        }
        $data = array();

        $order = ' ORDER BY pid ASC ';
        $postOrder = ' ORDER BY p.pid ASC ';
        if ($timeOrder) {
            $order = ' ORDER BY pid DESC ';
            $postOrder = ' ORDER BY p.pid DESC ';
        }


        /***************fetch reply*****************/
        // 正常帖子评论
        if ($filter == 2 || $filter == 3) {
            $posttableids = array(0);
            if ($filter == 3) {
                $sqlWhere[] = DB::field('invisible', array(0, -1, -2, -3), 'in');
            } else {
                $sqlWhere[] = DB::field('invisible', 0);
            }

            $sqlWhere[] = DB::field('first', 0);
            if (!empty($tids)) {
                $sqlWhere[] = DB::field('tid', $tids, 'in');
            } else {
                $sqlWhere[] = DB::field('fid', 0, '>');
            }
            if ($fid) {
                $sqlWhere[] = DB::field('fid', $fid);
            }
            if (!empty($author_ids)) {
                $sqlWhere[] = DB::field('authorid', $author_ids, 'in');
            }
            if ($author) {
                $sqlWhere[] = DB::field('author', $author);
            }
            if ($startTime) {
                $sqlWhere[] = DB::field('dateline', $startTime, '>');
            }
            if ($endTime) {
                $sqlWhere[] = DB::field('dateline', $endTime, '<');
            }

            $sql = implode(' AND ', $sqlWhere);

            $tmpCount = 0;
            foreach ($posttableids as $tableid) {
                $postList = DB::fetch_all('
                SELECT pid, fid, tid, author, authorid, subject, dateline, message, useip, attachment, invisible, status,anonymous
			    FROM %t m
			    WHERE %i '
                    . $order . DB::limit($offset, $limit), array(getposttable($tableid), $sql));
                $data[$tableid] = $postList;

                if ($count) {
                    $tmpCount = $tmpCount + DB::result_first('SELECT COUNT(*) FROM %t m WHERE %i ' . $order, array(getposttable($tableid), $sql));
                }
            }
            $result['count'] = $tmpCount;
        } else {
            $tmpCount = 0;
            loadcache('posttableids');
            $posttableids = $_G['cache']['posttableids'] ? $_G['cache']['posttableids'] : array(0);
            $sqlWhere = ForumThread::fetchReplyWhere($tid, $fid, $authorid, $author, $startTime, $endTime, $filter, $title);
            foreach ($posttableids as $tableid) {
                $postList = DB::fetch_all('
                SELECT p.pid, p.fid, p.tid,p.author, p.authorid, p.subject, p.dateline, p.message, p.useip, p.attachment, p.invisible, p.status,p.anonymous
			    FROM %t m
			    LEFT JOIN %t p on p.pid=m.id
			    WHERE %i '
                    . $postOrder . DB::limit($offset, $limit), array('forum_post_moderate', getposttable($tableid), $sqlWhere));

                $data[$tableid] = $postList;
                if ($count) {
                    $tmpCount = $tmpCount + DB::result_first('SELECT COUNT(*) FROM %t m LEFT JOIN %t p on p.pid=m.id WHERE %i ' . $postOrder, array('forum_post_moderate', getposttable($tableid), $sqlWhere));
                }
            }
            $result['count'] = $tmpCount;
        }
        /*******************************************/


        if ($data) {
            foreach ($data as $table_id => $value) {
                $tids = Tool::Array_Column($value, 'tid');
                $tids = array_unique($tids);
                $fids = array_unique(Tool::Array_Column($value, 'fid'));

                $forumInfo = DB::fetch_all("SELECT fid,name FROM %t WHERE fid in (%n)", array("forum_forum", $fids), 'fid');
                $threadList = C::t('forum_thread')->fetch_all_by_tid($tids);
                $tid_attachs = ForumThread::getAllAttaches($value, $threadList, 1);

                foreach ($value as $post) {
                    $poststick = C::t('forum_poststick')->fetch_all_by_tid($post['tid']);

                    // 引用回复，被引用的用户id
                    $quoteuid = 0;
                    if (strpos($post['message'], '[quote]') !== false && strpos($post['message'], '[/quote]') !== false) {
                        preg_match("/\[quote\]\[size=(.+?)\]\[url=forum.php\?mod=redirect&goto=findpost&pid=(.+?)&ptid=(.+?)\]\[color=(.+?)\](.+?)\[\/color\]\[\/url\]\[\/size\](.+?)\[\/quote\](.*?)/isU", $post['message'], $quote_pid);
                        if (isset($quote_pid[2]) && is_numeric($quote_pid[2])) {
                            $quote = DB::fetch_first("select authorid from %t where pid = %d and first = 0", array('forum_post', $quote_pid[2]));
                            $quoteuid = isset($quote['authorid']) ? $quote['authorid'] : 0;
                        }
                    }

                    $fpm = array(
                        'tid' => $post['tid'],
                        'pid' => $post['pid'],
                        'fid' => $post['fid'],
                        'fname' => isset($forumInfo[$post['fid']]) ? $forumInfo[$post['fid']]['name'] : '',
                        'table_id' => $table_id,
                        'subject' => isset($threadList[$post['tid']]) ? $threadList[$post['tid']]['subject'] : '',
                        'master_uid' => isset($threadList[$post['tid']]) ? $threadList[$post['tid']]['authorid'] : '',
                        'content' => ForumThread::getSmilesImg($post['message']),
                        'author' => $post['author'],
                        'authorid' => $post['authorid'],
                        'dateline' => $post['dateline'],
                        'authorip' => $post['useip'],
                        'invisible' => $post['invisible'],
                        'attach' => array(),
                        'ban' => $post['status'] & 1 ? 1 : 0,
                        'stick' => isset($poststick[$post['pid']]) && !empty($poststick[$post['pid']]) ? 1 : 0,
                        'anonymous' => $post['anonymous'],
                        'quoteuid' => $quoteuid,
                        'closed' => isset($threadList[$post['tid']]) ? $threadList[$post['tid']]['closed'] : 0,
                    );
                    if (isset($tid_attachs[$post['pid']])) {
                        $fpm['attach'] = $tid_attachs[$post['pid']];
                    }

                    $result['post'][] = $fpm;
                }
            }
        }
        Tool::getInstance()->success_json($result);
    }

    //通过或者忽略审核帖
    public function actionVerifyThread()
    {
        global $_G;
        $tids = WebHelper::getPost('tids', ''); //需要操作的帖子
        $operation = WebHelper::getPost('operation', ''); //操作 validate 通过审核 delete 删除 ignore 忽略
        $reason = WebHelper::getPost('reason', ''); //操作理由

        $tids = explode(',', $tids);
        if (!empty($tids) && in_array($operation, array('validate', 'delete', 'ignore'))) {
            require_once libfile('function/forum');
            require_once libfile('function/post');
            require_once libfile('function/delete');
            if ($operation == 'validate') {
                $forums = array();
                $modtids = $authoridarray = $moderatedthread = array();
                foreach (C::t('forum_thread')->fetch_all_by_tid_fid($tids, array()) as $thread) {
                    if ($thread['displayorder'] != -2 && $thread['displayorder'] != -3) {
                        continue;
                    }
                    $poststatus = C::t('forum_post')->fetch_threadpost_by_tid_invisible($thread['tid']);
                    $poststatus = $poststatus['status'];
                    $modtids[] = $thread['tid'];
                    if (getstatus($poststatus, 3) == 0) {
                        updatepostcredits('+', $thread['authorid'], 'post', $thread['fid']);
                        $attachcount = C::t('forum_attachment_n')->count_by_id('tid:' . $thread['tid'], 'tid', $thread['tid']);
                        updatecreditbyaction('postattach', $thread['authorid'], array(), '', $attachcount, 1, $thread['fid']);
                    }
                    $forums[] = $thread['fid'];
                    $validatedthreads[] = $thread;
                }
                if ($modtids) {
                    $tidstr = dimplode($modtids);
                    C::t('forum_post')->update_by_tid(0, $modtids, array('status' => 4), false, false, null, -2, 0);
                    loadcache('posttableids');
                    $posttableids = $_G['cache']['posttableids'] ? $_G['cache']['posttableids'] : array('0');
                    foreach ($posttableids as $id) {
                        C::t('forum_post')->update_by_tid($id, $modtids, array('invisible' => '0'), false, false, 1);
                    }
                    $validates = C::t('forum_thread')->update($modtids, array('displayorder' => 0, 'moderated' => 1));
                    foreach (array_unique($forums) as $fid) {
                        updateforumcount($fid);
                    }
                    updatemodworks('MOD', $validates);
                    updatemodlog($tidstr, 'MOD', 0, 0, $reason);
                    updatemoderate('tid', $modtids, 2);
                }
            } elseif ($operation == 'delete') {
                $deletetids = $recyclebintids = $deltids = array();
                $query = C::t('forum_forum')->fetch_all_valid_forum();
                foreach ($query as $forum) {
                    $recyclebins[$forum['fid']] = $forum['recyclebin'];
                }
                foreach (C::t('forum_thread')->fetch_all_by_tid_displayorder($tids, null, '>=', array()) as $thread) {
                    if ($recyclebins[$thread['fid']]) {
                        if ($thread['displayorder'] >= 0) {
                            $deltids[] = $thread['tid'];
                        } else {
                            $recyclebintids[] = $thread['tid'];
                        }
                    } else {
                        $deletetids[] = $thread['tid'];
                    }
                }

                // 处理已通过状态回复数
                if ($deltids) {
                    $recy = deletethread($deltids, true, true, true);
                    updatemodworks('MOD', $recy);
                    updatemodlog(implode(',', $deltids), 'DEL', 0, 0, $reason);
                }
                if ($recyclebintids) {
                    $recycles = deletethread($recyclebintids, false, false, true);
                    updatemodworks('MOD', $recycles);
                    updatemodlog(implode(',', $recyclebintids), 'DEL', 0, 0, $reason);
                }
                deletethread($deletetids);
                updatemoderate('tid', $tids, 2);
            } elseif ($operation == 'ignore') {
                $thread = DB::fetch_all("SELECT tid,fid,authorid FROM %t WHERE tid IN(%n) AND displayorder >= 0", array('forum_thread', $tids));
                C::t('forum_thread')->update_displayorder_by_tid_displayorder($tids, -2, -3);
                C::t('forum_thread')->update_displayorder_by_tid_displayorder($tids, 0, -3);

                if ($tids && is_array($tids)) {
                    foreach ($tids as $tid) {
                        C::t('forum_post')->update_by_tid(0, $tid, array('invisible' => -3), false, false, 1);
                    }
                }

                $moderateArr = ForumThread::getModerateThread($tids);
//                $diffArr = array_values(array_diff($tids, $moderateArr));
                if ($moderateArr) {
                    updatemoderate('tid', $moderateArr, 1);
                }

                if ($tids) {
                    foreach ($tids as $id) {
                        if (!in_array($id, $moderateArr)) {
                            C::t('common_moderate')->insert('tid', array(
                                'id' => $id,
                                'status' => 1,
                                'dateline' => TIMESTAMP,
                            ), false, true);
                        }
                        C::t('forum_thread')->clear_cache($id);
                    }
                }

                // 处理已通过状态回复数
                foreach ($thread as $v) {
                    updatepostcredits('-', $v['authorid'], 'post', $v['fid']);
                }
            }
        } else {
            Tool::getInstance()->fail_json(Code::UNDEFINED_ACTION, Tool::getInstance()->lang('undefined action'));
        }
        Tool::getInstance()->success_json(array('return' => 'success'));
    }

    public function actionVerifyReply()
    {
        global $_G;

        $pids = WebHelper::getPost('pids', ''); //需要操作的帖子
        $operation = WebHelper::getPost('operation', ''); //操作 validate 通过审核 delete 删除 ignore 忽略
        $post_ids = WebHelper::getPost('post_ids', ''); // 用于查询回复所在的表
        $arr = explode(';', $pids);
        $all_ids = $pids = $tids = array();

        // 根据tid获取存档表id
        if (!empty($post_ids)) {
            $post_ids = explode(';', $post_ids);
            foreach ($post_ids as $val) {
                $val = trim($val, ',');
                $tables = explode(',', $val);
                $tid = $tables[0];
                $tids[] = $tid;
                unset($tables[0]);
                $pids[$tid] = $tables;
            }
            $posttable = DB::fetch_all("SELECT tid, posttableid FROM %t WHERE tid in (%n)", array('forum_thread', $tids));
            foreach ($posttable as $v) {
                if (!empty($pids[$v['tid']])) {
                    $all_ids[$v['posttableid']] = isset($all_ids[$v['posttableid']]) ? array_merge($all_ids[$v['posttableid']], $pids[$v['tid']]) : $pids[$v['tid']];
                }
            }
        } else {// 根据pids截取post表id
            foreach ($arr as $val) {
                $val = trim($val, ',');
                $tables = explode(',', $val);
                $table_id = $tables[0];
                unset($tables[0]);
                $all_ids[$table_id] = $tables;
            }
        }

        if (!empty($all_ids) && in_array($operation, array('validate', 'delete', 'ignore'))) {
            require_once libfile('function/forum');
            require_once libfile('function/post');
            require_once libfile('function/delete');

            if ($operation == 'ignore') {
                foreach ($all_ids as $tableid => $pid) {
                    $pidArr = array_values($pid);
                    $postarr = DB::fetch_all("SELECT tid,fid,authorid FROM %t WHERE pid IN(%n) AND invisible = 0", array('forum_post', $pidArr));
                    C::t('forum_post')->update($tableid, $pid, array('invisible' => -3), false, false, 0, null, null);

                    $moderateArr = ForumThread::getModeratePost($pidArr);
                    $diffArr = array_values(array_diff($pidArr, $moderateArr));
                    if ($moderateArr) {
                        updatemoderate('pid', $moderateArr, 1);
                    }
                    if ($diffArr) {
                        foreach ($diffArr as $id) {
                            C::t('common_moderate')->insert('pid', array(
                                'id' => $id,
                                'status' => 1,
                                'dateline' => TIMESTAMP,
                            ), false, true);

                            // 删除热评
                            C::t('forum_hotreply_number')->delete_by_pid($id);
                            C::t('forum_hotreply_member')->delete_by_pid($id);
                        }
                    }

                    foreach ($pidArr as $post_id) {
                        // 兼容pc
                        $post = C::t('forum_post')->fetch($tableid, $post_id);
                        if ($post) {
                            C::t('forum_threaddisablepos')->insert(array('tid' => $post['tid']), false, true);
                            C::t('forum_threaddisablepos')->clear_cache($post['tid']);
                        }
                    }

                    // 处理已通过状态回复数
                    foreach ($postarr as $v) {
                        updatepostcredits('-', $v['authorid'], 'reply', $v['fid']);
                    }
                }
            } elseif ($operation == 'delete') {
                foreach ($all_ids as $tableid => $pid) {
                    $pids = $recyclebinpids = $delpids = array();
                    foreach (C::t('forum_post')->fetch_all($tableid, $pid) as $post) {
                        if ($post['first'] != 0) {
                            continue;
                        }
                        $query = C::t('forum_forum')->fetch_all_valid_forum();
                        foreach ($query as $forum) {
                            $recyclebins[$forum['fid']] = $forum['recyclebin'];
                        }
                        if ($recyclebins[$post['fid']]) {
                            if ($post['invisible'] == 0) {
                                $delpids[] = $post['pid'];
                            } else {
                                $recyclebinpids[] = $post['pid'];
                            }
                        } else {
                            $pids[] = $post['pid'];
                        }
                    }
                    if ($recyclebinpids) {
                        deletepost($recyclebinpids, 'pid', false, $tableid, true);
                    }
                    if ($pids) {
                        $deletes = deletepost($pids, 'pid', true, $tableid, true);
                    }

                    // 处理已通过状态回复数
                    if ($delpids) {
                        $deletes += deletepost($delpids, 'pid', true, $tableid, true);
                    }
                    $deletes += count($recyclebinpids);
                    updatemodworks('DLP', count($pid));
                    updatemoderate('pid', $pid, 2);
                }

            } elseif ($operation == 'validate') {
                foreach ($all_ids as $tableid => $pid) {
                    $forums = $threads = $attachments = $pidarray = $authoridarray = array();
                    $tids = $postlist = array();
                    foreach (C::t('forum_post')->fetch_all($tableid, $pid) as $post) {
                        if ($post['first'] != 0) {
                            continue;
                        }
                        $tids[$post['tid']] = $post['tid'];
                        $postlist[] = $post;
                    }
                    $threadlist = C::t('forum_thread')->fetch_all($tids);

                    foreach ($postlist as $post) {
                        $post['lastpost'] = $threadlist[$post['tid']]['lastpost'];

                        $pidarray[] = $post['pid'];
                        if (getstatus($post['status'], 3) == 0) {
                            updatepostcredits('+', $post['authorid'], 'reply', $post['fid']);
                            $attachcount = C::t('forum_attachment_n')->count_by_id('tid:' . $post['tid'], 'pid', $post['pid']);
                            updatecreditbyaction('postattach', $post['authorid'], array(), '', $attachcount, 1, $post['fid']);
                        }

                        $forums[] = $post['fid'];


                        $threads[$post['tid']]['replies']++;
                        if ($post['dateline'] > $post['lastpost']) {
                            $threads[$post['tid']]['lastpost'] = array($post['dateline']);
                            $threads[$post['tid']]['lastposter'] = array($post['anonymous'] && $post['dateline'] != $post['lastpost'] ? '' : $post['author']);
                        }
                        if ($threads[$post['tid']]['attachadd'] || $post['attachment']) {
                            $threads[$post['tid']]['attachment'] = array(1);
                        }
                    }
                    unset($postlist, $tids, $threadlist);

                    foreach ($threads as $tid => $thread) {
                        C::t('forum_thread')->increase($tid, $thread);
                    }

                    foreach (array_unique($forums) as $fid) {
                        updateforumcount($fid);
                    }

                    if (!empty($pidarray)) {
                        C::t('forum_post')->update($tableid, $pidarray, array('status' => 4), false, false, null, -2, null, 0);
                        $validates = C::t('forum_post')->update($tableid, $pidarray, array('invisible' => 0));
                        updatemodworks('MOD', $validates);
                        updatemoderate('pid', $pidarray, 2);
                    } else {
                        updatemodworks('MOD', 1);
                    }
                }

            }
        } else {
            Tool::getInstance()->fail_json(Code::UNDEFINED_ACTION, Tool::getInstance()->lang('undefined action'));

        }
        Tool::getInstance()->success_json(array('return' => 'success'));
    }

    /*
     *帖子内容处理
     */
    public function _contentFilter($content)
    {
        //去除字符
        $search = array(
            '/<embed src=\"(.+?)\".*?>(<\/embed>)?/',
            '/\[(audio|media|flash).*?\](.*?)\[\/\1\]/s',
            '/\[quote\](.*?)\[\/quote\]/',
            '/\[img=(.+?)\](.*?)\[\/img\]/',
            '/\[url=(.+?)\](.*?)\[\/url\]/',
            '/\[font=(.+?)\](.*?)\[\/font\]/',
            '/\[i=s\](.*?)\[\/i\]/',
            '/\[i\](.*?)\[\/i\]/',
            '/\[u\](.*?)\[\/u\]/',
            '/\[[a-z]+\]([^\[]+)[\/[a-z]+\]/'  //attach  qq
        );
        $replace = array(
            '',
            '',
            '',
            '',
            '',
            '',
            '',
            '',
            '',
            '',
        );
        //去除空格
        $ban = array(" ", "　", "\t", "\n", "\r");
        $rep = array("", "", "", "", "");
        $content = str_replace($ban, $rep, $content);
        $content = preg_replace($search, $replace, $content);
        $content = cutstr(dhtmlspecialchars(trim($content)), 200, '...');
        return $content;
    }


    /**
     * 敏感词
     */
    public function actionWordfilter()
    {
        $data = array();
        foreach (C::t('common_word')->fetch_all() as $censor) {
            $temp['word'] = $censor['find'];
            $temp['wordreplace'] = $censor['replacement'];
            $data[] = $temp;
        }

        Tool::getInstance()->success_json($data);
    }

    public function moderateswipe($type, $ids)
    {
        if ($type == 'pid') {
            $exist_ids = array_keys(C::t('forum_post')->fetch_all(0, $ids));
        } elseif ($type == 'tid') {
            $exist_ids = array_keys(C::t('forum_thread')->fetch_all($ids));
        }
        $remove_ids = array_diff($ids, $exist_ids);
        if ($remove_ids) {
            return C::t('common_moderate')->delete($remove_ids, $type);
        } else {
            return 0;
        }
    }

    public function actionReviewCount()
    {
        global $_G;
        $type = WebHelper::getPost('type', 0);

        $modcount = array();
        if ($type) {
            foreach (C::t('common_moderate')->count_group_idtype_by_status(0) as $value) {
                $modcount[$value['idtype']] = $value['count'];
            }
        } else {
            date_default_timezone_set('Asia/Shanghai');
            $startTime = strtotime(date('Y-m-d 00:00:00', strtotime('-1 month')));
            $endTime = strtotime(date('Y-m-d 23:59:59'));
            loadcache('posttableids');
            $postTableids = $_G['cache']['posttableids'] ? $_G['cache']['posttableids'] : array(0);

            $modcount['tid'] = $modcount['pid'] = $modcount['floor'] = 0;
            $fidArr = ForumThread::allForumIds();
            $sqlWhere = ForumThread::fetchThreadWhere(0, $fidArr, array(), '', $startTime, $endTime, -2, '');
            $replyWhere = ForumThread::fetchReplyWhere(0, 0, 0, '', $startTime, $endTime, 0, '');
            $threadList = DB::fetch_all('SELECT tid FROM ' . DB::table('forum_thread') . $sqlWhere[0], $sqlWhere[1]);

            // 待审帖子、回帖
            $tidArr = Tool::Array_Column($threadList, 'tid');
            foreach ($postTableids as $posttableid => $tableid) {
                if (!empty($tidArr)) {
                    $modcount['tid'] = $modcount['tid'] + DB::result_first("SELECT COUNT(*) FROM %t WHERE tid IN (%n) AND first=%d",
                            array(getposttable($tableid), $tidArr, 1));
                }
                $modcount['pid'] = $modcount['pid'] + DB::result_first('SELECT COUNT(*)FROM %t m LEFT JOIN %t p on p.pid=m.id WHERE %i',
                        array('forum_post_moderate', getposttable($tableid), $replyWhere));
            }

            // 待审核楼中楼
            $floorTable = DB::result_first("SHOW TABLES LIKE '%t'", array(ReplyFloor::$table));
            if ($floorTable) {
                $sqlWhere = array();
                $sqlWhere[] = DB::field('status', ReplyFloor::STATUS_REVIEW);
                $modcount['floor'] = (int)ReplyFloor::fetchCountByWhere($sqlWhere);
            }
        }
        Tool::getInstance()->success_json($modcount);
    }

    // 用户所有发帖的版块 及具体版块id
    public function actionUserPublishForum()
    {
        global $_G;
        $uid = WebHelper::getPost('uid', 0);
        $fid = WebHelper::getPost('fid', 0);// 1,2,3
        $fids = explode(',', $fid);

        if ($_G['uid']) {
            $uid = $_G['uid'];
        }
        if (empty($uid) || !is_numeric($uid) || $uid <= 0) {
            Tool::getInstance()->fail_json(Code::NOT_LOG_IN, Tool::getInstance()->lang('please log in first'));
        }
        // 用户发帖涉及的版块fid!=0
        $data = array();
        if ($fid && !empty($fid)) {
            $forum_num = DB::result_first('SELECT count(DISTINCT fid) as num FROM %t WHERE authorid=%d AND fid IN(%n)', array('forum_thread', $uid, $fids));
            $data['forum_num'] = empty($forum_num) ? 0 : $forum_num;
        }

        Tool::getInstance()->success_json($data);
    }

    // 当前用户参与的版块信息统计
    public function actionForumPublishUser()
    {
        global $_G;
        $uid = WebHelper::getPost('uid', 0);// int 当前登录用户
        $fid = WebHelper::getPost('fid', 0);// 1,2,3
        $fids = explode(',', $fid);

        if ($_G['uid']) {
            $uid = $_G['uid'];
        }

        if (empty($uid) || !is_numeric($uid) || $uid <= 0) {
            Tool::getInstance()->fail_json(Code::NOT_LOG_IN, Tool::getInstance()->lang('please log in first'));
        }
        // fid!=0
        if ($fid && !empty($fid)) {
            // 当前用户参与发帖的版块
            $data = array();
            $List = DB::fetch_all('SELECT DISTINCT fid FROM %t WHERE authorid=%d AND fid IN(%n)', array('forum_thread', $uid, $fids), 'fid');
            $forum_ids = Tool::Array_Column($List, 'fid');

            // 版块参与发帖的用户数量
            if (!empty($forum_ids)) {
                foreach ($forum_ids as $v) {
                    $num = DB::result_first('SELECT count(DISTINCT authorid) as num FROM %t WHERE fid=%d', array('forum_thread', $v));
                    $forumArr['fid'] = $v;
                    $forumArr['user_num'] = empty($num) ? 0 : $num;
                    $data[] = $forumArr;
                }
            }
            Tool::getInstance()->success_json($data);
        } else {
            Tool::getInstance()->fail_json(Code::UNDEFINED_ACTION, Tool::getInstance()->lang('undefined action'));
        }
    }
}