<?php
/**
 * Created by PhpStorm.
 * DISCUZ 发帖、回帖
 * User: liyifei 119422342@qq.com
 * Date: 15/11/26
 * Time: 下午2:20
 */

if (!defined('IN_DISCUZ')) {
    exit('Access Denied');
}

class PublishController extends Controller
{

    public function init()
    {
        loadcache(array('bbcodes_display', 'bbcodes', 'smileycodes', 'smilies', 'smileytypes',
            'domainwhitelist', 'albumcategory'));
    }

    public function actionPost()
    {
        //初始化板块
        global $_G;

        if (!function_exists('loadforum')) {
            require_once(libfile('function/forum'));
        }
        loadforum(intval(WebHelper::getPost('fid', 0)), intval(WebHelper::getPost('tid', 0)));

        //发布类型，NEW -> 新帖  REPLY -> 回复
        $posttype = WebHelper::getPost('posttype', 'new'); //Yii::app()->request->getPost( 'posttype', 'new' );
        //标题
        $atc_title = WebHelper::getPost('atc_title', ''); //Yii::app()->request->getPost( 'atc_title', '' );
        //内容
        $atc_content = WebHelper::getPost('atc_content', ''); //Yii::app()->request->getPost( 'atc_content', '' );
        //附件 eg. 1,2,3
        $flashatt = WebHelper::getPost('flastatt', ''); //Yii::app()->request->getPost( 'flashatt', '' );

        //是否开启匿名
        $anonymous = WebHelper::getPost('anonymous', 0);
        // 是否用新版的发帖传图方式 >0为开启
        $uploadtype = WebHelper::getPost('uploadtype', 0);
        // 是否关闭主题
        $closed = WebHelper::getPost('closed', 0);
        // 是否后台发帖、回复
        $uid = intval(WebHelper::getPost('uid', 0));

        // 登录判断
        if ($uid && !$_G['uid']) {
            $user = getuserbyuid($uid, 1);
            if ($user) {
                setloginstatus($user, 600);
            }
        }

        // 是否是富文本发帖
        if (strpos($atc_content, "[qianfan_html]") !== false) {
            $_GET['htmlon'] = 1;
            $_G['group']['allowposturl'] = 3;
        }

        // 上传图片的数量，默认3张
        $upload_num = WebHelper::getPost('upload_num', 3);
        $upload_num = intval($upload_num) - 1;
        $_GET['action'] = $posttype == 'new' ? 'newthread' : 'reply';

        if (!defined('NOROBOT')) {
            define('NOROBOT', TRUE);
        }

        // 楼中楼参数兼容
        $action = WebHelper::getPost('action', '');
        if ($action == 'post/create-innerfloor' || $posttype == 'replyFloor') {
            $atc_content = WebHelper::getPost('content', '');
            $_GET['action'] = 'replyFloor';
        }

        // 2.0.0社区上传图片以及大后台数据下发的图片处理
        if (!empty($uploadtype)) {
            if (empty($_G['uid'])) {
                Tool::getInstance()->fail_json(Code::NOT_LOG_IN, Tool::getInstance()->lang('please log in first'));
            }
            if (preg_match_all('/\[img\](.+?)\[\/img\]/i', $atc_content, $matches)) {
                $i = 0;
                foreach ($matches[1] as $key => $val) {
                    if ($i > $upload_num) break;
//                    $image = getimagesize($matches[1][$key]); // 验证是否是真实的图片
//                    if( empty($image) || !is_array($image) ) {
//                        $atc_content = str_replace( $matches[0][$key], '', $atc_content );
//                        continue;
//                    }

                    // 大图表情
                    if (strpos($matches[1][$key], '/bigface') !== false) {
                        $atc_content = str_replace($matches[0][$key], '[bigface]' . $matches[1][$key] . '[/bigface]', $atc_content);
                        continue;
                    }

                    $file = ForumThread::uploadImg($matches[1][$key]);
                    if (empty($file) || !is_array($file)) {
                        continue;
                    }
                    $aid = ForumThread::qianfanUpload($file, $_G['uid']);
                    if (empty($aid) || $aid <= 0) continue;

                    $aidArray[] = $aid;
                    $atc_content = str_replace($matches[0][$key], '[attachimg]' . $aid . '[/attachimg]', $atc_content);
                    $i++;
                }
            }
        }

        //用户基本设置检查
        //比如，用户没上传头像，是否有发帖权限
        //主要是DISCUZ 内部防刷限制
        //DISCUZ 后台 -》 防灌水
        require_once(Yii::getPathOfAlias('application.components.func') . DIRECTORY_SEPARATOR . 'forum_viewthread.php');
        $newuserresult = qf_cknewuser();
        if ($newuserresult !== true) {
            switch ($newuserresult) {
                //新手见习时间
                case 'no_privilege_newbiespan':
                    Tool::getInstance()->fail_json(Code::NO_PRIVILEGE_NEWBIESPAN, Tool::getInstance()->lang(
                        'no_privilege_newbiespan', array('{newbiespan}' => $_G['setting']['newbiespan'])));
                    break;
                //上传头像判断
                case 'no_privilege_avatar':
                    Tool::getInstance()->fail_json(Code::NO_PRIVILEGE_AVATAR, Tool::getInstance()->lang(
                        'no_privilege_avatar'));
                    break;
                //EMAIL判断 app忽略
//                case 'no_privilege_email':
//                    Tool::getInstance()->fail_json( Code::NO_PRIVILEGE_EMAIL, Tool::getInstance()->lang( 'no_privilege_email' ) );
//                    break;
                case 'no_privilege_friendnum':
                    Tool::getInstance()->fail_json(Code::NO_PRIVILEGE_FRIENDNUM, Tool::getInstance()->lang(
                        'no_privilege_friendnum', array('{friendnum}' => $_G['setting']['need_friendnum'])));
                    break;
                default:
                    break;
            }
        }

        if ($anonymous == 1) {
            //开启匿名回复或发帖时检查当前用户组或版块是否拥有匿名发帖权限
            if ($_G['group']['allowanonymous'] == 0 && $_G['forum']['allowanonymous'] == 0) {
                Tool::getInstance()->fail_json(Code::ANONYMOUS_DISABLED, Tool::getInstance()->lang('anonymous_disabled'));
            }
        }

        require_once libfile('class/credit');
        require_once libfile('function/post');

        //引用回复楼层？
        $pid = dintval(Yii::app()->request->getPost('pid', 0));
        //帖子分类ID
        $sortid = WebHelper::getPost('sortid', '');

        //分类信息详情
        //$typeoption = WebHelper::getPost( 'typeoption', '' );
        $typeoption = Yii::app()->request->getPost('typeoption', '');

        //分类信息有效期
        $typeexpiration = WebHelper::getPost('typeexpiration', '');

        if ($sortid) {
            $typeexpiration = $typeexpiration ? intval($typeexpiration) : 0;
            if (defined('IN_MOBILE') && strtoupper(Yii::app()->params['site_charset']) != 'UTF-8') {
                //坑死了 这个地方必须是utf8编码
                $typeoption = iconv('GBK', 'UTF-8//IGNORE', $typeoption);
            }
            $typeoption = $typeoption ? CJSON::decode($typeoption) : array();
            if (is_array($typeoption) && !empty($typeoption)) {
                $tmp = array();
                foreach ($typeoption as $val) {
                    if ($val['type'] == 'image' && !empty($val['image']))                          //上传图片处理
                    {
                        if (!$val['image']['url']) {
                            //获取的七牛地址为空
                            $tmp[$val['identifier']] = array('aid' => '', 'url' => '');
                            Yii::log(var_export('SORTSIMG-QINIUURl-EMPTY:url=' . $val['image']['url'] . 'title=' . $atc_title . '----time:' . date("Y-m-d H:i:s"), true));
                            continue;
                        }
                        /* 耗性能 弃用
                        //验证是否为图片
                        $imginfo = @getimagesize($val['image']['url']);
                        //支持png gif jpg 格式
                        if(empty($imginfo) || !is_array($imginfo) ||  !in_array($imginfo['2'],array('1','2','3'))){
                            $tmp[$val['identifier']] = array('aid'=>'','url'=>'');
                            Yii::log(var_export('DOWNLOAD-SORTSIMG-FAILED:only picture can be downloaded----time:'.date("Y-m-d H:i:s"), true));
                            continue;
                        }
                        */
                        $file = ForumThread::uploadImg($val['image']['url']);
                        if (empty($file) || !is_array($file)) {
                            //这个地方做下日志，下载到本地时，失败了
                            $tmp[$val['identifier']] = array('aid' => '', 'url' => '');
                            Yii::log(var_export('DOWNLOAD-SORTSIMG-FAILED:url=' . $val['image']['url'] . 'title=' . $atc_title . '----time:' . date("Y-m-d H:i:s"), true));
                            continue;
                        }
                        $aid = ForumThread::qianfanUpload($file, $_G['uid']);
                        if ($aid) {
                            $atta = C::t('forum_attachment')->fetch_by_aid_uid($aid, $_G['uid']);
                            if (empty($atta)) continue;   //没有拉到，论坛问题
                            $attachment = C::t('forum_attachment_n')->fetch($atta['tableid'], $aid);
                            if (empty($attachment)) continue; //同上
                            $imgurl = $_G['setting']['attachurl'] . 'forum/' . ($attachment['thumb'] && $attachment['filetype'] != 'image/gif' ? getimgthumbname($attachment['attachment']) : $attachment['attachment']);
                            $tmp[$val['identifier']] = array(
                                'aid' => $aid,
                                'url' => $imgurl
                            );
                        } else {
                            //这个地方做下日志，上传到本地时，失败了
                            $tmp[$val['identifier']] = array('aid' => '', 'url' => '');
                            Yii::log(var_export('UPLOAD-SORTSIMG-FAILED:file=' . $file['name'] . 'title=' . $atc_title . '----time:' . date("Y-m-d H:i:s"), true));
                        }
                    } else {
                        if ($val['type'] == 'radio' && $val['identifier'] == 'typeexpiration') {
                            $typeexpiration = $val['select'];
                            unset($val);
                        }
                        if (strtoupper(Yii::app()->params['site_charset']) != 'UTF-8') {
                            if ($val['type'] == 'text' || $val['type'] == 'textarea') {
                                //中文都转为gbk
                                $val['select'] = iconv('UTF-8', 'GBK//IGNORE', $val['select']);
                            }
                        }
                        if ($val['type'] == 'checkbox' && $val['select'] != '') $val['select'] = explode(',', $val['select']);  //多选字符串处理为数组
                        //if($val['type'] == 'calendar' && $val['select'] != '') $val['select'] = date('Y-m-d',$val['select']); //日历时间戳处理
                        $tmp[$val['identifier']] = $val['select'];
                    }

                }
                $typeoption = $tmp;
            } else {
                $typeoption = array();
            }
            $_GET['typeoption'] = $typeoption;
        }

        //帖子类型ID
        $typeid = WebHelper::getPost('typeid', '');
        //特殊铁标记
        $special = 0;

        $_GET['extra'] = '';

        $postinfo = array('subject' => '');
        $thread = array('readperm' => '', 'pricedisplay' => '', 'hiddenreplies' => '');


        $_G['forum_dtype'] = $_G['forum_checkoption'] = $_G['forum_optionlist'] = $tagarray = $_G['forum_typetemplate'] = array();

        //FORUM->STATUS = 3 代表板块是群组
        // DISCUZ群组功能，非主流功能，大致跑通了，不详细测试了
        if ($_G['forum']['status'] == 3) {
            //检测群组是否开启
            if (!helper_access::check_module('group')) {
                Tool::getInstance()->fail_json(Code::GROUP_OFF, Tool::getInstance()->lang('group_status_off'));
            }

            //一系列的权限验证
            require_once libfile('function/group');
            $status = groupperm($_G['forum'], $_G['uid'], 'post');
            if ($status == -1) {
                Tool::getInstance()->fail_json(Code::FORUM_NOT_GROUP, Tool::getInstance()->lang('forum_not_group'));
            } elseif ($status == 1) {
                Tool::getInstance()->fail_json(Code::FORUM_GROUP_STATUS_OFF, Tool::getInstance()->lang('forum_group_status_off'));
            } elseif ($status == 2) {
                Tool::getInstance()->fail_json(Code::FORUM_GROUP_NOALLOWED, Tool::getInstance()->lang('forum_group_noallowed'));
            } elseif ($status == 3) {
                Tool::getInstance()->fail_json(Code::FORUM_GROUP_MODERATED, Tool::getInstance()->lang('forum_group_moderated'));
            } elseif ($status == 4) {
                if ($_G['uid']) {
                    Tool::getInstance()->getInstance(Code::FORUM_GROUP_NOT_GROUPMEMBER, Tool::getInstance()->lang('forum_group_not_groupmember'));
                } else {
                    Tool::getInstance()->getInstance(Code::FORUM_GROUP_NOT_GROUPMEMBER_GUEST, Tool::getInstance()->lang('forum_group_not_groupmember_guest'));
                }
            } elseif ($status == 5) {
                Tool::getInstance()->fail_json(Code::FORUM_GROUP_MODERATED, Tool::getInstance()->lang('forum_group_moderated'));
            }
        }

        //判断动作
        if (!$posttype) {
            // 不可能走到这一步，随便报错，挂了拉倒
            showmessage('undefined_action', NULL);
        } elseif ($_GET['action'] == 'albumphoto') {
            // 不可能走到这一步，随便报错，挂了拉倒
            //require libfile('post/albumphoto', 'include');
        } elseif (($_G['forum']['simple'] & 1) || $_G['forum']['redirect']) {
            // 板块无法发帖，或者板块是外链地址
            Tool::getInstance()->fail_json(Code::FORUM_DISABLEPOST, Tool::getInstance()->lang('forum_disablepost'));
        }

        require_once libfile('function/discuzcode');

        $space = array();
        space_merge($space, 'field_home');

        /*
        if($posttype == 'reply') {
            $addfeedcheck = !empty($space['privacy']['feed']['newreply']) ? 'checked="checked"': '';
        } else {
            $addfeedcheck = !empty($space['privacy']['feed']['newthread']) ? 'checked="checked"': '';
        }
        */

        //导航栏内容，仅仅是COPY过来的，没用
        $navigation = $navtitle = '';

        if (!empty($_GET['cedit'])) {
            unset($_G['inajax'], $_GET['infloat'], $_GET['ajaxtarget'], $_GET['handlekey']);
        }

        // 如果是编辑帖子或者回复帖子，需要对主题帖做相关处理
        if ($_GET['action'] == 'edit' || $_GET['action'] == 'reply' || $_GET['action'] == 'replyFloor') {
            $thread = C::t('forum_thread')->fetch($_G['tid']);
            if (!$_G['forum_auditstatuson'] && !($thread['displayorder'] >= 0 || (in_array($thread['displayorder'], array(-4, -2)) && $thread['authorid'] == $_G['uid']))) {
                $thread = array();
            }
            if (!empty($thread)) {
                //贴组阅读权限判断
                if ($thread['readperm'] && $thread['readperm'] > $_G['group']['readaccess'] && !$_G['forum']['ismoderator'] && $thread['authorid'] != $_G['uid']) {
                    Tool::getInstance()->fail_json(Code::THREAD_NOPERMISSION, Tool::getInstance()->lang('thread_nopermission'));
                }

                $_G['fid'] = $thread['fid'];
                $special = $thread['special'];

            } else {
                //帖子不存在
                Tool::getInstance()->fail_json(Code::THREAD_NOT_EXISTS, Tool::getInstance()->lang('thread not exists'));
            }

            if ($thread['closed'] == 1 && !$_G['forum']['ismoderator']) {
                //帖子被关闭
                Tool::getInstance()->fail_json(Code::POST_THREAD_CLOSED, Tool::getInstance()->lang('post_thread_closed'));
            }
        }

        //每日操作时刻判断
        if (periodscheck('postbanperiods', 0)) {
            //period_nopermission
            $banperiods = str_replace("\r\n", ', ', $_G['setting']['postbanperiods']);
            Tool::getInstance()->fail_json(Code::POSTBANPERIODS, Tool::getInstance()->lang('postbanperiods', array
            ('{banperiods}' => $banperiods)));
        }

        //板块需要密码才能访问
        if ($_G['forum']['password']) {
            Tool::getInstance()->fail_json(Code::FORUM_NEED_PASSWORD, Tool::getInstance()->lang('need password to visit'));
        }

        //板块访问权限
        if (empty($_G['forum']['allowview'])) {
            if (!$_G['forum']['viewperm'] && !$_G['group']['readaccess']) {
                //用户组访问权限
                Tool::getInstance()->fail_json(Code::FORUM_VIEW_PERM, Tool::getInstance()->lang('your group:{group} can not read this content', array('{group}' => $_G['group']['grouptitle'])));
            } elseif ($_G['forum']['viewperm'] && !forumperm($_G['forum']['viewperm'])) {
                $res = qf_showmessagenoperm('viewperm', $_G['fid'], $_G['forum']['formulaperm']);
                $res = qf_rebuild4formulaperm($res);
                Tool::getInstance()->fail_json(Code::FORUM_VIEW_PERM, Tool::getInstance()->stripHtmlTags(lang('message', $res['message'], $res['params'])));
            }
        } elseif ($_G['forum']['allowview'] == -1) {
            // 没有操作板块的权限
            Tool::getInstance()->fail_json(Code::FORUM_ACCESS_VIEW_DISALLOW, Tool::getInstance()->lang('forum_access_view_disallow'));
        }

        // 权限表达式？尚且不清楚要是干什么的
        // 特定用户才能访问该版块
        // require_once( Yii::getPathOfAlias('application.components.func') . DIRECTORY_SEPARATOR . 'forum_viewthread.php' );
        $msg = qf_formulaperm($_G['forum']['formulaperm']);
        if ($msg['message'] != '') {
            $lanParamsTmp = $msg['params'];
            $lanParams = array();
            foreach ($lanParamsTmp as $k => $v) {
                $k = str_replace(array('{', '}'), '', $k);
                $lanParams[$k] = $v;
            }
            Tool::getInstance()->fail_json(Code::FORUM_VIEW_PERM, Tool::getInstance()->stripHtmlTags(lang('message', $msg['message'], $lanParams)));
        }

        //注册后发帖时间限制判断
        if (!$_G['adminid'] && $_G['setting']['newbiespan'] && (!getuserprofile('lastpost') || TIMESTAMP - getuserprofile('lastpost') < $_G['setting']['newbiespan'] * 60) && TIMESTAMP - $_G['member']['regdate'] < $_G['setting']['newbiespan'] * 60) {
            Tool::getInstance()->fail_json(Code::POST_NEWBIE_SPAN, Tool::getInstance()->lang('can not post since register {newbiespan}', array('{newbiespan}' => $_G['setting']['newbiespan'])));
        }

        //是否是特殊帖子之类的判断
        $special = $special > 0 && $special < 7 || $special == 127 ? intval($special) : 0;

        //板块是否允许上传附件
        $_G['forum']['allowpostattach'] = isset($_G['forum']['allowpostattach']) ? $_G['forum']['allowpostattach'] : '';

        //用户组是否允许上传附件
        $_G['group']['allowpostattach'] = $_G['forum']['allowpostattach'] != -1 && ($_G['forum']['allowpostattach'] == 1 || (!$_G['forum']['postattachperm'] && $_G['group']['allowpostattach']) || ($_G['forum']['postattachperm'] && forumperm($_G['forum']['postattachperm'])));

        //板块是否允许上传图片
        $_G['forum']['allowpostimage'] = isset($_G['forum']['allowpostimage']) ? $_G['forum']['allowpostimage'] : '';

        //用户组是否允许上传图片
        $_G['group']['allowpostimage'] = $_G['forum']['allowpostimage'] != -1 && ($_G['forum']['allowpostimage'] == 1 || (!$_G['forum']['postimageperm'] && $_G['group']['allowpostimage']) || ($_G['forum']['postimageperm'] && forumperm($_G['forum']['postimageperm'])));

        //设置用户组附件类型？
        $_G['group']['attachextensions'] = $_G['forum']['attachextensions'] ? $_G['forum']['attachextensions'] : $_G['group']['attachextensions'];

        //加载上传方法
        require_once libfile('function/upload');
        //获取上传配置
        $swfconfig = getuploadconfig($_G['uid'], $_G['fid']);

        //获取允许上传的图片扩展名
        $imgexts = str_replace(array(';', '*.'), array(', ', ''), $swfconfig['imageexts']['ext']);

        //总的上传数量和今日上传数量，能否继续上传，今日能否继续上传？
        $allowuploadnum = $allowuploadtoday = TRUE;

        //判断用户组附件数量上限和今日附件数量上限
        if ($_G['group']['allowpostattach'] || $_G['group']['allowpostimage']) {
            if ($_G['group']['maxattachnum']) {
                $allowuploadnum = $_G['group']['maxattachnum'] - getuserprofile('todayattachs');
                $allowuploadnum = $allowuploadnum < 0 ? 0 : $allowuploadnum;
                if (!$allowuploadnum) {
                    $allowuploadtoday = false;
                }
            }
            if ($_G['group']['maxsizeperday']) {
                $allowuploadsize = $_G['group']['maxsizeperday'] - getuserprofile('todayattachsize');
                $allowuploadsize = $allowuploadsize < 0 ? 0 : $allowuploadsize;
                if (!$allowuploadsize) {
                    $allowuploadtoday = false;
                }
                //上传附件的大小限制
                $allowuploadsize = $allowuploadsize / 1048576 >= 1 ? round(($allowuploadsize / 1048576), 1) . 'MB' : round(($allowuploadsize / 1024)) . 'KB';
            }
        }

        //是否允许上传图片
        //$allowpostimg = $_G['group']['allowpostimage'] && $imgexts;

        //获取上传类型？
        /*$enctype = ($_G['group']['allowpostattach'] || $_G['group']['allowpostimage']) ?
        'enctype="multipart/form-data"' : '';*/
        //获取附件最大上传单位 MB
        $maxattachsize_mb = $_G['group']['maxattachsize'] / 1048576 >= 1 ? round(($_G['group']['maxattachsize'] / 1048576), 1) . 'MB' : round(($_G['group']['maxattachsize'] / 1024)) . 'KB';

        //初始化最大帖子浏览价格
        $_G['group']['maxprice'] = isset($_G['setting']['extcredits'][$_G['setting']['creditstrans']]) ? $_G['group']['maxprice'] : 0;
        //附加属性
        //$extra = !empty($_GET['extra']) ? rawurlencode($_GET['extra']) : '';

        /*
        //邮件通知
        $emailnotify = '';
        //是否是置顶帖
        $sticktopic = '';
        //是否是精华帖
        $addtodigest = '';
        */
        /*$notifycheck = empty($emailnotify) ? '' : 'checked="checked"';
        $stickcheck = empty($sticktopic) ? '' : 'checked="checked"';
        $digestcheck = empty($addtodigest) ? '' : 'checked="checked"';*/

        //标题检查 主要检查标题是否包含敏感词，是否能发布链接
        $subject = $atc_title ? dhtmlspecialchars(censor(trim($atc_title), NULL, 1)) : '';
        //标题检查返回了错误信息
        if (is_array($subject) && isset($subject['message'])) {
            $censor = discuz_censor::instance();
            Yii::log(var_export(sprintf('title-censor-words: %s', implode(', ', $censor->words_found)), true));
            Tool::getInstance()->fail_json(Code::POST_SUBJECT_ILLEGAL, Tool::getInstance()->lang($subject['message']));
        }
        $subject = !empty($subject) ? str_replace("\t", ' ', $subject) : $subject;

        //内容检查 主要检查内容是否包含敏感词，是否能发布链接
        $message = censor($atc_content, NULL, 1);

        //标题检查返回了错误信息
        if (is_array($message) && isset($message['message'])) {
            $censor = discuz_censor::instance();
            $wordbanned_log = implode(', ', $censor->words_found);
            if (strtoupper($_G['charset']) != 'UTF-8') {
                $wordbanned_log = diconv($wordbanned_log, $_G['charset'], 'UTF-8');
            }
            Yii::log(var_export(sprintf('content-censor-words: %s', $wordbanned_log), true));
            Tool::getInstance()->fail_json(Code::POST_MESSAGE_ILLEGAL, Tool::getInstance()->lang($message['message']));
        }

        //投票内容，客户端无法发布投票帖，所以默认为空
        $polloptions = '';

        //阅读权限，客户端无法选择阅读权限，所以默认为0
        $readperm = 0;

        //帖子售价，客户端无法选择帖子售价，所以默认为0
        $price = 0;

        //是否允许发布隐藏内容判断
        if (empty($bbcodeoff) && !$_G['group']['allowhidecode'] && !empty($message) && preg_match("/\[hide=?\d*\].*?\[\/hide\]/is", preg_replace("/(\[code\](.+?)\[\/code\])/is", ' ', $message))) {
            // 客户端不可能发隐藏内容 所以不测试了 挂了拉倒
            Tool::getInstance()->fail_json(Code::POST_HIDE_NOPERMISSION, Tool::getInstance()->lang('post_hide_nopermission'));
        }

        //各种配置检查初始化
        $urloffcheck = $usesigcheck = $smileyoffcheck = $codeoffcheck = $htmloncheck = $emailcheck = '';

        //防水墙判断。。。有可能会导致接口速度变慢，后台可以配置关闭 
        //检查是否需要启用验证码、验证问答 3.0版本没有函数，做下判断
        if (function_exists('seccheck')) list($seccodecheck, $secqaacheck) = seccheck('post', $_GET['action']);

        //是否允许发布投票帖
        $_G['group']['allowpostpoll'] = $_G['group']['allowpost'] && $_G['group']['allowpostpoll'] && ($_G['forum']['allowpostspecial'] & 1);
        //是否允许发布分类信息帖
        $_G['group']['allowposttrade'] = $_G['group']['allowpost'] && $_G['group']['allowposttrade'] && ($_G['forum']['allowpostspecial'] & 2);
        //是否允许发布奖励？
        $_G['group']['allowpostreward'] = $_G['group']['allowpost'] && $_G['group']['allowpostreward'] && ($_G['forum']['allowpostspecial'] & 4);
        //是否允许发布活动贴
        $_G['group']['allowpostactivity'] = $_G['group']['allowpost'] && $_G['group']['allowpostactivity'] && ($_G['forum']['allowpostspecial'] & 8);
        //是否允许发布xx帖
        $_G['group']['allowpostdebate'] = $_G['group']['allowpost'] && $_G['group']['allowpostdebate'] && ($_G['forum']['allowpostspecial'] & 16);

        $usesigcheck = $_G['uid'] && $_G['group']['maxsigsize'] ? 'checked="checked"' : '';
        $ordertypecheck = !empty($thread['tid']) && getstatus($thread['status'], 4) ? 'checked="checked"' : '';
        $imgcontentcheck = !empty($thread['tid']) && getstatus($thread['status'], 15) ? 'checked="checked"' : '';
        $specialextra = !empty($_GET['specialextra']) ? $_GET['specialextra'] : '';

        //帖子插件配置
        $_G['forum']['threadplugin'] = dunserialize($_G['forum']['threadplugin']);
        if ($specialextra && $_G['group']['allowpost'] && $_G['setting']['threadplugins'] &&
            (!array_key_exists($specialextra, $_G['setting']['threadplugins']) ||
                !@in_array($specialextra, is_array($_G['forum']['threadplugin']) ? $_G['forum']['threadplugin'] : dunserialize($_G['forum']['threadplugin'])) ||
                !@in_array($specialextra, $_G['group']['allowthreadplugin']))) {
            $specialextra = '';
        }

        //交易积分关闭
        if ($special == 3 && !isset($_G['setting']['extcredits'][$_G['setting']['creditstrans']])) {
            // TODO
            Tool::getInstance()->fail_json(Code::REWARD_LCREDITS_CLOSED, Tool::getInstance()->lang('reward_credits_closed'));
        }

        //是否允许匿名发布配置
        $_G['group']['allowanonymous'] = $_G['forum']['allowanonymous'] || $_G['group']['allowanonymous'] ? 1 : 0;

        // 版块只允许发布特殊帖子
        // 版块如果只允许发布特殊帖子，会导致客户端无法发帖并崩溃
        if ($_GET['action'] == 'newthread' && $_G['forum']['allowspecialonly'] && !$special) {
            if ($_G['group']['allowpostpoll']) {
                $special = 1;
            } elseif ($_G['group']['allowposttrade']) {
                $special = 2;
            } elseif ($_G['group']['allowpostreward']) {
                $special = 3;
            } elseif ($_G['group']['allowpostactivity']) {
                $special = 4;
            } elseif ($_G['group']['allowpostdebate']) {
                $special = 5;
            } elseif ($_G['group']['allowpost'] && $_G['setting']['threadplugins'] && $_G['group']['allowthreadplugin']) {
                if (empty($_GET['specialextra'])) {
                    foreach ($_G['forum']['threadplugin'] as $tpid) {
                        if (array_key_exists($tpid, $_G['setting']['threadplugins']) && @in_array($tpid, $_G['group']['allowthreadplugin'])) {
                            $specialextra = $tpid;
                            break;
                        }
                    }
                }
                $threadpluginary = array_intersect($_G['forum']['threadplugin'], $_G['group']['allowthreadplugin']);
                $specialextra = in_array($specialextra, $threadpluginary) ? $specialextra : '';
            }

            //用户组无法发布特殊帖子
            if (!$special && !$specialextra) {
                Tool::getInstance()->fail_json(Code::GROUP_NOPERMISSION, Tool::getInstance()->lang('group_nopermission'));
            }
        }

        //对客户端无用
        if (!$sortid && !$specialextra) {
            $postspecialcheck[$special] = ' class="a"';
        }

        //对客户端无用
        if ($specialextra) {
            $special = 127;
        }

        if ($_GET['action'] == 'newthread') {
            $policykey = 'post';
        } elseif ($_GET['action'] == 'reply') {
            $policykey = 'reply';
        } else {
            $policykey = '';
        }

        if ($policykey) {
            $postcredits = $_G['forum'][$policykey . 'credits'] ? $_G['forum'][$policykey . 'credits'] : $_G['setting']['creditspolicy'][$policykey];
        }

        if ($_GET['action'] == 'reply') {
            $this->_check_allow_action('allowreply');
        } else {
            $this->_check_allow_action('allowpost');
        }

        if ($_GET['action'] == 'newthread' || $_GET['action'] == 'newtrade') {
            loadcache('groupreadaccess');
            /*
                        // 主题分类
                        if( $_G['forum']['threadtypes']['required'] )
                        {
                            $types = DB::fetch_all("SELECT * FROM %t WHERE fid=%d", array("forum_threadclass",
                                $_G['forum']['fid']));
                            if( !empty($types) )
                            {
                                $typeid = $types[0]['typeid'];
                            }
                        }
            */
            $this->_new($subject, $message, $typeid, $sortid, $special, $aidArray, $typeoption, $typeexpiration, $anonymous, $closed);
            //require_once libfile( 'post/newthread', 'include' );
        } elseif ($_GET['action'] == 'reply') {
            loadcache('groupreadaccess');
            $this->_reply($thread, $subject, $message, $special, $aidArray, $anonymous);
            //require_once libfile('post/newreply', 'include');
        } elseif ($_GET['action'] = 'replyFloor') {
            loadcache('groupreadaccess');
            $this->_replyFloor($thread, $subject, $message, $anonymous);
        }
    }


    /**
     * 云后台下发专属接口
     * chenyuzou @2016-12-22
     */
    public function actionPush()
    {
        global $_G;

        $uid = WebHelper::getPost('uid', 0);
        $subject = WebHelper::getPost('atc_title', '');
        $content = WebHelper::getPost('atc_content', '');

        // 初始化用户
        require_once libfile('function/member');

        if (!$_G['uid']) {
            $member = getuserbyuid($uid);
            if ($member) {
                setloginstatus($member, 600);
            }

        }

        // 没有解析到用户禁止发帖
        if ($_G['uid'] == 0) {
            Tool::getInstance()->fail_json(Code::NOT_LOG_IN, Tool::getInstance()->lang('please log in first'));
        }

        // 载入板块
        if (!function_exists('loadforum')) {
            require_once(libfile('function/forum'));
        }
        loadforum(intval(WebHelper::getPost('fid', 0)), intval(WebHelper::getPost('tid', 0)));

        // 板块发帖限制  先加着 或许可以干掉
        if (empty($_G['forum']['allowpost'])) {
            if (!$_G['forum']['postperm'] && !$_G['group']['allowpost']) {
                Tool::getInstance()->fail_json(Code::POSTPERM_NONE_NOPERMISSION, Tool::getInstance()->lang('postperm_none_nopermission'));
            } elseif ($_G['forum']['postperm'] && !forumperm($_G['forum']['postperm'])) {
                $res = qf_showmessagenoperm('postperm', $_G['fid'], $_G['forum']['formulaperm']);
                $res = qf_rebuild4formulaperm($res);
                Tool::getInstance()->fail_json(Code::POSTPERM, Tool::getInstance()->stripHtmlTags(lang('message', $res['message'], $res['params'])));
            }
        } // 板块只有特定用户组才能发布主题
        elseif ($_G['forum']['allowpost'] == -1) {
            Tool::getInstance()->fail_json(Code::POST_FORUM_NEWTHREAD_NOPERMISSION, Tool::getInstance()->lang('post_forum_newthread_nopermission'));
        }

        // 客户端发帖不走主题分类限制
        $_G['forum']['threadsorts']['required'] = false; // 关闭发帖强制分类
        $_G['forum']['threadtypes']['required'] = false;

        // 大后台数据下发的图片处理
        if (preg_match_all('/\[img\](.+?)\[\/img\]/i', $content, $matches)) {
            foreach ($matches[1] as $key => $val) {
                $file = ForumThread::uploadImg($matches[1][$key]);
                if (empty($file) || !is_array($file)) {
                    continue;
                }
                $aid = ForumThread::qianfanUpload($file, $_G['uid']);
                $aidArray[] = $aid;
                $content = str_replace($matches[0][$key], '[attachimg]' . $aid . '[/attachimg]', $content);
            }
        }

        // 附件初始化
        $_GET['attachnew'] = array();
        if (!empty($aidArray)) {
            foreach ($aidArray as $key => $val) {
                if (is_numeric($val) && $val) {
                    $_GET['attachnew'][$val] = array('description' => '');
                }
            }
        }

        $modthread = C::m('forum_thread');
        $modthread->showmessage = '';

        $bfmethods = $afmethods = array();

        $special = 0;   // 非特殊贴
        $typeid = 0;    // 主题分类
        $sortid = 0;    // 分类信息

        $params = array(
            'subject' => $subject,
            'message' => $content,
            'typeid' => $typeid,
            'sortid' => $sortid,
            'special' => $special,
        );

        //保存？不知道干嘛的，不过客户端肯定用不到，默认为0
        $_GET['save'] = 0;
        $_GET['cronpublishdate'] = 0;
        if ($_G['group']['allowsetpublishdate'] && $_GET['cronpublish'] && $_GET['cronpublishdate']) {
            $publishdate = strtotime($_GET['cronpublishdate']);
            if ($publishdate > $_G['timestamp']) {
                $_GET['save'] = 1;
            } else {
                $publishdate = $_G['timestamp'];
            }
        } else {
            $publishdate = $_G['timestamp'];
        }
        $params['publishdate'] = $publishdate;
        $params['save'] = $_GET['save'];
        //默认不是置顶帖
        $params['sticktopic'] = 0;
        //默认不是精华帖
        $params['digest'] = 0;
        //默认需要阅读权限
        $params['readperm'] = 0;
        //默认不允许匿名
        $params['isanonymous'] = 0;
        //默认不需要售价
        $params['price'] = 0;

        //不知道干吗用的
        $params['typeexpiration'] = 0;
        $params['ordertype'] = 0;
        $params['hiddenreplies'] = 0;
        $params['allownoticeauthor'] = 1;
        $params['tags'] = '';
        $params['bbcodeoff'] = '';
        $params['smileyoff'] = '';
        $params['parseurloff'] = '';
        $params['usesig'] = $_GET['usesig'];
        $params['htmlon'] = $_GET['htmlon'];


        //地理位置信息
        $params['geoloc'] = '';

        $bfmethods[] = array('class' => 'extend_thread_replycredit', 'method' => 'before_newthread');
        $afmethods[] = array('class' => 'extend_thread_replycredit', 'method' => 'after_newthread');

        $bfmethods[] = array('class' => 'extend_thread_allowat', 'method' => 'before_newthread');
        $afmethods[] = array('class' => 'extend_thread_allowat', 'method' => 'after_newthread');
        $afmethods[] = array('class' => 'extend_thread_image', 'method' => 'after_newthread');

        $modthread->attach_before_methods('newthread', $bfmethods);
        $modthread->attach_after_methods('newthread', $afmethods);

        // 声明pre_forum_thread  STATUS
        // $params['tstatus'] = 1024;
        // 声明pre_forum_post STATUS
        // $params['pstatus'] = 8;

        $return = $modthread->newthread($params);

        //发帖成功
        if ($return == 'post_newthread_succeed' || $return == 'post_newthread_mod_succeed') {
            $tid = $modthread->tid;
            Tool::getInstance()->success_json(array('tid' => $tid));
        } else {
            $errorMessage = '发布失败，请稍后再试';
            if (is_array($return)) {
                if (count($return) > 1) {
                    $errorMessage = lang('message', $return[0], $return[2]);
                } else {
                    $errorMessage = lang('message', $return[0]);
                }
            }

            Tool::getInstance()->fail_json(Code::POST_FAIL, $errorMessage);
        }

    }


    /**
     * 新帖
     */
    public function _new($subject, $message, $typeid = 0, $sortid = 0, $special = 0, $aidArr = array(), $typeoption = array(), $typeexpiration = 0, $anonymous = 0, $closed = 0)
    {
        global $_G;

        // 客户端不支持发布特殊贴，直接抛出错误
        if ($special > 0) {
            Tool::getInstance()->fail_json(Code::NOT_SUPPORT_SPECIAL, Tool::getInstance()->lang('not_support_special'
            ));
        }

        //群组、板块判断
        if (empty($_G['forum']['fid']) || $_G['forum']['type'] == 'group') {
            Tool::getInstance()->fail_json(Code::FORUM_NONEXISTENCE, Tool::getInstance()->lang('forum_nonexistence'));
        }

        //发布特殊帖子权限判断
        if (($special == 1 && !$_G['group']['allowpostpoll']) || ($special == 2 && !$_G['group']['allowposttrade']) || ($special == 3 && !$_G['group']['allowpostreward']) || ($special == 4 && !$_G['group']['allowpostactivity']) || ($special == 5 && !$_G['group']['allowpostdebate'])) {
            // 上面已经跑出错误了 这边就不测试了 挂了拉倒
            Tool::getInstance()->fail_json(Code::GROUP_NOPERMISSION, Tool::getInstance()->lang('group_nopermission'));
        }

        //判断是否只有QQ登录才能发帖
        if ($_G['setting']['connect']['allow'] && $_G['setting']['accountguard']['postqqonly'] && !$_G['member']['conisbind']) {
            Tool::getInstance()->fail_json(Code::POSTPERM_QQONLY_NOPERMISSION, Tool::getInstance()->lang('postperm_qqonly_nopermission'));
        }

        //登录判断
        if (!$_G['uid'] && !((!$_G['forum']['postperm'] && $_G['group']['allowpost']) || ($_G['forum']['postperm'] && forumperm($_G['forum']['postperm'])))) {
            Tool::getInstance()->fail_json(Code::POSTPERM_LOGIN_NOPERMISSION, Tool::getInstance()->lang('postperm_login_nopermission'));
        } //板块不允许发帖
        elseif (empty($_G['forum']['allowpost'])) {
            if (!$_G['forum']['postperm'] && !$_G['group']['allowpost']) {
                Tool::getInstance()->fail_json(Code::POSTPERM_NONE_NOPERMISSION, Tool::getInstance()->lang(
                    'postperm_none_nopermission'));
            } elseif ($_G['forum']['postperm'] && !forumperm($_G['forum']['postperm'])) {
                $res = qf_showmessagenoperm('postperm', $_G['fid'], $_G['forum']['formulaperm']);
                $res = qf_rebuild4formulaperm($res);
                Tool::getInstance()->fail_json(Code::POSTPERM, Tool::getInstance()->stripHtmlTags(lang('message', $res['message'], $res['params'])));
            }
        } //板块只有特定用户组才能发布主题
        elseif ($_G['forum']['allowpost'] == -1) {
            Tool::getInstance()->fail_json(Code::POST_FORUM_NEWTHREAD_NOPERMISSION, Tool::getInstance()->lang('post_forum_newthread_nopermission'));
        }

        //只有上传头像、绑定EMAIL、好友数量才能发布主题
        if (!$_G['uid'] && ($_G['setting']['need_avatar'] || $_G['setting']['need_email'] || $_G['setting']['need_friendnum'])) {
            // 入口处验证过了，为啥这边又要验证一次？搞不懂，挂了拉倒
            Tool::getInstance()->fail_json(Code::POSTPERM_LOGIN_NOPERMISSION, Tool::getInstance()->lang('postperm_login_nopermission'));
        }
        //分类信息相关数据处理
        if ($sortid) {
            if (is_array($typeoption) && !empty($typeoption)) {
                require_once libfile('post/threadsorts', 'include');
                //预先验证一下参数的合法性
                $this->check_typeoption($typeoption);
            } else {
                //走到这里 报错了
                Tool::getInstance()->fail_json(Code::POST_FAIL, Tool::getInstance()->lang('undefined action'));
            }
        }
        //验证剩余金币之类的东西 TODO
        $this->_checklowerlimit('post', 0, 1, $_G['forum']['fid']);

        //开始整合新帖发布逻辑
        // 客户端发帖不走主题分类限制
//        if( empty($typeid) || empty($sortid) ) {
//            $_G['forum']['threadsorts']['required'] = false;//关闭发帖强制分类
//            $_G['forum']['threadtypes']['required'] = false;
//        }

        // 如果开启强制主题分类，默认第一个
        if (empty($typeid) && !empty($_G['forum']['threadtypes']['required'])) {
            if (!empty($_G['forum']['threadtypes']['types']) && is_array($_G['forum']['threadtypes']['types'])) {
                $typeid = (int)current(array_keys($_G['forum']['threadtypes']['types']));
            }
        }
        if (empty($sortid)) {
            $_G['forum']['threadsorts']['required'] = false;
        }
        if (empty($typeid)) {
            $_G['forum']['threadtypes']['required'] = false;
        }

        $modthread = C::m('forum_thread');
        $modthread->showmessage = '';

        $bfmethods = $afmethods = array();

        //客户端附件初始化
        $flashatt = Yii::app()->request->getPost('flashatt', '');
        $_GET['attachnew'] = array();
        $flashatt = explode(',', $flashatt);
        if (!empty($aidArr)) {
            $flashatt = $aidArr;
        }
        if (!empty($flashatt)) {
            foreach ($flashatt as $key => $val) {
                if (is_numeric($val) && $val) {
                    $_GET['attachnew'][$val] = array('description' => '');
                }
            }
        }

        $params = array(
            'subject' => $subject,
            'message' => $message,
            'typeid' => $typeid,
            'sortid' => $sortid,
            'special' => $special,
        );

        //保存？不知道干嘛的，不过客户端肯定用不到，默认为0
        $_GET['save'] = 0;
        $_GET['cronpublishdate'] = 0;
        if ($_G['group']['allowsetpublishdate'] && $_GET['cronpublish'] && $_GET['cronpublishdate']) {
            $publishdate = strtotime($_GET['cronpublishdate']);
            if ($publishdate > $_G['timestamp']) {
                $_GET['save'] = 1;
            } else {
                $publishdate = $_G['timestamp'];
            }
        } else {
            $publishdate = $_G['timestamp'];
        }
        $params['publishdate'] = $publishdate;
        $params['save'] = $_GET['save'];
        //默认不是置顶帖
        $params['sticktopic'] = 0;
        //默认不是精华帖
        $params['digest'] = 0;
        //默认需要阅读权限
        $params['readperm'] = 0;
        $params['isanonymous'] = $anonymous;
        //默认不需要售价
        $params['price'] = 0;

        //特殊帖子处理，增加发帖前和发帖后的执行脚本
        if (in_array($special, array(1, 2, 3, 4, 5))) {
            $specials = array(
                1 => 'extend_thread_poll',
                2 => 'extend_thread_trade',
                3 => 'extend_thread_reward',
                4 => 'extend_thread_activity',
                5 => 'extend_thread_debate'
            );
            $bfmethods[] = array('class' => $specials[$special], 'method' => 'before_newthread');
            $afmethods[] = array('class' => $specials[$special], 'method' => 'after_newthread');
            if (!empty($_GET['addfeed'])) {
                $modthread->attach_before_method('feed', array('class' => $specials[$special], 'method' => 'before_feed'));
                if ($special == 2) {
                    $modthread->attach_before_method('feed', array('class' => $specials[$special], 'method' => 'before_replyfeed'));
                }
            }
        }

        //反正客户端不给你选发布特殊帖子
        $specialextra = 0;
        if ($special == 1) {
        } elseif ($special == 3) {
        } elseif ($special == 4) {
        } elseif ($special == 5) {
        } elseif ($specialextra) {
            @include_once DISCUZ_ROOT . './source/plugin/' . $_G['setting']['threadplugins'][$specialextra]['module'] . '.class.php';
            $classname = 'threadplugin_' . $specialextra;
            if (class_exists($classname) && method_exists($threadpluginclass = new $classname, 'newthread_submit')) {
                $threadpluginclass->newthread_submit($_G['fid']);
            }
            $special = 127;
            $params['special'] = 127;
            $params['message'] .= chr(0) . chr(0) . chr(0) . $specialextra;
        }
        //不知道干吗用的
        $params['typeexpiration'] = $typeexpiration;
        $params['ordertype'] = 0;
        $params['hiddenreplies'] = 0;
        $params['allownoticeauthor'] = 1;
        $params['tags'] = '';
        $params['bbcodeoff'] = '';
        $params['smileyoff'] = '';
        $params['parseurloff'] = '';
        $params['usesig'] = $_GET['usesig'];
        $params['htmlon'] = $_GET['htmlon'];

        /*
        if( $_G['group']['allowimgcontent'] )
        {
            $params['imgcontent'] = $_GET['imgcontent'];
            $params['imgcontentwidth'] = $_G['setting']['imgcontentwidth'] ? intval($_G['setting']['imgcontentwidth']) : 100;
        }
        */

        //地理位置信息
        $params['geoloc'] = '';

        $bfmethods[] = array('class' => 'extend_thread_replycredit', 'method' => 'before_newthread');
        $afmethods[] = array('class' => 'extend_thread_replycredit', 'method' => 'after_newthread');

        if ($sortid) {
            $bfmethods[] = array('class' => 'extend_thread_sort', 'method' => 'before_newthread');
            $afmethods[] = array('class' => 'extend_thread_sort', 'method' => 'after_newthread');
        }

        $bfmethods[] = array('class' => 'extend_thread_allowat', 'method' => 'before_newthread');
        $afmethods[] = array('class' => 'extend_thread_allowat', 'method' => 'after_newthread');
        $afmethods[] = array('class' => 'extend_thread_image', 'method' => 'after_newthread');

        $modthread->attach_before_methods('newthread', $bfmethods);
        $modthread->attach_after_methods('newthread', $afmethods);

        //声明pre_forum_thread  STATUS
        $params['tstatus'] = 1024;
        //声明pre_forum_post STATUS
        $params['pstatus'] = 8;
        if ($_GET['devicetype'] == 1) {
            //IOS
            $params['pstatus'] = 136;
        } elseif ($_GET['devicetype'] == 2) {
            //ANDROID
            $params['pstatus'] = 264;
        }
        //绕过主题分类信息验证
        $modthread->app->var['forum']['threadsorts']['expiration'][$typeid] = 0;
        $return = $modthread->newthread($params);

        //发帖成功
        if ($return == 'post_newthread_succeed' || $return == 'post_newthread_mod_succeed') {
            $tid = $modthread->tid;
            //兼容分类信息有效期
            if ($typeexpiration && $sortid) {
                $expi = DB::fetch_all('SELECT expiration FROM %t WHERE tid=%d', array('forum_typeoptionvar', $tid));
                if ($expi[0]['expiration'] == 0)
                    C::t('forum_typeoptionvar')->update_by_tid($tid, array('expiration' => (TIMESTAMP + $typeexpiration)), false, false, null, $sortid);

            }
            // 帖子审核情况
            $invisible = 0;
            if ($tid && $modthread->pid) {
                $post = C::t('forum_post')->fetch('tid:' . $tid, $modthread->pid);
                $invisible = isset($post['invisible']) ? $post['invisible'] : 0;
            }
            // app发帖显示空格处理
            if ($_GET['htmlon'] == 1) {
                C::t('forum_post')->update_by_tid('tid:' . $tid, $tid, array('htmlon' => 1), false, false, 1);
            }
            // 关闭主题
            if ($closed) {
                C::t('forum_thread')->update($tid, array('closed' => 1));
            }
            Tool::getInstance()->success_json(array('tid' => $tid, 'invisible' => $invisible));
        } else {
            $errorMessage = '发布失败，请稍后再试';
            if (is_array($return)) {
                if (count($return) > 1) {
                    $errorMessage = lang('message', $return[0], $return[2]);
                } else {
                    $errorMessage = lang('message', $return[0]);
                }
            }

            Tool::getInstance()->fail_json(Code::POST_FAIL, $errorMessage);
        }

    }

    /**
     * 回复
     */
    public function _reply($thread, $subject, $message, $special = 0, $aidArr = array(), $anonymous = 0)
    {
        global $_G;

        require_once libfile('function/forumlist');

        $pid = WebHelper::getPost('pid', 0);

        $isfirstpost = 0;
        $_G['group']['allowimgcontent'] = 0;
        $showthreadsorts = 0;
        $quotemessage = '';

        /*
        if($special == 5)
        {
            $debate = array_merge($thread, daddslashes(C::t('forum_debate')->fetch($_G['tid'])));
            $firststand = C::t('forum_debatepost')->get_firststand($_G['tid'], $_G['uid']);
            $stand = $firststand ? $firststand : intval($_GET['stand']);

            if($debate['endtime'] && $debate['endtime'] < TIMESTAMP) {
                showmessage('debate_end');
            }
        }
        */

        // 判断回帖权限
        // 游客权限判断
        // 用户单点权限判断
        // 用户组权限判断
        if (!$_G['uid'] && !((!$_G['forum']['replyperm'] && $_G['group']['allowreply']) || ($_G['forum']['replyperm'] && forumperm($_G['forum']['replyperm'])))) {
            Tool::getInstance()->fail_json(Code::REPLYPERM_LOGIN_NOPERMISSION, Tool::getInstance()->lang('replyperm_login_nopermission'));
            //showmessage('replyperm_login_nopermission', NULL, array(), array('login' => 1));
        } elseif (empty($_G['forum']['allowreply'])) {
            if (!$_G['forum']['replyperm'] && !$_G['group']['allowreply']) {
                Tool::getInstance()->fail_json(Code::REPLYPERM_NONE_NOPERMISSION, Tool::getInstance()->lang('replyperm_none_nopermission'));
                //showmessage('replyperm_none_nopermission', NULL, array(), array('login' => 1));
            } elseif ($_G['forum']['replyperm'] && !forumperm($_G['forum']['replyperm'])) {
                $res = qf_showmessagenoperm('viewperm', $_G['fid'], $_G['forum']['formulaperm']);
                $res = qf_rebuild4formulaperm($res);
                Tool::getInstance()->fail_json(Code::REPLYPERM_NONE_NOPERMISSION, Tool::getInstance()->stripHtmlTags(lang('message', $res['message'], $res['params'])));
            }
        } elseif ($_G['forum']['allowreply'] == -1) {
            Tool::getInstance()->fail_json(Code::POST_FORUM_NEWREPLY_NOPERMISSION, Tool::getInstance()->lang('post_forum_newreply_nopermission'));
            //showmessage('post_forum_newreply_nopermission', NULL);
        }

        // 若回帖需要上传头像，则抛出错误
        if (!$_G['uid'] && ($_G['setting']['need_avatar'] || $_G['setting']['need_email'] || $_G['setting']['need_friendnum'])) {
            Tool::getInstance()->fail_json(Code::REPLYPERM_LOGIN_NOPERMISSION, Tool::getInstance()->lang('replyperm_login_nopermission'));
        }

        // 帖子自身权限判断，帖子是否存在，帖子是否能被回复
        if (empty($thread)) {
            Tool::getInstance()->fail_json(Code::THREAD_NOT_EXISTS, Tool::getInstance()->lang('thread not exist'));
            //showmessage('thread_nonexistence');
        } elseif ($thread['price'] > 0 && $thread['special'] == 0 && !$_G['uid']) {
            Tool::getInstance()->fail_json(Code::GROUP_NOPERMISSION, Tool::getInstance()->lang('group_nopermission'));
            //showmessage('group_nopermission', NULL, array('grouptitle' => $_G['group']['grouptitle']), array
            //('login' => 1));
        }

        // 判断权限咯
        //无法再次回复该帖子，主要是需要消耗积分？金币？ TODO
        $this->_checklowerlimit('reply', 0, 1, $_G['forum']['fid']);

        /*************** 此处省略了帖子点品的权限判断逻辑 *******************/

        // 自定义特殊铁判断？
        if ($special == 127) {
            $postinfo = C::t('forum_post')->fetch_threadpost_by_tid_invisible($_G['tid']);
            $sppos = strrpos($postinfo['message'], chr(0) . chr(0) . chr(0));
            $specialextra = substr($postinfo['message'], $sppos + 3);
        }

        // 帖子STATUS判断 抢楼贴
        if (getstatus($thread['status'], 3)) {
            $rushinfo = C::t('forum_threadrush')->fetch($_G['tid']);
            if ($rushinfo['creditlimit'] != -996) {
                $checkcreditsvalue = $_G['setting']['creditstransextra'][11] ? getuserprofile('extcredits' . $_G['setting']['creditstransextra'][11]) : $_G['member']['credits'];
                if ($checkcreditsvalue < $rushinfo['creditlimit']) {
                    $creditlimit_title = $_G['setting']['creditstransextra'][11] ? $_G['setting']['extcredits'][$_G['setting']['creditstransextra'][11]]['title'] : lang('forum/misc', 'credit_total');
                    Tool::getInstance()->fail_json(Code::POST_RUSHREPLY_CREDITLIMIT, Tool::getInstance()->lang(
                        'post_rushreply_creditlimit', array('creditlimit_title' => $creditlimit_title, 'creditlimit'
                    => $rushinfo['creditlimit'])));
                    //showmessage('post_rushreply_creditlimit', '', array('creditlimit_title' => $creditlimit_title, 'creditlimit' => $rushinfo['creditlimit']));
                }
            }
            if (isset($rushinfo['replylimit']) && $rushinfo['replylimit'] > 0) {
                $replycount = C::t('forum_post')->count_by_tid_invisible_authorid($_G['tid'], $_G['uid']);
                if ($replycount >= $rushinfo['replylimit']) {
                    Tool::getInstance()->fail_json(Code::NOREPLY_REPLYNUM_ERROR, Tool::getInstance()->lang('noreply_replynum_error'));
                }
            }
        }

        $noticetrimstr = $noticeauthor = '';
        if ($pid) {
            $language = lang('forum/misc');

            $_GET['repquote'] = $pid;
            $thaquote = C::t('forum_post')->fetch('tid:' . $_G['tid'], $_GET['repquote']);
            if (!($thaquote && ($thaquote['invisible'] == 0 || $thaquote['authorid'] == $_G['uid'] && $thaquote['invisible'] == -2))) {
                $thaquote = array();
            }
            // 禁止引用自己和主题帖之外的帖子
            if ($thaquote['tid'] != $_G['tid']) {
                Tool::getInstance()->fail_json(Code::REPLY_QUOTEPOST_ERROR, Tool::getInstance()->lang(
                    'reply_quotepost_error'));
            }
            // 禁止引用自己和主题帖之外的帖子
            if (getstatus($thread['status'], 2) && $thaquote['authorid'] != $_G['uid'] && $_G['uid'] != $thread['authorid'] && $thaquote['first'] != 1 && !$_G['forum']['ismoderator']) {
                Tool::getInstance()->fail_json(Code::REPLY_QUOTEPOST_ERROR, Tool::getInstance()->lang(
                    'reply_quotepost_error'));
            }

            if (!($thread['price'] && !$thread['special'] && $thaquote['first'])) {
                $quotefid = $thaquote['fid'];
                $quotemessage = $thaquote['message'];
                if (strpos($quotemessage, '[/password]') !== FALSE) {
                    $quotemessage = '';
                }
                if ($_G['setting']['bannedmessages'] && $thaquote['authorid']) {
                    $author = getuserbyuid($thaquote['authorid']);
                    if (!$author['groupid'] || $author['groupid'] == 4 || $author['groupid'] == 5) {
                        $quotemessage = $language['post_banned'];
                    } elseif ($thaquote['status'] & 1) {
                        $quotemessage = $language['post_single_banned'];
                    }
                }
                $time = dgmdate($thaquote['dateline']);
                $quotemessage = messagecutstr($quotemessage, 100);
                $quotemessage = implode("\n", array_slice(explode("\n", $quotemessage), 0, 3));

                $thaquote['useip'] = substr($thaquote['useip'], 0, strrpos($thaquote['useip'], '.')) . '.x';

                if ($thaquote['author'] && $thaquote['anonymous']) {
                    $thaquote['author'] = lang('forum/misc', 'anonymoususer');
                } elseif (!$thaquote['author']) {
                    $thaquote['author'] = lang('forum/misc', 'guestuser') . ' ' . $thaquote['useip'];
                } else {
                    $thaquote['author'] = $thaquote['author'];
                }

                $post_reply_quote = lang('forum/misc', 'post_reply_quote', array('author' => $thaquote['author'], 'time' => $time));
                $noticeauthormsg = dhtmlspecialchars($quotemessage);

                $quotemessage = "[quote][size=2][url=forum.php?mod=redirect&goto=findpost&pid=$_GET[repquote]&ptid={$_G['tid']}][color=#999999]{$post_reply_quote}[/color][/url][/size]\n{$noticeauthormsg}[/quote]";

                $noticeauthor = dhtmlspecialchars(authcode('q|' . $thaquote['authorid'], 'ENCODE'));
                $noticetrimstr = $quotemessage;

            }

            $reppid = $_GET['repquote'];
        } else {
            $thapost = DB::fetch_first('SELECT * FROM %t WHERE tid=%d AND first=%d LIMIT 1', array('forum_post', $_G['tid'], 1));
            if (!($thapost && ($thapost['invisible'] == 0 || $thapost['authorid'] == $_G['uid'] && $thapost['invisible'] == -2))) {
                $thapost = array();
            }

            $thapost['useip'] = substr($thapost['useip'], 0, strrpos($thapost['useip'], '.')) . '.x';
            if ($thapost['author'] && $thapost['anonymous']) {
                $thapost['author'] = '[color=Olive]' . lang('forum/misc', 'anonymoususer') . '[/color]';
            } elseif (!$thapost['author']) {
                $thapost['author'] = '[color=Olive]' . lang('forum/misc', 'guestuser') . '[/color] ' . $thapost['useip'];
            } else {
                $thapost['author'] = '[color=Olive]' . $thapost['author'] . '[/color]';
            }
            //给论坛用户一个消息提醒
            $noticeauthor = dhtmlspecialchars(authcode('r|' . $thapost['authorid'], 'ENCODE'));
            $noticetrimstr = null;  //这个地方给空好了，该怎么用？

        }

        $modpost = C::m('forum_post', $_G['tid']);
        //直接返回错误状态
        //$modpost->showmessage = '';
        $modpost->showmessage = array(Tool::getInstance(), 'fail_for_discuz_model');

        $bfmethods = $afmethods = array();

        //客户端附件初始化
        $flashatt = Yii::app()->request->getPost('flashatt', '');
        $_GET['attachnew'] = array();
        $flashatt = explode(',', $flashatt);
        if (!empty($aidArr)) {
            $flashatt = $aidArr;
        }
        if (!empty($flashatt)) {
            foreach ($flashatt as $key => $val) {
                if (is_numeric($val) && $val) {
                    $_GET['attachnew'][$val] = array('description' => '');
                }
            }
        }

        $params = array(
            'subject' => $subject,
            'message' => $message,
            'special' => $special,
            'extramessage' => '',
            'bbcodeoff' => '',
            'smileyoff' => $_GET['smileyoff'],
            'htmlon' => '',
            'parseurloff' => '',
            'usesig' => '',
            'isanonymous' => $anonymous == 0 ? '' : 1,
            'noticetrimstr' => $noticetrimstr,
            'noticeauthor' => $noticeauthor,
            'from' => '',
            'sechash' => '',
            'geoloc' => '',
        );
        // 贸易贴的回帖钩子,需要实际应用中测试下
        if (!empty($_GET['trade']) && $thread['special'] == 2 && $_G['group']['allowposttrade']) {
            $bfmethods[] = array('class' => 'extend_thread_trade', 'method' => 'before_newreply');
        }

        $attentionon = 0;
        $attentionoff = 0;

        $bfmethods[] = array('class' => 'extend_thread_rushreply', 'method' => 'before_newreply');

        // 不知道干吗用的
        if ($_G['group']['allowat']) {
            $bfmethods[] = array('class' => 'extend_thread_allowat', 'method' => 'before_newreply');
        }

        $bfmethods[] = array('class' => 'extend_thread_comment', 'method' => 'before_newreply');
        $modpost->attach_before_method('newreply', array('class' => 'extend_thread_filter', 'method' => 'before_newreply'));

        // 不知道干吗用的
        if ($_G['group']['allowat']) {
            $afmethods[] = array('class' => 'extend_thread_allowat', 'method' => 'after_newreply');
        }


        $afmethods[] = array('class' => 'extend_thread_rushreply', 'method' => 'after_newreply');

        $afmethods[] = array('class' => 'extend_thread_comment', 'method' => 'after_newreply');

        if (helper_access::check_module('follow') && !empty($_GET['adddynamic'])) {
            $afmethods[] = array('class' => 'extend_thread_follow', 'method' => 'after_newreply');
        }

        if ($thread['replycredit'] > 0 && $thread['authorid'] != $_G['uid'] && $_G['uid']) {
            $afmethods[] = array('class' => 'extend_thread_replycredit', 'method' => 'after_newreply');
        }

        if ($special == 5) {
            $afmethods[] = array('class' => 'extend_thread_debate', 'method' => 'after_newreply');
        }

        $afmethods[] = array('class' => 'extend_thread_image', 'method' => 'after_newreply');

        //没有商品信息 做为普通回复处理
        if ($special == 2 && $_G['group']['allowposttrade'] && $thread['authorid'] == $_G['uid'] && !empty($_GET['trade'])) {
            $afmethods[] = array('class' => 'extend_thread_trade', 'method' => 'after_newreply');
        }
        $afmethods[] = array('class' => 'extend_thread_filter', 'method' => 'after_newreply');

        if ($_G['forum']['allowfeed']) {
            if ($special == 2 && !empty($_GET['trade'])) {
                $modpost->attach_before_method('replyfeed', array('class' => 'extend_thread_trade', 'method' => 'before_replyfeed'));
                //$modpost->attach_after_method('replyfeed', array('class' => 'extend_thread_trade', 'method' => 'after_replyfeed'));
            } elseif ($special == 3 && $thread['authorid'] != $_G['uid']) {
                $modpost->attach_before_method('replyfeed', array('class' => 'extend_thread_reward', 'method' => 'before_replyfeed'));
            } elseif ($special == 5 && $thread['authorid'] != $_G['uid']) {
                $modpost->attach_before_method('replyfeed', array('class' => 'extend_thread_debate', 'method' => 'before_replyfeed'));
            }
        }

        if (!isset($_GET['addfeed'])) {
            $space = array();
            space_merge($space, 'field_home');
            $_GET['addfeed'] = $space['privacy']['feed']['newreply'];
        }

        $modpost->attach_before_methods('newreply', $bfmethods);
        $modpost->attach_after_methods('newreply', $afmethods);

        $return = $modpost->newreply($params);

        //发帖成功
        if ($return == 'post_reply_mod_succeed' || $return == 'post_reply_succeed') {
            $pid = $modpost->pid;

            //设置客户端
            if ($_GET['devicetype']) {
                $threadStatus = DB::result_first("SELECT status FROM " . DB::table("forum_post") . " WHERE pid=" . intval($pid));
                $tstatus = 0;
                if ($_GET['devicetype'] == 1) {
                    $tstatus = setstatus(4, 1, 0);
                    $tstatus = setstatus(8, 1, $tstatus);
                } elseif ($_GET['devicetype'] == 2) {
                    $tstatus = setstatus(4, 1, 0);
                    $tstatus = setstatus(9, 1, $tstatus);
                }

                if ($tstatus) {
                    $threadStatus = $threadStatus | $tstatus;
                    DB::query("UPDATE " . DB::table("forum_post") . " SET status=" . $threadStatus . " WHERE pid=" . $pid);
                }
            }

            $canPush = 0;

            if (
                $pid && $return == 'post_reply_succeed' &&
                $_G['forum_thread']['authorid'] != $_G['uid'] &&
                Yii::app()->params['cloud_allow_notice'] && Yii::app()->params['cloud_reply_notice'] &&
                in_array($_G['forum_thread']['fid'], Yii::app()->params['cloud_fids_push']) &&
                in_array($_G['forum_thread']['replies'], Yii::app()->params['cloud_thread_replypush'])
            ) {
                $canPush = 1;
            }

            // 回帖审核情况
            $invisible = 0;
            if ($_G['tid'] && $pid) {
                $post = C::t('forum_post')->fetch('tid:' . $_G['tid'], $pid);
                $invisible = isset($post['invisible']) ? $post['invisible'] : 0;
            }

            Tool::getInstance()->success_json(array(
                'pid' => $pid,
                'authorid' => $_G['forum_thread']['authorid'],
                'from' => strtoupper($_G['charset']) == 'UTF-8' ? $_G['member']['username'] : diconv(
                    $_G['member']['username'], $_G['charset'], 'UTF-8'),
                'push' => $canPush,
                'subject' => strtoupper($_G['charset']) == 'UTF-8' ? $_G['forum_thread']['subject'] : diconv(
                    $_G['forum_thread']['subject'], $_G['charset'], 'UTF-8'),
                'message' => strtoupper($_G['charset']) == 'UTF-8' ? $message : diconv(
                    $message, $_G['charset'], 'UTF-8'),
                'invisible' => $invisible
            ));
        } else {
            $errorMessage = '发布失败，请稍后再试';
            if (is_array($return)) {
                if (count($return) > 1) {
                    $errorMessage = lang('message', $return[0], $return[2]);
                } else {
                    $errorMessage = lang('message', $return[0]);
                }
            }

            Tool::getInstance()->fail_json(Code::POST_FAIL, $errorMessage);
        }

    }

    /**
     * 判断动作的权限
     * @param $action
     */
    private function _check_allow_action($action)
    {
        global $_G;
        if (isset($_G['forum'][$action]) && $_G['forum'][$action] == -1) {
            Tool::getInstance()->fail_json(Code::FORUM_ACCESS_DISALLOW, Tool::getInstance()->lang('forum_access_disallow'));
        }
    }

    /**
     * 判断积分奖罚权限
     * @param $action
     */
    private function _checklowerlimit($action, $uid = 0, $coef = 1, $fid = 0, $returnonly = 0)
    {
        global $_G;

        include_once libfile('class/credit');
        $credit = &credit::instance();
        $limit = $credit->lowerlimit($action, $uid, $coef, $fid);
        if ($returnonly) return $limit;
        if ($limit !== true) {
            $GLOBALS['id'] = $limit;
            $lowerlimit = is_array($action) && $action['extcredits' . $limit] ? abs($action['extcredits' . $limit]) + $_G['setting']['creditspolicy']['lowerlimit'][$limit] : $_G['setting']['creditspolicy']['lowerlimit'][$limit];
            $rulecredit = array();
            if (!is_array($action)) {
                $rule = $credit->getrule($action, $fid);
                foreach ($_G['setting']['extcredits'] as $extcreditid => $extcredit) {
                    if ($rule['extcredits' . $extcreditid]) {
                        $rulecredit[] = $extcredit['title'] . ($rule['extcredits' . $extcreditid] > 0 ? '+' . $rule['extcredits' . $extcreditid] : $rule['extcredits' . $extcreditid]);
                    }
                }
            } else {
                $rule = array();
            }
            $values = array(
                '{title}' => $_G['setting']['extcredits'][$limit]['title'],
                '{lowerlimit}' => $lowerlimit,
                '{unit}' => $_G['setting']['extcredits'][$limit]['unit'],
                '{ruletext}' => $rule['rulename'],
                '{rulecredit}' => implode(', ', $rulecredit)
            );
            if (!is_array($action)) {
                if (!$fid) {
                    Tool::getInstance()->fail_json(Code::POLICY_LOWERLIMIT, Tool::getInstance()->lang('policy_lowerlimit', $values));
                } else {
                    Tool::getInstance()->fail_json(Code::POLICY_LOWERLIMIT, Tool::getInstance()->lang('policy_lowerlimit_fid', $values));
                }
            } else {
                Tool::getInstance()->fail_json(Code::POLICY_LOWERLIMIT, Tool::getInstance()->lang('policy_lowerlimit_norule', $values));
            }
        }
    }

    //验证分类信息参数合法性
    private function check_typeoption($sortoption)
    {
        global $_G, $var;
        if (!empty($sortoption)) {
            foreach ($_G['forum_checkoption'] as $var => $option) {
                //($sortoption[$var] === '' && $_G['forum_checkoption'][$var]['type'] != 'number')
                $name = $_G['forum_checkoption'][$var]['title'];
                if ($_G['forum_checkoption'][$var]['required'] && empty($sortoption[$var])) {
                    //资料不全  $_G['forum_checkoption'][$var]['title']
                    Tool::getInstance()->fail_json(Code::SORTS_THREAD_ERROR, Tool::getInstance()->lang('{name}information is incomplete', array('{name}' => $name)));
                } elseif ($sortoption[$var] && ($_G['forum_checkoption'][$var]['type'] == 'number' && !is_numeric($sortoption[$var]) || $_G['forum_checkoption'][$var]['type'] == 'email' && !isemail($sortoption[$var]))) {
                    //资料格式不正确
                    Tool::getInstance()->fail_json(Code::SORTS_THREAD_ERROR, Tool::getInstance()->lang('{name}data format is incorrect', array('{name}' => $name)));
                } elseif ($sortoption[$var] && $_G['forum_checkoption'][$var]['maxlength'] && strlen($sortoption[$var]) > $_G['forum_checkoption'][$var]['maxlength']) {
                    //资料长度过长
                    Tool::getInstance()->fail_json(Code::SORTS_THREAD_ERROR, Tool::getInstance()->lang('{name}length is too long', array('{name}' => $name)));
                } elseif ($sortoption[$var] && (($_G['forum_checkoption'][$var]['maxnum'] && $sortoption[$var] > $_G['forum_checkoption'][$var]['maxnum']) || ($_G['forum_checkoption'][$var]['minnum'] && $sortoption[$var] < $_G['forum_checkoption'][$var]['minnum']))) {
                    //资料数值不正确
                    Tool::getInstance()->fail_json(Code::SORTS_THREAD_ERROR, Tool::getInstance()->lang('{name}data is not correct', array('{name}' => $name)));
                } elseif ($sortoption[$var] && ($_G['forum_checkoption'][$var]['type'] == 'select')) {
                    if ($_G['forum_optionlist'][$_G['forum_checkoption'][$var]['optionid']]['choices'][$sortoption[$var]]['level'] != 1) {
                        //选择项错误
                        Tool::getInstance()->fail_json(Code::SORTS_THREAD_ERROR, Tool::getInstance()->lang('{name}selection error', array('{name}' => $name)));
                    }
                }


            }
        }
    }

    // 楼中楼回复
    private function _replyFloor($thread, $subject, $message, $anonymous)
    {
        global $_G;
        require_once(libfile('function/forum'));


        $pid = WebHelper::getPost('pid', 0);
        $parent_id = WebHelper::getPost('parent_id', 0);
        $platform = WebHelper::getPost('platform', 0);
        $content = $message;

        // 参数验证
        if (!$_G['uid']) {
            Tool::getInstance()->fail_json(Code::NOT_LOG_IN, Tool::getInstance()->lang('please log in first'));
        }
        if (!$_G['tid'] || !$pid || !$content) {
            Tool::getInstance()->fail_json(Code::NOT_LOG_IN, Tool::getInstance()->lang('undefined action'));
        }

        $postList = DB::fetch_first("SELECT * FROM %t WHERE tid = %d AND `first` != %d AND pid= %d LIMIT 1",
            array(C::t('forum_post')->get_tablename('tid:' . $_G['tid']), $_G['tid'], 1, $pid));
        if (!$postList) {
            Tool::getInstance()->fail_json(Code::UNDEFINED_ACTION, Tool::getInstance()->lang('undefined action'));
        }

        if (isset($postList['invisible']) && $postList['invisible'] < 0) {
            Tool::getInstance()->fail_json(Code::FLOOR_NOT_EXIST, Tool::getInstance()->lang('floor not exist'));
        }

        if ($parent_id) {
            $parentData = ReplyFloor::fetchById($parent_id);
            if (!$parentData || $parentData['pid'] != $pid) {
                Tool::getInstance()->fail_json(Code::UNDEFINED_ACTION, Tool::getInstance()->lang('undefined action'));
            }
        }

        // 禁止引用自己和主题帖之外的帖子 回复可见禁止引用回复和楼中楼回复
        if (getstatus($thread['status'], 2) && $_G['uid'] != $thread['authorid'] && !$_G['forum']['ismoderator']) {
            Tool::getInstance()->fail_json(Code::REPLY_QUOTEPOST_ERROR, Tool::getInstance()->lang('reply_quotepost_error'));
        }

        // 验证字数
        if (!$_G['group']['disablepostctrl']) {
            if ($_G['setting']['minpostsize']) {
                $minpostsize = $_G['setting']['minpostsize'];
                if (strlen($content) < $minpostsize) {
                    Tool::getInstance()->fail_json(Code::DISCUZ_MODEL_ERROR, Tool::getInstance()->stripHtmlTags(lang('message', 'post_message_tooshort', array('minpostsize' => $_G['setting']['minpostsize']))));
                }
            }
        }

        // 权限验证
        $this->checkReplyFloor($_G['tid'], $pid, $thread);

        // 审核判断
        list(, $modnewreplies) = threadmodstatus($content);
        $pinvisible = $modnewreplies ? -2 : ($thread['displayorder'] == -4 ? -3 : 0);
        if ($pinvisible == -2) {
            $stats = ReplyFloor::STATUS_REVIEW;
        } elseif ($pinvisible == -3) {
            $stats = ReplyFloor::STATUS_DELETE;
        } else {
            $stats = ReplyFloor::STATUS_APPROVE;
        }

        // 持久化
        $data = array(
            'tid' => $_G['tid'],
            'fid' => $postList['fid'],
            'pid' => $pid,
            'parent_id' => $parent_id,
            'platform' => $platform,
            'message' => $content,
            'authorid' => $_G['uid'],
            'author' => $_G['username'],
            'useip' => $_G['clientip'],
            'status' => $stats,
            'anonymous' => $anonymous,
            'attach_num' => ReplyFloor::getContentImg($content),
            'created_at' => $_G['timestamp'],
            'updated_at' => $_G['timestamp'],
        );
        $insertID = ReplyFloor::insert($data, true);

        // 更新帖子表lastpost
        C::t('forum_thread')->update($_G['tid'], array('lastpost' => $_G['timestamp']));

        // 回复量统计
        $sql = array();
        $floorStats = DB::fetch_first('SELECT * FROM %t WHERE tid=%d and pid=%d', array('qianfan_post_floor_stats', $_G['tid'], $pid));
        if (!$floorStats) {
            $stats = array(
                'tid' => $_G['tid'],
                'pid' => $pid,
                'total' => 1,
                'approve_num' => ($stats == 1) ? 1 : 0,
                'created_at' => $_G['timestamp'],
                'updated_at' => $_G['timestamp'],
            );
            DB::insert('qianfan_post_floor_stats', $stats, false);
        } else {
            $sql[] = "`total`=`total`+'1'";
            if ($stats == 1) {
                $sql[] = "`approve_num`=`approve_num`+'1'";
            }
            DB::query('UPDATE %t SET ' . implode(',', $sql) . ' WHERE tid=%d and pid=%d', array('qianfan_post_floor_stats', $_G['tid'], $pid));
        }

        $floor = ReplyFloor::fetchById($insertID);
        $data = ReplyFloor::formatSingleRes($floor, true);
        if ($parent_id) {
            $parent = ReplyFloor::fetchById($parent_id);
            if ($parent) {
                $parent = ReplyFloor::formatSingleRes($parent);
                $data['parent'] = $parent;
            }
        }
        Tool::getInstance()->success_json($data);
    }


    // 楼中楼权限验证
    protected function checkReplyFloor($tid, $pid, $thread)
    {
        global $_G;

        if (!$_G['uid'] && !((!$_G['forum']['replyperm'] && $_G['group']['allowreply']) || ($_G['forum']['replyperm'] && forumperm($_G['forum']['replyperm'])))) {
            Tool::getInstance()->fail_json(Code::REPLYPERM_LOGIN_NOPERMISSION, Tool::getInstance()->lang('replyperm_login_nopermission'));
        } elseif (empty($_G['forum']['allowreply'])) {
            if (!$_G['forum']['replyperm'] && !$_G['group']['allowreply']) {
                Tool::getInstance()->fail_json(Code::REPLYPERM_NONE_NOPERMISSION, Tool::getInstance()->lang('replyperm_none_nopermission'));
            } elseif ($_G['forum']['replyperm'] && !forumperm($_G['forum']['replyperm'])) {
                $res = qf_showmessagenoperm('viewperm', $_G['fid'], $_G['forum']['formulaperm']);
                $res = qf_rebuild4formulaperm($res);
                Tool::getInstance()->fail_json(Code::REPLYPERM_NONE_NOPERMISSION, Tool::getInstance()->stripHtmlTags(lang('message', $res['message'], $res['params'])));
            }
        } elseif ($_G['forum']['allowreply'] == -1) {
            Tool::getInstance()->fail_json(Code::POST_FORUM_NEWREPLY_NOPERMISSION, Tool::getInstance()->lang('post_forum_newreply_nopermission'));
        }

        // 若回帖需要上传头像，则抛出错误
        if (!$_G['uid'] && ($_G['setting']['need_avatar'] || $_G['setting']['need_email'] || $_G['setting']['need_friendnum'])) {
            Tool::getInstance()->fail_json(Code::REPLYPERM_LOGIN_NOPERMISSION, Tool::getInstance()->lang('replyperm_login_nopermission'));
        }

        // 帖子自身权限判断，帖子是否存在，帖子是否能被回复
        if (empty($thread)) {
            Tool::getInstance()->fail_json(Code::THREAD_NOT_EXISTS, Tool::getInstance()->lang('thread not exist'));
        } elseif ($thread['price'] > 0 && $thread['special'] == 0 && !$_G['uid']) {
            Tool::getInstance()->fail_json(Code::GROUP_NOPERMISSION, Tool::getInstance()->lang('group_nopermission'));
        }


        return true;
    }

    /**
     * 编辑楼中楼
     */
    public function actionEditReplyFloor()
    {
        global $_G;
        require_once(libfile('function/forum'));

        $floor_id = (int)WebHelper::getPost('floor_id', 0);
        $content = WebHelper::getPost('content', '');

        if (!$floor_id || !$content) {
            Tool::getInstance()->fail_json(Code::NOT_LOG_IN, Tool::getInstance()->lang('undefined action'));
        }

        $updateData = array();
        $updateData['message'] = $content;
        $updateData['attach_num'] = ReplyFloor::getContentImg($content);
        $res = DB::update(ReplyFloor::$table, $updateData, "id=" . $floor_id);
//        if (!$res) {
//            Tool::getInstance()->fail_json(Code::CHANGE_FAILED, Tool::getInstance()->lang('change_failed'));
//        }

        $floor = ReplyFloor::fetchById($floor_id);
        $data = ReplyFloor::formatSingleRes($floor, true);
        if ($floor['parent_id']) {
            $parent = ReplyFloor::fetchById($floor['parent_id']);
            if ($parent) {
                $parent = ReplyFloor::formatSingleRes($parent);
                $data['parent'] = $parent;
            }
        }
        Tool::getInstance()->success_json($data);
    }

}
