<?php

class SiteController extends Controller
{

    public function init()
    {
        $this->_map = $this->_actionMap();

        $this->_init_config();

        $this->_init_user();
    }

    private function _init_user()
    {
        global $_G;

        require_once libfile('function/member');

        if (!$_G['uid'] && isset($_POST['token']) && $_POST['token']) {
            $auth = daddslashes(explode("\t", authcode($_POST['token'], 'DECODE', Yii::app()
                    ->params['cloud_secretkey'] .
                $_G['config']['security']['authkey'])));
            list($discuz_pw, $discuz_uid) = $auth;

            $member = getuserbyuid($discuz_uid, 1);
            if ($member) {
                if ($discuz_pw == $member['password']) {
                    if (isset($member['_inarchive'])) {
                        C::t('common_member_archive')->move_to_master($discuz_uid);
                    }
                    setloginstatus($member, $_GET['cookietime'] ? 2592000 : 0);
                }
            } else {
                // 针对老CLIENTAPI兼容登录状态
                $token_arr = explode('/t', $_POST['token']);
                $cookieValue = $token_arr[1];
                if (count($token_arr) > 2) {
                    for ($i = 2; $i < count($token_arr); $i++) {
                        $cookieValue .= '/t' . $token_arr[$i];
                    }
                }

                $au = str_replace(' ', '+', $cookieValue);
                $sa = $token_arr[0];
                $authkey = md5(C::app()->config['security']['authkey'] . $sa);

                if ($auth = $au) {
                    $auth = daddslashes(explode("\t", Tool::getInstance()->authcode($auth, 'DECODE', $authkey)));
                    list($discuz_pw, $discuz_uid) = $auth;
                    $member = getuserbyuid($discuz_uid, 1);
                    if ($member) {
                        if ($discuz_pw == $member['password']) {
                            if (isset($member['_inarchive'])) {
                                C::t('common_member_archive')->move_to_master($discuz_uid);
                            }
                            setloginstatus($member, $_GET['cookietime'] ? 2592000 : 0);
                        }
                    }
                }

            }
            //用户禁言时间到期后 插件内部初始化
            if ($member && $member['groupexpiry'] > 0 && $member['groupexpiry'] < TIMESTAMP) {
                $memberfieldforum = C::t('common_member_field_forum')->fetch($discuz_uid);
                $groupterms = dunserialize($memberfieldforum['groupterms']);
                if (!empty($groupterms['main'])) {
                    C::t("common_member")->update($member['uid'], array('groupexpiry' => 0, 'groupid' => $groupterms['main']['groupid'], 'adminid' => $groupterms['main']['adminid']));
                    unset($groupterms['main'], $groupterms['ext'][$member['groupid']]);
                    C::t('common_member_field_forum')->update($discuz_uid, array('groupterms' => serialize($groupterms)));
                }
            }

        }
        //用户被锁定，app直接抛出非法操作
        if (isset($_G['member']['status']) && $_G['member']['status'] == -1) {
            //该用户被锁定
            Tool::getInstance()->fail_json(Code::USER_BE_LOCKEDe, Tool::getInstance()->lang('user_be_locked'));
        }
    }

    /**
     * 初始化插件配置
     */
    private function _init_config()
    {
        global $qianfan_config, $_G;

        // REMOTE附件不拼接REMOTE域名，交接给云接口
        if ($_POST['action'] != 'pceditthread'){
            $_G['setting']['ftp']['attachurl'] = '';
        }

        // 强制用户头像以静态方式调取
        //强制静态方式调取，用户如果没有头像是dz默认头像时候地址存在，会有问题,先注释掉
        //$_G['setting']['avatarmethod'] = 1;

        //项目编码
        Yii::app()->charset = $_G['charset'];

        //项目编码
        Yii::app()->params['site_charset'] = $_G['charset'];

        // 云服务器域名
        Yii::app()->params['cloud_host'] = isset($qianfan_config['cloud_host']) ? trim($qianfan_config['cloud_host']) : '';
        // 云服务器通信秘钥
        Yii::app()->params['cloud_secretkey'] = isset($qianfan_config['cloud_secretkey']) ? trim($qianfan_config['cloud_secretkey']) : '';
        //刷新阅读量配置
        Yii::app()->params['cloud_reads'] = isset($qianfan_config['cloud_reads']) ? $qianfan_config['cloud_reads'] : '1';
        //是否允许通知云端
        Yii::app()->params['cloud_allow_notice'] = isset($qianfan_config['cloud_allow_notice']) ? $qianfan_config['cloud_allow_notice'] : 0;
        //回帖是否允许通知云端
        Yii::app()->params['cloud_reply_notice'] = isset($qianfan_config['cloud_reply_notice']) ? $qianfan_config['cloud_reply_notice'] : 0;
        //允许将帖子推送云端的版块
        Yii::app()->params['cloud_fids_push'] = isset($qianfan_config['cloud_fids_push']) && is_array($qianfan_config['cloud_fids_push']) ?
            $qianfan_config['cloud_fids_push'] : array();
        //帖子推送的阀值
        Yii::app()->params['cloud_thread_replypush'] = isset($qianfan_config['cloud_thread_replypush']) && is_array($qianfan_config['cloud_thread_replypush']) ? $qianfan_config['cloud_thread_replypush'] : array();
        //搜索ID
        Yii::app()->params['search_id'] = isset($qianfan_config['search_id']) ? $qianfan_config['search_id'] : '';
        //帖子匹配URL
        Yii::app()->params['thread_match'] = isset($qianfan_config['thread_match']) ? $qianfan_config['thread_match'] : '';
        //用于APP特殊用户组
        Yii::app()->params['qianfan_groupid'] = isset($qianfan_config['qianfan_groupid']) ? trim($qianfan_config['qianfan_groupid']) : '';
        //APP搜索结果排序
        Yii::app()->params['search_sort'] = isset($qianfan_config['search_sort']) ? intval($qianfan_config['search_sort']) : 0;
        //找回密码是否开启图片验证码
        Yii::app()->params['open_image_auth'] = 1;
        //搜索用户匹配方式
        Yii::app()->params['search_user_type'] = isset($qianfan_config['search_user_type']) ? intval($qianfan_config['search_user_type']) : 0;

        if (!is_int(strpos($qianfan_config['cloud_host'], 'jztvxmt'))
            && !is_int(strpos($qianfan_config['cloud_host'], 'bbs965333'))
            && !is_int(strpos($qianfan_config['cloud_host'], 'ks.qianfanapi'))
            && !is_int(strpos($qianfan_config['cloud_host'], 'quxian.qianfanapi'))
        ) {
            Yii::app()->params['qianfan_groupid'] = null;
        }
        // 手机号存储
        Yii::app()->params['mobile_source'] = isset($qianfan_config['mobile_source']) ? intval($qianfan_config['mobile_source']) : 2;
        // app七牛附件地址
        Yii::app()->params['app_pic'] = isset($qianfan_config['app_pic']) ? trim($qianfan_config['app_pic']) : '';
        // 允许编辑富文本帖子的用户
        Yii::app()->params['htmledit_uid'] = isset($qianfan_config['htmledit_uid']) && is_array($qianfan_config['htmledit_uid']) ? $qianfan_config['htmledit_uid'] : array();

        // 限制帖子显示的时间
        Yii::app()->params['ban_time'] = isset($qianfan_config['ban_time']) ? $qianfan_config['ban_time'] : '';

        // 禁止修改头像
        Yii::app()->params['ban_edit_info'] = isset($qianfan_config['ban_edit_info']) ? $qianfan_config['ban_edit_info'] : '';
        Yii::app()->params['ban_edit_info_notice'] = isset($qianfan_config['ban_edit_info_notice']) ? $qianfan_config['ban_edit_info_notice'] : '';
        // 站点信息
        Yii::app()->params['site_id'] = isset($qianfan_config['site_id']) ? $qianfan_config['site_id'] : 0;
        Yii::app()->params['site_name'] = isset($qianfan_config['site_name']) ? $qianfan_config['site_name'] : '';
        Yii::app()->params['download_url'] = isset($qianfan_config['download_url']) ? $qianfan_config['download_url'] : '';
        Yii::app()->params['face_auth'] = isset($qianfan_config['face_auth']) ? $qianfan_config['face_auth'] : 0;
        // 开启ip归属地
        Yii::app()->params['open_ip_locate'] = isset($qianfan_config['open_ip_locate']) ? $qianfan_config['open_ip_locate'] : 0;
        // 内网IP位置
        Yii::app()->params['net_location'] = isset($qianfan_config['net_location']) ? $qianfan_config['net_location'] : '';
        // 开启手机号加密
        Yii::app()->params['enable_encrypt_mobile'] = isset($qianfan_config['enable_encrypt_mobile']) ? $qianfan_config['enable_encrypt_mobile'] : 0;

    }

    private function _actionMap()
    {
        return array(
            array('controller' => 'Member', 'actions' => array('login', 'thirdLogin', 'checkAuthMobile', 'deleteUserSign',
                'checkUsername', 'register', 'changemobile', 'editprofile', 'bindPlatformAccount', 'send4login', 'verifycodeLogin', 'fastLogin', 'getThirdInfo', 'checkEmail', 'changeEmail', 'decryptMobile')),
            array('controller' => 'Thread', 'actions' => array('changeThreadViews', 'threadInnerNum', 'verifyReplyFloor', 'reviewReplyFloorList', 'threadInner', 'replyInner', 'getthread', 'getthreadsinfo', 'recommendResult', 'attend', 'unattend', 'activityUser', 'bumpThread', 'appPic', 'editThread', 'pceditthread', 'totalthread', 'countthread', 'getThreadsData', 'getThreadsDetail', 'getPostInfos')),
            array('controller' => 'Forum', 'actions' => array('forumcategory', 'getthreads', 'allthreads', 'gethotthreads', 'topthread', 'reviewThreadList', 'reviewReplyList', 'forummaster', 'getForumInfo', 'hotrecommend', 'getthreadsbytids', 'getTypeByFids', 'getThreadsByFids', 'wordfilter', 'verifyThreadList', 'verifyRepliesList', 'verifyThread', 'verifyReply', 'reviewCount', 'userPublishForum', 'forumPublishUser')),
            array('controller' => 'Publish', 'actions' => array('editReplyFloor', 'innerfloor', 'post', 'push')),
            array('controller' => 'Upload', 'actions' => array('uploadicon', 'attupload', 'deleteAvatar')),
            array('controller' => 'User', 'actions' => array('unbindMember', 'deleteMember', 'userCredits', 'userAllCredits', 'pingList', 'collectthread', 'collectforum', 'uncollectforum', 'uncollectthread', 'pingthread', 'getavatar', 'userinfoes', 'userinfoesbyuname', 'userthread', 'userreplies', 'mycollectthread', 'vote', 'pingcomment', 'delMyThread', 'delMyReply', 'cancelPingThread', 'cancelPingComment', 'pingThreadByAdm', 'newregister', 'getUserInfos', 'userInfoByThird', 'pingCommentByAdm', 'pingfloor', 'cancelPingFloor', 'pingFloorByAdm')),
            array('controller' => 'Manager', 'actions' => array('managerinfo', 'usermanager', 'threadmanager', 'replymanager', 'isAdminGroup')),
            array('controller' => 'Setting', 'actions' => array('generateSearchConfig', 'binlogStatus', 'fetchsmiles', 'ver', 'changePwd', 'changeThirdPlatform', 'getUserinfoByUid', 'changeUsermobile', 'getUserinfoByType', 'changeUsername', 'search', 'tongJi', 'userInfoByMobile', 'logout', 'editgroup', 'appSiteInfo', 'logoutGroup', 'importMobileFromMag'))
        );
    }

    /**
     * 参数校验
     * @return bool
     */
    private function _checkPostData()
    {
        if (!isset(Yii::app()->params['cloud_secretkey'])) {
            return true;
        }

        $post = $_POST;
        if (defined('IN_MOBILE') && strtoupper(Yii::app()->params['site_charset']) != 'UTF-8') {
            $post = Tool::getInstance()->convert2charset($post);
        }

        return CodeSign::check($post, 'codeSign', Yii::app()->params['cloud_secretkey']);
    }

    /**
     * This is the default 'index' action that is invoked
     * when an action is not explicitly requested by users.
     */
    public function actionIndex()
    {

        if ($_POST['action'] != 'uploadicon' && $_POST['action'] != 'attupload' && $_POST['action'] != 'ver') {
            if (!$this->_checkPostData()) {
                Tool::getInstance()->fail_json(Code::KEY_ERROR, Tool::getInstance()->getInstance()->lang('key_error'));
            }
        }
        $executer = $this->getExecuter();
        if (empty($executer)) {
            Tool::getInstance()->fail_json(Code::FAILED_GET_RELATED_ACTIONS, Tool::getInstance()->getInstance()->lang('failed_get_related_actions'));
        }

        $route = implode('/', $executer);

        Yii::app()->runController($route);

    }

    public function actionError()
    {
        if ($error = Yii::app()->errorHandler->error) {
            Yii::log("message============>" . $error['message']);
            Yii::log("file===============>" . $error['file']);
            Yii::log("line===============>" . $error['line']);

        }
        Tool::getInstance()->fail_json(Code::SERVER_ERROR, 'SERVER ERROR');
        Yii::app()->end();
    }

}

