<?php
/**
 * Created by PhpStorm.
 * User: zhaofei
 * Date: 15/11/10
 * Time: 上午10:27
 */

if (!defined('IN_DISCUZ')) {
    exit('Access Denied');
}

class ThreadController extends Controller
{

    /**
     * 主题详细页
     */
    public function actionGetthread()
    {
        global $_G;

        $data = array(
            'thread' => array(),//主题内容
            'replies' => array(),//主题回复
            'hotpings' => array()//热门评论
        );

        //主题帖ID
        $tid = Yii::app()->request->getPost('tid', 0);
        //只看某个回复
        $replypid = WebHelper::getPost('replypid', 0);
        //是否只看楼主
        $isseemaster = Yii::app()->request->getPost('isseemaster', 0);
        //回复排序
        $replyorder = Yii::app()->request->getPost('replyorder', 0);
        //点赞排序
        $supportorder = Yii::app()->request->getPost('supportorder', 2);
        //SQL OFFSET
        $offset = Yii::app()->request->getPost('offset', 0);
        //SQL limit
        $limit = Yii::app()->request->getPost('limit', 10);

        //是否开启置顶评论
        $openToppings = Yii::app()->request->getPost('openToppings', 1);
        //是否开启点赞上去的评论
        $openHotpings = Yii::app()->request->getPost('openHotpings', 1);
        //多少条评论显示热门
        $commentlimit = Yii::app()->request->getPost('commentlimit', 10);
        //多少赞上热门
        $supportnum = Yii::app()->request->getPost('supportnum', 5);
        //最多显示多少热门
        $supportlimit = Yii::app()->request->getPost('supportlimit', 10);

        //缓存期间的阅读量（前面设置的是10秒）
        $readnum = Yii::app()->request->getPost('readnum', 1);

        //判断是否为新APP的接口
        $is_new = Yii::app()->request->getPost('is_new', 0);

        // 回复显示类型 0:默认 1:用户可以看到自己的待审核评论 默认启用
        $reply_type = Yii::app()->request->getPost('reply_type', 1);

        /********************************************加载主题帖*********************************************************/
        $topic = C::t('forum_thread')->fetch_by_tid_displayorder($tid, ForumThread::DISPLAY_ORDER_NORMAL);
        $topicCheck = C::t('forum_thread')->fetch_by_tid_displayorder($tid, ForumThread::DISPLAY_ORDER_CHECK, '=');
        // 审核中,用户可以看见自己的审核中的帖子
        if (!empty($topicCheck)) {
            if (isset($_G['uid']) && $_G['uid'] > 0 && $topicCheck['authorid'] == $_G['uid']) {
                $topic = $topicCheck;
            } else {
                Tool::getInstance()->fail_json(Code::THREAD_CHECK, Tool::getInstance()->lang('thread is check'));
            }
        }

        //主题帖不存在
        if (empty($topic)) {
            Tool::getInstance()->fail_json(Code::THREAD_NOT_EXISTS, Tool::getInstance()->lang('thread not exists'));
        }

        //保留移动贴
        //大坑 closed =1 可能代表是关闭主题，不是新移动帖地址
        if ($topic['closed'] && $topic['closed'] != 1) {
            $tid = $topic['closed'];
            $topic['tid'] = $tid;
        }
        /*************************************************************************************************************/

        /******************************加载板块信息****************************/
        $_GET['tid'] = $_G['tid'] = $tid;
        $_GET['fid'] = $topic['fid'];

        if (!function_exists('loadforum')) {
            require_once(libfile('function/forum'));
        }
        loadforum();

        // 千帆帖子保质期插件
        if (!ForumThread::qfThreadBan($topic['tid'], $topic['fid'], $topic['authorid'], $topic['dateline'])) {
            $qfMessage = Tool::getInstance()->lang('thread not exists');
            if (!empty($_G['cache']['plugin']['qfthread']['isopen']) && !empty($_G['cache']['plugin']['qfthread']['tips'])) {
                $qfMessage = $_G['cache']['plugin']['qfthread']['tips'];
            }
            Tool::getInstance()->fail_json(Code::THREAD_NOT_EXISTS, $qfMessage);
        }

        //兼容手机端 DISCUZ 模板，主要是为了返回的图片的SRC是静态地址
        //手机版也使用网页端的模板
        if (defined('IN_MOBILE')) {
            $tempMobileTpl = $_G['mobiletpl'][IN_MOBILE];
            if (!defined('TPL_DEFAULT')) {
                define('TPL_DEFAULT', true);
            }
            $_G['mobiletpl'][IN_MOBILE] = '';
        }

        if (empty($_G['forum']) || $_G['forum']['fid'] == 0) {
            Tool::getInstance()->fail_json(Code::FORUM_VIEW_PERM, Tool::getInstance()->lang('forum_access_disallow'));
//            Tool::getInstance()->fail_json(Code::THREAD_NOT_EXISTS, Tool::getInstance()->lang('thread not exists'));
        }

        /********************************************************************/
        require_once(Yii::getPathOfAlias('application.components.func') . DIRECTORY_SEPARATOR . 'forum_viewthread.php');
        // 处理抢楼贴
        threadrush();

        //检查板块访问权限
        if (empty($_G['forum']['allowview'])) {
            if (!$_G['forum']['viewperm'] && !$_G['group']['readaccess']) {
                Tool::getInstance()->fail_json(Code::GROUP_HAS_NOT_PERMISSION, Tool::getInstance()->lang('your group:{group} can not read this content', array('{group}' => $_G['group']['grouptitle'])));
            } elseif ($_G['forum']['viewperm'] && !forumperm($_G['forum']['viewperm'])) {
                $res = qf_showmessagenoperm('viewperm', $_G['fid'], $_G['forum']['formulaperm']);
                $res = qf_rebuild4formulaperm($res);
                Tool::getInstance()->fail_json(Code::FORUM_VIEW_PERM, Tool::getInstance()->stripHtmlTags(lang('message', $res['message'], $res['params'])));
                //Tool::getInstance()->fail_json();
                die('to do');
            }

        } elseif ($_G['forum']['allowview'] == -1) {
            //板块不允许被访问
            Tool::getInstance()->fail_json(Code::FORUM_NOPERMISSION, Tool::getInstance()->lang('forum can not read'));
        }

        // 版块设置了访问用户权限，没权限的禁止访问详情
        if ($_G['forum']['formulaperm']) {
            $msg = qf_formulaperm($_G['forum']['formulaperm']);
            if ($msg['message'] != '') {
                $lanParamsTmp = $msg['params'];
                $lanParams = array();
                foreach ($lanParamsTmp as $k => $v) {
                    $k = str_replace(array('{', '}'), '', $k);
                    $lanParams[$k] = $v;
                }
                Tool::getInstance()->fail_json(Code::FORUM_VIEW_PERM, Tool::getInstance()->stripHtmlTags(lang('message', $msg['message'], $lanParams)));
            }
        }

        //需要密码才能访问板块
        if ($_G['forum']['password']) {
            Tool::getInstance()->fail_json(Code::NEED_PASSWORD, Tool::getInstance()->lang('need password to visit'));
        }

        /*
        if($_G['forum']['price'] && !$_G['forum']['ismoderator']) {
            $membercredits = C::t('common_member_forum_buylog')->get_credits($_G['uid'], $_G['fid']);
            $paycredits = $_G['forum']['price'] - $membercredits;
            if($paycredits > 0) {
                // dheader("Location: $_G[siteurl]forum.php?mod=forumdisplay&fid=$_G[fid]");
            }
        }
        */

        //应该是帖子阅读权限的判断
        if ($_G['forum_thread']['readperm'] && $_G['forum_thread']['readperm'] > $_G['group']['readaccess'] && !$_G['forum']['ismoderator'] && $_G['forum_thread']['authorid'] != $_G['uid']) {
            Tool::getInstance()->fail_json(Code::THREAD_READPERM, Tool::getInstance()->lang('read permission should over {readperm}', array('{readperm}' => $_G['forum_thread']['readperm'])));
        }
        /*******************************主题帖、回帖******************************************/
        //topic post
        $topicInfo = array();
        $post = DB::fetch_first("SELECT * FROM %t WHERE tid = %d AND first = 1",
            array(C::t('forum_post')->get_tablename('tid:' . $topic['tid']), $topic['tid']));

        if (!empty($post)) {
            $topicAuthor = C::t('common_member')->fetch_by_username($post['author']);

            //设置作者的STATUS（禁言等）
            $post['memberstatus'] = $topic['memberstatus'] = $topicAuthor['memberstatus'];

            $msg1 = Tool::getInstance()->lang('shield by manager to user');
            $msg2 = Tool::getInstance()->lang('shield by manager');
            $msg3 = Tool::getInstance()->lang('author shield by manager to user');
            $msg4 = Tool::getInstance()->lang('author shield by manager');
            $msg5 = Tool::getInstance()->lang('ban author shield by manager to user');
            $msg6 = Tool::getInstance()->lang('ban author shield by manager');

            //处理主题帖内容：CONTENT
            $content = ForumThread::parsePostMessage($post, 1);
            //分类信息显示
            $sortContent = '';
            $sortImg = array();
            //帖子被屏蔽的话 分类信息不显示
            if (!in_array($content, array($msg1, $msg2, $msg3, $msg4, $msg5, $msg6))) {
                if ($topic['sortid'] && $_G['forum']['threadsorts']['types'][$topic['sortid']]) {
                    $sort = $_G['forum']['threadsorts']['types'][$_G['forum_thread']['sortid']];
                    $threadsortshow = ForumThread::getSortInfo($topic['sortid'], $_G['tid'], $sort, $topic['dateline']);
                    list($sortContent, $sortImg) = $threadsortshow;
                }
            }

            // 处理图片重复问题
            if (!empty($sortImg)) {
                foreach ($sortImg as $k => $v) {
                    $v = str_replace('/', '\/', $v);
                    if (preg_match('/<img([^<]*)src=\"' . $v . '\".*?>/i', $content, $matches)) {
                        $content = str_replace($matches[0], '', $content);
                    }
                }
            }
            $content = $sortContent . $content;

            // 修正帖子查看数
            if (isset($_G['forum_thread']['views']) && $_G['forum_thread']['tid'] == $topic['tid'] && $_G['forum_thread']['views'] > $topic['views']) {
                $topic['views'] = $_G['forum_thread']['views'];
            }
            //活动贴的重新组织
            if ($topic['special'] == 4) {

                $re = ForumThread::getActivityThread($topic, $content);
                $content = $re['con'];
                $topicInfo['activity'] = $re['re'];
            }
            //商品的重新组织
            if ($topic['special'] == 2) {
                $re = ForumThread::getTradeThread($topic);
                $extra_pid = $re['pid'];
                $content = $content . $re['con'];
            }

            // 兼容帖子隐藏插件
            $hideTable = DB::result_first("SHOW TABLES LIKE '%t'", array('qianfan_threadhide'));
            if ($hideTable && !empty($_G['cache']['plugin']['qfthreadhide'])) {
                $hidePluginConf = $_G['cache']['plugin']['qfthreadhide'];
                $isAdmin = false;
                if (!empty($_G['uid']) && !empty($_G['group']['radminid']) && in_array($_G['group']['radminid'], array(1, 2, 3))) {
                    $isAdmin = true;
                }
                $isAuthor = false;
                if (!empty($_G['uid']) && $_G['uid'] == $topic['authorid']) {
                    $isAuthor = true;
                }
                $isHide = C::t('#' . IDENTIFIER . '#qianfan_threadhide')->is_hide($tid);
                if (!$isAdmin && !$isAuthor && $isHide) {
                    $hideText = $hidePluginConf['tips'];
                    $content = sprintf('<span style="color:#BBBBBB;">%s</span>', $hideText);
                }
            }

            // 楼中楼评论数量
            $threadFloorRepies = 0;
            $floorTable = DB::result_first("SHOW TABLES LIKE '%t'", array(ReplyFloor::$table));
            if (!empty($floorTable)) {
                $threadFloorRepies = (int)DB::result_first("SELECT SUM(approve_num) as num FROM %t WHERE tid=%d",
                    array('qianfan_post_floor_stats', $tid)
                );
            }

            //组织云端内容字段
            $topicInfo['tid'] = $topic['tid'];
            $topicInfo['subject'] = htmlspecialchars_decode($topic['subject']);
            $topicInfo['fid'] = $topic['fid'];
            $topicInfo['fname'] = $_G['forum']['name'];
            $topicInfo['icon'] = discuz_uc_avatar($topic['authorid'], 'big', true);
            $topicInfo['author'] = $topic['author'];
            $topicInfo['authorid'] = $topic['authorid'];
            $topicInfo['ifcheck'] = $topic['displayorder'] < 0 ? 0 : 1;
            $topicInfo['postdate'] = $topic['dateline'];
            $topicInfo['lastpost'] = $topic['lastpost'];
            $topicInfo['lastposter'] = $topic['lastposter'];
            $topicInfo['hits'] = $topic['views'];
            $topicInfo['replies'] = $topic['replies'];
            $topicInfo['totalReplies'] = $topic['replies'] + $threadFloorRepies;
            $topicInfo['favors'] = $topic['favtimes'];
            $topicInfo['topped'] = $topic['displayorder'] > 0 ? 1 : 0;
            $topicInfo['digest'] = $topic['digest'];
            $topicInfo['special'] = $topic['special'];
            $topicInfo['ifupload'] = $topic['attachment'] > 0 ? 1 : 0;
            //新增返回主题是否被关闭
            $topicInfo['closed'] = isset($_G['forum_thread']['closed']) ? $_G['forum_thread']['closed'] : $topic['closed'];
            //获取作者的性别
            $topicInfo['gender'] = DB::result_first("SELECT gender FROM " . DB::table("common_member_profile") . " WHERE uid=%d", array($topic['authorid']));
            $topicInfo['content'] = $content;
            $topicInfo['isFavored'] = DB::result_first('SELECT id FROM ' . DB::table('home_favorite') . ' WHERE id = %d AND uid = %d', array($topic['tid'], $_G['uid'])) ? 1 : 0;
            $topicInfo['isFollow'] = 0;
            $topicInfo['disablepos'] = (int)DB::result_first("SELECT tid FROM " . DB::table("forum_threaddisablepos") . " WHERE tid=%d", array($topic['tid']));

            $topicInfo['pid'] = (int)$post['pid'];
            $topicInfo['anonymous'] = (int)$post['anonymous'];
            $topicInfo['userip'] = (string)$post['useip'];

            // 主题分类
            $topicInfo['types'] = array();
            if ($topic['typeid'] > 0 && $_G['forum']['threadtypes']['prefix'] == 1 && !empty($_G['forum']['threadtypes']['types'][$topic['typeid']])) {
                $topicInfo['types'] = array(
                    'id' => $topic['typeid'],
                    'name' => $_G['forum']['threadtypes']['types'][$topic['typeid']],
                );
            }

            /**********  wq_wechatcollection ******************/
            $topicInfo['content'] = ForumThread::handleWqwechatcollection($topicInfo['content'], $topicInfo['tid']);
            /************西蜀插件****************/
            if (file_exists('./source/plugin/xishu_cloud/tpl/replyaward.tpl.php')) {
                require_once './source/plugin/xishu_cloud/tpl/replyaward.tpl.php';
            }
//            global $postlist;
//            $postlist = array(
//                $post['pid'] => array(
//                    'first' => 1,
//                    'pid' => $post['pid'],
//                    'message' => ''
//                )
//            );
//            $this->_hook_wqwechatcollection();
//            if($postlist[$post['pid']]['message']){
//                $topicInfo['content']  = $postlist[$post['pid']]['message'];
//            }
            /**************************************************/

            //获取特殊用户组
            $topicInfo['specialgid'] = false;
            if (!empty(Yii::app()->params['qianfan_groupid']) && isset($topicAuthor['groupid']) && Yii::app()->params['qianfan_groupid'] == $topicAuthor['groupid']) {
                $topicInfo['specialgid'] = true;
            }

            //是否被赞
            if ($_G['uid']) {
                $isping = C::t('forum_memberrecommend')->fetch_by_recommenduid_tid($_G['uid'], $topic['tid']);
            } else {
                $isping = 0;
            }
            $topicInfo['isping'] = $isping;
            $topicInfo['pingCount'] = $topic['recommend_add'];

            //点评的用户
            $allPing = DB::fetch_all('SELECT recommenduid FROM ' . DB::table('forum_memberrecommend') . ' WHERE tid = %d ORDER BY dateline DESC limit 30', array($topic['tid']));
            $pinger = array();
            if (!empty($allPing)) {
                $pingUids = array();
                foreach ($allPing as $key => $ping) {
                    $pingUids[] = $ping['recommenduid'];
                }

                if (!empty($pingUids)) {
                    $pingerUsername = C::t('common_member')->fetch_all_username_by_uid($pingUids);
                    foreach ($pingUids as $val) {
                        $pinger[] = array(
                            'uid' => $val,
                            'username' => isset($pingerUsername[$val]) ? $pingerUsername[$val] : "",
                            'icon' => discuz_uc_avatar($val, 'big', true)
                        );
                    }
                }
            }

            $topicInfo['pinger'] = $pinger;
            if (!empty($post['attachments'])) {
                $allAttachs = array();
                foreach ($post['attachments'] as $key => $attach) {
                    $allAttachs[]['url'] = ForumThread::getAttachUrl($attach);
//                    $url = ($attach['remote'] ? $_G['setting']['ftp']['attachurl'] : $_G['setting']['siteurl']) . 'forum/';
//                    $allAttachs[]['url'] = $url . $attach['attachment'];
                }
            }
            $topicInfo['allAttachs'] = $allAttachs;
            $topicInfo['unUsedAttachs'] = array();


            $_G['tid'] = $topicInfo['tid'];
            //特殊帖子处理 投票
            if ($topicInfo['special'] == 1) {
                $topicInfo['poll'] = ForumThread::getVoteInfo($_G['tid']);
            }

        }
        /************************************************************************************/

        /************************************获取回帖*****************************************/
        // 贴内置顶
        $sticklist = array();
        if (!$replypid) {
            //新加了一个开启置顶的开关 $openToppings
            if ($openToppings && $offset == 0 && $_G['forum_thread']['stickreply'] && !$isseemaster) {
                $poststick = C::t('forum_poststick')->fetch_all_by_tid($_G['tid']);
                foreach (C::t('forum_post')->fetch_all($_G['forum_thread']['posttableid'], array_keys($poststick)) as $post) {
                    if ($post['invisible'] >= 0) {
                        $post['position'] = $poststick[$post['pid']]['position'];
                        $post['avatar'] = avatar($post['authorid'], 'small');
                        $post['isstick'] = true;
                        $sticklist[$post['pid']] = $post;
                    }
                }
            }
        }

        // 推荐帖子
        if ($is_new == 0) {
            $hiddenreplies = getstatus($_G['forum_thread']['status'], 2);
            $rushreply = getstatus($_G['forum_thread']['status'], 3);
            $hotpids = array();
            $hotpostarr = array();

            $remainhots = ($offset == 0 && !$rushreply && !$hiddenreplies && !$_G['forum_thread']['special'] && !$_G['forum']['noforumrecommend'] && empty($isseemaster)) ? $_G['setting']['threadhotreplies'] : 0;
            if ($remainhots) {
                $hotpids = array_keys(C::t('forum_hotreply_number')->fetch_all_by_tid_total($_G['tid'], 10));
                $remainhots = $remainhots - count($hotpids);
            }
            if ($_G['setting']['nofilteredpost'] && $_G['forum_thread']['replies'] > $_G['setting']['postperpage'] && $remainhots) {
                $hotpids = array_merge($hotpids, array_keys(C::t('forum_filter_post')->fetch_all_by_tid_postlength_limit($_G['tid'], $remainhots)));
            }
            if ($hotpids) {
                $hotposts = C::t('forum_post')->fetch_all_by_pid($_G['forum_thread']['posttableid'], $hotpids);
                foreach ($hotpids as $hotpid) {
                    if ($hotposts[$hotpid]) {
                        $hotpostarr[$hotpid] = $hotposts[$hotpid];
                        $hotpostarr[$hotpid]['hotrecommended'] = true;
                    }
                }
                unset($hotposts);
            }

        } else {


            $hotpostarr = array();

            $postSql = " SELECT a.*,b.support FROM %t a LEFT JOIN %t b ON a.pid = b.pid WHERE a.tid = $tid AND a.first != 1 AND a.invisible >= 0 AND b.support >=$supportnum ORDER BY b.support DESC LIMIT $supportlimit";

            //加一个通过点赞数上去的开关
            if ($openHotpings) {
                $hotpostarrs = DB::fetch_all($postSql, array('forum_post', 'forum_hotreply_number'));
                foreach ($hotpostarrs as $key => $post) {
                    $hotpostarr[$post['pid']] = $post;
                }
                unset($hotpostarrs);
            }

        }


        //是否仅作者可见
        $isOnlyAuthorTopic = getstatus($_G['forum_thread']['status'], 2) == 1 ? 1 : 0;

        //组织获取回帖SQL
        //invisible 审核状态
        $isseemaster = intval($isseemaster);//只看楼主
        $authorid = intval($topicInfo['authorid']);


        if (!$replypid) {
            if ($is_new == 0 || $supportorder == 2) //状态值为2的时候  表示关闭最赞排序,以楼层排序为主
            {
                if ($replyorder) {
                    $order = "dateline DESC";
                } else {
                    $order = "dateline ASC";
                }
                if ($_G['uid'] && $reply_type) {
                    $postSql = "SELECT * FROM %t WHERE tid = %d AND `first` != %d AND (invisible >= %d OR (invisible=-2 AND authorid={$_G['uid']}))" . ($isseemaster ? ' AND authorid =' . $authorid : '') . ($isseemaster ? ' AND anonymous = 0' : '') . " ORDER BY " . $order . "
                LIMIT
                %d, %d";
                } else {
                    $postSql = "SELECT * FROM %t WHERE tid = %d AND `first` != %d AND invisible >= %d" . ($isseemaster ? ' AND authorid =' . $authorid : '') . ($isseemaster ? ' AND anonymous = 0' : '') . " ORDER BY " . $order . "
                LIMIT
                %d, %d";
                }

            } else {
                if ($supportorder) {
                    $order = "b.support DESC";
                } else {
                    $order = "b.support ASC";
                }
                $postSql = "SELECT a.* FROM %t a LEFT JOIN " . DB::table("forum_hotreply_number ") . " b ON a.pid = b.pid WHERE a.tid = %d AND `first` != %d AND invisible >= %d" . ($isseemaster ? ' AND a.authorid =' . $authorid : '') . ($isseemaster ? ' AND anonymous = 0' : '') . " ORDER BY " . $order . "
                LIMIT
                %d, %d";

            }

            $postList = DB::fetch_all($postSql, array(
                C::t('forum_post')->get_tablename('tid:' . $tid),
                $tid, 1, 0,
                dintval($offset), dintval($limit)));
        } else {
            // 优化通过消息中心进入帖子
            $postList = DB::fetch_all("SELECT * FROM %t WHERE tid = %d AND `first` != %d AND pid= %d LIMIT 1",
                array(C::t('forum_post')->get_tablename('tid:' . $tid), $tid, 1, $replypid));
            if (!empty($postList)) {
                if ($postList[0]['invisible'] == -5 || $postList[0]['invisible'] == -3) {
                    $postList[0]['message'] = Tool::getInstance()->lang('thread not exists');
                } elseif ($postList[0]['invisible'] == -2) {
                    $postTemp = array();
                    if (preg_match_all('/\[qf_at=(.+?)\](.+?)\[\/qf_at\]/', $postList[0]['message'], $matches)) {
                        foreach ($matches[1] as $k => $v) {
                            if ($_G['uid'] > 0 && $v == $_G['uid']) {
                                $postTemp = $postList;
                                break;
                            }
                        }
                    }
                    $postList = $postTemp;
                } elseif ($postList[0]['invisible'] == 0) {
                    $postList = $postList;
                } else {
                    $postList = array();
                }
            }
        }
        //回复量没记录时，兼容下
        if (is_array($postList) && !empty($postList)) {
            $replies_num = count($postList);
            if ($topicInfo['replies'] == 0 && $replies_num != 0)
                $topicInfo['replies'] = $replies_num;
        }

        if ($postList) {
            $tempPids = $tempUids = array();
            $tempPostRecommends = array();
            foreach ($postList as $post) {
                $tempPids[] = dintval($post['pid']);
                $tempUids[] = dintval($post['authorid']);
            }

            // 回帖点赞数量
            $hotreplyNumber = C::t('forum_hotreply_number')->fetch_all_by_pids(array_values($tempPids));
            if (!empty($hotreplyNumber)) {
                foreach ($hotreplyNumber as $pid => $post) {
                    $tempPostRecommends[$pid] = dintval($post['support']);
                }
            }

            // 当前用户是否点赞回复
            $isSupportAry = DB::fetch_all("SELECT pid FROM %t WHERE uid=%d AND pid IN (%n)", array('forum_hotreply_member', $_G['uid'], $tempPids));
            $isSupport = array();
            if (!empty($isSupportAry)) {
                foreach ($isSupportAry as $key => $val) {
                    $isSupport[] = $val['pid'];
                }
            }

            // 回复者的性别
            $genders = array();
            $tempUids = array_unique($tempUids);
            $genderArr = DB::fetch_all("SELECT uid,gender FROM %t WHERE uid IN (%n)", array('common_member_profile', $tempUids));
            if (!empty($genderArr)) {
                foreach ($genderArr as $k => $v) {
                    $genders[$v['uid']] = $v['gender'];
                }
            }

            // 楼中楼接口
            $replyFloorNum = array();
            if (!empty($floorTable)) {
                $floorNumArr = DB::fetch_all("SELECT pid,approve_num as num FROM %t WHERE tid=%d AND pid IN (%n)",
                    array('qianfan_post_floor_stats', $tid, $tempPids)
                );
                foreach ($floorNumArr as $v) {
                    $replyFloorNum[$v['pid']] = $v['num'];
                }
            }

        }

        // 帖子内置顶组合回复列表，首页支持去重
        if ($is_new == 0) //使用老版的置顶加推荐的方式
        {
            if (!empty($sticklist) || !empty($hotpostarr)) {
                foreach ($postList as $key => $val) {
                    if (isset($sticklist[$val['pid']])) {
                        unset($postList[$key]);
                    }
                    if (isset($hotpostarr[$val['pid']])) {
                        unset($postList[$key]);
                    }
                }
                $postList = (array)$sticklist + (array)$hotpostarr + $postList;
            }
        } else {
            $posthot = array();
            //获取全部评论数量
            $all_postlist_num = $topicInfo['replies'];
            if ($all_postlist_num >= $commentlimit) {
                $posthot = (array)$sticklist + (array)$hotpostarr;
            } else if ($all_postlist_num < $commentlimit && isset($sticklist)) {
                $posthot = $sticklist;//只要有置顶的优先显示
            }
        }

        //遍历所有回复
        $replies = array();
        $pids = Tool::Array_Column($postList, 'pid');
        $tableid = DB::result_first('SELECT tableid FROM %t WHERE tid = %d', array('forum_attachment', $tid));
        $reply_attachs = C::t('forum_attachment_n')->fetch_all_by_id($tableid, 'pid', $pids, '', 1);

        if (!empty($postList)) {
            foreach ($postList as $key => $val) {
                $postdateline = $val['dateline'];

                $content = ForumThread::parsePostMessage($val);
                //是否仅作者可见
                $isOnlyAuthorSeeReply = 0;
                if ($isOnlyAuthorTopic && $_G['uid'] != $val['authorid'] && $_G['uid'] != $_G['forum_thread']['authorid'] && !$val['first'] && !$_G['forum']['ismoderator']) {
                    $isOnlyAuthorSeeReply = 1;
                }

                $content = $isOnlyAuthorSeeReply ? Tool::getInstance()->lang('hiddenreplies') : $content;

                $allAttachs = array();
                foreach ($reply_attachs as $k => $attach) {
                    if ($attach['pid'] == $val['pid']) {
                        $url = ($attach['remote'] ? $_G['setting']['ftp']['attachurl'] : $_G['setting']['attachurl']) . 'forum/';
                        $allAttachs[]['url'] = $url . $attach['attachment'];
                    }
                }

                //每个评论投票数和是否点赞
                $support_num = isset($tempPostRecommends[$val['pid']]) ? $tempPostRecommends[$val['pid']] : 0;

                //判断当前登录用户是否对该帖点赞没有
                $is_support = in_array($val['pid'], $isSupport) ? 1 : 0;

                //匿名帖子隐藏同户名
                $author = $val['anonymous'] ? '' : $val['author'];

                $reply = array(
                    'pid' => $val['pid'],
                    'tid' => $val['tid'],
                    'author' => $author,
                    'authorid' => $val['authorid'],
                    'icon' => discuz_uc_avatar($val['authorid'], 'big', 1),
                    'gender' => isset($genders[$val['authorid']]) ? $genders[$val['authorid']] : 0,
                    'postdate' => $postdateline,
                    'subject' => '',
                    'content' => $content,
                    'allAttachs' => $allAttachs,
                    'unUsedAttachs' => array(),
                    'anonymous' => $val['anonymous'],
                    'userip' => (string)$val['useip'],

                    'support_num' => $support_num,
                    'is_support' => $is_support,
                    'position' => $val['position'],
                    'inner_replies' => isset($replyFloorNum[$val['pid']]) ? (int)$replyFloorNum[$val['pid']] : 0
                );
                //针对商品中多余的楼层转移
                if ($topic['special'] == 2 && !empty($extra_pid) && in_array($val['pid'], $extra_pid)) {
                    $topicInfo['content'] = str_replace('[re]' . $val['pid'] . '[/re]', $content, $topicInfo['content']);
                    continue;
                }
                $replies[] = $reply;
            }
        }


        //遍历所有的热门评论
        if ($is_new == 1) {
            $hotpings = array();
            if (!empty($posthot)) {

                $hotPids = $hotUids = array();
                $hotPostRecommends = array();
                foreach ($posthot as $post) {
                    $hotPids[] = dintval($post['pid']);
                    $hotUids[] = dintval($post['authorid']);
                }

                // 回帖点赞数量
                $hotreplyNumber = C::t('forum_hotreply_number')->fetch_all_by_pids(array_values($hotPids));
                if (!empty($hotreplyNumber)) {
                    foreach ($hotreplyNumber as $pid => $post) {
                        $hotPostRecommends[$pid] = dintval($post['support']);
                    }
                }

                // 当前用户是否点赞回复
                $isSupportAry = DB::fetch_all("SELECT pid FROM %t WHERE uid=%d AND pid IN (%n)", array('forum_hotreply_member', $_G['uid'], $hotPids));
                $ishotSupport = array();
                if (!empty($isSupportAry)) {
                    foreach ($isSupportAry as $key => $val) {
                        $ishotSupport[] = $val['pid'];
                    }
                }


                // 回复者的性别
                $genders = array();
                $hotUids = array_unique($hotUids);
                $hotgenderArr = DB::fetch_all("SELECT uid,gender FROM %t WHERE uid IN (%n)", array('common_member_profile', $hotUids));
                if (!empty($hotgenderArr)) {
                    foreach ($hotgenderArr as $k => $v) {
                        $hotgenders[$v['uid']] = $v['gender'];
                    }
                }

                // 楼中楼接口
                $hotFloorNum = array();
                if (!empty($floorTable)) {
                    $floorNumArr = DB::fetch_all("SELECT pid,approve_num as num FROM %t WHERE tid=%d AND pid IN (%n)",
                        array('qianfan_post_floor_stats', $tid, $hotPids)
                    );
                    foreach ($floorNumArr as $v) {
                        $hotFloorNum[$v['pid']] = $v['num'];
                    }
                }


                foreach ($posthot as $key => $val) {
                    $postdateline = $val['dateline'];

                    $content = ForumThread::parsePostMessage($val);
                    $msg1 = Tool::getInstance()->lang('shield by manager to user');
                    $msg2 = Tool::getInstance()->lang('shield by manager');
                    $msg3 = Tool::getInstance()->lang('author shield by manager to user');
                    $msg4 = Tool::getInstance()->lang('author shield by manager');
                    $msg5 = Tool::getInstance()->lang('ban author shield by manager to user');
                    $msg6 = Tool::getInstance()->lang('ban author shield by manager');
                    if (in_array($content, array($msg1, $msg2, $msg3, $msg4, $msg5, $msg6))) {
                        unset($val);
                        continue;
                    }

                    //是否仅作者可见
                    $isOnlyAuthorSeeReply = 0;
                    if ($isOnlyAuthorTopic && $_G['uid'] != $val['authorid'] && $_G['uid'] != $_G['forum_thread']['authorid'] && !$val['first'] && !$_G['forum']['ismoderator']) {
                        $isOnlyAuthorSeeReply = 1;
                    }

                    $content = $isOnlyAuthorSeeReply ? Tool::getInstance()->lang('hiddenreplies') : $content;

                    $allAttachs = array();
                    foreach ($reply_attachs as $k => $attach) {
                        if ($attach['pid'] == $val['pid']) {
                            $url = ($attach['remote'] ? $_G['setting']['ftp']['attachurl'] : $_G['setting']['attachurl']) . 'forum/';
                            $allAttachs[]['url'] = $url . $attach['attachment'];
                        }
                    }

                    //每个评论投票数和是否点赞
                    //取消判断是否开启点赞功能
                    $support_num = isset($hotPostRecommends[$val['pid']]) ? $hotPostRecommends[$val['pid']] : 0;

                    //判断当前登录用户是否对该帖点赞没有
                    $is_support = in_array($val['pid'], $ishotSupport) ? 1 : 0;

                    //$is_stick = isset($val['isstick']) ? 1 : 0 ;//是否置顶
                    //$is_recommend = isset($val['hotrecommended']) ? 1 : 0 ;//是否推荐

                    //匿名帖子隐藏同户名
                    $author = $val['anonymous'] ? '' : $val['author'];

                    $hotping = array(
                        'pid' => $val['pid'],
                        'tid' => $val['tid'],
                        'author' => $author,
                        'authorid' => $val['authorid'],
                        'icon' => discuz_uc_avatar($val['authorid'], 'big', 1),
                        'gender' => isset($genders[$val['authorid']]) ? $hotgenders[$val['authorid']] : 0,
                        'postdate' => $postdateline,
                        'subject' => '',
                        'content' => $content,
                        'allAttachs' => $allAttachs,
                        'unUsedAttachs' => array(),
                        'anonymous' => $val['anonymous'],
                        'userip' => (string)$val['useip'],

                        'support_num' => $support_num,
                        'is_support' => $is_support,
                        'position' => $val['position'],
                        'inner_replies' => isset($hotFloorNum[$val['pid']]) ? (int)$hotFloorNum[$val['pid']] : 0
                    );
                    //针对商品中多余的楼层转移
                    if ($topic['special'] == 2 && !empty($extra_pid) && in_array($val['pid'], $extra_pid)) {
                        $topicInfo['content'] = str_replace('[re]' . $val['pid'] . '[/re]', $content, $topicInfo['content']);
                        continue;
                    }
                    $hotpings[] = $hotping;
                }
            }
            $data['hotpings'] = $hotpings;
        }

        // 匿名帖子，只看楼主时，评论返回空
        if ($isseemaster == 1 && $topicInfo['anonymous'] == 1) {
            $replies = array();
        }

        $data['thread'] = $topicInfo;
        $data['replies'] = $replies;

        // 更新帖子阅读量
        if (!$topicCheck) {
            ForumThread::updateThreadViews($topicInfo['threadtableid'], $readnum);
        }

        Tool::getInstance()->success_json($data);
        /************************************************************************************/
    }

    /**
     * 根据tid pid 获取帖子信息
     */
    public function actionGetthreadsinfo()
    {
        global $_G;

        $tids = WebHelper::getPost('tids', 0);
        $pids = WebHelper::getPost('pids', 0);
        $type = WebHelper::getPost('type', 1);// 1主题帖 2回复
        // 验证参数的合法性
        if (!preg_match('/^[0-9,]+$/', $tids) || !preg_match('/^[0-9,]+$/', $pids)) {
            Tool::getInstance()->fail_json(Code::UNDEFINED_ACTION, Tool::getInstance()->lang('undefined action'));
        }

        $pidAry = explode(',', $pids);
        $tidAry = explode(',', $tids);

        // 一次至多获取100条帖子基本信息，否则视为攻击
        if (count($tidAry) >= 100 || count($pidAry) >= 100) {
            Tool::getInstance()->fail_json(Code::REQUEST_IS_LARGE, Tool::getInstance()->lang('request_is_large'));
        }
        $data = array();
        loadcache('posttableids');
        $posttableids = $_G['cache']['posttableids'] ? $_G['cache']['posttableids'] : array(0);
        $post_info = array();
        if ($tids && $type == 1) {
            if (!empty($tidAry)) {
                $threads = C::t("forum_thread")->fetch_all_by_tid($tidAry);

                //特殊贴标记字段 specialgid
                $specialgid = Yii::app()->params['qianfan_groupid'];
                $groupid = array();
                if ($specialgid) {
                    foreach ($threads as $k => $v) {
                        $authoridArr[$k] = $v['authorid'];
                    }
                    if (!empty($authoridArr)) {
                        $groupidArr = DB::fetch_all('SELECT * FROM %t WHERE uid IN (%n)', array('common_member', $authoridArr));
                        if (!empty($groupidArr)) {
                            foreach ($groupidArr as $kk => $vv) {
                                $groupid[$vv['uid']] = $vv['groupid'];
                            }
                        }
                    }
                }

                if (!empty($threads)) {
                    if ($_G['setting']['optimizeviews']) {
                        $threadsoptimize = DB::fetch_all("SELECT * FROM %t WHERE tid in (%n)", array
                        ("forum_threadaddviews", $tidAry));
                    }

                    foreach ($posttableids as $id) {
                        $posts = DB::fetch_all("SELECT pid,fid,tid,message,anonymous,useip FROM %t WHERE tid in (%n) AND first = 1",
                            array(getposttable($id), $tidAry), 'tid');
                        if (!empty($posts)) {
                            $post_info = $post_info + $posts;
                        }
                    }

                    // 版块信息
                    $fids = array_unique(Tool::Array_Column($post_info, 'fid'));
                    $forumInfo = DB::fetch_all("SELECT fid,name FROM %t WHERE fid in (%n)", array("forum_forum", $fids), 'fid');
                    $attachs = ForumThread::getAllAttaches($post_info, $threads);

                    // 楼中楼回复数
                    $floorTable = DB::result_first("SHOW TABLES LIKE '%t'", array(ReplyFloor::$table));
                    $floorNum = array();
                    if ($floorTable) {
                        $floorNum = DB::fetch_all('SELECT tid,SUM(approve_num) as num FROM %t WHERE tid in (%n) group by tid', array('qianfan_post_floor_stats', $tidAry), 'tid');
                    }

                    foreach ($threads as $key => $thread) {
                        $d = array();
                        $d['views_num'] = $thread['views'];
                        $d['replies_num'] = $thread['replies'];
                        $d['likes_num'] = $thread['favtimes'];
                        $d['specialgid'] = (!empty(Yii::app()->params['qianfan_groupid']) && $groupid[$thread['authorid']] == $specialgid) ? true : false;

                        //2.0需要使用字段,所以添加以下的
                        $d['pid'] = $post_info[$thread['tid']]['pid'];
                        $d['fid'] = $thread['fid'];
                        $d['tid'] = $thread['tid'];
                        $d['subject'] = $thread['subject'];
                        $d['message'] = $post_info[$thread['tid']]['message'];
                        $d['author'] = $thread['author'];
                        $d['authorid'] = $thread['authorid'];
                        $d['authorip'] = $post_info[$thread['tid']]['useip'];
                        $d['forum_name'] = $forumInfo[$thread['fid']]['name'];
                        $d['dateline'] = $thread['dateline'];
                        $d['pings'] = isset($thread['recommend_add']) ? $thread['recommend_add'] : 0;
                        $d['special'] = $thread['special'];
                        // 加上楼中楼评论
                        if (isset($floorNum[$thread['tid']]['num'])) {
                            $d['replies_num'] = $d['replies_num'] + $floorNum[$thread['tid']]['num'];
                        }
                        // 是否匿名
                        $d['anonymous'] = $post_info[$thread['tid']]['anonymous'];
                        $d['attach'] = array();
                        $d['img_num'] = 0;

                        if (!empty($threadsoptimize)) {
                            foreach ($threadsoptimize as $k => $v) {
                                if ($v['tid'] == $thread['tid'] && $v['addviews']) {
                                    $d['views_num'] += $v['addviews'];
                                }
                            }
                        }

                        if ($thread['attachment'] == 2 || $thread['attachment'] == 1) {
                            if (isset($attachs[$thread['tid']]) && is_array($attachs[$thread['tid']]) && !empty($attachs[$thread['tid']])) {
                                $d['attach'] = $attachs[$thread['tid']];
                                $d['img_num'] = $d['img_num'] + count($attachs[$thread['tid']]);
                            }
                        }

                        $data[$thread['tid']] = $d;
                    }
                }
            }
        } elseif ($pids && $type == 2) {
            if (!empty($pidAry)) {
                foreach ($posttableids as $k => $id) {
                    $posts = DB::fetch_all("SELECT * FROM %t WHERE pid in (%n) AND first = 0", array(getposttable($id), $pidAry), 'pid');
                    if (!empty($posts)) {
                        $post_info = $post_info + $posts;
                    }
                }

                $tids = array_unique(Tool::Array_Column($post_info, 'tid'));

                $thread = DB::fetch_all("SELECT tid,subject FROM %t WHERE tid in (%n)", array("forum_thread", $tids), 'tid');
                $attachs = ForumThread::getAllAttaches($post_info, $thread, 1);
                // 特殊贴标记字段 specialgid
                $specialgid = Yii::app()->params['qianfan_groupid'];
                $groupid = array();
                if ($specialgid) {
                    $authoridArr = Tool::Array_Column($post_info, 'authorid');
                    $authoridArr = array_unique($authoridArr);
                    if (!empty($authoridArr)) {
                        $groupidArr = DB::fetch_all('SELECT * FROM %t WHERE uid IN (%n)', array('common_member', $authoridArr));
                        if (!empty($groupidArr)) {
                            foreach ($groupidArr as $kk => $vv) {
                                $groupid[$vv['uid']] = $vv['groupid'];
                            }
                        }
                    }
                }

                // 版块信息
                $fids = array_unique(Tool::Array_Column($post_info, 'fid'));
                $forumInfo = DB::fetch_all("SELECT fid,name FROM %t WHERE fid in (%n)", array("forum_forum", $fids), 'fid');
                if (!empty($post_info)) {
                    foreach ($post_info as $key => $post) {
                        $d = array();
                        $d['views_num'] = 0;
                        $d['replies_num'] = 0;
                        $d['likes_num'] = 0;
                        $d['specialgid'] = (!empty(Yii::app()->params['qianfan_groupid']) && $groupid[$post['authorid']] == $specialgid) ? true : false;

                        //2.0需要使用字段,所以添加以下的
                        $d['pid'] = $post['pid'];
                        $d['fid'] = $post['fid'];
                        $d['tid'] = $post['tid'];
                        $d['subject'] = $thread[$post['tid']]['subject'];
                        $d['message'] = $post['message'];
                        $d['author'] = $post['author'];

                        $d['authorid'] = $post['authorid'];
                        $d['authorip'] = $post['useip'];
                        $d['forum_name'] = $forumInfo[$post['fid']]['name'];
                        $d['dateline'] = $post['dateline'];
                        $d['pings'] = 0;
                        $d['special'] = 0;

                        // 是否匿名
                        $d['anonymous'] = $post['anonymous'];
//                        $d['port'] = $post['port'];
                        $d['attach'] = array();
                        $d['img_num'] = 0;

                        if ($post['attachment'] == 2 || $post['attachment'] == 1) {
                            if (isset($attachs[$post['pid']]) && is_array($attachs[$post['pid']]) && !empty($attachs[$post['pid']])) {
                                $d['attach'] = $attachs[$post['pid']];
                                $d['img_num'] = $d['img_num'] + count($attachs[$post['pid']]);
                            }
                        }

                        $data[$post['pid']] = $d;
                    }
                }
            }
        } else {
            Tool::getInstance()->fail_json(Code::UNDEFINED_ACTION, Tool::getInstance()->lang('undefined action'));
        }

        Tool::getInstance()->success_json($data);
    }

    /**
     * 获取帖子点赞列表
     */
    public function actionRecommendResult()
    {
        if (!function_exists('loadforum')) {
            require_once(libfile('function/forum'));
        }

        $tid = intval(WebHelper::getPost('tid', ''));
        $dateline = intval(WebHelper::getPost('dateline', ''));
        $offset = WebHelper::getPost('offset', 0);
        $limit = WebHelper::getPost('limit', 10);

        $pinger = array();
        if ($tid > 0) {
            if ($dateline > 0) {
                $allPing = DB::fetch_all('SELECT recommenduid FROM ' . DB::table('forum_memberrecommend') . ' WHERE tid = %d AND dateline < %d ORDER BY dateline DESC limit %d',
                    array($tid, $dateline, $limit));
            } else {
                $allPing = DB::fetch_all('SELECT recommenduid FROM ' . DB::table('forum_memberrecommend') . ' WHERE tid = %d ORDER BY dateline DESC limit %d, %d',
                    array($tid, $offset, $limit));
            }
            if (!empty($allPing)) {
                $pingUids = array();
                foreach ($allPing as $key => $ping) {
                    $pingUids[] = $ping['recommenduid'];
                }
                if (!empty($pingUids)) {
                    $pingerUsername = C::t('common_member')->fetch_all_username_by_uid($pingUids);
                    $pingerSign = DB::fetch_all("SELECT sightml,uid FROM %t WHERE uid IN (%n)", array("common_member_field_forum", $pingUids), 'uid');
                    foreach ($pingUids as $val) {
                        $pinger[] = array(
                            'uid' => $val,
                            'username' => isset($pingerUsername[$val]) ? $pingerUsername[$val] : "",
                            'icon' => discuz_uc_avatar($val, 'big', true),
                            'sign' => isset($pingerSign[$val]['sightml']) ? $pingerSign[$val]['sightml'] : ""
                        );
                    }
                }
            }
        }
        Tool::getInstance()->success_json($pinger);
    }

    private function _hook_wqwechatcollection()
    {
        global $postlist;
        if (file_exists(DISCUZ_ROOT . './source/plugin/wq_wechatcollecting/hooks.class.php')) {
            @include DISCUZ_ROOT . './source/plugin/wq_wechatcollecting/hooks.class.php';
            if (class_exists('plugin_wq_wechatcollecting_forum')) {
                $hookObj = new plugin_wq_wechatcollecting_forum();
                if (method_exists($hookObj, 'viewthread_posttop_output')) {
                    $hookObj->viewthread_posttop_output();
                    if (strtoupper(CHARSET) == 'GBK') {
                        foreach ($postlist as $key => $post) {
                            $postlist[$key]['message'] = iconv('GBK', 'UTF-8//ignore', $postlist[$key]['message']);
                            $postlist[$key]['message'] = iconv('UTF-8', 'GBK', $postlist[$key]['message']);
                        }
                    }

                }
            }
        }
    }

    public function actionActivityUser()
    {
        $tid = intval(WebHelper::getPost('tid', ''));
        $offset = intval(WebHelper::getPost('offset', ''));
        $limit = intval(WebHelper::getPost('limit', ''));

        $user = array();
        if ($tid) {
            $apply = DB::fetch_all("SELECT * FROM %t WHERE tid = %d ORDER BY `applyid` DESC LIMIT %d,%d", array('forum_activityapply', $tid, $offset, $limit));
            if (!empty($apply)) {
                if (!function_exists('discuz_uc_avatar')) {
                    require_once(libfile('function/forum'));
                }
                foreach ($apply as $val) {
                    $user[] = array(
                        'uid' => intval($val['uid']),
                        'username' => $val['username'],
                        'icon' => discuz_uc_avatar($val['uid'], 'big', true)
                    );
                }

            }
        }
        Tool::getInstance()->success_json($user);
    }

    /**
     * 升降帖子
     */
    public function actionbumpThread()
    {
        global $_G;
        require_once libfile('function/core');
        require_once libfile('function/post');

        $operation = WebHelper::getPost('operation', '');

        $tid = WebHelper::getPost('tid', '');
        $subject = WebHelper::getPost('subject', '');
        $lastposter = WebHelper::getPost('lastposter', '');
        $fid = WebHelper::getPost('fid', '');
        $expirationbump = WebHelper::getPost('expirationbump', '');     //'2019-12-17 14:24'
        $qianfan_admin = WebHelper::getPost('qianfan_admin', 0);

        if (!$qianfan_admin) {
            if (!$_G['group']['allowbumpthread']) {
                Tool::getInstance()->fail_json(Code::GROUP_NOPERMISSION, Tool::getInstance()->lang('group_nopermission'));
            }
        }
        // 取自 source/include/topicadmin/topicadmin_moderate.php
        if ($operation == 'bump') {
            // 提升帖子
            $modaction = 'BMP';
            if (!empty($expirationbump)) {
                $expiration = strtotime($expirationbump) - $_G['setting']['timeoffset'] * 3600 + date('Z');
            } else {
                $expiration = $_G['timestamp'];
            }

            C::t('forum_thread')->update(array($tid), array('lastpost' => $expiration, 'moderated' => 1), true);
            C::t('forum_forum')->update($fid, array('lastpost' => "$tid\t$subject\t$expiration\t$lastposter"));

            $_G['forum']['threadcaches'] && deletethreadcaches($tid);
        } elseif ($operation == 'down') {
            // 下沉帖子
            $modaction = 'DWN';
            $downtime = TIMESTAMP - 86400 * 730;
            C::t('forum_thread')->update(array($tid), array('lastpost' => $downtime, 'moderated' => 1), true);

            $_G['forum']['threadcaches'] && deletethreadcaches($tid);
        }

        // 记录日志
        $today = dgmdate(TIMESTAMP, 'Y-m-d');
        if ($_G['setting']['modworkstatus'] && $modaction && 1) {
            $affect_rows = C::t('forum_modwork')->increase_count_posts_by_uid_modaction_dateline(1, 1, $_G['uid'], $modaction, $today);
            if (!$affect_rows) {
                C::t('forum_modwork')->insert(array(
                    'uid' => $_G['uid'],
                    'modaction' => $modaction,
                    'dateline' => $today,
                    'count' => 1,
                    'posts' => 1,
                ));
            }
        }

        Tool::getInstance()->success_json(array());
    }


    //取消活动报名
    public function actionUnAttend()
    {
        global $_G;
        if (!$_G['uid']) {
            Tool::getInstance()->fail_json(Code::NOT_LOG_IN, Tool::getInstance()->lang('need_login'));
        }
        $tid = intval(WebHelper::getPost('tid', ''));
        $message = WebHelper::getPost('message', '');       //留言

        $_G['tid'] = $tid;
        $thread = C::t('forum_thread')->fetch_by_tid_displayorder($_G['tid'], 0);

        C::t('forum_activityapply')->delete_for_user($_G['uid'], $_G['tid']);
        $applynumber = C::t('forum_activityapply')->fetch_count_for_thread($_G['tid']);
        C::t('forum_activity')->update($_G['tid'], array('applynumber' => $applynumber));
        $message = cutstr(dhtmlspecialchars($message), 200);
        if ($thread['authorid'] != $_G['uid']) {
            notification_add($thread['authorid'], 'activity', 'activity_cancel', array(
                'tid' => $_G['tid'],
                'subject' => $thread['subject'],
                'reason' => $message
            ));
        }
        Tool::getInstance()->success_json(array('return' => 'success'));
    }

    //报名参加活动
    public function actionAttend()
    {
        global $_G;
        if (!$_G['uid']) {
            Tool::getInstance()->fail_json(Code::NOT_LOG_IN, Tool::getInstance()->lang('need_login'));
        }
        $tid = intval(WebHelper::getPost('tid', ''));
        $payment = WebHelper::getPost('payment', '');               //支付为金额，承担自己消费为-1
        $data = Yii::app()->request->getPost('data', '');                        //json字段

        if (strtoupper(Yii::app()->params['site_charset']) != 'UTF-8') {
            //必须是utf8编码
            $data = iconv('GBK', 'UTF-8//IGNORE', $data);
        }
        $data = json_decode($data, true);

        if (is_array($data) && !empty($data)) {
            $message = isset($data['message']) ? $data['message'] : '';
            if (strtoupper(Yii::app()->params['site_charset']) != 'UTF-8') {
                $message = iconv('UTF-8', 'GBK//IGNORE', $message);
            }
        } else {
            Tool::getInstance()->fail_json(Code::UNDEFINED_ACTION, Tool::getInstance()->lang('undefined action'));
        }

        $_G['tid'] = $tid;
        $thread = C::t('forum_thread')->fetch_by_tid_displayorder($_G['tid'], 0);
        $activity = C::t('forum_activity')->fetch($_G['tid']);

        if ($activity['expiration'] && $activity['expiration'] < TIMESTAMP) {
            Tool::getInstance()->fail_json(Code::ACTIVITY_ERROR, lang('message', 'activity_stop'));
        }
        $applyinfo = C::t('forum_activityapply')->fetch_info_for_user($_G['uid'], $_G['tid']);
        if ($applyinfo && $applyinfo['verified'] < 2) {
            Tool::getInstance()->fail_json(Code::ACTIVITY_ERROR, lang('message', 'activity_repeat_apply'));
        }
        //参数
        $message = cutstr(dhtmlspecialchars($message), 200);
        $verified = $thread['authorid'] == $_G['uid'] ? 1 : 0;
        if ($activity['ufield']) {
            $ufielddata = array();
            $activity['ufield'] = dunserialize($activity['ufield']);
            if (!empty($activity['ufield']['userfield'])) {
                $censor = discuz_censor::instance();
                loadcache('profilesetting');
                foreach ($activity['ufield']['userfield'] as $filedname) {
                    //电话 名字 qq
                    $value = isset($data[$filedname]) ? $data[$filedname] : '';
                    if (strtoupper(Yii::app()->params['site_charset']) != 'UTF-8') {
                        $value = iconv('UTF-8', 'GBK//IGNORE', $value);
                    }
                    if (is_array($value)) {
                        $value = implode(',', $value);
                    }
                    //长度限制200字符
                    $value = cutstr(dhtmlspecialchars(trim($value)), 200, '.');
                    if ($_G['cache']['profilesetting'][$filedname]['formtype'] == 'file' && !preg_match("/^https?:\/\/(.*)?\.(jpg|png|gif|jpeg|bmp)$/i", $value)) {
                        Tool::getInstance()->fail_json(Code::ACTIVITY_ERROR, lang('message', 'activity_imgurl_error'));
                    }
                    if (empty($value) && $filedname != 'residedist' && $filedname != 'residecommunity') {
                        Tool::getInstance()->fail_json(Code::ACTIVITY_ERROR, lang('message', 'activity_exile_field'));
                    }
                    $ufielddata['userfield'][$filedname] = $value;
                }
            }
            if (!empty($activity['ufield']['extfield'])) {
                foreach ($activity['ufield']['extfield'] as $fieldid) {
                    $value = isset($data[$fieldid]) ? $data[$fieldid] : '';
                    if (strtoupper(Yii::app()->params['site_charset']) != 'UTF-8') {
                        $value = iconv('UTF-8', 'GBK//IGNORE', $value);
                    }
                    $ufielddata['extfield'][$fieldid] = cutstr($value, 50, '.');
                }
            }
            $ufielddata = !empty($ufielddata) ? serialize($ufielddata) : '';
        }
        //威望值的 增减 可以忽略
        if ($_G['setting']['activitycredit'] && $activity['credit'] && empty($applyinfo['verified'])) {
            checklowerlimit(array('extcredits' . $_G['setting']['activitycredit'] => '-' . $activity['credit']));
            updatemembercount($_G['uid'], array($_G['setting']['activitycredit'] => '-' . $activity['credit']), true, 'ACC', $_G['tid']);
        }
        if ($applyinfo && $applyinfo['verified'] == 2) {
            $newinfo = array(
                'tid' => $_G['tid'],
                'username' => $_G['username'],
                'uid' => $_G['uid'],
                'message' => $message,
                'verified' => $verified,
                'dateline' => $_G['timestamp'],
                'payment' => $payment,
                'ufielddata' => $ufielddata
            );
            C::t('forum_activityapply')->update($applyinfo['applyid'], $newinfo);
        } else {
            $data = array('tid' => $_G['tid'], 'username' => $_G['username'], 'uid' => $_G['uid'], 'message' => $message, 'verified' => $verified, 'dateline' => $_G['timestamp'], 'payment' => $payment, 'ufielddata' => $ufielddata);
            C::t('forum_activityapply')->insert($data);
        }

        $applynumber = C::t('forum_activityapply')->fetch_count_for_thread($_G['tid']);
        C::t('forum_activity')->update($_G['tid'], array('applynumber' => $applynumber));

        if ($thread['authorid'] != $_G['uid']) {
            if (function_exists('notification_add')) {
                notification_add($thread['authorid'], 'activity', 'activity_notice', array(
                    'tid' => $_G['tid'],
                    'subject' => $thread['subject'],
                ));
            }
            $space = array();
            if (function_exists('space_merge')) {
                space_merge($space, 'field_home');
            }
            if (!empty($space['privacy']['feed']['newreply']) && function_exists('postfeed')) {
                $feed['icon'] = 'activity';
                $feed['title_template'] = 'feed_reply_activity_title';
                $feed['title_data'] = array(
                    'subject' => "<a href=\"forum.php?mod=viewthread&tid=$_G[tid]\">$thread[subject]</a>",
                    'hash_data' => "tid{$_G[tid]}"
                );
                $feed['id'] = $_G['tid'];
                $feed['idtype'] = 'tid';
                postfeed($feed);
            }
        }
        Tool::getInstance()->success_json(array('return' => 'success'));
    }

    //编辑帖子
    public function actionEditThread()
    {
        global $_G;

        $fid = WebHelper::getPost('fid', 0);//版块id
        $tid = WebHelper::getPost('tid', 0);//帖子id
//        $sortid = WebHelper::getPost( 'sortid', 0 );//分类信息ID
        $typeid = WebHelper::getPost('typeid', 0);//主题分类ID
        $subject = WebHelper::getPost('subject', '');// 帖子标题
        $message = WebHelper::getPost('message', '');// 帖子内容
        $anonymous = WebHelper::getPost('anonymous', 0);//是否开启匿名
        $closed = WebHelper::getPost('closed', 0);//是否关闭主题
        $qianfan_admin = WebHelper::getPost('qianfan_admin', 0);

        if (!$_G['uid'] && $qianfan_admin == 0) {
            Tool::getInstance()->fail_json(Code::NOT_LOG_IN, Tool::getInstance()->lang('need_login'));
        }

        $editthread = array(
            'fid' => $fid,
            'subject' => $subject,
            'typeid' => $typeid,
            'closed' => $closed
//            'sortid'=>$sortid,
        );
        $editpost = array(
            'fid' => $fid,
            'subject' => $subject,
            'message' => $message,
            'anonymous' => $anonymous
        );

        $thread = DB::result_first("SELECT subject FROM %t WHERE tid=%s", array('forum_thread', $tid));
        $post = DB::fetch_all("SELECT pid,tid,author,first FROM %t WHERE tid=%s and first=1", array('forum_post', $tid), 'tid');

        if (!empty($thread) && !empty($post)) {
            if (!$anonymous) {
                $editthread['author'] = $post[$tid]['author'];
            } else if ($anonymous == 1) {
                $editthread['author'] = '';
            }
            C::t('forum_thread')->update($tid, $editthread);
            C::t('forum_post')->update('first:1', $post[$tid]['pid'], $editpost);
            // app二次编辑空格处理
            if (strpos($message, "[qianfan_html]") !== false) {
                C::t('forum_post')->update_by_tid('tid:' . $tid, $tid, array('htmlon' => 1), false, false, 1);
            }

            // 判断是否需要审核
            require_once libfile('function/post');
            include_once libfile('function/forum');
            loadforum($fid);
            list($modnewthreads, $modnewreplies) = threadmodstatus($subject . "\t" . $message);
            if ($post[$tid]['first'] && $modnewthreads) {
                C::t('forum_thread')->update($tid, array('displayorder' => -2));
                manage_addnotify('verifythread');// 通知  新消息提醒
                C::t('forum_post')->update($thread['posttableid'], $post['pid'], array('status' => 4), false, false, null, -2, null, 0);
                updatemoderate('tid', $tid);// pre_forum_thread_moderate 主题审核记录数据

                C::t('forum_forum')->update_forum_counter($fid, 0, 0, 1);// 版块待处理消息
            }

            Tool::getInstance()->success_json(array());

        } else {
            Tool::getInstance()->fail_json(Code::THREAD_NOT_EXISTS, Tool::getInstance()->lang('thread not exists'));
        }

        Tool::getInstance()->success_json(array());
    }

    // 富文本附件域名
    public function actionAppPic()
    {
        $app_pic = WebHelper::getPost('app_pic', '');
        if ($app_pic) {
            $config = DB::result_first("SELECT value FROM %t WHERE name=%s", array('qianfan_plugin', 'config'));
            if (!empty($config)) {
                $config = json_decode($config, true);
            }

            //写配置缓存
            require_once libfile('function/cache');
            $config['app_pic'] = intval($app_pic);
            writetocache('qianfan_config', getcachevars(array('qianfan_config' => $config)));

            $value = json_encode($config);
            $con = DB::result_first("SELECT value FROM %t WHERE name=%s", array('qianfan_plugin', 'config'));
            if (empty($con)) {
                DB::insert("qianfan_plugin", array("name" => 'config', "value" => $value, "time" => time()));
            } else {
                DB::update("qianfan_plugin", array("value" => $value, "time" => time()), array("name" => "config"));
            }
        }
        Tool::getInstance()->success_json(array());
    }

    // 富文本PC编辑
    public function actionPceditthread()
    {

        global $_G;
        // 帖子id
        $tid = WebHelper::getPost('tid', 0);

        if ($tid) {
            $content = DB::result_first('SELECT message FROM %t WHERE tid=%d and first=1', array('forum_post', $tid));
            if (empty($content)) {
                Tool::getInstance()->fail_json(Code::THREAD_NOT_EXISTS, Tool::getInstance()->lang('thread not exists'));
            }

            // 图片及其他附件
            if (preg_match_all('/\[attach](.*?)\[\/attach]/is', $content, $aids)) {
                require_once libfile('function/attachment');
                $attachs = C::t('forum_attachment_n')->fetch_all_by_id('tid:' . $tid, 'aid', $aids[1]);
                $downloads = C::t('forum_attachment')->fetch_all($aids[1]);

                foreach ($attachs as $attach) {
                    // 附件存储位置
                    if (strpos($_G['setting']['attachurl'], 'http') === false) {
                        $url = rtrim($_G['setting']['siteurl'], '/') . '/' . trim($_G['setting']['attachurl'], '/');
                    } else {
                        $url = rtrim($_G['setting']['attachurl'], '/');
                    }
                    $attach['url'] = ($attach['remote'] ? rtrim($_G['setting']['ftp']['attachurl'], '/') : $url) . '/forum/';

                    $attach['dateline'] = dgmdate($attach['dateline'], 'u');
                    $extension = strtolower(fileext($attach['filename']));
                    $attach['downloads'] = $downloads[$attach['aid']]['downloads'];
                    $attach['attachicon'] = attachtype($extension . "\t" . $attach['filetype']);
                    $img = '';
                    if (preg_match_all('/\<.*?src="(.*?)".*?>/is', $attach['attachicon'], $typeimg)) {
                        $img = $typeimg[1][0];
                    }

                    $attach['attachsize'] = sizecount($attach['filesize']);
                    $aidencode = packaids($attach);
                    $is_archive = $_G['forum_thread']['is_archived'] ? "&fid=" . $_G['fid'] . "&archiveid=" . $_G['forum_thread']['archiveid'] : '';

                    if ($attach['isimage']) {
                        $html = '<img id="aimg_' . $attach['aid'] . '"aid="' . $attach['aid'] . '" src="' . $attach['url'] . $attach['attachment'] . '" zoomfile="' . $attach['url'] . $attach['attachment'] . '" file="' . $attach['url'] . $attach['attachment'] . '" class="zoom" initialized="true" width="' . $attach['width'] . '">';
                        $content = str_replace('[attach]' . $attach['aid'] . '[/attach]', $html, $content);
                    } else {
                        $html = '<div class="attach_download"><img class="vm" width="30px" height="30px" src="' . $_G["siteurl"] . $img . '" /><span id="attach_' . $attach["aid"] . '" initialized="true"><a style="font-size:14px" href="' . $_G["siteurl"] . '/forum.php?mod=attachment' . $is_archive . '&aid=' . $aidencode . '">' . $attach['filename'] . '</a><span style="color:#989898">(' . $attach["attachsize"] . ',' . Tool::getInstance()->lang("downloads") . $attach["downloads"] . ')</span></span></div>';
                        $content = str_replace('[attach]' . $attach['aid'] . '[/attach]', $html, $content);
                    }
                }
            }

            // 表情包处理
            $smileys = array(
                'searcharray' => array(),
                'replacearray' => array(),
                'typearray' => array()
            );

            foreach (C::t('common_smiley')->fetch_all_cache() as $smiley) {
                $smileys['searcharray'][$smiley['id']] = '/' . preg_quote(dhtmlspecialchars($smiley['code']), '/') . '/';
                $smileys['replacearray'][$smiley['id']] = $smiley['url'];
                $smileys['typearray'][$smiley['id']] = $smiley['typeid'];
            }

            $smileCategory = C::t('forum_imagetype')->fetch_all_by_type('smiley');
            $type = Tool::Array_Column($smileCategory, 'directory', 'typeid');

            $smileRootUrl = rtrim($_G['setting']['siteurl'], '/') . '/static/image/smiley/';

            foreach ($smileys['searcharray'] as $key => $smiley) {
                // 表情地址
                $url = $smileRootUrl . $type[$smileys['typearray'][$key]] . '/' . $smileys['replacearray'][$key];
                $smiley = stripslashes($smiley);

                $str = substr(substr(stripslashes($smiley), 0, strlen(stripslashes($smiley)) - 1), 1);
                $html = '<img smilieid="' . $key . '" src="' . $url . '" width="24" height="24" />';

                $content = str_replace($str, $html, $content);
            }

            // [hide]
            if (preg_match_all('/\[hide](.*?)\[\/hide]/is', $content, $hides)) {
                foreach ($hides[1] as $hide) {
                    $content = str_replace('[hide]' . $hide . '[/hide]', '', $content);
                }
            }
            // [i]
            if (preg_match_all('/\[i=s](.*?)\[\/i]/is', $content, $is)) {
                foreach ($is[1] as $i) {
                    $content = str_replace('[i=s]' . $i . '[/i]', '', $content);
                }
            }

            // [img]
            if (preg_match_all('/\[img](.*?)\[\/img]/is', $content, $imgs)) {
                foreach ($imgs[1] as $img) {
                    $content = str_replace('[img]' . $img . '[/img]', '<img src="' . $img . '" />', $content);
                }
            }
            if (preg_match_all('/\[img=.+?\](.*?)\[\/img]/is', $content, $imgs)) {
                foreach ($imgs as $k => $img) {
                    $content = str_replace($img, '<img src="' . $imgs[1][$k] . '" />', $content);
                }
            }
        } else {
            Tool::getInstance()->fail_json(Code::UNDEFINED_ACTION, Tool::getInstance()->lang('undefined action'));
        }

        $content = preg_replace("/\[attach]\d+\[\/attach]/i", '', $content);
        $data = array(
            'thread_id' => $tid,
            'content' => $content
        );

        Tool::getInstance()->success_json($data);
    }

    // 马甲主题帖统计
    public function actionTotalthread()
    {

        global $_G;
        // 马甲用户uid  string  1,2,3
        $uids = WebHelper::getPost('uids', '');
        $uids = explode(',', $uids);
        // 搜索开始时间   时间戳（）
        $starttime = WebHelper::getPost('starttime', 0);
        // 搜索结束时间时间   时间戳 （默认当前时间）
        $endtime = WebHelper::getPost('endtime', 0);

        if (count($uids) > 100) {
            Tool::getInstance()->fail_json(Code::REQUEST_IS_LARGE, Tool::getInstance()->lang('request_is_large'));
        }
        if (empty($uids) || empty($starttime)) {
            Tool::getInstance()->fail_json(Code::UNDEFINED_ACTION, Tool::getInstance()->lang('undefined action'));
        }
        $data = array();
        $sqlWhere = ForumThread::fetchThreadWhere(0, 0, $uids, '', $starttime, $endtime, 0);
        $threadList = DB::fetch_all('SELECT * FROM ' . DB::table('forum_thread') . $sqlWhere[0], $sqlWhere[1]);

        // 楼中楼马甲回复数量
        $tids = Tool::Array_Column($threadList, 'tid');
        $floorTable = DB::result_first("SHOW TABLES LIKE '%t'", array(ReplyFloor::$table));
        if (!empty($floorTable)) {
            $floorNum = DB::fetch_all('SELECT tid,SUM(approve_num) as num FROM %t WHERE tid in (%n) group by tid', array('qianfan_post_floor_stats', $tids), 'tid');
        }
        foreach ($threadList as $thread) {
            if (in_array($thread['authorid'], $uids)) {

                // 回贴量/浏览量/点赞量(发帖)
                $data[$thread['authorid']][$thread['tid']]['fid'] = $thread['fid'];
                $data[$thread['authorid']][$thread['tid']]['tid'] = $thread['tid'];
                $data[$thread['authorid']][$thread['tid']]['author'] = $thread['author'];
                $data[$thread['authorid']][$thread['tid']]['authorid'] = $thread['authorid'];
                $data[$thread['authorid']][$thread['tid']]['subject'] = $thread['subject'];
                $data[$thread['authorid']][$thread['tid']]['dateline'] = date('Y-m-d H:i:s', $thread['dateline']);

                $floor_num = isset($floorNum[$thread['tid']]['num']) ? $floorNum[$thread['tid']]['num'] : 0;
                $data[$thread['authorid']][$thread['tid']]['replys'] = $thread['replies'] + $floor_num;
                $data[$thread['authorid']][$thread['tid']]['views'] = $thread['views'];
                $data[$thread['authorid']][$thread['tid']]['pings'] = $thread['recommend_add'];
            }
        }

        Tool::getInstance()->success_json($data);
    }

    public function actionCountthread()
    {

        global $_G;
        // 马甲用户uid  string  1,2,3
        $uids = WebHelper::getPost('uids', 0);
        $uids = empty($uids) ? 0 : explode(',', $uids);// uids=0  全网

        // 默认0 运营助手   type=1 搜索 type=2 根据时间获取主题/评论点赞数
        $type = WebHelper::getPost('type', 0);
        // 搜索开始时间   时间戳（）
        $starttime = WebHelper::getPost('starttime', 0);
        // 搜索结束时间时间   时间戳 （默认当前时间）
        $endtime = WebHelper::getPost('endtime', 0);
        $stats = ReplyFloor::STATUS_APPROVE;//只统计通过的

        $data = array();
        if (empty($starttime) && empty($type)) {
            Tool::getInstance()->fail_json(Code::UNDEFINED_ACTION, Tool::getInstance()->lang('undefined action'));
        }

        if ($endtime) {
            $threadWhere = ' AND dateline<%d ';
            $replyWhere = ' AND dateline<%d AND first=0';
        } else {
            $threadWhere = '';
            $replyWhere = ' AND first=0';
        }

        // 评论分表情况
        loadcache('posttableids');
        $posttableids = $_G['cache']['posttableids'] ? $_G['cache']['posttableids'] : array(0);

        $floorTable = DB::result_first("SHOW TABLES LIKE '%t'", array(ReplyFloor::$table));
        // 运营助手
        if ($type == 0 && $starttime) {
            if (!empty($uids)) {
                // 马甲发帖量  回帖量
                $authorid = is_array($uids) && $uids ? 'authorid IN(%n)' : 'authorid=%d';
                $thread = DB::fetch_all('SELECT authorid,count(*) as user_thread FROM %t WHERE displayorder <> -4 AND ' . $authorid . ' AND dateline>=%d ' . $threadWhere . ' group by authorid',
                    array('forum_thread', $uids, $starttime, $endtime), 'authorid');

                $posts = array();
                foreach ($posttableids as $tableid) {
                    $user_reply = DB::fetch_all('SELECT authorid,count(*) as user_reply FROM %t WHERE ' . $authorid . ' AND dateline>=%d' . $replyWhere . ' group by authorid',
                        array(getposttable($tableid), $uids, $starttime, $endtime), 'authorid');

                    foreach ($uids as $v) {
                        $posts[$v]['user_reply'] = empty($posts[$v]['user_reply']) ? 0 + $user_reply[$v]['user_reply'] : $user_reply[$v]['user_reply'] + $posts[$v]['user_reply'];
                    }
                }

                // 楼中楼马甲回复数量
                $floorNum = array();
                if (!empty($floorTable)) {
                    $floorNum = DB::fetch_all('SELECT authorid,count(*) as num FROM %t WHERE ' . $authorid . ' AND status=%d AND created_at>=%d AND created_at<%d group by authorid',
                        array('qianfan_post_floor', $uids, $stats, $starttime, $endtime), 'authorid');
                }
                foreach ($uids as $v) {
                    $floor_num = isset($floorNum[$v]['num']) ? $floorNum[$v]['num'] : 0;
                    $data[$v]['user_thread'] = empty($thread[$v]['user_thread']) ? 0 : $thread[$v]['user_thread'];
                    $data[$v]['user_reply'] = $posts[$v]['user_reply'] + $floor_num;
                }

            } else {
                // 全网总量  发帖数  回帖数
                $threads = DB::result_first('SELECT count(*) FROM %t WHERE displayorder <> -4 AND dateline>=%d ' . $threadWhere,
                    array('forum_thread', $starttime, $endtime));

                $replys = 0;
                foreach ($posttableids as $tableid) {
                    $posts = DB::result_first('SELECT count(*) FROM %t WHERE dateline>=%d' . $replyWhere, array(getposttable($tableid), $starttime, $endtime));
                    $replys = $replys + $posts;
                }

                // 楼中楼马甲总数量
                $floorNum = 0;
                if (!empty($floorTable)) {
                    $floorNum = DB::result_first('SELECT count(*) FROM %t WHERE status=%d AND created_at>=%d AND created_at<%d', array('qianfan_post_floor', $stats, $starttime, $endtime));
                }
                $data['threads'] = empty($threads) ? 0 : $threads;
                $data['posts'] = (empty($replys) ? 0 : $replys) + (int)$floorNum;
            }
        }

        // 超级搜索 根据时间获取帖子数
        if ($type == 1) {
            $param = array('forum_thread');
            $start = '';
            if ($starttime) {
                $start = ' AND dateline>=%d';
                $param[] = $starttime;
            }

            if ($endtime)
                $param[] = $endtime;

            $threads = DB::result_first('SELECT count(*) FROM %t WHERE displayorder>=0' . $start . $threadWhere,
                $param);
            $data['threads'] = empty($threads) ? 0 : $threads;
        }

        // 根据时间获取主题/评论点赞数
        if ($type == 2 && $starttime) {
            if (!$endtime) {
                $endtime = time();
            }
            $data['thread_pings'] = DB::result_first("SELECT count(*) FROM %t WHERE dateline>=%d AND dateline<%d",
                array('forum_memberrecommend', $starttime, $endtime));
            $data['reply_pings'] = 0;
        }

        Tool::getInstance()->success_json($data);
    }


    // 获取多个帖子数据
    public function actionGetThreadsData()
    {
        global $_G;
        $tids = WebHelper::getPost('tids', '');
        $post_ids = WebHelper::getPost('post_ids', '');

        $pidAry = array();
        $post_ids = json_decode($post_ids, true);
        if (is_array($post_ids) && !empty($post_ids)) {
            $tidAry = Tool::Array_Column($post_ids, 'tid');
            $pidAry = Tool::Array_Column($post_ids, 'pid');
        } else {
            if (!preg_match('/[0-9,]+/', $tids)) {
                Tool::getInstance()->fail_json(Code::ILLEGAL_REQUEST, Tool::getInstance()->lang('illegal_request'));
            }
            $tidAry = explode(",", $tids);
        }

        // 一次至多获取100条帖子
        if (count($tidAry) >= 100) {
            Tool::getInstance()->fail_json(Code::ILLEGAL_REQUEST, Tool::getInstance()->lang('illegal_request'));
        }

        $data = array();
        if (!empty($tidAry)) {
            $threads = C::t("forum_thread")->fetch_all_by_tid($tidAry);

            loadcache('posttableids');
            $postList = array();
            $postArr = array();
            $postTableids = $_G['cache']['posttableids'] ? $_G['cache']['posttableids'] : array(0);
            foreach ($postTableids as $posttableid => $tableid) {
                $postTmp = C::t('forum_post')->fetch_all_by_tid($tableid, $tidAry, true, '', 0, 0, 1);
                $postList = array_merge($postList, $postTmp);
            }
            if ($postList) {
                foreach ($postList as $post) {
                    $postArr[$post['tid']] = $post;
                }
            }

            // 当前用户是否点赞
            $pingTids = array();
            if ($_G['uid']) {
                $pingArr = DB::fetch_all('SELECT * FROM %t WHERE recommenduid=%d AND tid IN (%n)', array('forum_memberrecommend', $_G['uid'], $tidAry));
                $pingTids = Tool::Array_Column($pingArr, 'tid');
            }

            // 当前登录用户是否收藏帖子
            $favTids = array();
            if ($_G['uid']) {
                $favArr = DB::fetch_all('SELECT * FROM ' . DB::table('home_favorite') . ' WHERE idtype=%s AND uid=%d AND id IN (%n)', array('tid', $_G['uid'], $tidAry));
                $favTids = Tool::Array_Column($favArr, 'id');
            }

            // 楼中楼评论数量
            $FloorRepies = array();
            $floorTable = DB::result_first("SHOW TABLES LIKE '%t'", array(ReplyFloor::$table));
            if (!empty($floorTable)) {
                $threadFloorRepies = DB::fetch_all("SELECT SUM(approve_num) as num,tid FROM %t WHERE tid IN (%n) group by tid",
                    array('qianfan_post_floor_stats', $tidAry));
                $FloorRepies = Tool::Array_Column($threadFloorRepies, 'num', 'tid');
            }

            if (!empty($threads)) {
                // 回复点赞量 pid为0的情况不查点赞数
                if (!empty($pidAry) && !in_array(0, $pidAry)) {
                    $pid_pings = DB::fetch_all("SELECT total,pid,tid FROM %t WHERE pid IN (%n)",
                        array('forum_hotreply_number', $pidAry), 'tid');
                }

                // 主题附件
                $attachs = ForumThread::getAllAttaches($postList, $threads);

                // 阅读量
                if ($_G['setting']['optimizeviews']) {
                    $threadsoptimize = DB::fetch_all("SELECT * FROM %t WHERE tid in (%n)", array
                    ("forum_threadaddviews", $tidAry));
                }

                foreach ($threads as $key => $thread) {
                    $d = array();
                    $d['tid'] = (int)$thread['tid'];
                    $d['subject'] = $thread['subject'];
                    $d['authorid'] = (int)$thread['authorid'];
                    $d['author'] = $thread['author'];
                    $d['fid'] = (int)$thread['fid'];
                    $d['postdate'] = (int)$thread['dateline'];
                    $d['special'] = (int)$thread['special'];
                    $d['ping_num'] = (int)$thread['recommend_add'];
                    $d['view_num'] = (int)$thread['views'];
                    $d['reply_num'] = (int)$thread['replies'];
                    $d['fav_num'] = (int)$thread['favtimes'];
                    $d['is_ping'] = (bool)in_array($thread['tid'], $pingTids);
                    $d['is_favor'] = (bool)in_array($thread['tid'], $favTids);
                    $d['displayorder'] = (int)$thread['displayorder'];
                    $d['anonymous'] = isset($postArr[$thread['tid']]) ? (int)$postArr[$thread['tid']]['anonymous'] : 0;
                    $d['pid_pings'] = isset($pid_pings[$thread['tid']]) ? (int)$pid_pings[$thread['tid']]['total'] : 0;
                    $d['attach'] = array();

                    if (!empty($threadsoptimize)) {
                        foreach ($threadsoptimize as $k => $v) {
                            if ($v['tid'] == $thread['tid'] && $v['addviews']) {
                                $d['views_num'] += $v['addviews'];
                            }
                        }
                    }
                    $d['totalReplies'] = $thread['replies'];
                    if (isset($FloorRepies[$thread['tid']])) {
                        $d['totalReplies'] = (int)($thread['replies'] + $FloorRepies[$thread['tid']]);
                    }
                    if ($thread['attachment'] == 2 || $thread['attachment'] == 1) {
                        if (isset($attachs[$thread['tid']]) && is_array($attachs[$thread['tid']]) && !empty($attachs[$thread['tid']])) {
                            $d['attach'] = $attachs[$thread['tid']];
                        }
                    }
                    $data[] = $d;
                }
            }
        }
        Tool::getInstance()->success_json($data);
    }

    // 获取帖子数据,取出图片，视频
    public function actionGetThreadsDetail()
    {
        global $_G;
        require_once(libfile('function/forum'));
        $type = WebHelper::getPost('type', 1);// 1 主题帖 2 评论
        $operation = WebHelper::getPost('operation', 1);// 1只获取总数  2获取具体信息
        $starttime = WebHelper::getPost('starttime', 0);
        $endtime = WebHelper::getPost('endtime', 0);
        $lastpid = WebHelper::getPost('lastpid', 0);
        $offset = WebHelper::getPost('offset', 0);
        $limit = WebHelper::getPost('limit', 100);

        $result = array(
            'thread_total' => 0,
            'reply_total' => 0,
            'img_num' => 0,
            'video_num' => 0,
            'lastpid' => 0,// 最后pid
            'list' => array(),
        );

        // 评论分表情况
        loadcache('posttableids');
        $posttableids = $_G['cache']['posttableids'] ? $_G['cache']['posttableids'] : array(0);
        if ($operation == 1 && $starttime && $endtime) {
            if (!empty($type)) {
                if ($type == 1) {
                    // 主题帖数量
                    $num = DB::result_first("SELECT COUNT(*) FROM %t WHERE displayorder in (0,1,2,3,-2) AND dateline>=%d AND dateline<%d",
                        array('forum_thread', $starttime, $endtime));
                    $result['thread_total'] = $num;

                    // 图片数量
                    foreach ($posttableids as $tableid) {
                        $result['img_num'] = $result['img_num'] + DB::result_first('SELECT COUNT(*) FROM %t p RIGHT JOIN %t a on a.pid=p.pid 
                        WHERE p.invisible in (0,-2) AND p.dateline>=%d AND p.dateline<%d AND p.first = 1',
                                array(getposttable($tableid), 'forum_attachment', $starttime, $endtime));
                    }
                }
                if ($type == 2) {
                    // 评论数量
                    foreach ($posttableids as $tableid) {
                        $num = DB::result_first("SELECT COUNT(*) FROM %t WHERE invisible in (0,-2) AND dateline>=%d AND dateline<%d AND first = 0",
                            array(getposttable($tableid), $starttime, $endtime));
                        $result['reply_total'] = $result['reply_total'] + $num;
                        // 图片数量
                        $result['img_num'] = $result['img_num'] + DB::result_first('SELECT COUNT(*) FROM %t p RIGHT JOIN %t a on a.pid=p.pid 
                        WHERE p.invisible in (0,-2) AND p.dateline>=%d AND p.dateline<%d AND p.first = 0',
                                array(getposttable($tableid), 'forum_attachment', $starttime, $endtime));
                    }
                }
            } else {
                Tool::getInstance()->fail_json(Code::UNDEFINED_ACTION, Tool::getInstance()->lang('undefined action'));
            }

        } elseif ($operation == 2 && $starttime && $endtime) {

            // $type 不为空返回帖子标题内容 图片视频
            if (!empty($type)) {
                if ($type == 1) {
                    // 主题帖
                    $threadlist = DB::fetch_all("SELECT tid FROM %t WHERE displayorder in (0,1,2,3,-2) AND dateline>=%d AND dateline<%d LIMIT %d,%d",
                        array('forum_thread', $starttime, $endtime, $offset, $limit));
                    $tids = Tool::Array_Column($threadlist, 'tid');
                    $tids = array_values(array_diff($tids, array(0)));

                    $post_info = array();
                    if (!empty($tids)) {
                        foreach ($posttableids as $id) {
                            $posts = DB::fetch_all("SELECT pid,tid,authorid,author,subject,message,attachment,dateline FROM %t WHERE tid in (%n) AND first = 1",
                                array(getposttable($id), $tids), 'tid');
                            $post_info = array_merge($post_info, $posts);
                        }
                    }
                    // 图片附件
                    $attachs = ForumThread::getAllAttaches($post_info, $threadlist);
                }
                if ($type == 2) {
                    // 评论
                    $order = 'ORDER BY dateline ASC';
                    $post_info = array();

                    foreach ($posttableids as $k => $id) {
                        $posts = DB::fetch_all("SELECT pid,tid,authorid,author,subject,message,attachment,dateline FROM %t WHERE invisible in (0,-2) AND pid>%d AND dateline>=%d AND dateline<%d AND first = 0 "
                            . $order . DB::limit(0, $limit), array(getposttable($id), $lastpid, $starttime, $endtime));
                        // 合并数据
                        if (!empty($posts)) {
                            $post_info = array_merge($post_info, $posts);
                        }
                    }
                    // 排序取出 limit条
                    if (count($posttableids) > 1 && !empty($post_info)) {
                        $pid = Tool::Array_Column($post_info, 'pid');
                        array_multisort($pid, SORT_ASC, $post_info);
                        $post_info = array_slice($post_info, 0, $limit);
                    }

                    // 图片附件
                    $tidArr = array_unique(Tool::Array_Column($post_info, 'tid'));
                    $threadlist = DB::fetch_all("SELECT tid FROM %t WHERE tid in(%n) AND displayorder in (0,1,2,3,-2) AND dateline>=%d AND dateline<%d",
                        array('forum_thread', $tidArr, $starttime, $endtime));
                    $attachs = ForumThread::getAllAttaches($post_info, $threadlist, 1);
                }

                if (!empty($post_info)) {
                    $lastpid = end($post_info);
                    $result['lastpid'] = $lastpid['pid'];
                    foreach ($post_info as $v) {
                        $list['pid'] = $v['pid'];
                        $list['tid'] = $v['tid'];
                        $list['authorid'] = $v['authorid'];
                        $list['author'] = $v['author'];
                        $list['subject'] = $v['subject'];
                        $list['message'] = $v['message'];
                        $list['attach'] = array();
                        $list['video'] = array();
                        $list['img_num'] = 0;
                        $list['video_num'] = 0;
                        $list['dateline'] = $v['dateline'];

                        //获取主题附件
                        if ($type == 1) {
                            if ($v['attachment'] == 2 || $v['attachment'] == 1) {
                                if (isset($attachs[$v['tid']]) && is_array($attachs[$v['tid']]) && !empty($attachs[$v['tid']])) {
                                    $list['attach'] = $attachs[$v['tid']];
                                    $list['img_num'] = $list['img_num'] + count($attachs[$v['tid']]);
                                }
                            }
                        } else {// 回复
                            if ($v['attachment'] == 2 || $v['attachment'] == 1) {
                                if (isset($attachs[$v['pid']]) && is_array($attachs[$v['pid']]) && !empty($attachs[$v['pid']])) {
                                    $list['attach'] = $attachs[$v['pid']];
                                    $list['img_num'] = $list['img_num'] + count($attachs[$v['pid']]);
                                }
                            }
                        }
                        $list['attach'] = array_unique($list['attach']);
                        $result['list'][] = $list;
                    }
                }

            } else {
                Tool::getInstance()->fail_json(Code::UNDEFINED_ACTION, Tool::getInstance()->lang('undefined action'));
            }
        } else {
            Tool::getInstance()->fail_json(Code::UNDEFINED_ACTION, Tool::getInstance()->lang('undefined action'));
        }
        Tool::getInstance()->success_json($result);
    }

    // 马甲预约回复根据pid获取回帖作者uid
    public function actionGetPostInfos()
    {
        global $_G;
        require_once(libfile('function/forum'));
        $tids = WebHelper::getPost('tids', 0);
        // 验证参数的合法性
        if (!preg_match('/^[0-9,]+$/', $tids)) {
            Tool::getInstance()->fail_json(Code::UNDEFINED_ACTION, Tool::getInstance()->lang('undefined action'));
        }

        $tidAry = explode(',', $tids);

        // 一次至多获取100条帖子基本信息，否则视为攻击
        if (count($tidAry) >= 100) {
            Tool::getInstance()->fail_json(Code::REQUEST_IS_LARGE, Tool::getInstance()->lang('request_is_large'));
        }
        $result = array(
            'author_id' => array(),// 主题作者id
            'reply_id' => array(),// 被回复作者id
            'position_id' => array()// 所有回复作者ID
        );
        loadcache('posttableids');
        $posttableids = $_G['cache']['posttableids'] ? $_G['cache']['posttableids'] : array(0);
        if (!empty($tidAry)) {
            // 主题帖和所有评论
            $post_info = array();
            foreach ($posttableids as $id) {
                $info = DB::fetch_all("SELECT pid,fid,tid,authorid,author,first FROM %t WHERE tid in (%n) AND invisible=0",
                    array(getposttable($id), $tidAry), 'pid');
                if (!empty($info)) {
                    $post_info = $post_info + $info;
                }
            }

            if (!empty($post_info)) {
                foreach ($post_info as $key => $v) {
                    $d = array();
                    $d['tid'] = $v['tid'];
                    $d['author'] = $v['author'];
                    $d['pid'] = $v['pid'];
                    $d['fid'] = $v['fid'];
                    $d['authorid'] = $v['authorid'];
                    // $d['first'] = $v['first'];
                    if ($v['first'] == 1) {
                        $result['author_id'][$v['tid']] = $d;
                    } else {
                        $result['position_id'][$v['tid']][] = $d;
                    }
                }
            }
        } else {
            Tool::getInstance()->fail_json(Code::UNDEFINED_ACTION, Tool::getInstance()->lang('undefined action'));
        }
        Tool::getInstance()->success_json($result);
    }


    public function qfThread($authorid)
    {
        global $_G;

        if (!empty($_G['cache']['plugin']['qfthread']['isopen'])) {
            $whiteuids = array();
            if (!empty($_G['cache']['plugin']['qfthread']['whiteuids'])) {
                $whiteuids = explode(',', $_G['cache']['plugin']['qfthread']['whiteuids']);
            }
            $whitetids = array();
            if (!empty($_G['cache']['plugin']['qfthread']['whitetids'])) {
                $whitetids = explode(',', $_G['cache']['plugin']['qfthread']['whitetids']);
            }
            $whitetauthorids = array();
            if (!empty($_G['cache']['plugin']['qfthread']['authorids'])) {
                $whitetauthorids = explode(',', $_G['cache']['plugin']['qfthread']['authorids']);
            }

            if (in_array($_G['uid'], $whiteuids) || in_array($_G['tid'], $whitetids) || in_array($authorid, $whitetauthorids)) {
                return true;
            }

            if (!empty($_G['cache']['plugin']['qfthread']['enableauthor']) && $_G['uid'] && $_G['uid'] == $authorid) {
                return true;
            }

            $limitFids = (array)unserialize($_G['cache']['plugin']['qfthread']['forums']);
            $limitFids = array_values(array_filter($limitFids));

            $limitGroups = (array)unserialize($_G['cache']['plugin']['qfthread']['groups']);
            $limitGroups = array_values(array_filter($limitGroups));


            if ((in_array($_G['fid'], $limitFids)) && (in_array($_G['groupid'], $limitGroups))) {
                if (!empty($_G['cache']['plugin']['qfthread']['bantime'])) {
                    if ($_G['thread']['dateline'] <= strtotime($_G['cache']['plugin']['qfthread']['bantime'])) {
                        return false;
                    }
                }

                if (!empty($_G['cache']['plugin']['qfthread']['limitdays'])) {
                    $limitTime = time() - 3600 * 24 * (int)$_G['cache']['plugin']['qfthread']['limitdays'];
                    if (!empty($_G['thread'])) {
                        if ($_G['thread']['dateline'] <= $limitTime) {
                            return false;
                        }
                    }
                }
            }
        }
        return true;
    }

    // 帖子详情回复
    public function actionThreadInner()
    {
        global $_G;

        $tid = WebHelper::getPost('tid', 0);
        $pids = WebHelper::getPost('pids', 0);
        $order_type = WebHelper::getPost('order_type', 0); // 0按时间正序  1按时间倒序 2点赞正序 3点赞倒序

        $_G['tid'] = $tid;
        if (!function_exists('loadforum')) {
            require_once(libfile('function/forum'));
        }
        loadforum();

        //是否仅作者可见
        $isOnlyAuthorTopic = getstatus($_G['forum_thread']['status'], 2) == 1 ? 1 : 0;
        if ($isOnlyAuthorTopic && $_G['uid'] != $_G['forum_thread']['authorid'] && !$_G['forum']['ismoderator']) {
            Tool::getInstance()->success_json(array());
        }
        // query sql
        if ($tid) {
            $sqlWhere[] = DB::field('tid', $tid);
        }
        $pidArr = explode(',', $pids);
        if ($pidArr) {
            $sqlWhere[] = DB::field('pid', $pidArr, 'in');
        }
        $sqlWhere[] = DB::field('status', 1);
        if ($order_type == 1) {
            $order = ' ORDER BY id DESC ';
        } elseif ($order_type == 2) {
            $order = ' ORDER BY ping_num ASC, created_at ASC ';
        } elseif ($order_type == 3) {
            $order = ' ORDER BY ping_num DESC, created_at ASC ';
        } else {
            $order = ' ORDER BY id ASC ';
        }
        $floors = ReplyFloor::fetchAllByWhere($sqlWhere, $order, 0, 2000);

        $res = array();
        $floorArr = array();
        $commentArr = array();
        foreach ($floors as $list) {
            $floorArr[$list['id']] = ReplyFloor::formatSingleRes($list);
        }

        foreach ($floors as $list) {
            $data = ReplyFloor::formatSingleRes($list, true);
            if ($list['parent_id']) {
                $data['parent'] = $floorArr[$list['parent_id']];
            }
            $commentArr[$list['pid']][] = $data;

            unset($data);
        }

        foreach ($pidArr as $pid) {
            $commentSlice = array();
            if (isset($commentArr[$pid])) {
                $commentSlice = array_slice($commentArr[$pid], 0, 5);
            }
            $res[] = array(
                'pid' => $pid,
                'comments' => $commentSlice,
            );
        }

        Tool::getInstance()->success_json($res);
    }

    // 帖子的一级评论的楼中楼回复数量
    public function actionThreadInnerNum()
    {
        $tid = WebHelper::getPost('tid', 0);
        $pids = WebHelper::getPost('pids', '');
        $pidArr = explode(',', $pids);

        $res = array();
        $floorNumArr = DB::fetch_all("SELECT pid,approve_num as num FROM %t WHERE tid=%d and pid IN (%n)",
            array('qianfan_post_floor_stats', $tid, $pidArr)
        );

        foreach ($floorNumArr as $v) {
            $res[$v['pid']] = $v['num'];
        }

        Tool::getInstance()->success_json($res);
    }


    // 楼中楼详情页面
    public function actionReplyInner()
    {
        global $_G;

        require_once(libfile('function/forum'));

        $tid = WebHelper::getPost('tid', 0);
        $pid = WebHelper::getPost('pid', 0);
        $floor_id = WebHelper::getPost('floor_id', 0);
        $skip = WebHelper::getPost('skip', 0);
        $limit = WebHelper::getPost('limit', 10);
        $order_type = WebHelper::getPost('order_type', 0); // 0按时间正序  1按时间倒序 2点赞正序 3点赞倒序

        $res = array(
            'reply' => array(),
            'list' => array()
        );

        $reply = DB::fetch_first("SELECT * FROM %t WHERE tid = %d AND `first` != %d AND pid= %d LIMIT 1",
            array(C::t('forum_post')->get_tablename('tid:' . $tid), $tid, 1, $pid));
        $thread = C::t("forum_thread")->fetch($tid);

        //兼容app访问使用网页端的模板,解决楼中楼详情图片无法访问问题
        if (defined('IN_MOBILE')) {
            $tempMobileTpl = $_G['mobiletpl'][IN_MOBILE];
            if (!defined('TPL_DEFAULT')) {
                define('TPL_DEFAULT', true);
            }
            $_G['mobiletpl'][IN_MOBILE] = '';
        }

        $parentArr = array();
        if ($reply && $thread) {
            // 版块权限
            $_GET['tid'] = $tid;
            $_GET['fid'] = $reply['fid'];

            if (!function_exists('loadforum')) {
                require_once(libfile('function/forum'));
            }
            loadforum();

            $support = C::t('forum_hotreply_number')->fetch_by_pid($pid);
            $supportNum = isset($support['support']) ? $support['support'] : 0;
            $isSupport = (int)DB::result_first("SELECT pid FROM %t WHERE uid=%d AND pid IN (%n)", array('forum_hotreply_member', $_G['uid'], $pid));
            $content = ForumThread::parsePostMessage($reply, 1);

            // query sql
            $sqlWhere = array();
            if ($floor_id) {
                $sqlWhere[] = DB::field('id', $floor_id);
            }
            if ($tid) {
                $sqlWhere[] = DB::field('tid', $tid);
            }
            if ($pid) {
                $sqlWhere[] = DB::field('pid', $pid);
            }
            $sqlWhere[] = DB::field('status', 1);
            if ($order_type == 1) {
                $order = ' ORDER BY id DESC ';
            } elseif ($order_type == 2) {
                $order = ' ORDER BY ping_num ASC, created_at ASC ';
            } elseif ($order_type == 3) {
                $order = ' ORDER BY ping_num DESC, created_at ASC ';
            } else {
                $order = ' ORDER BY id ASC ';
            }

            $floors = ReplyFloor::fetchAllByWhere($sqlWhere, $order, $skip, $limit);
            $floorNum = ReplyFloor::fetchCountByWhere($sqlWhere);

            $res['reply'] = array(
                'pid' => $reply['pid'],
                'anonymous' => $reply['anonymous'],
                'userip' => (string)$reply['useip'],
                'title' => $thread['subject'],
                'closed' => $thread['closed'],
                'authorid' => $reply['authorid'],
                'author' => $reply['anonymous'] ? '' : $reply['author'],
                'icon' => discuz_uc_avatar($reply['authorid'], 'big', true),
                'inner_replies' => (int)$floorNum,
                'content' => $content,
                'is_support' => $isSupport ? 1 : 0,
                'support_num' => (int)$supportNum,
                'postdate' => is_numeric($reply['dbdateline']) ? $reply['dbdateline'] : strtotime($reply['dbdateline']),
            );

            // parent
            $parentIds = Tool::Array_Column($floors, 'parent_id');
            $parentIds = array_values(array_unique(array_filter($parentIds)));
            if ($parentIds) {
                $parentSqlWhere = array();
                $parentSqlWhere[] = DB::field('id', $parentIds, 'in');
                $parentSqlWhere[] = DB::field('status', 1);
                $parents = ReplyFloor::fetchAllByWhere($parentSqlWhere);
                foreach ($parents as $v) {
                    $parentArr[$v['id']] = $v;
                }
            }

            // 是否点赞
            $pings = array();
            if (DB::result_first("SHOW TABLES LIKE '%t'", array('qianfan_post_floor_comment'))) {
                $Ids = Tool::Array_Column($floors, 'id');
                $pings = DB::fetch_all("SELECT floor_id FROM %t WHERE uid=%d AND floor_id IN (%n)", array('qianfan_post_floor_comment', $_G['uid'], $Ids), 'floor_id');
            }

            foreach ($floors as $list) {
                $data = ReplyFloor::formatSingleRes($list, true);
                if ($list['parent_id'] && !empty($parentArr[$list['parent_id']])) {
                    $data['parent'] = ReplyFloor::formatSingleRes($parentArr[$list['parent_id']]);
                }
                $data['is_support'] = 0;
                if (isset($pings[$list['id']]) && $pings[$list['id']]) {
                    $data['is_support'] = empty($pings[$list['id']]) ? 0 : 1;
                }
                $res['list'][] = $data;
                unset($data);
            }
        }

        Tool::getInstance()->success_json($res);
    }

    // 楼中楼审核列表
    public function actionReviewReplyFloorList()
    {
        global $_G;
        require_once libfile('function/discuzcode');

        $floor_id = WebHelper::getPost('floor_id', 0);
        $tid = (int)WebHelper::getPost('tid', 0);
        $fid = (int)WebHelper::getPost('fid', 0);
        $authorid = (int)WebHelper::getPost('authorid', 0);
        $status = WebHelper::getPost('status', null);
        $content = WebHelper::getPost('content', 0);
        $offset = WebHelper::getPost('offset', 0);
        $limit = WebHelper::getPost('limit', 20);
        $startAt = WebHelper::getPost('start_at', 0);
        $endAt = WebHelper::getPost('end_at', 0);

        $sqlWhere = array();
        $threads = array();
        $result = array(
            'post' => array(),
            'img_num' => 0,
            'count' => 0
        );
        $floorIdArr = $floor_id ? explode(',', $floor_id) : array();

        if (!empty($floorIdArr)) {
            $sqlWhere[] = DB::field('id', $floorIdArr, 'in');
        }
        if ($fid) {
            $sqlWhere[] = DB::field('fid', $fid);
        }
        if ($authorid) {
            $sqlWhere[] = DB::field('authorid', $authorid);
        }
        if ($tid) {
            $sqlWhere[] = DB::field('tid', $tid);
        }
        if ($startAt) {
            $sqlWhere[] = DB::field('created_at', $startAt, '>=');
        }
        if ($endAt) {
            $sqlWhere[] = DB::field('created_at', $endAt, '<=');
        }
        if ($content) {
            $sqlWhere[] = DB::field('message', '%' . $content . '%', 'like');
        }
        if (isset($status) && in_array($status, array(0, 1, 2, 3))) {
            $sqlWhere[] = DB::field('status', $status);
        }

        $order = ' ORDER BY id DESC ';
        $floors = ReplyFloor::fetchAllByWhere($sqlWhere, $order, $offset, $limit);
        if ($floors) {
            $result['count'] = ReplyFloor::fetchCountByWhere($sqlWhere);
            $result['img_num'] = ReplyFloor::countImgNumByWhere($sqlWhere);
            $tidArr = Tool::Array_Column($floors, 'tid');
            $threads = C::t("forum_thread")->fetch_all_by_tid($tidArr);
        }

        foreach ($floors as $floor) {
            $result['post'][] = array(
                'id' => $floor['id'],
                'pid' => $floor['pid'],
                'tid' => $floor['tid'],
                'anonymous' => $floor['anonymous'],
                'uid' => $floor['authorid'],
                'username' => $floor['author'],
                'content' => ForumThread::getSmilesImg($floor['message']),
                'if_check' => $floor['status'],
                'created_at' => $floor['created_at'],
                'authorid' => $floor['authorid'],
                'ip' => $floor['useip'],
                'fid' => $floor['fid'],
                'title' => isset($threads[$floor['tid']]) ? $threads[$floor['tid']]['subject'] : '',
                'closed' => isset($threads[$floor['tid']]) ? $threads[$floor['tid']]['closed'] : 0,
                'ping_num' => isset($floor['ping_num']) ? $floor['ping_num'] : 0,
            );
        }

        Tool::getInstance()->success_json($result);
    }

    public function actionVerifyReplyFloor()
    {
        global $_G;

        $floor_id = (string)WebHelper::getPost('floor_id', '');
        $qianfan_admin = (int)WebHelper::getPost('qianfan_admin', 0);
        $operation = WebHelper::getPost('operation', ''); //操作 validate 通过审核 delete 删除 ignore 忽略
        $floorIdArr = explode(',', $floor_id);

        // 权限验证
        if (!$qianfan_admin) {
            if (empty($_G['uid']) || empty($_G['group']['radminid']) || !in_array($_G['group']['radminid'], array(1, 2, 3))) {
                Tool::getInstance()->fail_json(Code::NO_PERMISSION, Tool::getInstance()->lang('illegal operation'));
            }
        }

        $status = 0;
        if ($operation == 'validate') {
            $status = ReplyFloor::STATUS_APPROVE;
        } elseif ($operation == 'delete') {
            $status = ReplyFloor::STATUS_DELETE;
        } elseif ($operation == 'ignore') {
            $status = ReplyFloor::STATUS_REJECT;
        } else {
            Tool::getInstance()->fail_json(Code::UNDEFINED_ACTION, Tool::getInstance()->lang('undefined action'));
        }
        $floorArr = ReplyFloor::fetchByIds($floorIdArr);
        if (!$floorArr) {
            Tool::getInstance()->fail_json(Code::UNDEFINED_ACTION, Tool::getInstance()->lang('undefined action'));
        }

        foreach ($floorArr as $floor) {
            $oldStatus = $floor['status'];
            DB::update(ReplyFloor::$table, array('status' => $status), 'id=' . $floor['id']);
            // 更新数量
            if ($oldStatus == ReplyFloor::STATUS_APPROVE) {
                if ($status != ReplyFloor::STATUS_APPROVE) {
                    $sql = "`approve_num`=`approve_num`-'1'";
                    DB::query('UPDATE %t SET ' . $sql . ' WHERE tid=%d and pid=%d', array('qianfan_post_floor_stats', $floor['tid'], $floor['pid']));
                }
            } else {
                if ($status == ReplyFloor::STATUS_APPROVE) {
                    $sql = "`approve_num`=`approve_num`+'1'";
                    DB::query('UPDATE %t SET ' . $sql . ' WHERE tid=%d and pid=%d', array('qianfan_post_floor_stats', $floor['tid'], $floor['pid']));
                }
            }
        }

        Tool::getInstance()->success_json(array());
    }

    public function actionChangeThreadViews()
    {
        $tid = (int)WebHelper::getPost('tid', 0);
        $newViews = (int)WebHelper::getPost('views', 0);
        $newPings = (int)WebHelper::getPost('pings', 0);
        if (!$tid) {
            Tool::getInstance()->fail_json(Code::UNDEFINED_ACTION, Tool::getInstance()->lang('undefined action'));
        }
        $topic = C::t('forum_thread')->fetch_by_tid_displayorder($tid);
        if (empty($topic)) {
            Tool::getInstance()->fail_json(Code::THREAD_NOT_EXISTS, Tool::getInstance()->lang('thread not exists'));
        }

        if ($newViews) {
            Yii::log(var_export(sprintf('change-thread-view tid:%d before-views:%d after-views:%d', $tid, $topic['views'], $newViews), true));
            C::t('forum_thread')->update($tid, array('views' => $newViews));
        }
        if ($newPings) {
            Yii::log(var_export(sprintf('change-thread-ping tid:%d before-views:%d after-views:%d', $tid, $topic['recommend_add'], $newPings), true));
            C::t('forum_thread')->update($tid, array('recommend_add' => $newPings));
        }

        Tool::getInstance()->success_json(array());
    }
}
