<?php
/**
 * Created by PhpStorm.
 * User: sunbing
 * Date: 2015/11/26
 * Time: 15:27
 */

if (!defined('IN_DISCUZ')) {
    exit('Access Denied');
}
require_once DISCUZ_ROOT . './source/discuz_version.php';

class UserController extends Controller
{
    /**
     * 用户收藏帖子
     */
    public function actionCollectthread()
    {
        global $_G;
        $idType = 'tid';

        //帖子ID
        $tid = dintval(WebHelper::getPost('tid', 0));

        /************************************验证登录，帖子信息*****************************************/
        //判断用户登录
        if (empty($_G['uid'])) {
            Tool::getInstance()->fail_json(Code::NOT_LOG_IN, Tool::getInstance()->lang('please log in first'));
        }
        $uid = $_G['uid'];

        //判断帖子是否存在
        $thread = C::t('forum_thread')->fetch($tid);
        $title = $thread['subject'];
        if (empty($title)) {
            Tool::getInstance()->fail_json(Code::THREAD_NOT_EXISTS, Tool::getInstance()->lang('thread not exists'));
        }

        //判断是否已经收藏该帖子
        $fav = C::t('home_favorite')->fetch_by_id_idtype($tid, $idType, $_G['uid']);
        if ($fav) {
            Tool::getInstance()->fail_json(Code::ALREADY_COLLECTED, Tool::getInstance()->lang('thread is collected'));
        }
        /************************************************************************************/

        /************************************收藏成功，更新收藏信息*****************************************/
        $fav_count = C::t('home_favorite')->count_by_id_idtype($tid, $idType);
        $description = '';
        require_once libfile('function/home');
        $arr = array(
            'uid' => intval($uid),
            'idtype' => $idType,
            'id' => $tid,
            'spaceuid' => $thread['authorid'],
            'title' => getstr($title, 255),
            'description' => getstr($description, '', 0, 0, 1),
            'dateline' => TIMESTAMP
        );
        $favid = C::t('home_favorite')->insert($arr, true);
        if ($favid) {
            ForumThread::cloudService('user_favor_post', $arr, 0, $favid);
            C::t('forum_thread')->increase($tid, array('favtimes' => 1));
            require_once libfile('function/forum');
            update_threadpartake($tid);
            $data = array();
            Tool::getInstance()->success_json($data);
        } else {
            Tool::getInstance()->fail_json(Code::COLLECT_FAIL, Tool::getInstance()->lang('fail to collect'));
        }
        /************************************************************************************/
    }

    /**
     * 收藏版块
     */
    public function actionCollectforum()
    {
        global $_G;
        $idType = 'fid';
        $spaceuid = empty($_GET['spaceuid']) ? 0 : intval($_GET['spaceuid']);

        //版块ID
        $fid = dintval(WebHelper::getPost('fid', 0));

        /************************************验证登录，版块信息*****************************************/
        //判断用户登录
        if (empty($_G['uid'])) {
            Tool::getInstance()->fail_json(Code::NOT_LOG_IN, Tool::getInstance()->lang('please log in first'));
        }
        $uid = $_G['uid'];

        //判断版块是否可收藏
        $foruminfo = C::t('forum_forum')->fetch($fid);
        loadcache('forums');
        $forum = $_G['cache']['forums'][$fid];
        if (!empty($foruminfo['fup']) && !$forum['viewperm'] || ($forum['viewperm'] && forumperm($forum['viewperm'])) || strstr($forum['users'], "\t$_G[uid]\t")) {
            $title = $foruminfo['status'] != 3 ? $foruminfo['name'] : '';
            // $icon = '<img src="static/image/feed/discuz.gif" alt="forum" class="vm" /> ';
        }
        if (empty($title)) {
            Tool::getInstance()->fail_json(Code::FORUM_CANNOT_COLLECT, Tool::getInstance()->lang('forum cannot be collected'));
        }

        //判断是否已经收藏该版块
        $fav = C::t('home_favorite')->fetch_by_id_idtype($fid, $idType, $uid);
        if ($fav) {
            Tool::getInstance()->fail_json(Code::ALREADY_COLLECTED, Tool::getInstance()->lang('forum is collected'));
        }
        /************************************************************************************/

        /************************************收藏成功，更新收藏信息**************************************/
        $fav_count = C::t('home_favorite')->count_by_id_idtype($fid, $idType);
        $description = '';
        require_once libfile('function/home');
        $arr = array(
            'uid' => intval($uid),
            'idtype' => $idType,
            'id' => $fid,
            'spaceuid' => $spaceuid,
            'title' => getstr($title, 255),
            'description' => getstr($description, '', 0, 0, 1),
            'dateline' => TIMESTAMP
        );
        $favid = C::t('home_favorite')->insert($arr, true);
        if ($favid) {
            ForumThread::cloudService('user_favor_forum', $arr, 0, $favid);
            C::t('forum_forum')->update_forum_counter($fid, 0, 0, 0, 0, 1);
            //$extrajs = '<script type="text/javascript">$("number_favorite_num").innerHTML = parseInt($("number_favorite_num").innerHTML)+1;$("number_favorite").style.display="";</script>';
            dsetcookie('nofavfid', '', -1);

            //列出用户所有关注的版块
            $data = array();
            $forums = C::t('home_favorite')->fetch_all_by_uid_idtype($_G['uid'], $idType);
            foreach ($forums as $row) {
                $data[] = $row['id'];
            }
            $data = array('shortcut' => implode(',', $data));
            Tool::getInstance()->success_json($data);
        } else {
            Tool::getInstance()->fail_json(Code::COLLECT_FAIL, Tool::getInstance()->lang('fail to collect'));
        }
        /************************************************************************************/
    }

    /**
     * 取消收藏版块
     */
    public function actionUncollectforum()
    {
        global $_G;
        $idType = 'fid';

        $fid = dintval(WebHelper::getPost('fid', 0));

        //判断用户登录
        if (empty($_G['uid'])) {
            Tool::getInstance()->fail_json(Code::NOT_LOG_IN, Tool::getInstance()->lang('please log in first'));
        }
        $uid = $_G['uid'];

        //判断版块是否可收藏
        $foruminfo = C::t('forum_forum')->fetch($fid);
        loadcache('forums');
        $forum = $_G['cache']['forums'][$fid];
        if (!empty($foruminfo['fup']) && !$forum['viewperm'] || ($forum['viewperm'] && forumperm($forum['viewperm'])) || strstr($forum['users'], "\t$_G[uid]\t")) {
            $title = $foruminfo['status'] != 3 ? $foruminfo['name'] : '';
            // $icon = '<img src="static/image/feed/discuz.gif" alt="forum" class="vm" /> ';
        }
        if (empty($title)) {
            Tool::getInstance()->fail_json(Code::FORUM_CANNOT_COLLECT, Tool::getInstance()->lang('forum cannot be collected'));
        }

        //判断是否已经收藏
        $fav = C::t('home_favorite')->fetch_by_id_idtype($fid, $idType, $uid);
        if (!$fav) {
            Tool::getInstance()->fail_json(Code::NOT_COLLECTED, Tool::getInstance()->lang('not collected'));
        }

        //取消收藏,更新信息
        $favid = $fav['favid'];

        C::t('home_favorite')->delete($favid);
        C::t('forum_forum')->update_forum_counter($fid, 0, 0, 0, 0, -1);

        ForumThread::cloudService('user_cancel_favor_forum', array(), $_G['uid'], $favid);
        //列出用户所有关注的版块
        $data = array();
        $forums = C::t('home_favorite')->fetch_all_by_uid_idtype($_G['uid'], $idType);
        foreach ($forums as $row) {
            $data[] = $row['id'];
        }
        $data = array('shortcut' => implode(',', $data));
        Tool::getInstance()->success_json($data);
    }

    /**
     * 取消收藏帖子
     */
    public function actionUncollectthread()
    {
        global $_G;
        $idType = 'tid';

        //帖子ID
        $tid = dintval(WebHelper::getPost('tid', 0));

        //判断用户登录
        if (empty($_G['uid'])) {
            Tool::getInstance()->fail_json(Code::NOT_LOG_IN, Tool::getInstance()->lang('please log in first'));
        }
        $uid = $_G['uid'];

        //判断帖子是否存在
        $thread = C::t('forum_thread')->fetch($tid);
        $title = $thread['subject'];
        if (empty($title)) {
            Tool::getInstance()->fail_json(Code::THREAD_NOT_EXISTS, Tool::getInstance()->lang('thread not exists'));
        }

        //判断是否已经收藏该帖子
        $fav = C::t('home_favorite')->fetch_by_id_idtype($tid, $idType, $_G['uid']);
        if (!$fav) {
            Tool::getInstance()->fail_json(Code::NOT_COLLECTED, Tool::getInstance()->lang('not collected'));
        }

        //取消收藏,更新信息
        $favid = $fav['favid'];
        C::t('home_favorite')->delete($favid);
        ForumThread::cloudService('user_cancel_favor_post', array(), $_G['uid'], $favid);
        $data = array();
        Tool::getInstance()->success_json($data);
    }

    /**
     * 帖子点赞
     */
    public function actionPingthread()
    {
        global $_G;
        $action = 'ping';
        //帖子ID
        $_G['tid'] = dintval(WebHelper::getPost('tid', 0));

        /************************************验证登录，帖子，后台设置信息*****************************************/
        //判断用户登录
        if (empty($_G['uid'])) {
            Tool::getInstance()->fail_json(Code::NOT_LOG_IN, Tool::getInstance()->lang('please log in first'));
        }

        //判断帖子是否存在
        $thread = C::t('forum_thread')->fetch($_G['tid']);
        if (empty($thread['tid'])) {
            Tool::getInstance()->fail_json(Code::THREAD_NOT_EXISTS, Tool::getInstance()->lang('thread not exists'));
        }

        //判断主题评价功能是否开启
        if (!$_G['setting']['recommendthread']['status'] || !$_G['group']['allowrecommend']) {
            Tool::getInstance()->fail_json(Code::NO_PRIVILEGE_RECOMMEND, Tool::getInstance()->lang('no_privilege_recommend'));
        }

        //判断是否评价自己的主题
        if ($thread['authorid'] == $_G['uid'] && !$_G['setting']['recommendthread']['ownthread']) {
            Tool::getInstance()->fail_json(Code::RECOMMEND_SELF_DISALLOW, Tool::getInstance()->lang('recommend_self_disallow'));
        }

        //判断是否赞过该主题
        if (C::t('forum_memberrecommend')->fetch_by_recommenduid_tid($_G['uid'], $_G['tid'])) {
            Tool::getInstance()->fail_json(Code::RECOMMEND_DUPLICATE, Tool::getInstance()->lang('recommend_duplicate'));
        }

        //判断24小时点赞次数
        $recommendcount = C::t('forum_memberrecommend')->count_by_recommenduid_dateline($_G['uid'], $_G['timestamp'] - 86400);
        if ($_G['setting']['recommendthread']['daycount'] && $recommendcount >= $_G['setting']['recommendthread']['daycount']) {
            Tool::getInstance()->fail_json(Code::RECOMMEND_OUTOFTIMES, Tool::getInstance()->lang('recommend_outoftimes'));
        }
        /************************************************************************************/

        /************************************点赞成功，更新信息**************************************/
        $_G['group']['allowrecommend'] = intval($action == 'ping' ? $_G['group']['allowrecommend'] : -$_G['group']['allowrecommend']);
        $fieldarr = array();
        if ($action == 'ping') {
            $heatadd = 'recommend_add=recommend_add+1';
            $fieldarr['recommend_add'] = 1;
        } else {
            $heatadd = 'recommend_sub=recommend_sub+1';
            $fieldarr['recommend_sub'] = 1;
        }
        require_once libfile('function/forum');
        update_threadpartake($_G['tid']);
        $fieldarr['heats'] = 0;
        $fieldarr['recommends'] = $_G['group']['allowrecommend'];
        C::t('forum_thread')->increase($_G['tid'], $fieldarr);
        //C::t('forum_thread')->update($_G['tid'], array('lastpost' => TIMESTAMP));//禁止点赞更新lastpost
        C::t('forum_memberrecommend')->insert(array('tid' => $_G['tid'], 'recommenduid' => $_G['uid'], 'dateline' => $_G['timestamp']));

        dsetcookie('recommend', 1, 43200);
        $data = array();
        Tool::getInstance()->success_json($data);
        /************************************************************************************/
    }


    // 后台马甲主题点赞
    public function actionPingThreadByAdm()
    {
        global $_G;
        require_once libfile('function/forum');
        require_once libfile('class/member');
        loaducenter();
        //帖子ID
        $_G['tid'] = dintval(WebHelper::getPost('tid', 0));
        $uids = WebHelper::getPost('uid');
        if (!$uids) {
            Tool::getInstance()->fail_json(Code::UNDEFINED_ACTION, Tool::getInstance()->lang('undefined action'));
        }

        $uidArr = explode(',', $uids);
        $pingUid = array();
        foreach ($uidArr as $uid) {
            $isPing = true;
            //判断帖子是否存在
            $thread = C::t('forum_thread')->fetch($_G['tid']);
            if (empty($thread['tid'])) {
                $isPing = false;
            }

            if (!uc_get_user($uid, 1)) {
                $isPing = false;
            }

            //判断主题评价功能是否开启
            if (!$_G['setting']['recommendthread']['status']) {
                $isPing = false;
            }

            //判断是否评价自己的主题
            if ($thread['authorid'] == $uid && !$_G['setting']['recommendthread']['ownthread']) {
                $isPing = false;
            }

            //判断是否赞过该主题
            if (C::t('forum_memberrecommend')->fetch_by_recommenduid_tid($uid, $_G['tid'])) {
                $isPing = false;
            }

            // 点赞成功，更新信息
            if ($isPing) {
                $pingUid[] = $uid;
                $_G['group']['allowrecommend'] = (int)$_G['group']['allowrecommend'];
                $fieldarr = array();
                $heatadd = 'recommend_add=recommend_add+1';
                $fieldarr['recommend_add'] = 1;

//                update_threadpartake($_G['tid']);
                $fieldarr['heats'] = 1;
                $fieldarr['recommends'] = 1;
                C::t('forum_thread')->increase($_G['tid'], $fieldarr);
                C::t('forum_memberrecommend')->insert(array('tid' => $_G['tid'], 'recommenduid' => $uid, 'dateline' => $_G['timestamp']));
            }
        }
        dsetcookie('recommend', 1, 43200);
        $data = array('uid' => $pingUid);
        Tool::getInstance()->success_json($data);
    }

    // 后台马甲评论点赞
    public function actionPingCommentByAdm()
    {
        global $_G;
        $uids = WebHelper::getPost('uid');
        if (!$uids) {
            Tool::getInstance()->fail_json(Code::UNDEFINED_ACTION, Tool::getInstance()->lang('undefined action'));
        }
        $uidArr = explode(',', $uids);

        //主题（帖子）ID
        $tid = dintval(WebHelper::getPost('tid', 0));
        //帖子（评论）ID
        $pid = dintval(WebHelper::getPost('pid', 0));
        //方法
        $do = WebHelper::getPost('do', 'support');
        $doArray = array('support', 'against');
        $post = C::t('forum_post')->fetch('tid:' . $tid, $pid, false);

        $pingUid = array();
        foreach ($uidArr as $uid) {
            $isPing = true;
            if (empty($post) || !in_array($do, $doArray) || $post['first'] == 1) {
                $isPing = false;
            }

            $hotreply = C::t('forum_hotreply_number')->fetch_by_pid($post['pid']);
            if (empty($hotreply)) {
                $hotreply['pid'] = C::t('forum_hotreply_number')->insert(array(
                    'pid' => $post['pid'],
                    'tid' => $post['tid'],
                    'support' => 0,
                    'against' => 0,
                    'total' => 0,
                ), true);
            } else {
                if (C::t('forum_hotreply_member')->fetch($post['pid'], $uid)) {
                    $isPing = false;
                }
            }

            if ($isPing) {
                $pingUid[] = $uid;
                $typeid = $do == 'support' ? 1 : 0;
                C::t('forum_hotreply_number')->update_num($post['pid'], $typeid);
                C::t('forum_hotreply_member')->insert(array(
                    'tid' => $post['tid'],
                    'pid' => $post['pid'],
                    'uid' => $uid,
                    'attitude' => $typeid,
                ));

                $hotreply[$do]++;
            }
        }

        $data = array('uid' => $pingUid);
        Tool::getInstance()->success_json($data);

    }

    /**
     * 帖子评论点赞
     */
    public function actionPingcomment()
    {
        //-------forum.php?mod=misc&action=postreview&do=support&tid=2&pid=5&hash=a56f11c9&ajaxmenu=1&inajax=1&ajaxtarget=_menu_content
        global $_G;

        //判断是否开启点赞
        //绕过论坛的设置,直接默认开启,所以注释掉了
//        if(!$_G['setting']['repliesrank']){
//            Tool::getInstance()->fail_json( Code::NOT_LOG_IN, Tool::getInstance()->lang('site did not open this function') );
//        }

        //判断是否登录
        if (empty($_G['uid'])) {
            Tool::getInstance()->fail_json(Code::NOT_LOG_IN, Tool::getInstance()->lang('please log in first'));
        }

        //主题（帖子）ID
        $tid = dintval(WebHelper::getPost('tid', 0));
        //帖子（评论）ID
        $pid = dintval(WebHelper::getPost('pid', 0));
        //方法
        $do = WebHelper::getPost('do');
        $do = !empty($do) ? $do : 'support';

        $doArray = array('support', 'against');
        $post = C::t('forum_post')->fetch('tid:' . $tid, $pid, false);

        //多少赞上热门
        $supportnum = dintval(WebHelper::getPost('supportnum', 10));
        //最多显示多少热门
        $supportlimit = dintval(WebHelper::getPost('supportlimit', 20));
        //评论楼层
        $position = dintval(WebHelper::getPost('position', 1));
        //兼容类型
        $type = dintval(WebHelper::getPost('type', 0));
        if ($type == 1) {
            $stick_num = C::t('forum_poststick')->count_by_tid($tid);  //获取置顶个数
            if ($stick_num < $supportlimit) {
                $is_stick = C::t('forum_poststick')->count_by_pid($pid);  //获取是否已经置顶
                if ($is_stick == 0) {
                    $zan_arr_pid = C::t('forum_hotreply_number')->fetch_all_by_pids(array_values($pid)); //获取当前评论点赞个数
                    if (count($zan_arr_pid) + 1 == $supportnum) {
                        //主题修改字段
                        if ($stick_num == 0) {
                            C::t('forum_thread')->update($tid, array('moderated' => 1, 'stickreply' => 1));
                        }
                        //条件都复合进行置顶操作
                        C::t('forum_poststick')->insert(array(
                            'tid' => $tid,
                            'pid' => $pid,
                            'position' => $position,
                            'dateline' => time(),
                        ), false, true);

                    }
                }
            }
        }

        if (empty($post)) {//评论不存在
            Tool::getInstance()->fail_json(Code::POST_NOT_EXIST, Tool::getInstance()->lang('post_not_exist'));
        }

        //($_G['setting']['threadfilternum'] && $_G['setting']['filterednovote'] && getstatus($post['status'], 11))  此处是水帖不能参与回帖投票的设置


        if (!in_array($do, $doArray) || $post['first'] == 1) {
            Tool::getInstance()->fail_json(Code::FIRST_POST_INOPERABLE, Tool::getInstance()->lang('first_post_inoperable'));
        }

        //判断是否可以自己给自己点赞
        /*
        if($_G['setting']['commentpostself']==0 && $_G['uid'] == $post['authorid']) {
            Tool::getInstance()->fail_json( Code::RECOMMEND_SELF_DISALLOW, Tool::getInstance()->lang('noreply_yourself_error') );
        }
        */

        $hotreply = C::t('forum_hotreply_number')->fetch_by_pid($post['pid']);
        if (empty($hotreply)) {
            $hotreply['pid'] = C::t('forum_hotreply_number')->insert(array(
                'pid' => $post['pid'],
                'tid' => $post['tid'],
                'support' => 0,
                'against' => 0,
                'total' => 0,
            ), true);
        } else {
            if (C::t('forum_hotreply_member')->fetch($post['pid'], $_G['uid'])) {
                Tool::getInstance()->fail_json(Code::THREAD_POLL_VOTED, Tool::getInstance()->lang('noreply_voted_error'));
            }
        }

        $typeid = $do == 'support' ? 1 : 0;
        C::t('forum_hotreply_number')->update_num($post['pid'], $typeid);
        C::t('forum_hotreply_member')->insert(array(
            'tid' => $post['tid'],
            'pid' => $post['pid'],
            'uid' => $_G['uid'],
            'attitude' => $typeid,
        ));

        $hotreply[$do]++;

        $data = array();
        Tool::getInstance()->success_json($data);

    }


    /**
     * 获取大头像
     */
    public function actionGetavatar()
    {
        $uid = WebHelper::getPost('uid', 0);

        require_once(libfile('function/forum'));

        Tool::getInstance()->success_json(array('icon' => discuz_uc_avatar($uid, 'big', true)));
    }

    /**
     * 通过一组UID，获取用户基本信息
     * 增加返回用户手机号优先取phonebind表后取common_memeber_profile
     */
    public function actionUserinfoes()
    {
        global $_G;
        $uids = WebHelper::getPost('uids', '');

        if (!empty($uids)) {
            $uidAry = explode(',', $uids);
        }

        $result = DB::fetch_all("SELECT t.uid, t.username, t.regdate, t.groupid, t.status, p.gender, p.mobile,  s.extcredits1, s.extcredits2, s.threads,s.posts FROM %t as t INNER JOIN %t as p ON t.uid = p.uid INNER JOIN %t as s ON t.uid=s.uid  WHERE t.uid in (%n)", array('common_member', 'common_member_profile', 'common_member_count', $uidAry));

//        $re_uids = array_map(function($row){
//            return $row['uid'];
//        },$result);

        // 个性签名
        $sightml = DB::fetch_all("SELECT uid,sightml FROM %t WHERE uid IN (%n)", array('common_member_field_forum', $uidAry), 'uid');

        $re_uids = array();
        foreach ($result as $v) {
            $re_uids[] = $v['uid'];
        }

        // 用户存档表
        $arc = ForumThread::getUserArchive();
        if ($arc['member_arc'] && $arc['profile_arc'] && $arc['count_arc']) {
            $result_arc = DB::fetch_all("SELECT t.uid, t.username, t.regdate, p.gender, p.mobile,  s.extcredits1, s.extcredits2, s.threads,s.posts FROM %t as t INNER JOIN %t as p ON t.uid = p.uid INNER JOIN %t as s ON t.uid=s.uid  WHERE t.uid in (%n)", array('common_member_archive', 'common_member_profile_archive', 'common_member_count_archive', $uidAry), 'uid');
        }
        if ($arc['forum_arc']) {
            $sightml_arc = DB::fetch_all("SELECT uid,sightml FROM %t WHERE uid IN (%n)", array('common_member_field_forum_archive', $uidAry), 'uid');
        }

        foreach ($uidAry as $uid) {
            if (empty($re_uids) || !in_array($uid, $re_uids)) {
                if (isset($result_arc) && !empty($result_arc[$uid])) {
                    if (isset($sightml_arc[$uid])) {
                        $result_arc[$uid]['sightml'] = $sightml_arc[$uid]['sightml'];
                    }
                    $result[] = $result_arc[$uid];
                } else {
                    $userInfo = getuserbyuid($uid, 1);
                    if ($userInfo) {
                        $result[] = array(
                            'uid' => $uid,
                            'username' => $userInfo['username'],
                            'status' => $userInfo['status'],
                            'groupid' => $userInfo['groupid'],
                            'gender' => 0,
                            'regdate' => 0,
                            'sightml' => '',
                            'mobile' => 0,
                            'extcredits1' => 0,
                            'extcredits2' => 0,
                            'threads' => 0,
                            'posts' => 0,
                            'home_ban' => ($userInfo['status'] == -1 || in_array($userInfo['groupid'], array(4, 5, 6))) ? 1 : 0,
                        );
                    } else {
                        $result[] = array(
                            'uid' => $uid,
                            'username' => Tool::getInstance()->lang('user_not_find'),
                            'status' => 0,
                            'groupid' => 0,
                            'gender' => 0,
                            'regdate' => 0,
                            'sightml' => '',
                            'mobile' => 0,
                            'extcredits1' => 0,
                            'extcredits2' => 0,
                            'threads' => 0,
                            'posts' => 0,
                            'home_ban' => 0,
                        );
                    }
                }
            }
        }
        //获取phonbind表的手机号
        $userPhone = Mobile::fetchMobileByUids($uidAry); // DB::fetch_all("SELECT * FROM %t WHERE uid in (%n)", array('phonebind', $uidAry));
//        $phone = array_column($userPhone, 'phone', 'uid');
        //兼容5.5以下版本
        $re = $phone = array();
        foreach ($userPhone as $k => $v) {
            $re[$v['uid']] = $v['phone'];
        }
        $phone = $re;
        if (!empty($result)) {
            require_once(libfile('function/forum'));
            foreach ($result as $key => $val) {
                $result[$key]['icon'] = discuz_uc_avatar($val['uid'], 'big', true);
                // 默认动态地址，用于用户扫描
                $result[$key]['avatar'] = $_G['setting']['ucenterurl'] . '/avatar.php?uid=' . $val['uid'] . '&size=big';
                $result[$key]['rvrc'] = $val['extcredits1'];
                $result[$key]['money'] = $val['extcredits2'];
                if (!isset($val['sightml'])) {
                    $result[$key]['sightml'] = $sightml[$val['uid']]['sightml'];
                }
                $result[$key]['mobile'] = $phone[$val['uid']] ? $phone[$val['uid']] : '';
                $result[$key]['postnum'] = $val['threads'];
                $result[$key]['replynum'] = $val['posts'] - $val['threads'];
                $result[$key]['home_ban'] = ($val['status'] == -1 || in_array($val['groupid'], array(4, 5, 6))) ? 1 : 0;
                unset($result[$key]['extcredits1']);
                unset($result[$key]['extcredits2']);
                unset($result[$key]['threads']);
                unset($result[$key]['posts']);
            }
        }

        Tool::getInstance()->success_json($result);
    }

    /**
     * 通过一组USERNAME，获取用户基本信息
     */
    public function actionUserinfoesbyuname()
    {
        $username = WebHelper::getPost('username', '');

        if (!empty($username)) {
            $usernameAry = explode(',', $username);
        }

        $result = DB::fetch_all("SELECT t.uid, t.username, p.gender FROM %t as t INNER JOIN %t as p ON t.uid = p.uid WHERE t.username in (%n)", array('common_member', 'common_member_profile', $usernameAry));

        if (!empty($result)) {
            require_once(libfile('function/forum'));
            foreach ($result as $key => $val) {
                $result[$key]['icon'] = discuz_uc_avatar($val['uid'], 'big', true);
            }
        }

        Tool::getInstance()->success_json($result);
    }

    /**
     * 用户发表的帖子列表
     */
    public function actionUserthread()
    {
        global $_G;
        $offset = WebHelper::getPost('offset', '');
        $offset = $offset ? $offset : 0;
        $limit = WebHelper::getPost('limit', '');
        $lastid = WebHelper::getPost('lastid', '');
        $endtime = intval(WebHelper::getPost('endtime', 0));

        $userid = WebHelper::getPost('uid', 0);
        $uid = $userid ? $userid : $_G['uid'];
        if (!$uid) {
            Tool::getInstance()->fail_json(Code::NOT_LOG_IN, Tool::getInstance()->lang('please log in first'));
        }

        // 允许用户查看的版块
        $viewThreadFids = array();
        $allowView = true;

        if ($_G['setting']['allowviewuserthread'] == -1 && $_G['adminid'] != 1) {
            $allowView = false;
        }
        if ($userid == $_G['uid']) {
            $allowView = true;
        }

        if (!$allowView) {
            Tool::getInstance()->success_json(array());
        }

        if ($_G['setting']['allowviewuserthread'] && $_G['setting']['allowviewuserthread'] != -1) {
            $viewThreadFids = str_replace("'", '', $_G['setting']['allowviewuserthread']);
            if (!empty($viewThreadFids)) {
                $viewThreadFids = explode(',', $viewThreadFids);
            }
        }

        //用户自己可以看到待审核帖子
        $displayorder = $_G['uid'] == $uid ? 'displayorder in (0,1,2,3,-2)' : 'displayorder >= 0';
        $endtime = $endtime > 0 ? ' AND dateline<=' . $endtime : '';
        if ($lastid > 0) {
            // 解决分页问题
            if ($viewThreadFids) {
                $result = DB::fetch_all('
                SELECT *
                FROM %t
                WHERE authorid = %d
                AND ' . $displayorder . $endtime . '
                AND tid < %d
                AND fid in (%n)
                ORDER BY dateline DESC
                LIMIT %d
                ', array("forum_thread", $uid, $lastid, $viewThreadFids, $limit));

            } else {
                $result = DB::fetch_all('
                SELECT *
                FROM %t
                WHERE authorid = %d
                AND ' . $displayorder . $endtime . '
                AND tid < %d
                ORDER BY dateline DESC
                LIMIT %d
                ', array("forum_thread", $uid, $lastid, $limit));
            }

        } else {
            if ($viewThreadFids) {
                $result = DB::fetch_all('
                SELECT *
                FROM %t
                WHERE authorid = %d
                AND ' . $displayorder . $endtime . '
                AND fid in (%n)
                ORDER BY dateline DESC
                LIMIT %d ,%d
                ', array("forum_thread", $uid, $viewThreadFids, $offset, $limit));
            } else {
                $result = DB::fetch_all('
                SELECT *
                FROM %t
                WHERE authorid = %d
                AND ' . $displayorder . $endtime . '
                ORDER BY dateline DESC
                LIMIT %d ,%d
                ',
                    array("forum_thread", $uid, $offset, $limit));
            }
        }

        $data = array();
        require_once(libfile('function/forum'));
        $tids = Tool::Array_Column($result, 'tid');

        //用户可以看到自己匿名的主题
        $anonymous = $_G['uid'] == $uid ? 'anonymous >= 0' : 'anonymous = 0';
        loadcache('posttableids');
        $posttableids = $_G['cache']['posttableids'] ? $_G['cache']['posttableids'] : array('0');
        $post_info = array();
        foreach ($posttableids as $table_id) {
            $split_post_info = DB::fetch_all("SELECT tid,pid,status,anonymous FROM %t WHERE tid in (%n) AND " . $anonymous . " AND first = 1", array(getposttable($table_id), $tids), 'tid');
            $post_info = $post_info + $split_post_info;
        }
        $tid_attachs = ForumThread::getAllAttaches($post_info, $result);

        // 统计点赞用户uid
        $pingUids = DB::fetch_all("SELECT recommenduid,tid FROM %t WHERE tid IN (%n)", array("forum_memberrecommend", $tids));
        if (!empty($pingUids)) {
            $uids = array();
            foreach ($pingUids as $key => $ping) {
                $uids[$ping['tid']][] = $ping['recommenduid'];
            }
        }

        foreach ($result as $k => $v) {
            if (isset($post_info[$v['tid']])) {
                $data_temp['tid'] = $v['tid'];
                $data_temp['fid'] = $v['fid'];
                $data_temp['subject'] = $v['subject'];
                $data_temp['digest'] = $v['digest'];
                $data_temp['authorid'] = $v['authorid'];
                $data_temp['hits'] = $v['views'];
                $data_temp['author'] = $v['author'];
                $data_temp['postdate'] = $v['dateline'];
                $data_temp['favors'] = $v['rate'];
                $data_temp['pingcount'] = $v['recommend_add'];
                $data_temp['pinguids'] = isset($uids[$v['tid']]) ? implode(',', $uids[$v['tid']]) : '';
                $data_temp['replies'] = $v['replies'];
                $data_temp['ifupload'] = $v['attachment'] > 0 ? 1 : 0;
                $data_temp['special'] = $v['special'];
                $data_temp['topped'] = $v['displayorder'] > 0 ? 1 : 0;
                $data_temp['ifcheck'] = $v['displayorder'] < 0 ? 0 : 1;
                $data_temp['icon'] = discuz_uc_avatar($v['authorid'], 'big', 1);
                $data_temp['attach'] = array();
                $data_temp['attnum'] = '';

                $data_temp['anonymous'] = isset($post_info[$data_temp['tid']]) ? $post_info[$data_temp['tid']]['anonymous'] : 0;
                $data_temp['pid'] = isset($post_info[$v['tid']]) ? $post_info[$v['tid']]['pid'] : 0;

                $is_shield = 1;
                if (!empty($post_info[$data_temp['tid']]['status']) && ($post_info[$data_temp['tid']]['status'] & 1)) {
                    $is_shield = 0;
                }

                //获取帖子附件
                if ($is_shield && ($v['attachment'] == 2 || $v['attachment'] == 1)) {
                    if (isset($tid_attachs[$v['tid']]) && is_array($tid_attachs[$v['tid']]) && !empty($tid_attachs[$v['tid']])) {
                        $data_temp['attach'] = $tid_attachs[$v['tid']];
                        $data_temp['attnum'] = '' . count($tid_attachs[$v['tid']]);
                    }
                }
                $data[] = $data_temp;
            }
        }
        Tool::getInstance()->success_json($data);
    }

    /**
     * 用户回复的帖子列表
     */
    public function actionUserreplies()
    {
        global $_G;
        $offset = WebHelper::getPost('offset', '');
        $offset = $offset ? $offset : 0;
        $limit = WebHelper::getPost('limit', '');

        $uid = $_G['uid'];
        if (!$uid) {
            Tool::getInstance()->fail_json(Code::NOT_LOG_IN, Tool::getInstance()->lang('please log in first'));
        }

        // 允许用户查看的版块
        $viewThreadFids = array();
        $allowView = true;
        if ($_G['setting']['allowviewuserthread'] === -1 && $_G['adminid'] != 1) {
            $allowView = false;
        }
        if ($_G['setting']['allowviewuserthread'] && $_G['setting']['allowviewuserthread'] != -1) {
            $viewThreadFids = str_replace("'", '', $_G['setting']['allowviewuserthread']);
            if (!empty($viewThreadFids)) {
                $viewThreadFids = explode(',', $viewThreadFids);
            }
        }

        $result = DB::fetch_all('
            SELECT post.*, thread.views, thread.replies, thread.digest, thread.special, thread.displayorder, thread.attachment 
            FROM %t post INNER JOIN %t thread
            ON post.tid = thread.tid
            WHERE post.authorid = %d
            AND post.first = 0
            ORDER BY post.pid DESC
            LIMIT %d, %d
            ',
            array('forum_post', 'forum_thread', $uid, $offset, $limit));

        $data = array();
        require_once libfile('function/discuzcode');
        $tids = Tool::Array_Column($result, 'tid');
        loadcache('posttableids');
        $posttableids = $_G['cache']['posttableids'] ? $_G['cache']['posttableids'] : array('0');
        $post_info = array();
        foreach ($posttableids as $table_id) {
            $split_post_info = DB::fetch_all("SELECT tid,pid,status,subject,anonymous FROM %t WHERE tid in (%n) AND first = 1", array(getposttable($table_id), $tids), 'tid');
            $post_info = $post_info + $split_post_info;
        }

        $tid_attachs = ForumThread::getAllAttaches($post_info, $result);

        foreach ($result as $k => $v) {
            if ($viewThreadFids && !in_array($v['fid'], $viewThreadFids)) {
                continue;
            }

            $data_temp['pid'] = $v['pid'];
            $data_temp['tid'] = $v['tid'];
            $data_temp['subject'] = isset($post_info[$v['tid']]) ? $post_info[$v['tid']]['subject'] : '';
            $data_temp['digest'] = $v['digest'];
            $data_temp['authorid'] = $v['authorid'];
            $data_temp['hits'] = $v['views'];
            $data_temp['author'] = $v['author'];
            $data_temp['postdate'] = $v['dateline'];
            $data_temp['replies'] = $v['replies'];
            $data_temp['ifupload'] = $v['attachment'] > 0 ? 1 : 0;
            $data_temp['special'] = $v['special'];
            $data_temp['topped'] = $v['displayorder'] > 0 ? 1 : 0;
            $data_temp['attach'] = array();
            $data_temp['attnum'] = '';

            $data_temp['anonymous'] = isset($post_info[$data_temp['tid']]) ? $post_info[$data_temp['tid']]['anonymous'] : 0;

            if ($v['attachment'] == 2 || $v['attachment'] == 1) {
                if (isset($tid_attachs[$v['tid']]) && is_array($tid_attachs[$v['tid']]) && !empty($tid_attachs[$v['tid']])) {
                    $data_temp['attach'] = $tid_attachs[$v['tid']];
                    $data_temp['attnum'] = '' . count($tid_attachs[$v['tid']]);
                }

            }
            $data[] = $data_temp;
        }

        Tool::getInstance()->success_json($data);
    }

    /**
     * 用户收藏的帖子列表
     * 1.5.1要改动lastid为favid
     */
    public function actionMycollectthread()
    {
        global $_G;

        $offset = WebHelper::getPost('offset', '');
        $offset = $offset ? $offset : 0;
        $limit = WebHelper::getPost('limit', '');
        $lastid = WebHelper::getPost('lastid', '');
        $is_new = intval(WebHelper::getPost('is_new', 0)); //是否新版
        $lastid = $lastid ? $lastid : 0;
        $idType = 'tid';
        $uid = $_G['uid'];

        if (!$uid) {
            Tool::getInstance()->fail_json(Code::NOT_LOG_IN, Tool::getInstance()->lang('please log in first'));
        }

        if ($lastid > 0) {
            if ($is_new) {
                $result = DB::fetch_all('
            SELECT thread.*, favorite.title, favorite.favid,favorite.dateline as c_time 
            FROM %t favorite INNER JOIN %t thread
            ON favorite.id = thread.tid
            WHERE favorite.uid = %d
            AND favorite.idtype = %s
            AND favid < %d
            ORDER BY favorite.favid DESC
            LIMIT %d
            ',
                    array('home_favorite', 'forum_thread', $uid, $idType, $lastid, $limit));
            } else {
                $result = DB::fetch_all('
            SELECT thread.*, favorite.title
            FROM %t favorite INNER JOIN %t thread
            ON favorite.id = thread.tid
            WHERE favorite.uid = %d
            AND favorite.idtype = %s
            AND tid < %d
            ORDER BY favorite.favid DESC
            LIMIT %d
            ',
                    array('home_favorite', 'forum_thread', $uid, $idType, $lastid, $limit));
            }
        } else {
            $result = DB::fetch_all('
            SELECT thread.*, favorite.title, favorite.favid,favorite.dateline as c_time  
            FROM %t favorite INNER JOIN %t thread
            ON favorite.id = thread.tid
            WHERE favorite.uid = %d
            AND favorite.idtype = %s
            ORDER BY favorite.favid DESC
            LIMIT %d, %d
            ',
                array('home_favorite', 'forum_thread', $uid, $idType, $offset, $limit));
        }
        $data = array();
        $tids = Tool::Array_Column($result, 'tid');
        $post_info = DB::fetch_all("SELECT tid,pid,status,subject,anonymous FROM %t WHERE tid in (%n) AND first = 1", array("forum_post", $tids), 'tid');
        $tid_attachs = ForumThread::getAllAttaches($post_info, $result);
        foreach ($result as $k => $v) {
            $data_temp['tid'] = $v['tid'];
            $data_temp['fid'] = $v['fid'];
            $data_temp['subject'] = $v['title'];
            $data_temp['digest'] = $v['digest'];
            $data_temp['authorid'] = $v['authorid'];
            $data_temp['favors'] = $v['favtimes'];
            $data_temp['author'] = $v['author'];
            $data_temp['postdate'] = $v['dateline'];
            $data_temp['replies'] = $v['replies'];
            $data_temp['ifupload'] = $v['attachment'] > 0 ? 1 : 0;
            $data_temp['special'] = $v['special'];

            $data_temp['anonymous'] = isset($post_info[$data_temp['tid']]) ? $post_info[$data_temp['tid']]['anonymous'] : 0;

            if ($is_new) {
                $data_temp['pid'] = isset($post_info[$v['tid']]) ? $post_info[$v['tid']]['pid'] : 0;
                $data_temp['favid'] = $v['favid'];
                $data_temp['c_time'] = $v['c_time'];
                $data_temp['attach'] = array();
                $data_temp['attnum'] = '';

                $is_shield = 1;
                if (!empty($post_info[$data_temp['tid']]['status']) && ($post_info[$data_temp['tid']]['status'] & 1)) {
                    $is_shield = 0;
                }

                if ($is_shield && ($v['attachment'] == 2 || $v['attachment'] == 1)) {
                    if (isset($tid_attachs[$v['tid']]) && is_array($tid_attachs[$v['tid']]) && !empty($tid_attachs[$v['tid']])) {
                        $data_temp['attach'] = $tid_attachs[$v['tid']];
                        $data_temp['attnum'] = '' . count($tid_attachs[$v['tid']]);
                    }

                }
            }
            $data[] = $data_temp;
        }

        Tool::getInstance()->success_json($data);
    }

    /**
     * 投票接口
     * 参数polloptions为用户选择的投票项polloptionid
     */
    public function actionVote()
    {
        global $_G;
        $_G['tid'] = dintval(WebHelper::getPost('tid', 0));
        $polloptions = WebHelper::getPost('polloptions', ''); //用户选择的投票项polloptionid

        require_once libfile('function/post');
        $thread = C::t('forum_thread')->fetch($_G['tid']);
        if (!$_G['group']['allowvote']) {
            Tool::getInstance()->fail_json(Code::GROUP_NOPERMISSION, Tool::getInstance()->lang('group_nopermission'));
        } elseif (!empty($thread['closed'])) {
            Tool::getInstance()->fail_json(Code::THREAD_POLL_CLOSED, Tool::getInstance()->lang('thread_poll_closed')); // 本主题已关闭，无法继续投票
        } elseif (empty($polloptions)) {
            Tool::getInstance()->fail_json(Code::THREAD_POLL_INVALID, Tool::getInstance()->lang('thread_poll_invalid')); // 您没有选择投票选项
        }

        $_GET['pollanswers'] = explode(',', $polloptions);
        $pollarray = C::t('forum_poll')->fetch($_G['tid']);
        $overt = $pollarray['overt'];
        if (!$pollarray) {
            Tool::getInstance()->fail_json(Code::POLL_NOT_FOUND, Tool::getInstance()->lang('poll_not_found')); // 投票未找到
        } elseif ($pollarray['expiration'] && $pollarray['expiration'] < TIMESTAMP) {
            Tool::getInstance()->fail_json(Code::POLL_OVERDUE, Tool::getInstance()->lang('poll_overdue')); // 投票已过期
        } elseif ($pollarray['maxchoices'] && $pollarray['maxchoices'] < count($_GET['pollanswers'])) {
            // 抱歉，此投票最多只能选择 {maxchoices} 项
            Tool::getInstance()->fail_json(Code::POLL_CHOOSE_MOST, Tool::getInstance()->lang('poll_choose_most {maxchoices}', array('{maxchoices}' => $pollarray['maxchoices'])));

        }

        $voterids = $_G['uid'] ? $_G['uid'] : $_G['clientip'];
        $polloptionid = array();
        $query = C::t('forum_polloption')->fetch_all_by_tid($_G['tid']);
        foreach ($query as $v) {
            if (strexists("\t" . $v['voterids'] . "\t", "\t" . $voterids . "\t")) {
                Tool::getInstance()->fail_json(Code::THREAD_POLL_VOTED, Tool::getInstance()->lang('thread_poll_voted')); // 已经投过票了
            }
            $polloptionid[] = $v['polloptionid'];
        }

        $polloptionids = array();
        foreach ($_GET['pollanswers'] as $key => $id) {
            if (!in_array($id, $polloptionid)) {
                Tool::getInstance()->fail_json(Code::UNDEFINED_ACTION, Tool::getInstance()->lang('undefined action')); // 参数错误
            }
            unset($polloptionid[$key]);
            $polloptionids[] = $id;
        }

        //更新,返回数据
        foreach ($_GET['pollanswers'] as $key => $value) {
            C::t('forum_polloption')->update_vote($value, $voterids . "\t", 1);
            C::t('forum_thread')->update($_G['tid'], array('lastpost' => $_G['timestamp']), true);
            C::t('forum_poll')->update_vote($_G['tid']);
            C::t('forum_pollvoter')->insert(array(
                'tid' => $_G['tid'],
                'uid' => $_G['uid'],
                'username' => $_G['username'],
                'options' => $value,
                'dateline' => $_G['timestamp'],
            ));
            updatecreditbyaction('joinpoll');
            $space = array();
            space_merge($space, 'field_home');
        }
        require_once(Yii::getPathOfAlias('application.components.func') . DIRECTORY_SEPARATOR . 'forum_viewthread.php');
        $data = ForumThread::getVoteInfo($_G['tid']);
        Tool::getInstance()->success_json($data);
    }

    //用户自己删除帖子
    public function actionDelMyThread()
    {
        global $_G;
        $tid = Yii::app()->request->getPost('tid', 0);
        if (!$tid)
            Tool::getInstance()->fail_json(Code::MANAGER_ERR, Tool::getInstance()->lang('undefined action'));
        //加载板块信息
        if (!function_exists('loadforum')) require_once(libfile('function/forum'));
        loadforum(null, $tid);
        $threadtableids = !empty($_G['cache']['threadtableids']) ? $_G['cache']['threadtableids'] : array();
        if (!in_array(0, $threadtableids)) {
            $threadtableids = array_merge(array(0), $threadtableids);
        }
        $thread = array();
        foreach ($threadtableids as $tableid) {
            $thread = C::t('forum_thread')->fetch_all_by_tid_fid_displayorder($tid, $_G['fid'], null, '', 0, $_G['tpp'], '', '', $tableid);
            if (!empty($thread[$tid])) {
                $thread = $thread[$tid];
                break;
            }
        }
        if (empty($thread))
            Tool::getInstance()->fail_json(Code::THREAD_NOT_EXISTS, Tool::getInstance()->lang('thread not exists'));
        //用户无权限 操作非法
        if (!$_G['uid'] || $_G['uid'] != $thread['authorid'])
            Tool::getInstance()->fail_json(Code::NO_PERMISSION, Tool::getInstance()->lang('illegal operation'));
        //已经在回收站
        if ($thread['displayorder'] == -1) {
            Tool::getInstance()->success_json(array('tid' => $tid));
        }
        loadcache('threadtableids');
        $stickmodify = 0;
        $deleteredirect = $remarkclosed = array();

        if ($thread['digest']) {
            updatecreditbyaction('digest', $thread['authorid'], array('digestposts' => -1), '', -$thread['digest']);
        }
        if (in_array($thread['displayorder'], array(2, 3))) {
            $stickmodify = 1;
        }
        if ($_G['forum']['status'] == 3 && $thread['closed'] > 1) {
            $deleteredirect[] = $thread['closed'];
        }
        if ($thread['isgroup'] == 1 && $thread['closed'] > 1) {
            $remarkclosed[] = $thread['closed'];
        }
        require_once libfile('function/delete');
        //兼容部分站点 不知为何没有包含这个文件导致的问题
        if (!function_exists('updateattachcredits')) require_once libfile('function/post');
        //直接回收站处理
        deletethread(array($tid), true, true, true);
        manage_addnotify('verifyrecycle', 1);
        $forumstickthreads = $_G['setting']['forumstickthreads'];
        $forumstickthreads = !empty($forumstickthreads) ? dunserialize($forumstickthreads) : array();

        unset($forumstickthreads[$tid]);
        C::t('common_setting')->update('forumstickthreads', $forumstickthreads);
        C::t('forum_forum_threadtable')->delete_none_threads();
        if (!empty($deleteredirect)) {
            deletethread($deleteredirect);
        }
        if (!empty($remarkclosed)) {
            C::t('forum_thread')->update($remarkclosed, array('closed' => 0));
        }
        if ($_G['setting']['globalstick'] && $stickmodify) {
            require_once libfile('function/cache');
            updatecache('globalstick');
        }
        updateforumcount($_G['fid']);
        //删除记录
        $modaction = 'DEL';
        $moderatetids = dimplode(array($tid));
        updatemodlog($moderatetids, $modaction, 0, 0, '');
        Tool::getInstance()->success_json(array('tid' => $tid));
    }

    //用户自己删除回复
    public function actionDelMyReply()
    {
        global $_G;
        $tid = Yii::app()->request->getPost('tid', 0);
        $pid = Yii::app()->request->getPost('pid', 0);

        if (!$pid || !$tid) {
            Tool::getInstance()->fail_json(Code::MANAGER_ERR, Tool::getInstance()->lang('undefined action'));
        }

        $modpost = C::m('forum_post', $tid, $pid);
        $post = C::t('forum_post')->fetch('tid:' . $tid, $pid, false);

        // 判断操作人是否为作者
        if (!$_G['uid'] || $_G['uid'] != $post['authorid']) {
            Tool::getInstance()->fail_json(Code::NO_PERMISSION, Tool::getInstance()->lang('illegal operation'));
        }


        //source/module/forum/forum_post.php
        $thread = C::t('forum_thread')->fetch($_G['tid']);

        if ($thread['closed'] == 1 && !$_G['forum']['ismoderator']) {
            //主题锁定则无法操作
            Tool::getInstance()->fail_json(Code::POST_THREAD_CLOSED, Tool::getInstance()->lang('post_thread_closed'));
        }

        if (!$_G['forum_auditstatuson'] && !($thread['displayorder'] >= 0 || (in_array($thread['displayorder'], array(-4, -2)) && $thread['authorid'] == $_G['uid']))) {
            $thread = array();
        }
        if (!empty($thread)) {
            $_G['fid'] = $thread['fid'];
            $special = $thread['special'];
        } else {
            // 抱歉，指定的主题不存在或已被删除或正在被审核
            Tool::getInstance()->fail_json(Code::THREAD_NOT_EXISTS, Tool::getInstance()->lang('thread not exists'));
        }
        if (isset($_G['forum']['allowpost']) && $_G['forum']['allowpost'] == -1) {
            // 抱歉，您在本版没有权限进行此操作
            Tool::getInstance()->fail_json(Code::FORUM_ACCESS_DISALLOW, Tool::getInstance()->lang('forum_access_disallow'));
        }
        //forum_post.php:167
        if ($_G['forum']['allowview'] == -1) {
            // 抱歉，您在本版没有权限进行此操作
            Tool::getInstance()->fail_json(Code::FORUM_ACCESS_VIEW_DISALLOW, Tool::getInstance()->lang('forum_access_view_disallow'));
        }


        $special = intval(getgpc('special'));
        //source/module/forum/forum_post.php:352 require -> post_editpost.php

        $rushreply = getstatus($thread['status'], 3);

        $orig = get_post_by_tid_pid($tid, $pid);

        if (empty($orig)) {
            // 帖子不存在
            Tool::getInstance()->fail_json(Code::POST_NOT_EXIST, Tool::getInstance()->lang('post_not_exist'));
        }

        $isfirstpost = $orig['first'] ? 1 : 0;
        $isanonymous = ($_G['group']['allowanonymous'] || $orig['anonymous']) && getgpc('isanonymous') ? 1 : 0;

        //source/include/post/post_editpost.php:451
        // 悬赏
        // 若超时则“抱歉，悬赏已结束，无法退还积分” 否则根据 积分日志表（pre_common_credit_log） 处理
        if ($thread['special'] == 3) {
            $modpost->attach_before_method('deletepost', array('class' => 'extend_thread_reward', 'method' => 'before_deletepost'));
        }
        // 抱歉，抢楼帖不能删除
        if ($rushreply) {
            Tool::getInstance()->fail_json(Code::POST_NOT_EXIST, Tool::getInstance()->lang('post_edit_delete_rushreply_nopermission'));
        }
        // 回帖奖励积分处理
        if ($thread['replycredit'] && $isfirstpost) {
            $modpost->attach_before_method('deletepost', array('class' => 'extend_thread_replycredit', 'method' => 'before_deletepost'));
        }
        // 回帖附件处理
        $modpost->attach_before_method('deletepost', array('class' => 'extend_thread_image', 'method' => 'before_deletepost'));

        // 商品贴 删除商品信息表
        if ($thread['special'] == 2) {
            $modpost->attach_after_method('deletepost', array('class' => 'extend_thread_trade', 'method' => 'after_deletepost'));
        }
        // 分类信息
        if ($isfirstpost) {
            $modpost->attach_after_method('deletepost', array('class' => 'extend_thread_sort', 'method' => 'after_deletepost'));
        }

        // 回帖投票处理
        $modpost->attach_after_method('deletepost', array('class' => 'extend_thread_filter', 'method' => 'after_deletepost'));

        $param = array(
            'special' => $special,
            'isanonymous' => $isanonymous,
        );

        $modpost->deletepost($param);

        Tool::getInstance()->success_json(array());

    }

    // 取消帖子点赞
    public function actionCancelPingThread()
    {
        global $_G;
        $action = 'ping';
        //帖子ID
        $_G['tid'] = dintval(WebHelper::getPost('tid', 0));

        /************************************验证登录，帖子，后台设置信息*****************************************/
        //判断用户登录
        if (empty($_G['uid'])) {
            Tool::getInstance()->fail_json(Code::NOT_LOG_IN, Tool::getInstance()->lang('please log in first'));
        }

        //判断帖子是否存在
        $thread = C::t('forum_thread')->fetch($_G['tid']);
        if (empty($thread['tid'])) {
            Tool::getInstance()->fail_json(Code::THREAD_NOT_EXISTS, Tool::getInstance()->lang('thread not exists'));
        }

        //判断主题评价功能是否开启
        if (!$_G['setting']['recommendthread']['status'] || !$_G['group']['allowrecommend']) {
            Tool::getInstance()->fail_json(Code::NO_PRIVILEGE_RECOMMEND, Tool::getInstance()->lang('no_privilege_recommend'));
        }

        //判断是否评价自己的主题
        if ($thread['authorid'] == $_G['uid'] && !$_G['setting']['recommendthread']['ownthread']) {
            Tool::getInstance()->fail_json(Code::RECOMMEND_SELF_DISALLOW, Tool::getInstance()->lang('recommend_self_disallow'));
        }

        //判断是否赞过该主题
        if (!C::t('forum_memberrecommend')->fetch_by_recommenduid_tid($_G['uid'], $_G['tid'])) {
            Tool::getInstance()->fail_json(Code::USER_NOT_RECOMMEND, Tool::getInstance()->lang('user_not_recommend'));
        }
        /************************************************************************************/

        /************************************点赞成功，更新信息**************************************/
        $uid = $_G['uid'];
        $tid = $_G['tid'];

        $_G['group']['allowrecommend'] = intval($action == 'ping' ? $_G['group']['allowrecommend'] : -$_G['group']['allowrecommend']);
        $fieldarr = array();
        if ($action == 'ping') {
            $heatadd = 'recommend_add=recommend_add-1';
            $fieldarr['recommend_add'] = -1;
        } else {
            $heatadd = 'recommend_sub=recommend_sub+1';
            $fieldarr['recommend_sub'] = 1;
        }
        require_once libfile('function/forum');
        update_threadpartake($_G['tid']);
        $fieldarr['heats'] = 0;
        $fieldarr['recommends'] = $_G['group']['allowrecommend'] > 0 ? '-' . $_G['group']['allowrecommend'] : 0;
        C::t('forum_thread')->increase($_G['tid'], $fieldarr);
        DB::delete('forum_memberrecommend', "recommenduid='$uid' AND tid='$tid'");

        $data = array();
        Tool::getInstance()->success_json($data);
        /************************************************************************************/
    }

    // 取消评论点赞
    public function actionCancelPingComment()
    {
        //-------forum.php?mod=misc&action=postreview&do=support&tid=2&pid=5&hash=a56f11c9&ajaxmenu=1&inajax=1&ajaxtarget=_menu_content
        global $_G;

        //主题（帖子）ID
        $tid = dintval(WebHelper::getPost('tid', 0));
        //帖子（评论）ID
        $pid = dintval(WebHelper::getPost('pid', 0));
        //方法
        $do = WebHelper::getPost('do');
        $do = !empty($do) ? $do : 'support';

        $doArray = array('support', 'against');
        $post = C::t('forum_post')->fetch('tid:' . $tid, $pid, false);
        $uid = $_G['uid'];

        // 判断是否登录
        if (empty($_G['uid'])) {
            Tool::getInstance()->fail_json(Code::NOT_LOG_IN, Tool::getInstance()->lang('please log in first'));
        }
        // 评论不存在
        if (empty($post)) {
            Tool::getInstance()->fail_json(Code::POST_NOT_EXIST, Tool::getInstance()->lang('post_not_exist'));
        }
        if (!in_array($do, $doArray) || $post['first'] == 1) {
            Tool::getInstance()->fail_json(Code::FIRST_POST_INOPERABLE, Tool::getInstance()->lang('first_post_inoperable'));
        }

        $hotreply = C::t('forum_hotreply_number')->fetch_by_pid($post['pid']);
        $record = C::t('forum_hotreply_member')->fetch($post['pid'], $_G['uid']);
        if (empty($hotreply) || empty($record)) {
            Tool::getInstance()->fail_json(Code::USER_NOT_RECOMMEND, Tool::getInstance()->lang('user_not_recommend'));
        }

        $typename = 'support';
        DB::query('UPDATE %t SET ' . $typename . '=' . $typename . '-1, total=total-1 WHERE pid=%d', array('forum_hotreply_number', $post['pid']));
        DB::delete('forum_hotreply_member', "uid='$uid' AND pid='$pid'");


        Tool::getInstance()->success_json(array());
    }

    // 新注册用户量
    public function actionNewregister()
    {
        global $_G;

        // 搜索开始时间   时间戳（）
        $starttime = WebHelper::getPost('starttime', 0);
        // 搜索结束时间时间   时间戳 （默认当前时间）
        $endtime = WebHelper::getPost('endtime', 0);

        $data = array();
        if (empty($starttime) || empty($endtime)) {
            Tool::getInstance()->fail_json(Code::UNDEFINED_ACTION, Tool::getInstance()->lang('undefined action'));
        }
        $num = DB::result_first('SELECT count(*) as num FROM %t WHERE regdate>=%d AND regdate<%d', array('common_member', $starttime, $endtime));
        $data['regnum'] = empty($num) ? 0 : $num;
        Tool::getInstance()->success_json($data);
    }

    // 获取用户头像、个性签名、用户名  主要用于用户安全扫描
    public function actionGetUserInfos()
    {
        global $_G;
        require_once(libfile('function/forum'));

        $type = WebHelper::getPost('type', '1');// 1用户名 2头像 3个性签名
        $is_arc = WebHelper::getPost('is_arc', 0);// 1查存档表 0查主表
        $operation = WebHelper::getPost('operation', 1);// 1只获取总数  2获取具体信息
        $starttime = WebHelper::getPost('starttime', '');
        $endtime = WebHelper::getPost('endtime', '');
        $offset = WebHelper::getPost('offset', 0);
        $limit = WebHelper::getPost('limit', 1000);
        $types = explode(',', $type);

        $result = array(
            'user_total' => '',
            'is_arc' => 0,
            'username_num' => '',
            'avatar_num' => '',
            'sign_num' => '',
            'list' => array(),
        );

        $arc = ForumThread::getUserArchive();
        if ($operation == 1 && $starttime && $endtime) {
            // 用户存档表
            $num_archive = 0;
            $sign_num = 0;
            if ($arc['member_arc']) {
                $num_archive = DB::result_first("SELECT COUNT(*) FROM %t WHERE regdate>=%d AND regdate<%d", array('common_member_archive', $starttime, $endtime));
                if (in_array(3, $types)) {
                    $uid_archive = DB::fetch_all("SELECT uid FROM %t WHERE regdate>=%d AND regdate<%d", array('common_member_archive', $starttime, $endtime), 'uid');
                    if ($arc['forum_arc']) {
                        $uids = Tool::Array_Column($uid_archive, 'uid');
                        $sign_num = DB::result_first("SELECT COUNT(*) FROM %t WHERE uid IN (%n) AND sightml <> ''", array('common_member_field_forum_archive', $uids));
                    }
                }
                $result['is_arc'] = $num_archive;
            }

            // 用户总量（头像和用户名总量）
            $num = DB::result_first("SELECT COUNT(*) FROM %t WHERE regdate>=%d AND regdate<%d", array('common_member', $starttime, $endtime));

            if (!empty($types)) {
                $result['user_total'] = $num + $num_archive;

                if (in_array(1, $types)) {
                    $result['username_num'] = $num + $num_archive;
                }
                if (in_array(2, $types)) {
                    $result['avatar_num'] = $num + $num_archive;
                }
                // 个性签名数量
                if (in_array(3, $types)) {
                    $uidArr = DB::fetch_all("SELECT uid FROM %t WHERE regdate>=%d AND regdate<%d", array('common_member', $starttime, $endtime), 'uid');
                    $uids = Tool::Array_Column($uidArr, 'uid');
                    $result['sign_num'] = DB::result_first("SELECT COUNT(*) FROM %t WHERE uid IN (%n) AND sightml <> ''", array('common_member_field_forum', $uids));
                    $result['sign_num'] = $result['sign_num'] + $sign_num;
                }
            }

        } elseif ($operation == 2 && $starttime && $endtime) {
            // $type 不为空返回用户名称 签名及 头像
            if (!empty($type)) {
                // 存档表数据
                if ($is_arc) {
                    $uidArr = DB::fetch_all("SELECT uid,username FROM %t WHERE regdate>=%d AND regdate<%d" . DB::limit($offset, $limit), array('common_member_archive', $starttime, $endtime), 'uid');

                    if ($arc['forum_arc']) {
                        $uids = Tool::Array_Column($uidArr, 'uid');
                        $sightml = DB::fetch_all("SELECT uid,sightml FROM %t WHERE uid IN (%n) AND sightml <> ''", array('common_member_field_forum_archive', $uids), 'uid');
                    }
                } else {
                    $uidArr = DB::fetch_all("SELECT uid,username FROM %t WHERE regdate>=%d AND regdate<%d" . DB::limit($offset, $limit), array('common_member', $starttime, $endtime), 'uid');
                    $uids = Tool::Array_Column($uidArr, 'uid');
                    $sightml = DB::fetch_all("SELECT uid,sightml FROM %t WHERE uid IN (%n) AND sightml <> ''", array('common_member_field_forum', $uids), 'uid');
                }

                if (!empty($uidArr)) {
                    foreach ($uidArr as $k => $v) {
                        $list['uid'] = $v['uid'];
                        $list['username'] = $v['username'];

                        $list['sightml'] = '';
                        if (isset($sightml) && !empty($sightml[$k]['sightml'])) {
                            $list['sightml'] = $sightml[$k]['sightml'];
                        }

                        $list['avatar'] = avatar($v['uid'], 'big', true, FALSE, 1);
                        $result['list'][] = $list;
                    }
                }

            } else {
                Tool::getInstance()->fail_json(Code::UNDEFINED_ACTION, Tool::getInstance()->lang('undefined action'));
            }
        } else {
            Tool::getInstance()->fail_json(Code::UNDEFINED_ACTION, Tool::getInstance()->lang('undefined action'));
        }

        Tool::getInstance()->success_json($result);
    }


    /**
     * 用户点赞列表
     */
    public function actionPingList()
    {
        $uid = (int)WebHelper::getPost('uid', 0);
        $startTime = WebHelper::getPost('startTime', 0);
        $endTime = WebHelper::getPost('endTime', 0);

        $type = (int)WebHelper::getPost('type', 0);
        $offset = (int)WebHelper::getPost('offset', 0);
        $limit = (int)WebHelper::getPost('limit', 20);

        $parameter = array('forum_memberrecommend', $uid);

        if ($startTime) {
            $parameter[] = $startTime;
            $wherearr[] = 'm.dateline>=%d';
        }
        if ($endTime) {
            $parameter[] = $endTime;
            $wherearr[] = 'm.dateline<%d';
        }

        $order = ' ORDER BY m.dateline DESC ';
        $wheresql = !empty($wherearr) && is_array($wherearr) ? 'AND ' . implode(' AND ', $wherearr) : '';

        // 获取用户帖子点赞列表
        $querySql = "SELECT m.tid, m.recommenduid as uid, m.dateline, t.subject as title FROM %t m LEFT JOIN " . DB::table("forum_thread ") . " t ON m.tid = t.tid WHERE m.recommenduid = %d " . $wheresql . $order . DB::limit($offset, $limit);
        $data = DB::fetch_all($querySql, $parameter);

        Tool::getInstance()->success_json($data);
    }

    /**
     * 根据三方信息获取用户uid
     */
    public function actionuserInfoByThird()
    {
        $unionid = WebHelper::getPost('unionid', '');// 第三方id 手机号 unionid
        $weibotype = WebHelper::getPost('weibotype', 'phone');// 手机号:phone QQ:qq  微信:wechat 微博:weibo

        if (!$weibotype) {
            Tool::getInstance()->fail_json(Code::UNDEFINED_ACTION, Tool::getInstance()->lang('undefined action'));
        }

        if ($weibotype == 'phone') {
            // 检查是否是合法手机号
            if (!Tool::getInstance()->VerifyMobileNumber($unionid, 1)) {
                Tool::getInstance(Code::ILLEGAL_MOBILE, Tool::getInstance()->lang('illegal_mobile'));
            }
            $uid = Mobile::fetchUidByMobile($unionid);
        } elseif ($weibotype == 'qq') {
            $uid = DB::result_first("SELECT uid FROM %t WHERE weibotype=%s AND openid=%s", array('thirdbind', $weibotype, $unionid));
        } elseif ($weibotype == 'wechat') {
            $uid = DB::result_first("SELECT uid FROM %t WHERE weibotype=%s AND unionid=%s", array('thirdbind', $weibotype, $unionid));
        } elseif ($weibotype == 'weibo') {
            $uid = DB::result_first("SELECT uid FROM %t WHERE weibotype=%s AND openid=%s", array('thirdbind', 'sinaweibo', $unionid));
        } else {
            Tool::getInstance()->fail_json(Code::UNDEFINED_ACTION, Tool::getInstance()->lang('undefined action'));
        }

        if (!$uid) {
            Tool::getInstance()->fail_json(Code::USER_NOT_EXISTS, Tool::getInstance()->lang('user_not_exists'));
        }

        $data = array(
            'uid' => $uid,
        );

        Tool::getInstance()->success_json($data);
    }

    /**
     * 用户积分数据
     */
    public function actionUserCredits()
    {
        require_once(libfile('function/forum'));

        $offset = WebHelper::getPost('offset', 0);
        $limit = WebHelper::getPost('limit', 20);
        $last_id = (int)WebHelper::getPost('last_id', 0);
        $uids = WebHelper::getPost('uids', '');
        $sqlWhere = array();
        $res = array();

        $sqlWhere[] = DB::field('uid', $last_id, '>');
        if ($uids) {
            $uidArr = explode(',', $uids);
            $sqlWhere[] = DB::field('uid', $uidArr, 'in');
        }

        $whereArr = implode(' AND ', $sqlWhere);
        $order = ' ORDER BY uid ASC ';
        $data = DB::fetch_all('
                SELECT uid,username,credits
			    FROM %t
			    WHERE %i ' . $order . DB::limit($offset, $limit),
            array('common_member', $whereArr)
        );

        foreach ($data as $v) {
            $res[] = array(
                'uid' => $v['uid'],
                'username' => $v['username'],
                'credits' => $v['credits'],
                'avatar' => discuz_uc_avatar($v['uid'], 'big', true),
            );
        }

        Tool::getInstance()->success_json($res);
    }

    /**
     * 获取用户所有积分
     * @throws DbException
     */
    public function actionUserAllCredits()
    {
        require_once(libfile('function/forum'));

        $offset = WebHelper::getPost('offset', 0);
        $limit = WebHelper::getPost('limit', 20);
        $last_id = (int)WebHelper::getPost('last_id', 0);
        $uids = WebHelper::getPost('uids', '');
        $sqlWhere = array();

        $sqlWhere[] = DB::field('uid', $last_id, '>');
        if ($uids) {
            $uidArr = explode(',', $uids);
            $sqlWhere[] = DB::field('uid', $uidArr, 'in');
        }

        $whereArr = implode(' AND ', $sqlWhere);
        $order = ' ORDER BY uid ASC ';
        $data = DB::fetch_all('
                SELECT *
			    FROM %t
			    WHERE %i ' . $order . DB::limit($offset, $limit),
            array('common_member_count', $whereArr)
        );

        $res = $data ? $data : array();
        Tool::getInstance()->success_json($res);
    }


    /**
     * 删除用户所有信息数据
     */
    public function actionDeleteMember()
    {
        global $_G;
        $uids = WebHelper::getPost('uids', '');
        $extToken = WebHelper::getPost('ext_token', 0);
        $secretKey = Yii::app()->params['cloud_secretkey'];
        $uidAry = explode(',', $uids);

        if (!$uidAry || !$extToken) {
            Tool::getInstance()->fail_json(Code::UNDEFINED_ACTION, Tool::getInstance()->lang('undefined action'));
        }
        // 验证token
        if ($extToken) {
            $token = Xxtea::decrypt(base64_decode($extToken), $secretKey);
            if (!$token || !authcode($token, 'DECODE', $secretKey)) {
                Tool::getInstance()->fail_json(Code::ILLEGAL_REQUEST, Tool::getInstance()->lang('illegal_request'));
            }
        }

        // 处理存档表
        $archiveArr = C::t('common_member_archive')->fetch_all($uidAry);
        if ($archiveArr) {
            foreach ($archiveArr as $uid => $member) {
                if (isset($member['_inarchive'])) {
                    C::t('common_member_archive')->move_to_master($uid);
                }
            }
        }
        // 验证管理员用户组
        $groups = DB::fetch_all("SELECT uid FROM %t WHERE uid IN (%n) AND adminid IN (%n)", array('common_member', $uidAry, array(1, 2, 3)));
        if ($groups) {
            Tool::getInstance()->fail_json(Code::ADMIN_USER_PROTECTED, Tool::getInstance()->lang('admin_user_protected'));
        }

        Yii::log(var_export(sprintf('start-delete-member-uids: %s client-IP: %s', $uids, $_G['clientip']), true));
        require_once libfile('function/delete');
        require_once libfile('function/forum');
        // 删除用户信息，评论，附件
        deletemember($uidAry, true);

        // 删除uc
        loaducenter();
        uc_user_delete($uidAry);

        // 删除帖子
        $pertask = 1000;
        $threads = $fids = $threadsarray = array();
        foreach (C::t('forum_thread')->fetch_all_by_authorid($uidAry, $pertask) as $thread) {
            $threads[$thread['fid']][] = $thread['tid'];
        }
        if ($threads) {
            require_once libfile('function/post');
            foreach ($threads as $fid => $tids) {
                deletethread($tids);
            }
            if ($_G['setting']['globalstick']) {
                require_once libfile('function/cache');
                updatecache('globalstick');
            }
        }

        // 删除home_blog
        $blogs = array();
        $query = C::t('home_blog')->fetch_blogid_by_uid($uidAry, 0, $pertask);
        foreach ($query as $blog) {
            $blogs[] = $blog['blogid'];
        }
        if ($blogs) {
            deleteblogs($blogs);
        }

        // 删除相册
        $pics = array();
        $query = C::t('home_pic')->fetch_all_by_uid($uidAry, 0, $pertask);
        foreach ($query as $pic) {
            $pics[] = $pic['picid'];
        }
        if ($pics) {
            deletepics($pics);
        }

        // 删除用户记录表
        $doings = array();
        $query = C::t('home_doing')->fetch_all_by_uid_doid($uidAry, '', '', 0, $pertask);
        foreach ($query as $doing) {
            $doings[] = $doing['doid'];
        }
        if ($doings) {
            deletedoings($doings);
        }

        // 删除用户分享
        $shares = array();
        foreach (C::t('home_share')->fetch_all_by_uid($uidAry, $pertask) as $share) {
            $shares[] = $share['sid'];
        }
        if ($shares) {
            deleteshares($shares);
        }

        // 删除被关注者消息
        C::t('home_follow_feed')->delete_by_uid($uidAry);

        // 删除home_comment
        $comments = array();
        $query = C::t('home_comment')->fetch_all_by_uid($uidAry, 0, $pertask);
        foreach ($query as $comment) {
            $comments[] = $comment['cid'];
        }
        if ($comments) {
            deletecomments($comments);
        }

        // 解绑手机号和第三方绑定信息
        foreach ($uidAry as $uid) {
            Mobile::deleteByUid($uid);
            DB::delete('thirdbind', DB::field('uid', $uid));
        }

        Tool::getInstance()->success_json(array());
    }

    /**
     * 解绑所有不存在用户的手机号和三方信息
     */
    public function actionUnbindMember()
    {
        global $_G;
        $type = WebHelper::getPost('type', 0);//0解绑手机号 1解绑三方
        $last_id = WebHelper::getPost('last_id', 0);//last_id
        $pageSize = 2000;

        $member_arc = DB::result_first("SHOW TABLES LIKE '%common_member_archive'");
        if ($type == 1) {
            while ($data = DB::fetch_all("SELECT uid FROM %t WHERE uid>%d ORDER BY uid ASC LIMIT %d", array('thirdbind', $last_id, $pageSize))) {
                $uids = Tool::Array_Column($data, 'uid');
                $member = DB::fetch_all("SELECT uid FROM %t WHERE uid IN(%n)", array('common_member', $uids));
                if ($member_arc) {
                    $arc_uid = DB::fetch_all("SELECT uid FROM %t WHERE uid IN(%n)", array('common_member_archive', $uids));
                    if (!empty($arc_uid)) {
                        $member = array_merge($member, $arc_uid);
                    }
                }
                $member_uids = Tool::Array_Column($member, 'uid');
                $ids = array_values(array_diff($uids, $member_uids));
                if (!empty($ids)) {
                    DB::delete('thirdbind', DB::field('uid', $ids));
                }

                $last = end($data);
                $last_id = $last['uid'];
                Yii::log(var_export('thirdbind: ' . $last_id, true));// 用户过多导致超时记录uid
                unset($data);
            }
        } else {
            while ($data = DB::fetch_all("SELECT uid FROM %t WHERE uid>%d ORDER BY uid ASC LIMIT %d", array('phonebind', $last_id, $pageSize))) {
                $uids = Tool::Array_Column($data, 'uid');
                $member = DB::fetch_all("SELECT uid FROM %t WHERE uid IN(%n)", array('common_member', $uids));
                if ($member_arc) {
                    $arc_uid = DB::fetch_all("SELECT uid FROM %t WHERE uid IN(%n)", array('common_member_archive', $uids));
                    if (!empty($arc_uid)) {
                        $member = array_merge($member, $arc_uid);
                    }
                }
                $member_uids = Tool::Array_Column($member, 'uid');
                $ids = array_values(array_diff($uids, $member_uids));
                if (!empty($ids)) {
                    DB::delete('phonebind', DB::field('uid', $ids));
                }

                $last = end($data);
                $last_id = $last['uid'];
                Yii::log(var_export('phonebind: ' . $last_id, true));// 用户过多导致超时记录uid
                unset($data);
            }
        }

        Tool::getInstance()->success_json(array());
    }

    /**
     * 楼中楼点赞
     */
    public function actionPingfloor()
    {
        global $_G;

        //主题（帖子）ID 楼主
        $tid = (int)WebHelper::getPost('tid', 0);
        //帖子（评论）ID 层主
        $pid = (int)WebHelper::getPost('pid', 0);
        // 楼中楼的id
        $floor_id = (int)WebHelper::getPost('floor_id', 0);

        $table = DB::result_first("SHOW TABLES LIKE '%t'", array('qianfan_post_floor_comment'));
        if (!$table) {
            Tool::getInstance()->fail_json(Code::NO_PRIVILEGE_RECOMMEND, Tool::getInstance()->lang('no_privilege_recommend'));
        }

        //判断是否登录
        if (empty($_G['uid'])) {
            Tool::getInstance()->fail_json(Code::NOT_LOG_IN, Tool::getInstance()->lang('please log in first'));
        }

        // 主题是否存在
        $thread = C::t('forum_thread')->fetch($tid);
        if (empty($thread['tid'])) {
            Tool::getInstance()->fail_json(Code::THREAD_NOT_EXISTS, Tool::getInstance()->lang('thread not exists'));
        }

        // 层主评论是否存在
        $post = C::t('forum_post')->fetch('tid:' . $tid, $pid, false);
        if (empty($post)) {
            Tool::getInstance()->fail_json(Code::POST_NOT_EXIST, Tool::getInstance()->lang('post_not_exist'));
        }

        // 楼中楼评论是否存在
        $floor = ReplyFloor::fetchById($floor_id);
        if (!$floor || $floor['pid'] != $pid) {
            Tool::getInstance()->fail_json(Code::UNDEFINED_ACTION, Tool::getInstance()->lang('undefined action'));
        }

        $floor_comment = ReplyFloor::floorPingsByIds($floor_id, $_G['uid']);
        if (empty($floor_comment[$_G['uid']])) {
            $comment = array(
                'uid' => $_G['uid'],
                'floor_id' => $floor_id,
                'created_at' => $_G['timestamp']
            );
            DB::insert('qianfan_post_floor_comment', $comment, false);
            $sql = "`ping_num`=`ping_num`+'1'";
            DB::query('UPDATE %t SET ' . $sql . ' WHERE id=%d', array('qianfan_post_floor', $floor_id));
        } else {
            Tool::getInstance()->fail_json(Code::THREAD_POLL_VOTED, Tool::getInstance()->lang('noreply_voted_error'));
        }

        $data = array();
        Tool::getInstance()->success_json($data);
    }

    /**
     * 楼中楼取消点赞
     */
    public function actionCancelPingFloor()
    {
        global $_G;

        //主题（帖子）ID 楼主
        $tid = (int)WebHelper::getPost('tid', 0);
        //帖子（评论）ID 层主
        $pid = (int)WebHelper::getPost('pid', 0);
        // 楼中楼的id
        $floor_id = (int)WebHelper::getPost('floor_id', 0);

        $table = DB::result_first("SHOW TABLES LIKE '%t'", array('qianfan_post_floor_comment'));
        if (!$table) {
            Tool::getInstance()->fail_json(Code::NO_PRIVILEGE_RECOMMEND, Tool::getInstance()->lang('no_privilege_recommend'));
        }

        // 判断是否登录
        if (empty($_G['uid'])) {
            Tool::getInstance()->fail_json(Code::NOT_LOG_IN, Tool::getInstance()->lang('please log in first'));
        }

        // 主题是否存在
        $thread = C::t('forum_thread')->fetch($tid);
        if (empty($thread['tid'])) {
            Tool::getInstance()->fail_json(Code::THREAD_NOT_EXISTS, Tool::getInstance()->lang('thread not exists'));
        }

        // 层主评论是否存在
        $post = C::t('forum_post')->fetch('tid:' . $tid, $pid, false);
        if (empty($post)) {
            Tool::getInstance()->fail_json(Code::POST_NOT_EXIST, Tool::getInstance()->lang('post_not_exist'));
        }

        // 楼中楼评论是否存在
        $floor = ReplyFloor::fetchById($floor_id);
        if (!$floor || $floor['pid'] != $pid) {
            Tool::getInstance()->fail_json(Code::UNDEFINED_ACTION, Tool::getInstance()->lang('undefined action'));
        }

        $floor_comment = ReplyFloor::floorPingsByIds($floor_id, array($_G['uid']));
        if (!empty($floor_comment[$_G['uid']])) {
            DB::delete('qianfan_post_floor_comment', DB::field('id', $floor_comment[$_G['uid']]['id']));
            $sql = "`ping_num`=`ping_num`-'1'";
            DB::query('UPDATE %t SET ' . $sql . ' WHERE id=%d', array('qianfan_post_floor', $floor_id));
        } else {
            Tool::getInstance()->fail_json(Code::USER_NOT_RECOMMEND, Tool::getInstance()->lang('user_not_recommend'));
        }


        Tool::getInstance()->success_json(array());
    }

    /**
     * 后台楼中楼马甲评论点赞
     */
    public function actionPingFloorByAdm()
    {
        global $_G;

        // 用户uid
        $uid = WebHelper::getPost('uid', 0);
        //主题（帖子）ID 楼主
        $tid = (int)WebHelper::getPost('tid', 0);
        //帖子（评论）ID 层主
        $pid = (int)WebHelper::getPost('pid', 0);
        // 楼中楼的id
        $floor_id = (int)WebHelper::getPost('floor_id', 0);

        $table = DB::result_first("SHOW TABLES LIKE '%t'", array('qianfan_post_floor_comment'));
        if (!$table) {
            Tool::getInstance()->fail_json(Code::NO_PRIVILEGE_RECOMMEND, Tool::getInstance()->lang('no_privilege_recommend'));
        }

        $uidArr = explode(',', $uid);
        if (empty($uidArr)) {
            Tool::getInstance()->fail_json(Code::UNDEFINED_ACTION, Tool::getInstance()->lang('undefined action'));
        }

        // 过滤不存在的用户
        $member = DB::fetch_all("SELECT uid FROM %t WHERE uid IN(%n)", array("common_member", $uidArr));
        $arc = ForumThread::getUserArchive();
        if ($arc['member_arc']) {
            $member = $member + DB::fetch_all("SELECT uid FROM %t WHERE uid IN(%n)", array("common_member_archive", $uidArr));
        }
        $uidArr = Tool::Array_Column($member, 'uid');

        // 主题是否存在
        $thread = C::t('forum_thread')->fetch($tid);
        if (empty($thread['tid'])) {
            Tool::getInstance()->fail_json(Code::THREAD_NOT_EXISTS, Tool::getInstance()->lang('thread not exists'));
        }

        // 层主评论是否存在
        $post = C::t('forum_post')->fetch('tid:' . $tid, $pid, false);
        if (empty($post)) {
            Tool::getInstance()->fail_json(Code::POST_NOT_EXIST, Tool::getInstance()->lang('post_not_exist'));
        }

        // 楼中楼评论是否存在
        $floor = ReplyFloor::fetchById($floor_id);
        if (!$floor || $floor['pid'] != $pid) {
            Tool::getInstance()->fail_json(Code::UNDEFINED_ACTION, Tool::getInstance()->lang('undefined action'));
        }

        $pingUid = $data = array();
        $floor_comments = ReplyFloor::floorPingsByIds($floor_id, $uidArr);
        foreach ($uidArr as $uid) {
            if (empty($floor_comments[$uid])) {
                $pingUid[] = $uid;
                $comment = array(
                    'uid' => $uid,
                    'floor_id' => $floor_id,
                    'created_at' => $_G['timestamp']
                );
                DB::insert('qianfan_post_floor_comment', $comment, false);
                $sql = "`ping_num`=`ping_num`+'1'";
                DB::query('UPDATE %t SET ' . $sql . ' WHERE id=%d', array('qianfan_post_floor', $floor_id));
            }
        }

        if (!empty($pingUid)) {
            $data = array('uid' => $pingUid);
        }

        Tool::getInstance()->success_json($data);
    }

}
