<?php
/**
 * Created by PhpStorm.
 * User: sunbing
 * Date: 2017/1/8
 * Time: 19:45
 */

class QianfanPlugin {

    protected $_table = 'qianfan_plugin';

    //保存类实例的静态成员变量
    private static $_instance;

    //创建__clone方法防止对象被复制克隆
    public function __clone() {
        throw new ErrorException( 'Clone is not allow', E_USER_ERROR );
    }

    public function __construct() {
        if( empty($this->_checkTableExist($this->_table)) ) return false;
    }

    public static function getInstance() {
        if ( !(self::$_instance instanceof self) ) {
            self::$_instance = new self;
        }

        return self::$_instance;
    }


    /**
     * 获取值
     * @param $name
     * @param int $expire
     * @return bool|string
     */
    public function get($name, $expire = 0) {
        if( !$name ) return false;
        $result = DB::result_first("SELECT value FROM %t WHERE name=%s", array($this->_table, $name));

        if( $expire && isset($result['time']) && time() > $result['time'] ) {
            return '';
        }
        return $result;
    }

    /**
     * 设置值
     * @param $name
     * @param $value
     * @param int $expire
     * @return bool
     */
    public function set($name, $value, $expire = 0) {
        if( !$name || !$value ) return false;
        $time = time()+$expire;
        if( empty(self::get($name)) ) {
            DB::insert("qianfan_plugin", array("name" => $name, "value" => $value, "time" => $time));
        }else {
            DB::update( "qianfan_plugin", array("value" => $value, "time" => $time), array("name" => $name) );
        }
        return true;
    }

    /**
     * 验证表是否存在
     * @param $table
     * @return bool
     */
    private function _checkTableExist($table) {
        if( !$table ) return false;
        $table = DB::result_first("SHOW TABLES LIKE '%".$table."'");
        return $table;
    }

}