<!DOCTYPE html>
<html>
<head>
    <meta charset="<?php echo Yii::app()->charset ?>" />
    <meta name="viewport" content="width=device-width,initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0, user-scalable=no"/>
    <meta name="apple-mobile-web-app-capable" content="yes">
    <meta name="apple-mobile-web-app-status-bar-style" content="black">
    <meta http-equiv="Content-Type" content="text/html; charset=<?php echo Yii::app()->charset ?>" />
    <link rel="stylesheet" type="text/css" href="source/plugin/qianfan/static/search/style/style.css?v=1.0">
    <script type="text/javascript" src="source/plugin/qianfan/static/search/js/QF.js"></script>
    <script type="text/javascript" src="source/plugin/qianfan/static/search/js/zepto.min.js"></script>
    <title><?php echo $this->tplLang('search') ?></title>
</head>

<body class="bg-gray">
<!-- <div class="title-bar bg-blue"><a class="back2" href=""></a><?php echo $this->tplLang('search') ?></div> -->

<?php if(count($users)){?>
<div class="block">
    <div class="title"><?php echo $this->tplLang('search_users', array('{keyword}' => $keyword)) ?></div>
    <div class="cont">
        <?php foreach($users as $i=>$user){?>
        <div class="user-box">
            <a onclick="javascript:QFH5.jumpUser(<?php echo intval($user['id'])?>)">
                <img src="<?php echo $user['icon']?>" onerror="this.onerror=null;this.src='<?php echo $user['def_icon']?>'" />
                <p><?php echo $user['username']?></p>
            </a>
        </div>
        <?php }?>
        <div class="user-box">
            <?php if($user_num>3){?>
            <a href="/plugin.php?id=qianfan:search&r=search/user&keyword=<?php echo $keyword?>" class="user-more"><?php echo $this->tplLang('more') ?>></a>
            <?php }?>
        </div>
    </div>
</div>
<?php }?>

<?php if(count($posts)){?>
<div class="block">
    <div class="title"><?php echo $this->tplLang('search_threads', array('{keyword}' => $keyword)) ?></div>
    <div class="post_list" id="post_list">
        <?php foreach($posts as $i=>$post){?>
            <div class="post" onclick="javascript:QFH5.jumpThread(<?php echo intval($post['id'])?>)">

            <a ><?php echo $post['subject']?></a>
            <p class="info"><span class="date"><?php echo $post['postdate']?></span><?php echo $post['author']?></p>
            </div>
        <?php }?>
    </div>
        <div id="pullUp" class="">
            <span class="pullUpIcon">&</span><span class="pullUpLabel"><?php echo $this->tplLang('click_load_more') ?></span>
        </div>
</div>
<?php }?>
<?php if(empty($users) and empty($posts)){?>
<div class="block" style="margin-top: 0;text-align: center;">
    <div class="title"><?php echo $this->tplLang('search_nothing') ?></div>
</div>
<?php }?>

<script type="text/javascript">
    Zepto(function($){
        var myScroll,
            pullUpEl,
            page = 1;
	var url = window.location.href;
        function pullUpAction () {
            pullUpEl.addClass("loading");
            pullUpEl.find('.pullUpLabel').html('load...');
            page++;
            $.ajax({
                type: "POST",
                url: url,
                data: {page:page,type:'ajax'},
                dataType: 'json',
                success: function(data) {
                    var el, li, i;
                    el = $('#post_list');
                    if(data.length> 0){
                        $.each((data),function(key,val){
                            var html = '<div class="post" onclick="javascript:QFH5.jumpThread('+val['id']+')">'
                                + '<a >' + val['subject'] + '</a>'
                                + '<p class="info"><span class="date">' + val['postdate'] + '</span>' + val['author'] + '</p>'
                                + '</div>';
                            var node = $(html);
                            el.append(node);
                        });
			if(data.length < 10){
                        	pullUpEl.find('.pullUpLabel').html("<?php echo $this->tplLang('no_more') ?>");
                        	pullUpEl.unbind('click');
			}else{
                        	pullUpEl.find('.pullUpLabel').html("<?php echo $this->tplLang('click_load_more') ?>");
			}
                    } else {
                        pullUpEl.find('.pullUpLabel').html("<?php echo $this->tplLang('search_nothing') ?>");
                        pullUpEl.unbind('click');
                    }
                    pullUpEl.removeClass("loading");
                }
            });
        }
        pullUpEl = $('#pullUp');
        pullUpEl.on('click',pullUpAction);
    });
</script>
</body>
</html>
